                                 DDSCAT.5a9
                                 ***********

                               Bruce T. Draine
                       Princeton University Observatory
                              Princeton NJ 08544
                         (draine@astro.princeton.edu)

                                     and

                               Piotr J. Flatau
                      University of California, San Diego
                      Scripps Institution of Oceanography
                  La Jolla Shores Dr., La Jolla CA 92093-0221
                            (pflatau@ucsd.edu)

                         [last revised: 98.12.22]
        Copyright (C) 1994,1995,1996,1997,1998 B.T. Draine and P.J. Flatau


                               1. INTRODUCTION
                               ****************

   DDSCAT is a FORTRAN program to calculate scattering and absorption of
electromagnetic radiation by arbitrary targets using the "Discrete Dipole
Approximation" (DDA).  In this approximation the target is replaced by
an array of point dipoles; the electromagnetic scattering problem for the
array of point dipoles is then solved essentially exactly.  The DDA was
apparently first proposed by Purcell and Pennypacker (1973).  DDA theory is
reviewed and developed further by Draine (1988), Draine and Goodman (1993),
and recently reviewed by Draine and Flatau (1994).

   DDSCAT.5a9 is a FORTRAN implementation of the DDA developed by the authors.
It is intended to be a versatile implementation, suitable for a wide variety
of applications ranging from interstellar dust to atmospheric aerosols.  As
written, the code should be usable for many applications without modification,
but the program is written in a modular form, so that modifications, if
required, should be fairly straightforward.  The current version of DDSCAT
uses the DDA formulae from Draine (1988).  The code incorporates Fast Fourier
Transform (FFT) methods (Goodman, Draine, and Flatau 1991).  The Lattice
Dispersion Relation (LDR) prescription (Draine and Goodman 1993) is used for
determining dipole polarizabilities.

   At present the user may choose among different FFT implementations:
(1) FORTRAN implementation (FOURX) from Brenner (1969); 
(2) FORTRAN implementation (CFFT99F) from Temperton (1983); 
(3) FORTRAN implementation (GPFA) from Temperton (1994);
(4) the native vector library implementation (C3DFFT) on Convex computers.

   To facilitate comparisons of the different FFT options, we provide a
separate FORTRAN program TSTFFT which will provide timing information for
comparison of the 3 FORTRAN FFT options.  This will enable the user to make
the best choice of FFT for the particular hardware/architecture being used.
   
   The current release of DDSCAT includes an option to calculate torques and
transverse forces on targets, as described in Draine and Weingartner (1996).

   Detailed instructions for using DDSCAT are contained in the User Guide for
DDSCAT.5a9.  The User Guide is available in the ftp directory as either
* UserGuide.ps    : postscript file
* UserGuide.ps.gz : gzipped postscript file
* UserGuide.tex   : LaTeX file; requires encapsulated postcript files f1.eps,
                    f2.eps, f3.eps, f4.eps, and f5.eps .

   The UserGuide is available on-line via the WWW, at
http://www/astro.princeton.edu/~draine/UserGuide/UserGuide.html


                              IMPORTANT NOTE
                              **************

   Previous releases of version 5a (including version 5a8), while solving
the scattering problem correctly, unfortunately contained an error in the
routine getmueller.f which calculated complex scattering amplitudes S_i and 
Mueller matrix elements S_ij from the f_ml.  The S_i and S_ij were computed 
correctly only for the special case where the scattering plane had phi=0;
for other scattering planes, S_11 was computed correctly, but other elements
were not correct.

   These errors have been corrected in the present release DDSCAT.5a9.

   It should be stressed that calculations by DDSCAT.5a8 and previous releases 
of

* absorption efficiencies Q_abs
* scattering efficiencies Q_sca
* extinction efficiencies Q_ext
* <cos(theta)> for scattering
* radiation pressure efficiency vector Q_pr
* radiation torque efficiency vector Q_gamma

were all computed and reported correctly.


                               2. AVAILABILITY
                               ***************

   The authors make this code openly available to others, in the hope that
it will prove to be a useful tool.  We ask only that:

* If you publish results obtained using DDSCAT, please consider acknowledging
  the source of the code.

* If you discover any errors in the code, please promptly communicate them to
  the authors.

* You comply with the "copyleft" agreement (more formally, the GNU General
  Public License) of the Free Software Foundation: you may copy, distribute,
  and/or modify the software identified as coming under this agreement.  If
  you distribute copies of this software, you must give the recipients all the
  rights which you have.  See the file "copyleft" distributed with the
  DDSCAT software.

   We also strongly encourage you to send email to the authors identifying
yourself as a user of DDSCAT;  this will enable the authors to notify you of
any bugs, corrections, or improvements in DDSCAT.


                             3. HOW TO COPY IT
                             *****************

                            a) Where to find it
                            ===================

   The easiest way to obtain DDSCAT.5a9 is to download the latest distribution
from the WWW site:

	ftp://astro.princeton.edu/draine/scat/ddscat/ver5a9/ddscat5a9.tar.gz

   Alternatively, one can use "anonymous ftp" to "astro.princeton.edu" .
To gain access to this computer from another computer on the Internet, type:
      ftp astro.princeton.edu
or, if that didn't work, try
      ftp 128.112.24.45
When you get the login prompt type "anonymous"; when you get the password
prompt type your full email address.  To get to the appropriate subdirectory,
type
      cd draine/scat/ddscat/ver5a9
which will place you in a directory containing various files, including:
* README (a copy of the text you are reading now);
* rel_notes (release notes, including a list of known or suspected bugs);
* ddscat5a9.tar.gz ("gzipped tarfile" used for transfer to other UNIX systems);
* UserGuide.ps (postscript User Guide for DDSCAT)
* UserGuide.ps.gz ("gzipped" postscript User Guide)
* UserGuide.tex (LaTeX source code for "user guide")
* f1.eps, f2.eps, f3.eps, f4.eps f5.eps (encapsulated postscript figures 
  required by UserGuide.tex)
* SRCn.FOR (where n=0,...,9; for transfer to non-UNIX systems);
* GPFA.FOR (for transfer to non-UNIX systems);
* LAPACK.FOR (for transfer to non-UNIX systems);
* MISC.FOR (for transfer to non-UNIX systems);
* PIM.FOR (for transfer to non-UNIX systems);
* copyleft (for transfer to non-UNIX systems);
* ddscat.par (for transfer to non-UNIX systems);
* diel.tab (for transfer to non-UNIX systems).
   You may check the contents of the directory by typing
      ls
which should list the names of these files.

                            b) To a UNIX System
                            ===================

   The file "ddscat5a9.tar.gz" in this directory is a "gzipped" "tar" file for
easy transfer of EVERYTHING you need to other UNIX machines via ftp or tape.
It contains the following:
* The complete FORTRAN source code for the DDA scattering program DDSCAT,
  including the source code for the 3 different FFT implementations;
* The FORTRAN source code for the program CALLTARGET;
* The FORTRAN source code for the program TSTFFT;
* "Makefile" -- for compiling and linking using the UNIX utility "make";
* "rel_notes" -- release notes, including a list of known or suspected bugs;
* "ddscat.par" -- a sample parameter file set up for a test calculation;
* "diel.tab" -- a sample data file for specifying refractive index;
* "UserGuide.ps" -- a postscript User Guide providing extensive instructions
   on how to use DDSCAT.5a
* "README" (a copy of the file you are now reading);
* "copyleft" (a description of the GNU General Public License agreement).
To copy "ddscat5a9.tar.gz" to your system, type

      binary                     [invoke ftp "binary" option]
      get ddscat5a9.tar.gz       [to copy it to your computer]
      bye                        [to terminate your ftp session]

   After successfully transferring "ddscat5a9.tar.gz" to your UNIX system you
should do the following:

1. Move ddscat5a9.tar.gz to the desired directory.  In what follows below,
   this directory will be referred to as "~/DDA".  Thus you should now have
   a file "~/DDA/ddscat5a9.tar.gz" .

2. Position yourself in ~/DDA by typing

      cd ~/DDA

3. Now unzip "ddscat5a9.tar.gz" by typing

      gunzip ddscat5a9.tar.gz

   This command should replace the file "ddscat5a9.tar.gz" by a new file
"ddscat5a9.tar".

4. Now "extract" all of the files from "ddscat5a9.tar" by typing

      tar -xvf ddscat5a9.tar

   This will:

* create subdirectories ~/DDA/src, ~/DDA/doc, ~/DDA/misc, ~/DDA/IDL
* put "Makefile" and all of the source code in ~/DDA/src;
* put "README", "INSTRUCTIONS", "rel_notes", "ddscat.par", "diel.tab",
  "copyleft", and UserGuide.ps into the directory ~/DDA/doc;
* put miscellaneous source code into the directory ~/DDA/misc
* put some IDL code into the directory ~/DDA/IDL

  After doing this, you should consult the User Guide for further information.

                         c) To a Non-UNIX System
                         =======================

   If, alas, you are on a non-UNIX system, you should IGNORE the file
named "ddscat5a9.tar.gz".  There are a number of ASCII files in the directory 
in which you should be located:
* "README" -- a copy of the file you are now reading;
* "UserGuide.ps" -- User Guide (postscript)
* "UserGuide.tex" -- User Guide (LaTeX source)
* "f1.eps" ... "f5.eps" -- encapsulated postscript figures required by 
   UserGuide.tex
* "SRCn.FOR" for n=0,1,...,9  -- the entire source code with a VMS timing
   routine;
* "CGCOMMON.FOR" -- the source code for various routines common to
   conjugate gradient packages;
* "GPFA.FOR" -- the source code for Temperton's GPFA FFT package;
* "LAPACK.FOR" -- the source code for the public domain LAPACK package for
   linear algebra;
* "MISC.FOR" -- a program "calltarget", plus alternate timing routines;
* "PIM.FOR" -- a file containing source code for the PIM package;
* "rel_notes" -- release notes, including a list of known or suspected bugs;
* "ddscat.par" -- a sample parameter file; and
* "diel.tab" -- a sample dielectric file; and
* "copyleft" -- a description of the GNU General Public License agreement.
Copy them to your system using ftp by typing
      get README
      get INSTRUCTIONS
      prompt		[to turn off interactive prompting]
      mget *.FOR	[to transfer all files with .FOR suffix]
      get rel_notes
      get ddscat.par
      get diel.tab
      get copyleft
      get UserGuide.ps	[if you have a postscript printer]
      get UserGuide.tex [if you want LaTeX source for the User Guide]
      mget f*.eps	[if you want to be able to use the LaTeX source for
			 the User Guide]

The files "SRCn.FOR" , for n=0-9, plus CGCOMMON.FOR, GPFA.FOR, LAPACK.FOR, and 
PIM.FOR, contain all the DDSCAT source code including a timing routine 
suitable for VMS systems.  If you are on a VMS system, you can simply use a 
standard FORTRAN compiler to compile and link the routines in the 12 *.FOR 
files.  If you are on a non-VMS system, the timing routine (SUBROUTINE TIMEIT) 
supplied in "SRC9.FOR" may not work, in which case you should replace it with 
one of the alternate timing routines in the file "MISC.FOR" (comments within 
each routine will indicate what operating system it is appropriate to).
   The file "MISC.FOR" also contains code for a program CALLTARGET which
uses the target generation routines from DDSCAT to allow you to interactively
create various target lattices.  Consult the User Guide for more information.

                               ACKNOWLEDGMENTS
                               ***************

   The routine ESELF making use of the FFT was originally written by Jeremy J.
Goodman.  The FFT routine FOURX is based on a FFT routine written by Norman M.
Brenner.  The FFT routine CXFFT3 is based on a FFT routine written by Clive J.
Temperton.  The routine REFICE was written by Steven B. Warren, based on
Warren (1984).  The routine REFWAT was written by Eric A. Smith.  The GPFA
FFT routine was written by Clive Temperton, and generously made available by
him.  The LAPACK package is the result of work by Jack Dongarra and others at
the Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd., Courant 
Institute, Argonne National Lab, and Rice University.  The PIM package
(including routines in CGCOMMON) are due to Rudnei Dias da Cunha and Tim
Hopkins.  We are indebted to all of these authors for making their code 
available.

   We also thank those who have called our attention to bugs in earlier
versions of this code, in particular Henriette Lemke, Timo Nousianen, and 
Mike Wolff.

   Development of this code was supported in part by National Science
Foundation grants AST-8341412, AST-8612013, AST-9017082, AST-9319283, 
AST-9619429 to BTD, in part by support from the Office of Naval Research 
Young Investigator Program to PJF, in part by Air Force Office of Scientific 
Research grant AFOSR-88-0143 to PFJ, and in part by Dupont Corporate
Educational Assistance to PJF.


                  APPENDIX: How "ddscat5a9.tar.gz" was created
                  ******************************************

   In case you need to know, the file "ddscat5a9.tar.gz" in this directory was
created using the following procedure on a PC running Linux:

      cd ~/DDA/ver5a9
      tar cvf ddscat5a9.tar src doc misc IDL
      gzip ddscat5a9.tar

Here "~/DDA/ver5a9" is a directory containing version 5a9 of the DDA program.
The "tar" command was used to create a file "ddscat5a9.tar" (in the directory
"~/DDA/ver5a9").  The file "ddscat5a9.tar" includes the complete directories 
"~/DDA/ver5a9/src", "~/DDA/ver5a9/doc", "~/DDA/ver5a9/misc", and 
"~/DDA/ver5a9/IDL".  
The "gzip" command was used to create the gzipped file "ddscat5a9.tar.gz".


                                 REFERENCES
                                 **********

Brenner, N.M. 1969, IEEE Trans. Audio Electroacoust. AU-17, 128.

Draine, B.T. 1988, "The Discrete-Dipole Approximation and its Application to
   Interstellar Graphite Grains", Astrophys. J. 333, 848-872.

Draine, B.T., and Goodman, J. J. 1993, "Beyond Clausius-Mossotti: Wave
   Propagation on a Polarizable Point Lattice and the Discrete Dipole
   Approximation", Astrophys. J., 405, 685-697.

Draine, B.T., and Flatau, P.J. 1994, "Discrete-dipole approximation for
   scattering calculations", J. Opt. Soc. Am. A., 11, 1491-1499.

Draine, B.T., and Weingartner, J. 1996, "Radiative Torques on Interstellar 
   Grains: I. Superthermal Rotation", Ap. J., 470, 551.

Draine, B.T., and Weingartner, J. 1997, "Radiative Torques on Interstellar
   Grains: II. Alignment with the Magnetic Field", Ap. J., submitted.

Goodman, J.J., Draine, B.T., and Flatau, P.J. 1991, "Application of FFT
   Techniques to the Discrete Dipole Approximation, Opt. Lett., 16, 1198-
   1200.

Purcell, E.M., and Pennypacker, C.R. 1973, "Scattering and Absorption of Light
   by Nonspherical Dielectric Grains", Astrophys. J. 186, 705-714.

Temperton, C.J. 1983, "Self-sorting mixed-radix Fast Fourier Transforms",
   J. Comp. Phys. 52, 1-23.

Temperton, C.J. 1994, private communication.

Warren, S.G. 1984, "Optical Constants of Ice from the Ultraviolet to the
   Microwave", Appl. Opt., 23, 1206-1225.

98.12.06 BTD:
	in rotate.f, it is *assumed* that phi0=0 when theta=0
	shouldn't phi0 be determined by orientation of a2?
	(though admittedly it is then necessary to make assumption
	about beta)?  should look into this...

      SUBROUTINE EIGV (IBAL,A,KA,N,WR,WI,ZR,ZI,IERR)
C Arguments:
      INTEGER IBAL,IERR,KA,N
      REAL A(KA,N), WR(N), WI(N), ZR(KA,N), ZI(KA,N)
C Local variables:
      INTEGER IGH,J,K,KP1,LOW
C-----------------------------------------------------------------------
C           EIGENVALUES AND EIGENVECTORS OF REAL MATRICES
C
C This routine obtained from:
C Naval Surface Warfare Center Library of Mathematics Subroutines
C (January 1993)
C by Alfred H. Morris, Jr.
C Naval Surface Warfare Center
C Dahlgren Division
C Dahlgren VA 22448-5000
C
C-----------------------------------------------------------------------
C
      LOW = 1
      IGH = N
      IF (IBAL .NE. 0) CALL BALANC (KA,N,A,LOW,IGH,ZI)
      CALL ELMHS0 (KA,N,LOW,IGH,A,WR)
      CALL ELTRN0 (KA,N,LOW,IGH,A,WR,ZR)
      CALL HQR2 (KA,N,LOW,IGH,A,WR,WI,ZR,IERR)
      IF (IERR .NE. 0) RETURN
      IF (IBAL .NE. 0) CALL BALBAK (KA,N,LOW,IGH,ZI,N,ZR)
C
      DO 30 K = 1,N
         IF (WI(K)) 30,10,20
   10    DO 11 J = 1,N
   11       ZI(J,K) = 0.0
         GO TO 30
   20    KP1 = K + 1
         DO 21 J = 1,N
            ZI(J,K) = ZR(J,KP1)
            ZR(J,KP1) = ZR(J,K)
   21       ZI(J,KP1) = -ZI(J,K)
   30 CONTINUE
      RETURN
      END
      SUBROUTINE BALANC(NM,N,A,LOW,IGH,SCALE)
C
      INTEGER I,J,K,L,M,N,JJ,NM,IGH,LOW,IEXC
      REAL A(NM,N),SCALE(N)
      REAL C,F,G,R,S,B2,RADIX
      INTEGER IPMPAR
C     REAL ABS
      LOGICAL NOCONV
C-----------------------------------------------------------------------
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE BALANCE,
C     NUM. MATH. 13, 293-304(1969) BY PARLETT AND REINSCH.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 315-326(1971).
C
C     THIS SUBROUTINE BALANCES A REAL MATRIX AND ISOLATES
C     EIGENVALUES WHENEVER POSSIBLE.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        A CONTAINS THE INPUT MATRIX TO BE BALANCED.
C
C     ON OUTPUT-
C
C        A CONTAINS THE BALANCED MATRIX,
C
C        LOW AND IGH ARE TWO INTEGERS SUCH THAT A(I,J)
C          IS EQUAL TO ZERO IF
C           (1) I IS GREATER THAN J AND
C           (2) J=1,...,LOW-1 OR I=IGH+1,...,N,
C
C        SCALE CONTAINS INFORMATION DETERMINING THE
C           PERMUTATIONS AND SCALING FACTORS USED.
C
C     SUPPOSE THAT THE PRINCIPAL SUBMATRIX IN ROWS LOW THROUGH IGH
C     HAS BEEN BALANCED, THAT P(J) DENOTES THE INDEX INTERCHANGED
C     WITH J DURING THE PERMUTATION STEP, AND THAT THE ELEMENTS
C     OF THE DIAGONAL MATRIX USED ARE DENOTED BY D(I,J).  THEN
C        SCALE(J) = P(J),    FOR J = 1,...,LOW-1
C                 = D(J,J),      J = LOW,...,IGH
C                 = P(J)         J = IGH+1,...,N.
C     THE ORDER IN WHICH THE INTERCHANGES ARE MADE IS N TO IGH+1,
C     THEN 1 TO LOW-1.
C
C     NOTE THAT 1 IS RETURNED FOR IGH IF IGH IS ZERO FORMALLY.
C
C     THE ALGOL PROCEDURE EXC CONTAINED IN BALANCE APPEARS IN
C     BALANC  IN LINE.  (NOTE THAT THE ALGOL ROLES OF IDENTIFIERS
C     K,L HAVE BEEN REVERSED.)
C
C This routine obtained from:
C Naval Surface Warfare Center Library of Mathematics Subroutines
C (January 1993)
C by Alfred H. Morris, Jr.
C Naval Surface Warfare Center
C Dahlgren Division
C Dahlgren VA 22448-5000
C
C-----------------------------------------------------------------------
C
C     ********** RADIX IS A MACHINE DEPENDENT PARAMETER SPECIFYING
C                THE BASE OF THE MACHINE FLOATING POINT REPRESENTATION.
C
                 RADIX = IPMPAR(4)
C
C                **********
C
      B2 = RADIX * RADIX
      K = 1
      L = N
      GO TO 100
C     ********** IN-LINE PROCEDURE FOR ROW AND
C                COLUMN EXCHANGE **********
   20 SCALE(M) = J
      IF (J .EQ. M) GO TO 50
C
      DO 30 I = 1, L
         F = A(I,J)
         A(I,J) = A(I,M)
         A(I,M) = F
   30 CONTINUE
C
      DO 40 I = K, N
         F = A(J,I)
         A(J,I) = A(M,I)
         A(M,I) = F
   40 CONTINUE
C
   50 GO TO (80,130), IEXC
C     ********** SEARCH FOR ROWS ISOLATING AN EIGENVALUE
C                AND PUSH THEM DOWN **********
   80 IF (L .EQ. 1) GO TO 280
      L = L - 1
C     ********** FOR J=L STEP -1 UNTIL 1 DO -- **********
  100 DO 120 JJ = 1, L
         J = L + 1 - JJ
C
         DO 110 I = 1, L
            IF (I .EQ. J) GO TO 110
            IF (A(J,I) .NE. 0.0) GO TO 120
  110    CONTINUE
C
         M = L
         IEXC = 1
         GO TO 20
  120 CONTINUE
C
      GO TO 140
C     ********** SEARCH FOR COLUMNS ISOLATING AN EIGENVALUE
C                AND PUSH THEM LEFT **********
  130 K = K + 1
C
  140 DO 170 J = K, L
C
         DO 150 I = K, L
            IF (I .EQ. J) GO TO 150
            IF (A(I,J) .NE. 0.0) GO TO 170
  150    CONTINUE
C
         M = K
         IEXC = 2
         GO TO 20
  170 CONTINUE
C     ********** NOW BALANCE THE SUBMATRIX IN ROWS K TO L **********
      DO 180 I = K, L
  180 SCALE(I) = 1.0
C     ********** ITERATIVE LOOP FOR NORM REDUCTION **********
  190 NOCONV = .FALSE.
C
      DO 270 I = K, L
         C = 0.0
         R = 0.0
C
         DO 200 J = K, L
            IF (J .EQ. I) GO TO 200
            C = C + ABS(A(J,I))
            R = R + ABS(A(I,J))
  200    CONTINUE
C     ********** GUARD AGAINST ZERO C OR R DUE TO UNDERFLOW **********
         IF (C .EQ. 0.0 .OR. R .EQ. 0.0) GO TO 270
         G = R / RADIX
         F = 1.0
         S = C + R
  210    IF (C .GE. G) GO TO 220
         F = F * RADIX
         C = C * B2
         GO TO 210
  220    G = R * RADIX
  230    IF (C .LT. G) GO TO 240
         F = F / RADIX
         C = C / B2
         GO TO 230
C     ********** NOW BALANCE **********
  240    IF ((C + R) / F .GE. 0.95 * S) GO TO 270
         G = 1.0 / F
         SCALE(I) = SCALE(I) * F
         NOCONV = .TRUE.
C
         DO 250 J = K, N
  250    A(I,J) = A(I,J) * G
C
         DO 260 J = 1, L
  260    A(J,I) = A(J,I) * F
C
  270 CONTINUE
C
      IF (NOCONV) GO TO 190
C
  280 LOW = K
      IGH = L
      RETURN
      END
      SUBROUTINE BALBAK(NM,N,LOW,IGH,SCALE,M,Z)
C
      INTEGER I,J,K,M,N,II,NM,IGH,LOW
      REAL SCALE(N),Z(NM,M)
      REAL S
C-----------------------------------------------------------------------
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE BALBAK,
C     NUM. MATH. 13, 293-304(1969) BY PARLETT AND REINSCH.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 315-326(1971).
C
C     THIS SUBROUTINE FORMS THE EIGENVECTORS OF A REAL GENERAL
C     MATRIX BY BACK TRANSFORMING THOSE OF THE CORRESPONDING
C     BALANCED MATRIX DETERMINED BY  BALANC.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        LOW AND IGH ARE INTEGERS DETERMINED BY  BALANC,
C
C        SCALE CONTAINS INFORMATION DETERMINING THE PERMUTATIONS
C          AND SCALING FACTORS USED BY  BALANC,
C
C        M IS THE NUMBER OF COLUMNS OF Z TO BE BACK TRANSFORMED,
C
C        Z CONTAINS THE REAL AND IMAGINARY PARTS OF THE EIGEN-
C          VECTORS TO BE BACK TRANSFORMED IN ITS FIRST M COLUMNS.
C
C     ON OUTPUT-
C
C        Z CONTAINS THE REAL AND IMAGINARY PARTS OF THE
C          TRANSFORMED EIGENVECTORS IN ITS FIRST M COLUMNS.
C
C This routine obtained from:
C Naval Surface Warfare Center Library of Mathematics Subroutines
C (January 1993)
C by Alfred H. Morris, Jr.
C Naval Surface Warfare Center
C Dahlgren Division
C Dahlgren VA 22448-5000
C
C-----------------------------------------------------------------------
C
      IF (M .EQ. 0) GO TO 200
      IF (IGH .EQ. LOW) GO TO 120
C
      DO 110 I = LOW, IGH
         S = SCALE(I)
C     ********** LEFT HAND EIGENVECTORS ARE BACK TRANSFORMED
C                IF THE FOREGOING STATEMENT IS REPLACED BY
C                S=1.0/SCALE(I). **********
         DO 100 J = 1, M
  100    Z(I,J) = Z(I,J) * S
C
  110 CONTINUE
C     ********- FOR I=LOW-1 STEP -1 UNTIL 1,
C               IGH+1 STEP 1 UNTIL N DO -- **********
  120 DO 140 II = 1, N
         I = II
         IF (I .GE. LOW .AND. I .LE. IGH) GO TO 140
         IF (I .LT. LOW) I = LOW - II
         K = SCALE(I)
         IF (K .EQ. I) GO TO 140
C
         DO 130 J = 1, M
            S = Z(I,J)
            Z(I,J) = Z(K,J)
            Z(K,J) = S
  130    CONTINUE
C
  140 CONTINUE
C
  200 RETURN
      END
      SUBROUTINE ELMHS0(NM,N,LOW,IGH,A,INT)
C
      INTEGER I,J,M,N,LA,NM,IGH,KP1,LOW,MM1,MP1
      REAL A(NM,N)
      REAL X,Y
C     REAL ABS
      REAL INT(IGH)
C-----------------------------------------------------------------------
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE ELMHES,
C     NUM. MATH. 12, 349-368(1968) BY MARTIN AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 339-358(1971).
C
C     GIVEN A REAL GENERAL MATRIX, THIS SUBROUTINE
C     REDUCES A SUBMATRIX SITUATED IN ROWS AND COLUMNS
C     LOW THROUGH IGH TO UPPER HESSENBERG FORM BY
C     STABILIZED ELEMENTARY SIMILARITY TRANSFORMATIONS.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        LOW AND IGH ARE INTEGERS DETERMINED BY THE BALANCING
C          SUBROUTINE  BALANC.  IF  BALANC  HAS NOT BEEN USED,
C          SET LOW=1, IGH=N,
C
C        A CONTAINS THE INPUT MATRIX.
C
C     ON OUTPUT-
C
C        A CONTAINS THE HESSENBERG MATRIX.  THE MULTIPLIERS
C          WHICH WERE USED IN THE REDUCTION ARE STORED IN THE
C          REMAINING TRIANGLE UNDER THE HESSENBERG MATRIX,
C
C        INT CONTAINS INFORMATION ON THE ROWS AND COLUMNS
C          INTERCHANGED IN THE REDUCTION.
C          ONLY ELEMENTS LOW THROUGH IGH ARE USED.
C
C This routine obtained from:
C Naval Surface Warfare Center Library of Mathematics Subroutines
C (January 1993)
C by Alfred H. Morris, Jr.
C Naval Surface Warfare Center
C Dahlgren Division
C Dahlgren VA 22448-5000
C
C-----------------------------------------------------------------------
C
      LA = IGH - 1
      KP1 = LOW + 1
      IF (LA .LT. KP1) GO TO 200
C
      DO 180 M = KP1, LA
         MM1 = M - 1
         X = 0.0
         I = M
C
         DO 100 J = M, IGH
            IF (ABS(A(J,MM1)) .LE. ABS(X)) GO TO 100
            X = A(J,MM1)
            I = J
  100    CONTINUE
C
         INT(M) = I
         IF (I .EQ. M) GO TO 130
C    ********** INTERCHANGE ROWS AND COLUMNS OF A **********
         DO 110 J = MM1, N
            Y = A(I,J)
            A(I,J) = A(M,J)
            A(M,J) = Y
  110    CONTINUE
C
         DO 120 J = 1, IGH
            Y = A(J,I)
            A(J,I) = A(J,M)
            A(J,M) = Y
  120    CONTINUE
C    ********** END INTERCHANGE **********
  130    IF (X .EQ. 0.0) GO TO 180
         MP1 = M + 1
C
         DO 160 I = MP1, IGH
            Y = A(I,MM1)
            IF (Y .EQ. 0.0) GO TO 160
            Y = Y / X
            A(I,MM1) = Y
C
            DO 140 J = M, N
  140       A(I,J) = A(I,J) - Y * A(M,J)
C
            DO 150 J = 1, IGH
  150       A(J,M) = A(J,M) + Y * A(J,I)
C
  160    CONTINUE
C
  180 CONTINUE
C
  200 RETURN
      END
      SUBROUTINE ELTRN0(NM,N,LOW,IGH,A,INT,Z)
C
      INTEGER I,J,N,KL,MM,MP,NM,IGH,LOW,MP1
      REAL A(NM,IGH),Z(NM,N)
      REAL INT(IGH)
C-----------------------------------------------------------------------
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE ELMTRANS,
C     NUM. MATH. 16, 181-204(1970) BY PETERS AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 372-395(1971).
C
C     THIS SUBROUTINE ACCUMULATES THE STABILIZED ELEMENTARY
C     SIMILARITY TRANSFORMATIONS USED IN THE REDUCTION OF A
C     REAL GENERAL MATRIX TO UPPER HESSENBERG FORM BY  ELMHS0.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        LOW AND IGH ARE INTEGERS DETERMINED BY THE BALANCING
C          SUBROUTINE  BALANC.  IF  BALANC  HAS NOT BEEN USED,
C          SET LOW=1, IGH=N,
C
C        A CONTAINS THE MULTIPLIERS WHICH WERE USED IN THE
C          REDUCTION BY  ELMHS0  IN ITS LOWER TRIANGLE
C          BELOW THE SUBDIAGONAL,
C
C        INT CONTAINS INFORMATION ON THE ROWS AND COLUMNS
C          INTERCHANGED IN THE REDUCTION BY  ELMHS0.
C          ONLY ELEMENTS LOW THROUGH IGH ARE USED.
C
C     ON OUTPUT-
C
C        Z CONTAINS THE TRANSFORMATION MATRIX PRODUCED IN THE
C          REDUCTION BY  ELMHS0.
C
C This routine obtained from:
C Naval Surface Warfare Center Library of Mathematics Subroutines
C (January 1993)
C by Alfred H. Morris, Jr.
C Naval Surface Warfare Center
C Dahlgren Division
C Dahlgren VA 22448-5000
C
C-----------------------------------------------------------------------
C
C     ********** INITIALIZE Z TO IDENTITY MATRIX **********
      DO 80 I = 1, N
C
         DO 60 J = 1, N
   60    Z(I,J) = 0.0
C
         Z(I,I) = 1.0
   80 CONTINUE
C
      KL = IGH - LOW - 1
      IF (KL .LT. 1) GO TO 200
C     ********** FOR MP=IGH-1 STEP -1 UNTIL LOW+1 DO -- **********
      DO 140 MM = 1, KL
         MP = IGH - MM
         MP1 = MP + 1
C
         DO 100 I = MP1, IGH
  100    Z(I,MP) = A(I,MP-1)
C
         I = INT(MP)
         IF (I .EQ. MP) GO TO 140
C
         DO 130 J = MP, IGH
            Z(MP,J) = Z(I,J)
            Z(I,J) = 0.0
  130    CONTINUE
C
         Z(I,MP) = 1.0
  140 CONTINUE
C
  200 RETURN
      END
      SUBROUTINE HQR2(NM,N,LOW,IGH,H,WR,WI,Z,IERR)
C
      INTEGER I,J,K,L,M,N,EN,II,JJ,LL,MM,NA,NM,NN,
     X        IGH,ITS,LOW,MP2,ENM2,IERR
      REAL H(NM,N),WR(N),WI(N),Z(NM,N)
      REAL P,Q,R,S,T,W,X,Y,RA,SA,VI,VR,ZZ,NORM,MACHEP,SPMPAR
C     REAL SQRT,ABS
C     INTEGER MIN0
      LOGICAL NOTLAS
      COMPLEX Z3
C     COMPLEX CMPLX
C     REAL REAL,AIMAG
C-----------------------------------------------------------------------
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE HQR2,
C     NUM. MATH. 16, 181-204(1970) BY PETERS AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 372-395(1971).
C
C     THIS SUBROUTINE FINDS THE EIGENVALUES AND EIGENVECTORS
C     OF A REAL UPPER HESSENBERG MATRIX BY THE QR METHOD.  THE
C     EIGENVECTORS OF A REAL GENERAL MATRIX CAN ALSO BE FOUND
C     IF  ELMHES  AND  ELTRAN  OR  ORTHES  AND  ORTRAN  HAVE
C     BEEN USED TO REDUCE THIS GENERAL MATRIX TO HESSENBERG FORM
C     AND TO ACCUMULATE THE SIMILARITY TRANSFORMATIONS.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        LOW AND IGH ARE INTEGERS DETERMINED BY THE BALANCING
C          SUBROUTINE  BALANC.  IF  BALANC  HAS NOT BEEN USED,
C          SET LOW=1, IGH=N,
C
C        H CONTAINS THE UPPER HESSENBERG MATRIX,
C
C        Z CONTAINS THE TRANSFORMATION MATRIX PRODUCED BY  ELTRAN
C          AFTER THE REDUCTION BY  ELMHES, OR BY  ORTRAN  AFTER THE
C          REDUCTION BY  ORTHES, IF PERFORMED.  IF THE EIGENVECTORS
C          OF THE HESSENBERG MATRIX ARE DESIRED, Z MUST CONTAIN THE
C          IDENTITY MATRIX.
C
C     ON OUTPUT-
C
C        H HAS BEEN DESTROYED,
C
C        WR AND WI CONTAIN THE REAL AND IMAGINARY PARTS,
C          RESPECTIVELY, OF THE EIGENVALUES.  THE EIGENVALUES
C          ARE UNORDERED EXCEPT THAT COMPLEX CONJUGATE PAIRS
C          OF VALUES APPEAR CONSECUTIVELY WITH THE EIGENVALUE
C          HAVING THE POSITIVE IMAGINARY PART FIRST.  IF AN
C          ERROR EXIT IS MADE, THE EIGENVALUES SHOULD BE CORRECT
C          FOR INDICES IERR+1,...,N,
C
C        Z CONTAINS THE REAL AND IMAGINARY PARTS OF THE EIGENVECTORS.
C          IF THE I-TH EIGENVALUE IS REAL, THE I-TH COLUMN OF Z
C          CONTAINS ITS EIGENVECTOR.  IF THE I-TH EIGENVALUE IS COMPLEX
C          WITH POSITIVE IMAGINARY PART, THE I-TH AND (I+1)-TH
C          COLUMNS OF Z CONTAIN THE REAL AND IMAGINARY PARTS OF ITS
C          EIGENVECTOR.  THE EIGENVECTORS ARE UNNORMALIZED.  IF AN
C          ERROR EXIT IS MADE, NONE OF THE EIGENVECTORS HAS BEEN FOUND,
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          J          IF THE J-TH EIGENVALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C     ARITHMETIC IS REAL EXCEPT FOR THE REPLACEMENT OF THE ALGOL
C     PROCEDURE CDIV BY COMPLEX DIVISION.
C
C This routine obtained from:
C Naval Surface Warfare Center Library of Mathematics Subroutines
C (January 1993)
C by Alfred H. Morris, Jr.
C Naval Surface Warfare Center
C Dahlgren Division
C Dahlgren VA 22448-5000
C
C-----------------------------------------------------------------------
C
C     ********** MACHEP IS A MACHINE DEPENDENT PARAMETER. ASSIGN
C                MACHEP THE VALUE U WHERE U IS THE SMALLEST POSITIVE
C                FLOATING POINT NUMBER SUCH THAT 1.0 + U .GT. 1.0 .
C
                 MACHEP = SPMPAR(1)
C
C                **********
C
      IERR = 0
      NORM = 0.0
      K = 1
C     ********** STORE ROOTS ISOLATED BY BALANC
C                AND COMPUTE MATRIX NORM **********
      DO 50 I = 1, N
C
         DO 40 J = K, N
   40    NORM = NORM + ABS(H(I,J))
C
         K = I
         IF (I .GE. LOW .AND. I .LE. IGH) GO TO 50
         WR(I) = H(I,I)
         WI(I) = 0.0
   50 CONTINUE
C
      EN = IGH
      T = 0.0
C     ********** SEARCH FOR NEXT EIGENVALUES **********
   60 IF (EN .LT. LOW) GO TO 340
      ITS = 0
      NA = EN - 1
      ENM2 = NA - 1
C     ********** LOOK FOR SINGLE SMALL SUB-DIAGONAL ELEMENT
C                FOR L=EN STEP -1 UNTIL LOW DO -- **********
   70 DO 80 LL = LOW, EN
         L = EN + LOW - LL
         IF (L .EQ. LOW) GO TO 100
         S = ABS(H(L-1,L-1)) + ABS(H(L,L))
         IF (S .EQ. 0.0) S = NORM
         IF (ABS(H(L,L-1)) .LE. MACHEP * S) GO TO 100
   80 CONTINUE
C     ********** FORM SHIFT **********
  100 X = H(EN,EN)
      IF (L .EQ. EN) GO TO 270
      Y = H(NA,NA)
      W = H(EN,NA) * H(NA,EN)
      IF (L .EQ. NA) GO TO 280
      IF (ITS .EQ. 30) GO TO 1000
      IF (ITS .NE. 10 .AND. ITS .NE. 20) GO TO 130
C     ********** FORM EXCEPTIONAL SHIFT **********
      T = T + X
C
      DO 120 I = LOW, EN
  120 H(I,I) = H(I,I) - X
C
      S = ABS(H(EN,NA)) + ABS(H(NA,ENM2))
      X = 0.75 * S
      Y = X
      W = -0.4375 * S * S
  130 ITS = ITS + 1
C     ********** LOOK FOR TWO CONSECUTIVE SMALL
C                SUB-DIAGONAL ELEMENTS.
C                FOR M=EN-2 STEP -1 UNTIL L DO -- **********
      DO 140 MM = L, ENM2
         M = ENM2 + L - MM
         ZZ = H(M,M)
         R = X - ZZ
         S = Y - ZZ
         P = (R * S - W) / H(M+1,M) + H(M,M+1)
         Q = H(M+1,M+1) - ZZ - R - S
         R = H(M+2,M+1)
         S = ABS(P) + ABS(Q) + ABS(R)
         P = P / S
         Q = Q / S
         R = R / S
         IF (M .EQ. L) GO TO 150
         IF (ABS(H(M,M-1)) * (ABS(Q) + ABS(R)) .LE. MACHEP * ABS(P)
     X    * (ABS(H(M-1,M-1)) + ABS(ZZ) + ABS(H(M+1,M+1)))) GO TO 150
  140 CONTINUE
C
  150 MP2 = M + 2
C
      DO 160 I = MP2, EN
         H(I,I-2) = 0.0
         IF (I .EQ. MP2) GO TO 160
         H(I,I-3) = 0.0
  160 CONTINUE
C     ********** DOUBLE QR STEP INVOLVING ROWS L TO EN AND
C                COLUMNS M TO EN **********
      DO 260 K = M, NA
         NOTLAS = K .NE. NA
         IF (K .EQ. M) GO TO 170
         P = H(K,K-1)
         Q = H(K+1,K-1)
         R = 0.0
         IF (NOTLAS) R = H(K+2,K-1)
         X = ABS(P) + ABS(Q) + ABS(R)
         IF (X .EQ. 0.0) GO TO 260
         P = P / X
         Q = Q / X
         R = R / X
  170    S = SQRT(P*P + Q*Q + R*R)
         IF (P .LT. 0.0) S = -S
         IF (K .EQ. M) GO TO 180
         H(K,K-1) = -S * X
         GO TO 190
  180    IF (L .NE. M) H(K,K-1) = -H(K,K-1)
  190    P = P + S
         X = P / S
         Y = Q / S
         ZZ = R / S
         Q = Q / P
         R = R / P
C     ********** ROW MODIFICATION **********
         DO 210 J = K, N
            P = H(K,J) + Q * H(K+1,J)
            IF (.NOT. NOTLAS) GO TO 200
            P = P + R * H(K+2,J)
            H(K+2,J) = H(K+2,J) - P * ZZ
  200       H(K+1,J) = H(K+1,J) - P * Y
            H(K,J) = H(K,J) - P * X
  210    CONTINUE
C
         J = MIN0(EN,K+3)
C     ********** COLUMN MODIFICATION **********
         DO 230 I = 1, J
            P = X * H(I,K) + Y * H(I,K+1)
            IF (.NOT. NOTLAS) GO TO 220
            P = P + ZZ * H(I,K+2)
            H(I,K+2) = H(I,K+2) - P * R
  220       H(I,K+1) = H(I,K+1) - P * Q
            H(I,K) = H(I,K) - P
  230    CONTINUE
C     ********** ACCUMULATE TRANSFORMATIONS **********
         DO 250 I = LOW, IGH
            P = X * Z(I,K) + Y * Z(I,K+1)
            IF (.NOT. NOTLAS) GO TO 240
            P = P + ZZ * Z(I,K+2)
            Z(I,K+2) = Z(I,K+2) - P * R
  240       Z(I,K+1) = Z(I,K+1) - P * Q
            Z(I,K) = Z(I,K) - P
  250    CONTINUE
C
  260 CONTINUE
C
      GO TO 70
C     ********** ONE ROOT FOUND **********
  270 H(EN,EN) = X + T
      WR(EN) = H(EN,EN)
      WI(EN) = 0.0
      EN = NA
      GO TO 60
C     ********** TWO ROOTS FOUND **********
  280 P = (Y - X) / 2.0
      Q = P * P + W
      ZZ = SQRT(ABS(Q))
      H(EN,EN) = X + T
      X = H(EN,EN)
      H(NA,NA) = Y + T
      IF (Q .LT. 0.0) GO TO 320
C     ********** REAL PAIR **********
      IF (P .LT. 0.0) ZZ = -ZZ
      ZZ = P + ZZ
      WR(NA) = X + ZZ
      WR(EN) = WR(NA)
      IF (ZZ .NE. 0.0) WR(EN) = X - W / ZZ
      WI(NA) = 0.0
      WI(EN) = 0.0
      X = H(EN,NA)
      S = ABS(X) + ABS(ZZ)
      P = X / S
      Q = ZZ / S
      R = SQRT(P*P+Q*Q)
      P = P / R
      Q = Q / R
C     ********** ROW MODIFICATION **********
      DO 290 J = NA, N
         ZZ = H(NA,J)
         H(NA,J) = Q * ZZ + P * H(EN,J)
         H(EN,J) = Q * H(EN,J) - P * ZZ
  290 CONTINUE
C     ********** COLUMN MODIFICATION **********
      DO 300 I = 1, EN
         ZZ = H(I,NA)
         H(I,NA) = Q * ZZ + P * H(I,EN)
         H(I,EN) = Q * H(I,EN) - P * ZZ
  300 CONTINUE
C     ********** ACCUMULATE TRANSFORMATIONS **********
      DO 310 I = LOW, IGH
         ZZ = Z(I,NA)
         Z(I,NA) = Q * ZZ + P * Z(I,EN)
         Z(I,EN) = Q * Z(I,EN) - P * ZZ
  310 CONTINUE
C
      GO TO 330
C     ********** COMPLEX PAIR **********
  320 WR(NA) = X + P
      WR(EN) = X + P
      WI(NA) = ZZ
      WI(EN) = -ZZ
  330 EN = ENM2
      GO TO 60
C     ********** ALL ROOTS FOUND.  BACKSUBSTITUTE TO FIND
C                VECTORS OF UPPER TRIANGULAR FORM **********
  340 IF (NORM .EQ. 0.0) GO TO 1001
C     ********** FOR EN=N STEP -1 UNTIL 1 DO -- **********
      DO 800 NN = 1, N
         EN = N + 1 - NN
         P = WR(EN)
         Q = WI(EN)
         NA = EN - 1
         IF (Q) 710, 600, 800
C     ********** REAL VECTOR **********
  600    M = EN
         H(EN,EN) = 1.0
         IF (NA .EQ. 0) GO TO 800
C     ********** FOR I=EN-1 STEP -1 UNTIL 1 DO -- **********
         DO 700 II = 1, NA
            I = EN - II
            W = H(I,I) - P
            R = H(I,EN)
            IF (M .GT. NA) GO TO 620
C
            DO 610 J = M, NA
  610       R = R + H(I,J) * H(J,EN)
C
  620       IF (WI(I) .GE. 0.0) GO TO 630
            ZZ = W
            S = R
            GO TO 700
  630       M = I
            IF (WI(I) .NE. 0.0) GO TO 640
            T = W
            IF (W .EQ. 0.0) T = MACHEP * NORM
            H(I,EN) = -R / T
            GO TO 700
C     ********** SOLVE REAL EQUATIONS **********
  640       X = H(I,I+1)
            Y = H(I+1,I)
            Q = (WR(I) - P) * (WR(I) - P) + WI(I) * WI(I)
            T = (X * S - ZZ * R) / Q
            H(I,EN) = T
            IF (ABS(X) .LE. ABS(ZZ)) GO TO 650
            H(I+1,EN) = (-R - W * T) / X
            GO TO 700
  650       H(I+1,EN) = (-S - Y * T) / ZZ
  700    CONTINUE
C     ********** END REAL VECTOR **********
         GO TO 800
C     ********** COMPLEX VECTOR **********
  710    M = NA
C     ********** LAST VECTOR COMPONENT CHOSEN IMAGINARY SO THAT
C                EIGENVECTOR MATRIX IS TRIANGULAR **********
         IF (ABS(H(EN,NA)) .LE. ABS(H(NA,EN))) GO TO 720
         H(NA,NA) = Q / H(EN,NA)
         H(NA,EN) = -(H(EN,EN) - P) / H(EN,NA)
         GO TO 730
  720    Z3 = CMPLX(0.0,-H(NA,EN)) / CMPLX(H(NA,NA)-P,Q)
         H(NA,NA) = REAL(Z3)
         H(NA,EN) = AIMAG(Z3)
  730    H(EN,NA) = 0.0
         H(EN,EN) = 1.0
         ENM2 = NA - 1
         IF (ENM2 .EQ. 0) GO TO 800
C     ********** FOR I=EN-2 STEP -1 UNTIL 1 DO -- **********
         DO 790 II = 1, ENM2
            I = NA - II
            W = H(I,I) - P
            RA = 0.0
            SA = H(I,EN)
C
            DO 760 J = M, NA
               RA = RA + H(I,J) * H(J,NA)
               SA = SA + H(I,J) * H(J,EN)
  760       CONTINUE
C
            IF (WI(I) .GE. 0.0) GO TO 770
            ZZ = W
            R = RA
            S = SA
            GO TO 790
  770       M = I
            IF (WI(I) .NE. 0.0) GO TO 780
            Z3 = CMPLX(-RA,-SA) / CMPLX(W,Q)
            H(I,NA) = REAL(Z3)
            H(I,EN) = AIMAG(Z3)
            GO TO 790
C     ********** SOLVE COMPLEX EQUATIONS **********
  780       X = H(I,I+1)
            Y = H(I+1,I)
            VR = (WR(I) - P) * (WR(I) - P) + WI(I) * WI(I) - Q * Q
            VI = (WR(I) - P) * 2.0 * Q
            IF (VR .EQ. 0.0 .AND. VI .EQ. 0.0) VR = MACHEP * NORM
     X       * (ABS(W) + ABS(Q) + ABS(X) + ABS(Y) + ABS(ZZ))
            Z3 = CMPLX(X*R-ZZ*RA+Q*SA,X*S-ZZ*SA-Q*RA) / CMPLX(VR,VI)
            H(I,NA) = REAL(Z3)
            H(I,EN) = AIMAG(Z3)
            IF (ABS(X) .LE. ABS(ZZ) + ABS(Q)) GO TO 785
            H(I+1,NA) = (-RA - W * H(I,NA) + Q * H(I,EN)) / X
            H(I+1,EN) = (-SA - W * H(I,EN) - Q * H(I,NA)) / X
            GO TO 790
  785       Z3 = CMPLX(-R-Y*H(I,NA),-S-Y*H(I,EN)) / CMPLX(ZZ,Q)
            H(I+1,NA) = REAL(Z3)
            H(I+1,EN) = AIMAG(Z3)
  790    CONTINUE
C     ********** END COMPLEX VECTOR **********
  800 CONTINUE
C     ********** END BACK SUBSTITUTION.
C                VECTORS OF ISOLATED ROOTS **********
      DO 840 I = 1, N
         IF (I .GE. LOW .AND. I .LE. IGH) GO TO 840
C
         DO 820 J = I, N
  820    Z(I,J) = H(I,J)
C
  840 CONTINUE
C     ********** MULTIPLY BY TRANSFORMATION MATRIX TO GIVE
C                VECTORS OF ORIGINAL FULL MATRIX.
C                FOR J=N STEP -1 UNTIL LOW DO -- **********
      DO 880 JJ = LOW, N
         J = N + LOW - JJ
         M = MIN0(J,IGH)
C
         DO 880 I = LOW, IGH
            ZZ = 0.0
C
            DO 860 K = LOW, M
  860       ZZ = ZZ + Z(I,K) * H(K,J)
C
            Z(I,J) = ZZ
  880 CONTINUE
C
      GO TO 1001
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
 1000 IERR = EN
 1001 RETURN
      END
      INTEGER FUNCTION IPMPAR(I)
C Arguments:
      INTEGER I
C Local variables:
      INTEGER IMACH(10)
C
C-----------------------------------------------------------------------
C
C     IPMPAR PROVIDES THE INTEGER MACHINE CONSTANTS FOR THE COMPUTER
C     THAT IS USED. IT IS ASSUMED THAT THE ARGUMENT I IS AN INTEGER
C     HAVING ONE OF THE VALUES 1-10. IPMPAR(I) HAS THE VALUE ...
C
C  INTEGERS.
C
C     ASSUME INTEGERS ARE REPRESENTED IN THE N-DIGIT, BASE-A FORM
C
C               SIGN ( X(N-1)*A**(N-1) + ... + X(1)*A + X(0) )
C
C               WHERE 0 .LE. X(I) .LT. A FOR I=0,...,N-1.
C
C     IPMPAR(1) = A, THE BASE.
C
C     IPMPAR(2) = N, THE NUMBER OF BASE-A DIGITS.
C
C     IPMPAR(3) = A**N - 1, THE LARGEST MAGNITUDE.
C
C  FLOATING-POINT NUMBERS.
C
C     IT IS ASSUMED THAT THE SINGLE AND DOUBLE PRECISION FLOATING
C     POINT ARITHMETICS HAVE THE SAME BASE, SAY B, AND THAT THE
C     NONZERO NUMBERS ARE REPRESENTED IN THE FORM
C
C               SIGN (B**E) * (X(1)/B + ... + X(M)/B**M)
C
C               WHERE X(I) = 0,1,...,B-1 FOR I=1,...,M,
C               X(1) .GE. 1, AND EMIN .LE. E .LE. EMAX.
C
C     IPMPAR(4) = B, THE BASE.
C
C  SINGLE-PRECISION
C
C     IPMPAR(5) = M, THE NUMBER OF BASE-B DIGITS.
C
C     IPMPAR(6) = EMIN, THE SMALLEST EXPONENT E.
C
C     IPMPAR(7) = EMAX, THE LARGEST EXPONENT E.
C
C  DOUBLE-PRECISION
C
C     IPMPAR(8) = M, THE NUMBER OF BASE-B DIGITS.
C
C     IPMPAR(9) = EMIN, THE SMALLEST EXPONENT E.
C
C     IPMPAR(10) = EMAX, THE LARGEST EXPONENT E.
C
C-----------------------------------------------------------------------
C
C     TO DEFINE THIS FUNCTION FOR THE COMPUTER BEING USED, ACTIVATE
C     THE DATA STATMENTS FOR THE COMPUTER BY REMOVING THE C FROM
C     COLUMN 1. (ALL THE OTHER DATA STATEMENTS SHOULD HAVE C IN
C     COLUMN 1.)
C
C     IF DATA STATEMENTS ARE NOT GIVEN FOR THE COMPUTER BEING USED,
C     THEN THE FORTRAN MANUAL FOR THE COMPUTER NORMALLY GIVES THE
C     CONSTANTS IPMPAR(1), IPMPAR(2), AND IPMPAR(3) FOR THE INTEGER
C     ARITHMETIC. HOWEVER, HELP MAY BE NEEDED TO OBTAIN THE CONSTANTS
C     IPMPAR(4),...,IPMPAR(10) FOR THE SINGLE AND DOUBLE PRECISION
C     ARITHMETICS. THE SUBROUTINES MACH AND RADIX ARE PROVIDED FOR
C     THIS PURPOSE.
C
C-----------------------------------------------------------------------
C
C     IPMPAR IS AN ADAPTATION OF THE FUNCTION I1MACH, WRITTEN BY
C     P.A. FOX, A.D. HALL, AND N.L. SCHRYER (BELL LABORATORIES).
C     IPMPAR WAS FORMED BY A.H. MORRIS (NSWC). THE CONSTANTS ARE
C     FROM BELL LABORATORIES, NSWC, AND OTHER SOURCES.
C
C This routine obtained from:
C Naval Surface Warfare Center Library of Mathematics Subroutines
C (January 1993)
C by Alfred H. Morris, Jr.
C Naval Surface Warfare Center
C Dahlgren Division
C Dahlgren VA 22448-5000
C
C History:
C 95.11.16 (BTD) Explicit declaration of all variables.
C
C-----------------------------------------------------------------------
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   33 /
C     DATA IMACH( 3) / 8589934591 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   24 /
C     DATA IMACH( 6) / -256 /
C     DATA IMACH( 7) /  255 /
C     DATA IMACH( 8) /   60 /
C     DATA IMACH( 9) / -256 /
C     DATA IMACH(10) /  255 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700 SYSTEM.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   39 /
C     DATA IMACH( 3) / 549755813887 /
C     DATA IMACH( 4) /    8 /
C     DATA IMACH( 5) /   13 /
C     DATA IMACH( 6) /  -50 /
C     DATA IMACH( 7) /   76 /
C     DATA IMACH( 8) /   26 /
C     DATA IMACH( 9) /  -50 /
C     DATA IMACH(10) /   76 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 6700/7700 SYSTEMS.
C
C     DATA IMACH( 1) /      2 /
C     DATA IMACH( 2) /     39 /
C     DATA IMACH( 3) / 549755813887 /
C     DATA IMACH( 4) /      8 /
C     DATA IMACH( 5) /     13 /
C     DATA IMACH( 6) /    -50 /
C     DATA IMACH( 7) /     76 /
C     DATA IMACH( 8) /     26 /
C     DATA IMACH( 9) / -32754 /
C     DATA IMACH(10) /  32780 /
C
C     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES
C     60 BIT ARITHMETIC, AND THE CDC CYBER 995 64 BIT
C     ARITHMETIC (NOS OPERATING SYSTEM).
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   48 /
C     DATA IMACH( 3) / 281474976710655 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   48 /
C     DATA IMACH( 6) / -974 /
C     DATA IMACH( 7) / 1070 /
C     DATA IMACH( 8) /   95 /
C     DATA IMACH( 9) / -926 /
C     DATA IMACH(10) / 1070 /
C
C     MACHINE CONSTANTS FOR THE CDC CYBER 995 64 BIT
C     ARITHMETIC (NOS/VE OPERATING SYSTEM).
C
C     DATA IMACH( 1) /     2 /
C     DATA IMACH( 2) /    63 /
C     DATA IMACH( 3) / 9223372036854775807 /
C     DATA IMACH( 4) /     2 /
C     DATA IMACH( 5) /    48 /
C     DATA IMACH( 6) / -4096 /
C     DATA IMACH( 7) /  4095 /
C     DATA IMACH( 8) /    96 /
C     DATA IMACH( 9) / -4096 /
C     DATA IMACH(10) /  4095 /
C
C     MACHINE CONSTANTS FOR THE CRAY 1.
C
C     DATA IMACH( 1) /     2 /
C     DATA IMACH( 2) /    63 /
C     DATA IMACH( 3) / 9223372036854775807 /
C     DATA IMACH( 4) /     2 /
C     DATA IMACH( 5) /    48 /
C     DATA IMACH( 6) / -8192 /
C     DATA IMACH( 7) /  8191 /
C     DATA IMACH( 8) /    96 /
C     DATA IMACH( 9) / -8192 /
C     DATA IMACH(10) /  8191 /
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   15 /
C     DATA IMACH( 3) / 32767 /
C     DATA IMACH( 4) /   16 /
C     DATA IMACH( 5) /    6 /
C     DATA IMACH( 6) /  -64 /
C     DATA IMACH( 7) /   63 /
C     DATA IMACH( 8) /   14 /
C     DATA IMACH( 9) /  -64 /
C     DATA IMACH(10) /   63 /
C
C     MACHINE CONSTANTS FOR THE HARRIS 220.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   23 /
C     DATA IMACH( 3) / 8388607 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   23 /
C     DATA IMACH( 6) / -127 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   38 /
C     DATA IMACH( 9) / -127 /
C     DATA IMACH(10) /  127 /
C
C     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   35 /
C     DATA IMACH( 3) / 34359738367 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   27 /
C     DATA IMACH( 6) / -127 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   63 /
C     DATA IMACH( 9) / -127 /
C     DATA IMACH(10) /  127 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     3 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   15 /
C     DATA IMACH( 3) / 32767 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   23 /
C     DATA IMACH( 6) / -128 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   39 /
C     DATA IMACH( 9) / -128 /
C     DATA IMACH(10) /  127 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     4 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   15 /
C     DATA IMACH( 3) / 32767 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   23 /
C     DATA IMACH( 6) / -128 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   55 /
C     DATA IMACH( 9) / -128 /
C     DATA IMACH(10) /  127 /
C
C     MACHINE CONSTANTS FOR THE HP 9000.
C
C     DATA IMACH( 1) /     2 /
C     DATA IMACH( 2) /    31 /
C     DATA IMACH( 3) / 2147483647 /
C     DATA IMACH( 4) /     2 /
C     DATA IMACH( 5) /    24 /
C     DATA IMACH( 6) /  -126 /
C     DATA IMACH( 7) /   128 /
C     DATA IMACH( 8) /    53 /
C     DATA IMACH( 9) / -1021 /
C     DATA IMACH(10) /  1024 /
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE AMDAHL 470/V6, THE ICL 2900, THE ITEL AS/6,
C     THE XEROX SIGMA 5/7/9 AND THE SEL SYSTEMS 85/86.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   31 /
C     DATA IMACH( 3) / 2147483647 /
C     DATA IMACH( 4) /   16 /
C     DATA IMACH( 5) /    6 /
C     DATA IMACH( 6) /  -64 /
C     DATA IMACH( 7) /   63 /
C     DATA IMACH( 8) /   14 /
C     DATA IMACH( 9) /  -64 /
C     DATA IMACH(10) /   63 /
C
C     MACHINE CONSTANTS FOR THE IBM PC - MICROSOFT FORTRAN,
C     RM FORTRAN, PROFESSIONAL FORTRAN, AND LAHEY FORTRAN.
C
      DATA IMACH( 1) /     2 /
      DATA IMACH( 2) /    31 /
      DATA IMACH( 3) / 2147483647 /
      DATA IMACH( 4) /     2 /
      DATA IMACH( 5) /    24 /
      DATA IMACH( 6) /  -125 /
      DATA IMACH( 7) /   128 /
      DATA IMACH( 8) /    53 /
      DATA IMACH( 9) / -1021 /
      DATA IMACH(10) /  1024 /
C
C     MACHINE CONSTANTS FOR THE MICROVAX - VMS FORTRAN.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   31 /
C     DATA IMACH( 3) / 2147483647 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   24 /
C     DATA IMACH( 6) / -127 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   56 /
C     DATA IMACH( 9) / -127 /
C     DATA IMACH(10) /  127 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA PROCESSOR).
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   35 /
C     DATA IMACH( 3) / 34359738367 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   27 /
C     DATA IMACH( 6) / -128 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   54 /
C     DATA IMACH( 9) / -101 /
C     DATA IMACH(10) /  127 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KI PROCESSOR).
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   35 /
C     DATA IMACH( 3) / 34359738367 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   27 /
C     DATA IMACH( 6) / -128 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   62 /
C     DATA IMACH( 9) / -128 /
C     DATA IMACH(10) /  127 /
C
C     MACHINE CONSTANTS FOR THE PDP-11 FORTRAN SUPPORTING
C     32-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   31 /
C     DATA IMACH( 3) / 2147483647 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   24 /
C     DATA IMACH( 6) / -127 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   56 /
C     DATA IMACH( 9) / -127 /
C     DATA IMACH(10) /  127 /
C
C     MACHINE CONSTANTS FOR THE PDP-11 FORTRAN SUPPORTING
C     16-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   15 /
C     DATA IMACH( 3) / 32767 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   24 /
C     DATA IMACH( 6) / -127 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   56 /
C     DATA IMACH( 9) / -127 /
C     DATA IMACH(10) /  127 /
C
C     MACHINE CONSTANTS FOR THE SUN 3.
C
C     DATA IMACH( 1) /     2 /
C     DATA IMACH( 2) /    31 /
C     DATA IMACH( 3) / 2147483647 /
C     DATA IMACH( 4) /     2 /
C     DATA IMACH( 5) /    24 /
C     DATA IMACH( 6) /  -125 /
C     DATA IMACH( 7) /   128 /
C     DATA IMACH( 8) /    53 /
C     DATA IMACH( 9) / -1021 /
C     DATA IMACH(10) /  1024 /
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   35 /
C     DATA IMACH( 3) / 34359738367 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   27 /
C     DATA IMACH( 6) / -128 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   60 /
C     DATA IMACH( 9) /-1024 /
C     DATA IMACH(10) / 1023 /
C
C     MACHINE CONSTANTS FOR THE VAX 11/780.
C
C     DATA IMACH( 1) /    2 /
C     DATA IMACH( 2) /   31 /
C     DATA IMACH( 3) / 2147483647 /
C     DATA IMACH( 4) /    2 /
C     DATA IMACH( 5) /   24 /
C     DATA IMACH( 6) / -127 /
C     DATA IMACH( 7) /  127 /
C     DATA IMACH( 8) /   56 /
C     DATA IMACH( 9) / -127 /
C     DATA IMACH(10) /  127 /
C
      IPMPAR = IMACH(I)
      RETURN
      END
      REAL FUNCTION SPMPAR (I)
C Arguments:
      INTEGER I
C-----------------------------------------------------------------------
C
C     SPMPAR PROVIDES THE SINGLE PRECISION MACHINE CONSTANTS FOR
C     THE COMPUTER BEING USED. IT IS ASSUMED THAT THE ARGUMENT
C     I IS AN INTEGER HAVING ONE OF THE VALUES 1, 2, OR 3. IF THE
C     SINGLE PRECISION ARITHMETIC BEING USED HAS M BASE B DIGITS AND
C     ITS SMALLEST AND LARGEST EXPONENTS ARE EMIN AND EMAX, THEN
C
C        SPMPAR(1) = B**(1 - M), THE MACHINE PRECISION,
C
C        SPMPAR(2) = B**(EMIN - 1), THE SMALLEST MAGNITUDE,
C
C        SPMPAR(3) = B**EMAX*(1 - B**(-T)), THE LARGEST MAGNITUDE.
C
C-----------------------------------------------------------------------
C     WRITTEN BY
C        ALFRED H. MORRIS, JR.
C        NAVAL SURFACE WARFARE CENTER
C        DAHLGREN VIRGINIA
C
C This routine obtained from:
C Naval Surface Warfare Center Library of Mathematics Subroutines
C (January 1993)
C by Alfred H. Morris, Jr.
C Naval Surface Warfare Center
C Dahlgren Division
C Dahlgren VA 22448-5000
C
C-----------------------------------------------------------------------
      INTEGER EMAX,EMIN,IBETA,IPMPAR,M
      REAL B,BINV,BM1,ONE,W,Z
C
      IF (I .GT. 1) GO TO 10
         B = IPMPAR(4)
         M = IPMPAR(5)
         SPMPAR = B**(1 - M)
         RETURN
C
   10 IF (I .GT. 2) GO TO 20
         B = IPMPAR(4)
         EMIN = IPMPAR(6)
         ONE = FLOAT(1)
         BINV = ONE/B
         W = B**(EMIN + 2)
         SPMPAR = ((W * BINV) * BINV) * BINV
         RETURN
C
   20 IBETA = IPMPAR(4)
      M = IPMPAR(5)
      EMAX = IPMPAR(7)
C
      B = IBETA
      BM1 = IBETA - 1
      ONE = FLOAT(1)
      Z = B**(M - 1)
      W = ((Z - ONE)*B + BM1)/(B*Z)
C
      Z = B**(EMAX - 2)
      SPMPAR = ((W * Z) * B) * B
      RETURN
      END

      PROGRAM TSTFFT
C Parameters:
      INTEGER MX,MY,MZ
        PARAMETER (MX=100, MY=100, MZ=100)
C Local variables:
      INTEGER IN,N,NX,NY,NZ
      INTEGER NF235(45)
      COMPLEX C(MX,MY,MZ),CW(MX,MY,MZ)
C***********************************************************************
C Purpose:
C Tests different 3D FFT implementations (CPU time).
C Required routines:
C cfft99f.o  cxfft3.o  cxfft3n.o  
C errmsg.o  fourx.o 
C gpfa.o  timeit_sgi.o  tst.o  wrimsg.o gen.o
C
C History:
C 94.06.20 (PJF): Original version
C 94.12.18 (BTD): Minor changes in output formatting.
C                 Explicit declaration of all variables.
C 95.07.12 (BTD): Minor changes in formatting.
C 96.11.14 (PJF)  getset not needed
C Copyright (C) 1994,1995 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C
C***********************************************************************
C Elements of NF235 are numbers.le.4096  which can be factored by 2,3,5:
       DATA NF235/2,3,4,5,6,8,9,10,12,15,16,18,20,24,25,27,30,32,36,40,
     &    45,48,50,54,60,64,72,75,80,81,90,96,100,108,120,125,128,135,
     &    144,150,160,162,180,192,200/
       PRINT *,"Calculation time for different 3-D FFT's methods"
       PRINT *,"================================================ " 
       PRINT *," "
       open(unit=20,file='err.dat',status='unknown')
       open(unit=21,file='res.dat',status='unknown')
       WRITE(21,6021)
 6021 FORMAT(' CPU time (sec) for different 3-D FFT methods',/,
     &   ' Machine=_______',/,
     &   ' parameter LVR =_____',/,
     &   ' LVR="length of vector registers" in gpfa2f,gpfa3f,gpfa5f',/,
     &   '==========================================================',/,
     &   '                     Brenner      Temperton    ',
     &   '  Temperton',/,
     &   '   NX  NY  NZ        (FOURX)        (Old)      ',
     &   '    (GPFA)')
      rewind(20)
      DO 10 IN=1,31
         N=NF235(IN)
         NX=N
         NY=N
         NZ=N
         CALL CASE(C,CW,NX,NY,NZ)
10    CONTINUE
      STOP
      END
      SUBROUTINE CASE(C,CW,NX,NY,NZ)
C Arguments:
      INTEGER NX,NY,NZ
      COMPLEX C(NX,NY,NZ),CW(NX,NY,NZ)
C Local variables:
      INTEGER NN(3)
      REAL T0,T1,T2,T3
      COMPLEX C1, C2, C3, C4, C5, C6
C***********************************************************************
C Purpose: interface to 3D FFT codes (for use in FFT tests)
C History:
C 94.06.20 (PJF): Original version
C 94.12.19 (BTD): Explicit declaration of all variables.
C
C Copyright (C) 1994, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
***********************************************************************C
C--------- BRENNR
         NN(1)=NX
         NN(2)=NY
         NN(3)=NZ
         call  gen(c,nx,ny,nz)
         CALL TIMEIT('BREN',T0)         
         CALL FOURX(C,NN,3,1)
         CALL TIMEIT('BREN',T1)
         c1=c(1,1,1)
         c2=c(2,1,1)

C--------- TEMP-OLD
         call  gen(c,nx,ny,nz)
         CALL TIMEIT('OLD',T0)
         CALL CXFFT3(C,NX,NY,NZ,1,CW)
         CALL TIMEIT('OLD',T2)
         c3=c(1,1,1)
         c4=c(2,1,1)

C--------- TEMP-NEW
         call  gen(c,nx,ny,nz)
         CALL TIMEIT('NEW',T0)
         CALL CXFFT3n (C,NX,NY,NZ,1)
         CALL TIMEIT('NEW',T3)
         c5=c(1,1,1)
         c6=c(2,1,1)
C--------- Print
         WRITE(21, '(1x,3i4,3F15.6)') NX,NY,NZ,T1,T2,T3 
         write(20,100) nx, c1,c2
         write(20,100) nx, c3,c4
         write(20,100) nx, c5,c6
 100     format(1x,i5,4g15.4)
         RETURN
         END
      subroutine gen(c,nx,ny,nz)
C Arguments:
      INTEGER NX,NY,NZ
      complex c(nx,ny,nz)
C Local variables:
      INTEGER I1,I2,I3
      REAL F
C Purpose:
C generates a 3D matrix for use in 3D FFT CPU timmings
      do 103 i1=1, nx
         do 102 i2=1, ny
            do 101 i3=1, nz
c              f=i1*i2*i3
               f=sin(float(i1))+sin(float(i2))+sin(float(i3))
               c(i1,i2,i3)=cmplx(f*1.,f*0.5)
 101        CONTINUE
 102     CONTINUE
 103  continue
      return
      end

      SUBROUTINE CFFT99(A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C PURPOSE      PERFORMS MULTIPLE FAST FOURIER TRANSFORMS.  THIS PACKAGE
C              WILL PERFORM A NUMBER OF SIMULTANEOUS COMPLEX PERIODIC
C              FOURIER TRANSFORMS OR CORRESPONDING INVERSE TRANSFORMS.
C              THAT IS, GIVEN A SET OF COMPLEX GRIDPOINT VECTORS, THE
C              PACKAGE RETURNS A SET OF COMPLEX FOURIER
C              COEFFICIENT VECTORS, OR VICE VERSA.  THE LENGTH OF THE
C              TRANSFORMS MUST BE A NUMBER GREATER THAN 1 THAT HAS
C              NO PRIME FACTORS OTHER THAN 2, 3, AND 5.
C
C              THE PACKAGE CFFT99 CONTAINS SEVERAL USER-LEVEL ROUTINES:
C
C            SUBROUTINE CFTFAX
C                AN INITIALIZATION ROUTINE THAT MUST BE CALLED ONCE
C                BEFORE A SEQUENCE OF CALLS TO CFFT99
C                (PROVIDED THAT N IS NOT CHANGED).
C
C            SUBROUTINE CFFT99
C                THE ACTUAL TRANSFORM ROUTINE ROUTINE, CABABLE OF
C                PERFORMING BOTH THE TRANSFORM AND ITS INVERSE.
C                HOWEVER, AS THE TRANSFORMS ARE NOT NORMALIZED,
C                THE APPLICATION OF A TRANSFORM FOLLOWED BY ITS
C                INVERSE WILL YIELD THE ORIGINAL VALUES MULTIPLIED
C                BY N.
C
C
C ACCESS       *FORTRAN,P=XLIB,SN=CFFT99
C
C
C USAGE        LET N BE OF THE FORM 2**P * 3**Q * 5**R, WHERE P .GE. 0,
C              Q .GE. 0, AND R .GE. 0.  THEN A TYPICAL SEQUENCE OF
C              CALLS TO TRANSFORM A GIVEN SET OF COMPLEX VECTORS OF
C              LENGTH N TO A SET OF (UNSCALED) COMPLEX FOURIER
C              COEFFICIENT VECTORS OF LENGTH N IS
C
C                   DIMENSION IFAX(13),TRIGS(2*N)
C                   COMPLEX A(...), WORK(...)
C
C                   CALL CFTFAX (N, IFAX, TRIGS)
C                   CALL CFFT99 (A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C              THE OUTPUT VECTORS OVERWRITE THE INPUT VECTORS, AND
C              THESE ARE STORED IN A.  WITH APPROPRIATE CHOICES FOR
C              THE OTHER ARGUMENTS, THESE VECTORS MAY BE CONSIDERED
C              EITHER THE ROWS OR THE COLUMNS OF THE ARRAY A.
C              SEE THE INDIVIDUAL WRITE-UPS FOR CFTFAX AND
C              CFFT99 BELOW, FOR A DETAILED DESCRIPTION OF THE
C              ARGUMENTS.
C
C HISTORY      THE PACKAGE WAS WRITTEN BY CLIVE TEMPERTON AT ECMWF IN
C              NOVEMBER, 1978.  IT WAS MODIFIED, DOCUMENTED, AND TESTED
C              FOR NCAR BY RUSS REW IN SEPTEMBER, 1980.  IT WAS
C              FURTHER MODIFIED FOR THE FULLY COMPLEX CASE BY DAVE
C              FULKER IN NOVEMBER, 1980.
C
C-----------------------------------------------------------------------
C
C SUBROUTINE CFTFAX (N,IFAX,TRIGS)
C
C PURPOSE      A SET-UP ROUTINE FOR CFFT99.  IT NEED ONLY BE
C              CALLED ONCE BEFORE A SEQUENCE OF CALLS TO CFFT99,
C              PROVIDED THAT N IS NOT CHANGED.
C
C ARGUMENT     IFAX(13),TRIGS(2*N)
C DIMENSIONS
C
C ARGUMENTS
C
C ON INPUT     N
C               AN EVEN NUMBER GREATER THAN 1 THAT HAS NO PRIME FACTOR
C               GREATER THAN 5.  N IS THE LENGTH OF THE TRANSFORMS (SEE
C               THE DOCUMENTATION FOR CFFT99 FOR THE DEFINITION OF
C               THE TRANSFORMS).
C
C              IFAX
C               AN INTEGER ARRAY.  THE NUMBER OF ELEMENTS ACTUALLY USED
C               WILL DEPEND ON THE FACTORIZATION OF N.  DIMENSIONING
C               IFAX FOR 13 SUFFICES FOR ALL N LESS THAN 1 MILLION.
C
C              TRIGS
C               A REAL ARRAY OF DIMENSION 2*N
C
C ON OUTPUT    IFAX
C               CONTAINS THE FACTORIZATION OF N.  IFAX(1) IS THE
C               NUMBER OF FACTORS, AND THE FACTORS THEMSELVES ARE STORED
C               IN IFAX(2),IFAX(3),...  IF N HAS ANY PRIME FACTORS
C               GREATER THAN 5, IFAX(1) IS SET TO -99.
C
C              TRIGS
C               AN ARRAY OF TRIGONOMETRIC FUNCTION VALUES SUBSEQUENTLY
C               USED BY THE CFT ROUTINES.
C
C-----------------------------------------------------------------------
C
C SUBROUTINE CFFT99 (A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C PURPOSE      PERFORM A NUMBER OF SIMULTANEOUS (UNNORMALIZED) COMPLEX
C              PERIODIC FOURIER TRANSFORMS OR CORRESPONDING INVERSE
C              TRANSFORMS.  GIVEN A SET OF COMPLEX GRIDPOINT
C              VECTORS, THE PACKAGE RETURNS A SET OF
C              COMPLEX FOURIER COEFFICIENT VECTORS, OR VICE
C              VERSA.  THE LENGTH OF THE TRANSFORMS MUST BE A
C              NUMBER HAVING NO PRIME FACTORS OTHER THAN
C              2, 3, AND 5.  THIS ROUTINE IS
C              OPTIMIZED FOR USE ON THE CRAY-1.
C
C ARGUMENT     COMPLEX A(N*INC+(LOT-1)*JUMP), WORK(N*LOT)
C DIMENSIONS   REAL TRIGS(2*N), INTEGER IFAX(13)
C
C ARGUMENTS
C
C ON INPUT     A
C               A COMPLEX ARRAY OF LENGTH N*INC+(LOT-1)*JUMP CONTAINING
C               THE INPUT GRIDPOINT OR COEFFICIENT VECTORS.  THIS ARRAY
C               OVERWRITTEN BY THE RESULTS.
C
C               N.B. ALTHOUGH THE ARRAY A IS USUALLY CONSIDERED TO BE OF
C               TYPE COMPLEX IN THE CALLING PROGRAM, IT IS TREATED AS
C               REAL WITHIN THE TRANSFORM PACKAGE.  THIS REQUIRES THAT
C               SUCH TYPE CONFLICTS ARE PERMITTED IN THE USER"S
C               ENVIRONMENT, AND THAT THE STORAGE OF COMPLEX NUMBERS
C               MATCHES THE ASSUMPTIONS OF THIS ROUTINE.  THIS ROUTINE
C               ASSUMES THAT THE REAL AND IMAGINARY PORTIONS OF A
C               COMPLEX NUMBER OCCUPY ADJACENT ELEMENTS OF MEMORY.  IF
C               THESE CONDITIONS ARE NOT MET, THE USER MUST TREAT THE
C               ARRAY A AS REAL (AND OF TWICE THE ABOVE LENGTH), AND
C               WRITE THE CALLING PROGRAM TO TREAT THE REAL AND
C               IMAGINARY PORTIONS EXPLICITLY.
C
C              WORK
C               A COMPLEX WORK ARRAY OF LENGTH N*LOT OR A REAL ARRAY
C               OF LENGTH 2*N*LOT.  SEE N.B. ABOVE.
C
C              TRIGS
C               AN ARRAY SET UP BY CFTFAX, WHICH MUST BE CALLED FIRST.
C
C              IFAX
C               AN ARRAY SET UP BY CFTFAX, WHICH MUST BE CALLED FIRST.
C
C
C               N.B. IN THE FOLLOWING ARGUMENTS, INCREMENTS ARE MEASURED
C               IN WORD PAIRS, BECAUSE EACH COMPLEX ELEMENT IS ASSUMED
C               TO OCCUPY AN ADJACENT PAIR OF WORDS IN MEMORY.
C
C              INC
C               THE INCREMENT (IN WORD PAIRS) BETWEEN SUCCESSIVE ELEMENT
C               OF EACH (COMPLEX) GRIDPOINT OR COEFFICIENT VECTOR
C               (E.G.  INC=1 FOR CONSECUTIVELY STORED DATA).
C
C              JUMP
C               THE INCREMENT (IN WORD PAIRS) BETWEEN THE FIRST ELEMENTS
C               OF SUCCESSIVE DATA OR COEFFICIENT VECTORS.  ON THE CRAY-
C               TRY TO ARRANGE DATA SO THAT JUMP IS NOT A MULTIPLE OF 8
C               (TO AVOID MEMORY BANK CONFLICTS).  FOR CLARIFICATION OF
C               INC AND JUMP, SEE THE EXAMPLES BELOW.
C
C              N
C               THE LENGTH OF EACH TRANSFORM (SEE DEFINITION OF
C               TRANSFORMS, BELOW).
C
C              LOT
C               THE NUMBER OF TRANSFORMS TO BE DONE SIMULTANEOUSLY.
C
C              ISIGN
C               = -1 FOR A TRANSFORM FROM GRIDPOINT VALUES TO FOURIER
C                    COEFFICIENTS.
C               = +1 FOR A TRANSFORM FROM FOURIER COEFFICIENTS TO
C                    GRIDPOINT VALUES.
C
C ON OUTPUT    A
C               IF ISIGN = -1, AND LOT GRIDPOINT VECTORS ARE SUPPLIED,
C               EACH CONTAINING THE COMPLEX SEQUENCE:
C
C               G(0),G(1), ... ,G(N-1)  (N COMPLEX VALUES)
C
C               THEN THE RESULT CONSISTS OF LOT COMPLEX VECTORS EACH
C               CONTAINING THE CORRESPONDING N COEFFICIENT VALUES:
C
C               C(0),C(1), ... ,C(N-1)  (N COMPLEX VALUES)
C
C               DEFINED BY:
C                 C(K) = SUM(J=0,...,N-1)( G(J)*EXP(-2*I*J*K*PI/N) )
C                 WHERE I = SQRT(-1)
C
C
C               IF ISIGN = +1, AND LOT COEFFICIENT VECTORS ARE SUPPLIED,
C               EACH CONTAINING THE COMPLEX SEQUENCE:
C
C               C(0),C(1), ... ,C(N-1)  (N COMPLEX VALUES)
C
C               THEN THE RESULT CONSISTS OF LOT COMPLEX VECTORS EACH
C               CONTAINING THE CORRESPONDING N GRIDPOINT VALUES:
C
C               G(0),G(1), ... ,G(N-1)  (N COMPLEX VALUES)
C
C               DEFINED BY:
C                 G(J) = SUM(K=0,...,N-1)( G(K)*EXP(+2*I*J*K*PI/N) )
C                 WHERE I = SQRT(-1)
C
C
C               A CALL WITH ISIGN=-1 FOLLOWED BY A CALL WITH ISIGN=+1
C               (OR VICE VERSA) RETURNS THE ORIGINAL DATA, MULTIPLIED
C               BY THE FACTOR N.
C
C
C EXAMPLE       GIVEN A 64 BY 9 GRID OF COMPLEX VALUES, STORED IN
C               A 66 BY 9 COMPLEX ARRAY, A, COMPUTE THE TWO DIMENSIONAL
C               FOURIER TRANSFORM OF THE GRID.  FROM TRANSFORM THEORY,
C               IT IS KNOWN THAT A TWO DIMENSIONAL TRANSFORM CAN BE
C               OBTAINED BY FIRST TRANSFORMING THE GRID ALONG ONE
C               DIRECTION, THEN TRANSFORMING THESE RESULTS ALONG THE
C               ORTHOGONAL DIRECTION.
C
C               COMPLEX A(66,9), WORK(64,9)
C               REAL TRIGS1(128), TRIGS2(18)
C               INTEGER IFAX1(13), IFAX2(13)
C
C               SET UP THE IFAX AND TRIGS ARRAYS FOR EACH DIRECTION:
C
C               CALL CFTFAX(64, IFAX1, TRIGS1)
C               CALL CFTFAX( 9, IFAX2, TRIGS2)
C
C               IN THIS CASE, THE COMPLEX VALUES OF THE GRID ARE
C               STORED IN MEMORY AS FOLLOWS (USING U AND V TO
C               DENOTE THE REAL AND IMAGINARY COMPONENTS, AND
C               ASSUMING CONVENTIONAL FORTRAN STORAGE):
C
C   U(1,1), V(1,1), U(2,1), V(2,1),  ...  U(64,1), V(64,1), 4 NULLS,
C
C   U(1,2), V(1,2), U(2,2), V(2,2),  ...  U(64,2), V(64,2), 4 NULLS,
C
C   .       .       .       .         .   .        .        .
C   .       .       .       .         .   .        .        .
C   .       .       .       .         .   .        .        .
C
C   U(1,9), V(1,9), U(2,9), V(2,9),  ...  U(64,9), V(64,9), 4 NULLS.
C
C               WE CHOOSE (ARBITRARILY) TO TRANSORM FIRST ALONG THE
C               DIRECTION OF THE FIRST SUBSCRIPT.  THUS WE DEFINE
C               THE LENGTH OF THE TRANSFORMS, N, TO BE 64, THE
C               NUMBER OF TRANSFORMS, LOT, TO BE 9, THE INCREMENT
C               BETWEEN ELEMENTS OF EACH TRANSFORM, INC, TO BE 1,
C               AND THE INCREMENT BETWEEN THE STARTING POINTS
C               FOR EACH TRANSFORM, JUMP, TO BE 66 (THE FIRST
C               DIMENSION OF A).
C
C               CALL CFFT99( A, WORK, TRIGS1, IFAX1, 1, 66, 64, 9, -1)
C
C               TO TRANSFORM ALONG THE DIRECTION OF THE SECOND SUBSCRIPT
C               THE ROLES OF THE INCREMENTS ARE REVERSED.  THUS WE DEFIN
C               THE LENGTH OF THE TRANSFORMS, N, TO BE 9, THE
C               NUMBER OF TRANSFORMS, LOT, TO BE 64, THE INCREMENT
C               BETWEEN ELEMENTS OF EACH TRANSFORM, INC, TO BE 66,
C               AND THE INCREMENT BETWEEN THE STARTING POINTS
C               FOR EACH TRANSFORM, JUMP, TO BE 1
C
C               CALL CFFT99( A, WORK, TRIGS2, IFAX2, 66, 1, 9, 64, -1)
C
C               THESE TWO SEQUENTIAL STEPS RESULTS IN THE TWO-DIMENSIONA
C               FOURIER COEFFICIENT ARRAY OVERWRITING THE INPUT
C               GRIDPOINT ARRAY, A.  THE SAME TWO STEPS APPLIED AGAIN
C               WITH ISIGN = +1 WOULD RESULT IN THE RECONSTRUCTION OF
C               THE GRIDPOINT ARRAY (MULTIPLIED BY A FACTOR OF 64*9).
C
C
C-----------------------------------------------------------------------
C*** Modification 90/11/29 (BTD)
C      DIMENSION A(1),WORK(1),TRIGS(1),IFAX(1)
      DIMENSION A(*),WORK(*),TRIGS(*),IFAX(*)
C
C     SUBROUTINE "CFFT99" - MULTIPLE FAST COMPLEX FOURIER TRANSFORM
C
C     A IS THE ARRAY CONTAINING INPUT AND OUTPUT DATA
C     WORK IS AN AREA OF SIZE N*LOT
C     TRIGS IS A PREVIOUSLY PREPARED LIST OF TRIG FUNCTION VALUES
C     IFAX IS A PREVIOUSLY PREPARED LIST OF FACTORS OF N
C     INC IS THE INCREMENT WITHIN EACH DATA 'VECTOR'
C         (E.G. INC=1 FOR CONSECUTIVELY STORED DATA)
C     JUMP IS THE INCREMENT BETWEEN THE START OF EACH DATA VECTOR
C     N IS THE LENGTH OF THE DATA VECTORS
C     LOT IS THE NUMBER OF DATA VECTORS
C     ISIGN = +1 FOR TRANSFORM FROM SPECTRAL TO GRIDPOINT
C           = -1 FOR TRANSFORM FROM GRIDPOINT TO SPECTRAL
C
C
C     VECTORIZATION IS ACHIEVED ON CRAY BY DOING THE TRANSFORMS IN
C     PARALLEL.
C
C
C
C
C
      NN = N+N
      INK=INC+INC
      JUM = JUMP+JUMP
      NFAX=IFAX(1)
      JNK = 2
      JST = 2
      IF (ISIGN.GE.0) GO TO 30
C
C     THE INNERMOST TEMPERTON ROUTINES HAVE NO FACILITY FOR THE
C     FORWARD (ISIGN = -1) TRANSFORM.  THEREFORE, THE INPUT MUST BE
C     REARRANGED AS FOLLOWS:
C
C     THE ORDER OF EACH INPUT VECTOR,
C
C     G(0), G(1), G(2), ... , G(N-2), G(N-1)
C
C     IS REVERSED (EXCLUDING G(0)) TO YIELD
C
C     G(0), G(N-1), G(N-2), ... , G(2), G(1).
C
C     WITHIN THE TRANSFORM, THE CORRESPONDING EXPONENTIAL MULTIPLIER
C     IS THEN PRECISELY THE CONJUGATE OF THAT FOR THE NORMAL
C     ORDERING.  THUS THE FORWARD (ISIGN = -1) TRANSFORM IS
C     ACCOMPLISHED
C
C     FOR NFAX ODD, THE INPUT MUST BE TRANSFERRED TO THE WORK ARRAY,
C     AND THE REARRANGEMENT CAN BE DONE DURING THE MOVE.
C
      JNK = -2
      JST = NN-2
      IF (MOD(NFAX,2).EQ.1) GOTO 40
C
C     FOR NFAX EVEN, THE REARRANGEMENT MUST BE APPLIED DIRECTLY TO
C     THE INPUT ARRAY.  THIS CAN BE DONE BY SWAPPING ELEMENTS.
C
      IBASE = 1
      ILAST = (N-1)*INK
      NH = N/2
      DO 20 L=1,LOT
      I1 = IBASE+INK
      I2 = IBASE+ILAST
CDIR$ IVDEP
      DO 10 M=1,NH
C     SWAP REAL AND IMAGINARY PORTIONS
      HREAL = A(I1)
      HIMAG = A(I1+1)
      A(I1) = A(I2)
      A(I1+1) = A(I2+1)
      A(I2) = HREAL
      A(I2+1) = HIMAG
      I1 = I1+INK
      I2 = I2-INK
   10 CONTINUE
      IBASE = IBASE+JUM
   20 CONTINUE
      GOTO 100
C
   30 CONTINUE
      IF (MOD(NFAX,2).EQ.0) GOTO 100
C
   40 CONTINUE
C
C     DURING THE TRANSFORM PROCESS, NFAX STEPS ARE TAKEN, AND THE
C     RESULTS ARE STORED ALTERNATELY IN WORK AND IN A.  IF NFAX IS
C     ODD, THE INPUT DATA ARE FIRST MOVED TO WORK SO THAT THE FINAL
C     RESULT (AFTER NFAX STEPS) IS STORED IN ARRAY A.
C
      IBASE=1
      JBASE=1
      DO 60 L=1,LOT
C     MOVE REAL AND IMAGINARY PORTIONS OF ELEMENT ZERO
      WORK(JBASE) = A(IBASE)
      WORK(JBASE+1) = A(IBASE+1)
      I=IBASE+INK
      J=JBASE+JST
CDIR$ IVDEP
      DO 50 M=2,N
C     MOVE REAL AND IMAGINARY PORTIONS OF OTHER ELEMENTS (POSSIBLY IN
C     REVERSE ORDER, DEPENDING ON JST AND JNK)
      WORK(J) = A(I)
      WORK(J+1) = A(I+1)
      I=I+INK
      J=J+JNK
   50 CONTINUE
      IBASE=IBASE+JUM
      JBASE=JBASE+NN
   60 CONTINUE
C
  100 CONTINUE
C
C     PERFORM THE TRANSFORM PASSES, ONE PASS FOR EACH FACTOR.  DURING
C     EACH PASS THE DATA ARE MOVED FROM A TO WORK OR FROM WORK TO A.
C
C     FOR NFAX EVEN, THE FIRST PASS MOVES FROM A TO WORK
      IGO = 110
C     FOR NFAX ODD, THE FIRST PASS MOVES FROM WORK TO A
      IF (MOD(NFAX,2).EQ.1) IGO = 120
      LA=1
      DO 140 K=1,NFAX
      IF (IGO.EQ.120) GO TO 120
  110 CONTINUE
      CALL VPASSM(A(1),A(2),WORK(1),WORK(2),TRIGS,
     *   INK,2,JUM,NN,LOT,N,IFAX(K+1),LA)
      IGO=120
      GO TO 130
  120 CONTINUE
      CALL VPASSM(WORK(1),WORK(2),A(1),A(2),TRIGS,
     *    2,INK,NN,JUM,LOT,N,IFAX(K+1),LA)
      IGO=110
  130 CONTINUE
      LA=LA*IFAX(K+1)
  140 CONTINUE
C
C     AT THIS POINT THE FINAL TRANSFORM RESULT IS STORED IN A.
C
      RETURN
      END
      SUBROUTINE CFTFAX(N,IFAX,TRIGS)
C Modification 90/11/29 (BTD):
C      DIMENSION IFAX(13),TRIGS(1)
      DIMENSION IFAX(13),TRIGS(*)
C
C     THIS ROUTINE WAS MODIFIED FROM TEMPERTON"S ORIGINAL
C     BY DAVE FULKER.  IT NO LONGER PRODUCES FACTORS IN ASCENDING
C     ORDER, AND THERE ARE NONE OF THE ORIGINAL 'MODE' OPTIONS.
C
C ON INPUT     N
C               THE LENGTH OF EACH COMPLEX TRANSFORM TO BE PERFORMED
C
C               N MUST BE GREATER THAN 1 AND CONTAIN NO PRIME
C               FACTORS GREATER THAN 5.
C
C ON OUTPUT    IFAX
C               IFAX(1)
C                 THE NUMBER OF FACTORS CHOSEN OR -99 IN CASE OF ERROR
C               IFAX(2) THRU IFAX( IFAX(1)+1 )
C                 THE FACTORS OF N IN THE FOLLOWIN ORDER:  APPEARING
C                 FIRST ARE AS MANY FACTORS OF 4 AS CAN BE OBTAINED.
C                 SUBSEQUENT FACTORS ARE PRIMES, AND APPEAR IN
C                 ASCENDING ORDER, EXCEPT FOR MULTIPLE FACTORS.
C
C              TRIGS
C               2N SIN AND COS VALUES FOR USE BY THE TRANSFORM ROUTINE
C
      CALL FACT(N,IFAX)
      K = IFAX(1)
      IF (K .LT. 1 .OR. IFAX(K+1) .GT. 5) IFAX(1) = -99
      IF (IFAX(1) .LE. 0 )  CALL ERRMSG('FATAL','CFFT99F',
     $ '  FFTFAX - INVALID N')
      CALL CFTRIG (N, TRIGS)
      RETURN
      END
      SUBROUTINE FACT(N,IFAX)
C     FACTORIZATION ROUTINE THAT FIRST EXTRACTS ALL FACTORS OF 4
      DIMENSION IFAX(13)
      IF (N.GT.1) GO TO 10
      IFAX(1) = 0
      IF (N.LT.1) IFAX(1) = -99
      RETURN
   10 NN=N
      K=1
C     TEST FOR FACTORS OF 4
   20 IF (MOD(NN,4).NE.0) GO TO 30
      K=K+1
      IFAX(K)=4
      NN=NN/4
      IF (NN.EQ.1) GO TO 80
      GO TO 20
C     TEST FOR EXTRA FACTOR OF 2
   30 IF (MOD(NN,2).NE.0) GO TO 40
      K=K+1
      IFAX(K)=2
      NN=NN/2
      IF (NN.EQ.1) GO TO 80
C     TEST FOR FACTORS OF 3
   40 IF (MOD(NN,3).NE.0) GO TO 50
      K=K+1
      IFAX(K)=3
      NN=NN/3
      IF (NN.EQ.1) GO TO 80
      GO TO 40
C     NOW FIND REMAINING FACTORS
   50 L=5
      MAX = SQRT(FLOAT(NN))
      INC=2
C     INC ALTERNATELY TAKES ON VALUES 2 AND 4
   60 IF (MOD(NN,L).NE.0) GO TO 70
      K=K+1
      IFAX(K)=L
      NN=NN/L
      IF (NN.EQ.1) GO TO 80
      GO TO 60
   70 IF (L.GT.MAX) GO TO 75
      L=L+INC
      INC=6-INC
      GO TO 60
   75 K = K+1
      IFAX(K) = NN
   80 IFAX(1)=K-1
C     IFAX(1) NOW CONTAINS NUMBER OF FACTORS
      RETURN
      END
      SUBROUTINE CFTRIG(N,TRIGS)
C Modification 90/11/29 (BTD):
C      DIMENSION TRIGS(1)
      DIMENSION TRIGS(*)
      PI=2.0*ASIN(1.0)
      DEL=(PI+PI)/FLOAT(N)
      L=N+N
      DO 10 I=1,L,2
      ANGLE=0.5*FLOAT(I-1)*DEL
      TRIGS(I)=COS(ANGLE)
      TRIGS(I+1)=SIN(ANGLE)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE VPASSM(A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,LOT,N,IFAC,LA)
      DIMENSION A(N),B(N),C(N),D(N),TRIGS(N)
C
C     SUBROUTINE "VPASSM" - MULTIPLE VERSION OF "VPASSA"
C     PERFORMS ONE PASS THROUGH DATA
C     AS PART OF MULTIPLE COMPLEX (INVERSE) FFT ROUTINE
C     A IS FIRST REAL INPUT VECTOR
C     B IS FIRST IMAGINARY INPUT VECTOR
C     C IS FIRST REAL OUTPUT VECTOR
C     D IS FIRST IMAGINARY OUTPUT VECTOR
C     TRIGS IS PRECALCULATED TABLE OF SINES & COSINES
C     INC1 IS ADDRESSING INCREMENT FOR A AND B
C     INC2 IS ADDRESSING INCREMENT FOR C AND D
C     INC3 IS ADDRESSING INCREMENT BETWEEN A"S & B"S
C     INC4 IS ADDRESSING INCREMENT BETWEEN C"S & D"S
C     LOT IS THE NUMBER OF VECTORS
C     N IS LENGTH OF VECTORS
C     IFAC IS CURRENT FACTOR OF N
C     LA IS PRODUCT OF PREVIOUS FACTORS
C
      DATA SIN36/0.587785252292473/,COS36/0.809016994374947/,
     *     SIN72/0.951056516295154/,COS72/0.309016994374947/,
     *     SIN60/0.866025403784437/
C
c*** diagnostic
c      write(0,*)'in vpassm, n=',n
c***
      M=N/IFAC
      IINK=M*INC1
      JINK=LA*INC2
      JUMP=(IFAC-1)*JINK
      IBASE=0
      JBASE=0
      IGO=IFAC-1
      IF (IGO.GT.4) RETURN
      GO TO (10,50,90,130),IGO
C
C     CODING FOR FACTOR 2
C
   10 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      DO 20 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 15 IJK=1,LOT
      C(JA+J)=A(IA+I)+A(IB+I)
      D(JA+J)=B(IA+I)+B(IB+I)
      C(JB+J)=A(IA+I)-A(IB+I)
      D(JB+J)=B(IA+I)-B(IB+I)
      I=I+INC3
      J=J+INC4
   15 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
   20 CONTINUE
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
      DO 40 K=LA1,M,LA
      KB=K+K-2
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      DO 30 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 25 IJK=1,LOT
      C(JA+J)=A(IA+I)+A(IB+I)
      D(JA+J)=B(IA+I)+B(IB+I)
      C(JB+J)=C1*(A(IA+I)-A(IB+I))-S1*(B(IA+I)-B(IB+I))
      D(JB+J)=S1*(A(IA+I)-A(IB+I))+C1*(B(IA+I)-B(IB+I))
      I=I+INC3
      J=J+INC4
   25 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
   30 CONTINUE
      JBASE=JBASE+JUMP
   40 CONTINUE
      RETURN
C
C     CODING FOR FACTOR 3
C
   50 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
      DO 60 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 55 IJK=1,LOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))
      D(JA+J)=B(IA+I)+(B(IB+I)+B(IC+I))
      C(JB+J)=(A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)-B(IC+I)))
      C(JC+J)=(A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)-B(IC+I)))
      D(JB+J)=(B(IA+I)-0.5*(B(IB+I)+B(IC+I)))+(SIN60*(A(IB+I)-A(IC+I)))
      D(JC+J)=(B(IA+I)-0.5*(B(IB+I)+B(IC+I)))-(SIN60*(A(IB+I)-A(IC+I)))
      I=I+INC3
      J=J+INC4
   55 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
   60 CONTINUE
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
      DO 80 K=LA1,M,LA
      KB=K+K-2
      KC=KB+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      DO 70 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 65 IJK=1,LOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))
      D(JA+J)=B(IA+I)+(B(IB+I)+B(IC+I))
      C(JB+J)=
     *    C1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)-B(IC+I))))
     *   -S1*((B(IA+I)-0.5*(B(IB+I)+B(IC+I)))+(SIN60*(A(IB+I)-A(IC+I))))
      D(JB+J)=
     *    S1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)-B(IC+I))))
     *   +C1*((B(IA+I)-0.5*(B(IB+I)+B(IC+I)))+(SIN60*(A(IB+I)-A(IC+I))))
      C(JC+J)=
     *    C2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)-B(IC+I))))
     *   -S2*((B(IA+I)-0.5*(B(IB+I)+B(IC+I)))-(SIN60*(A(IB+I)-A(IC+I))))
      D(JC+J)=
     *    S2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)-B(IC+I))))
     *   +C2*((B(IA+I)-0.5*(B(IB+I)+B(IC+I)))-(SIN60*(A(IB+I)-A(IC+I))))
      I=I+INC3
      J=J+INC4
   65 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
   70 CONTINUE
      JBASE=JBASE+JUMP
   80 CONTINUE
      RETURN
C
C     CODING FOR FACTOR 4
C
   90 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
      ID=IC+IINK
      JD=JC+JINK
      DO 100 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 95 IJK=1,LOT
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))
      C(JC+J)=(A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I))
      D(JA+J)=(B(IA+I)+B(IC+I))+(B(IB+I)+B(ID+I))
      D(JC+J)=(B(IA+I)+B(IC+I))-(B(IB+I)+B(ID+I))
      C(JB+J)=(A(IA+I)-A(IC+I))-(B(IB+I)-B(ID+I))
      C(JD+J)=(A(IA+I)-A(IC+I))+(B(IB+I)-B(ID+I))
      D(JB+J)=(B(IA+I)-B(IC+I))+(A(IB+I)-A(ID+I))
      D(JD+J)=(B(IA+I)-B(IC+I))-(A(IB+I)-A(ID+I))
      I=I+INC3
      J=J+INC4
   95 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  100 CONTINUE
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
      DO 120 K=LA1,M,LA
      KB=K+K-2
      KC=KB+KB
      KD=KC+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      DO 110 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 105 IJK=1,LOT
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))
      D(JA+J)=(B(IA+I)+B(IC+I))+(B(IB+I)+B(ID+I))
      C(JC+J)=
     *    C2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))
     *   -S2*((B(IA+I)+B(IC+I))-(B(IB+I)+B(ID+I)))
      D(JC+J)=
     *    S2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))
     *   +C2*((B(IA+I)+B(IC+I))-(B(IB+I)+B(ID+I)))
      C(JB+J)=
     *    C1*((A(IA+I)-A(IC+I))-(B(IB+I)-B(ID+I)))
     *   -S1*((B(IA+I)-B(IC+I))+(A(IB+I)-A(ID+I)))
      D(JB+J)=
     *    S1*((A(IA+I)-A(IC+I))-(B(IB+I)-B(ID+I)))
     *   +C1*((B(IA+I)-B(IC+I))+(A(IB+I)-A(ID+I)))
      C(JD+J)=
     *    C3*((A(IA+I)-A(IC+I))+(B(IB+I)-B(ID+I)))
     *   -S3*((B(IA+I)-B(IC+I))-(A(IB+I)-A(ID+I)))
      D(JD+J)=
     *    S3*((A(IA+I)-A(IC+I))+(B(IB+I)-B(ID+I)))
     *   +C3*((B(IA+I)-B(IC+I))-(A(IB+I)-A(ID+I)))
      I=I+INC3
      J=J+INC4
  105 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  110 CONTINUE
      JBASE=JBASE+JUMP
  120 CONTINUE
      RETURN
C
C     CODING FOR FACTOR 5
C
  130 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
      ID=IC+IINK
      JD=JC+JINK
      IE=ID+IINK
      JE=JD+JINK
      DO 140 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 135 IJK=1,LOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))
      D(JA+J)=B(IA+I)+(B(IB+I)+B(IE+I))+(B(IC+I)+B(ID+I))
      C(JB+J)=(A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *  -(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I)))
      C(JE+J)=(A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *  +(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I)))
      D(JB+J)=(B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *  +(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I)))
      D(JE+J)=(B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *  -(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I)))
      C(JC+J)=(A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *  -(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I)))
      C(JD+J)=(A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *  +(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I)))
      D(JC+J)=(B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *  +(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I)))
      D(JD+J)=(B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *  -(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I)))
      I=I+INC3
      J=J+INC4
  135 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  140 CONTINUE
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
      DO 160 K=LA1,M,LA
      KB=K+K-2
      KC=KB+KB
      KD=KC+KB
      KE=KD+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      C4=TRIGS(KE+1)
      S4=TRIGS(KE+2)
      DO 150 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 145 IJK=1,LOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))
      D(JA+J)=B(IA+I)+(B(IB+I)+B(IE+I))+(B(IC+I)+B(ID+I))
      C(JB+J)=
     *    C1*((A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *      -(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I))))
     *   -S1*((B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *      +(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))))
      D(JB+J)=
     *    S1*((A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *      -(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I))))
     *   +C1*((B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *      +(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))))
      C(JE+J)=
     *    C4*((A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *      +(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I))))
     *   -S4*((B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *      -(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))))
      D(JE+J)=
     *    S4*((A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *      +(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I))))
     *   +C4*((B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *      -(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))))
      C(JC+J)=
     *    C2*((A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *      -(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I))))
     *   -S2*((B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *      +(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))))
      D(JC+J)=
     *    S2*((A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *      -(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I))))
     *   +C2*((B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *      +(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))))
      C(JD+J)=
     *    C3*((A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *      +(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I))))
     *   -S3*((B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *      -(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))))
      D(JD+J)=
     *    S3*((A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *      +(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I))))
     *   +C3*((B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *      -(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))))
      I=I+INC3
      J=J+INC4
  145 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  150 CONTINUE
      JBASE=JBASE+JUMP
  160 CONTINUE
      RETURN
      END

      SUBROUTINE REAPAR(cbinflag, cnetflag, AEFFA,
     &                  BETAMI,BETAMX,
     &                  CALPHA,CDIEL,CFLEPS,CFLPAR,CMDSOL,CMDFFT,CSHAPE,
     &                  CMDTRQ,CXE01,CXE02,
     &                  DEGRAD,
     &                  ICTHM,IDVERR,IDVOUT,INIT,IOPAR,IORTH,IPHM,
     &                  IWRKSC,
     &                  MXBETA,MXCOMP,MXMEM,MXPHI,MXRAD,MXSCA,MXTHET,
     &                  MXWAV,
     &                  NBETA,NCOMP,NPHI,NRAD,NSCA,NTHETA,NWAV,
     &                  PHIMIN,PHIMAX,PHIN,
     &                  THETAN,THETMI,THETMX,TOL,
     &                  WAVEA,SHPAR)
C***********************************************************************
C Subroutine REAPAR handles the reading of input parameters from the
C "ddscat.par" file, as well as elementary processing with those input
C parameters to generate arrays.
C Original version created by P.J.Flatau, Colorado State Univ.
C Modified by B.T.Draine, Princeton Univ. Obs.
C History:
C 90.11.09 (BTD): Modified so as to remove sensitivity to errors
C                 in sign of entered value of DTHETA.
C 90.11.30 (BTD): Added test to compare CMDFFT and MXMEM
C 90.12.14 (BTD): Changed option MKRECT to RCTNGL
C 91.01.03 (BTD): Added MXBETA,MXPHI,MXTHET to argument list
C                 and added checking of NBETA,NPHI,NTHETA
C 91.05.08 (BTD): Added CALPHA to allow choice of prescription
C                 for polarizabilities
C 91.05.08 (BTD): Some rewriting done.
C 91.05.14 (BTD): Added separate options LDRXYZ and LDRAVG
C 91.05.15 (BTD): Added new option LDR000
C 91.05.23 (BTD): Added variable IWRKSC to argument list and
C                 added code to read IWRKSC
C 91.05.30 (BTD): Changed LDRXYZ->LDR100
C                 Added option LDR111
C 91.11.13 (BTD): Now three options: DRAI88, GOBR88, LATTDR
C                 (subroutine ALPHA now allows for directional
C                 dependence for LATTDR option)
C 92.05.14 (BTD): Allow for experimental option LDRISO
C 92.09.21 (BTD): Allow for option ANIELL (ellipsoid of anisotropic
C                 material); change option GRPHIT -> UNICYL (cylinder
C                 of uniaxial material)
C 93.01.07 (BTD): Allow for options TWOELL and TWOAEL (two touching
C                 ellipsoids, each either isotropic or anisotropic)
C 93.03.11 (BTD): Deleted all code associated with variable CMACHN
C                 which previously was used to identify machine/OS
C                 This information was not used or needed.
C 93.12.15 (BTD): Added code to check for compatibility of NCOMP
C                 when CSHAPE=TWOELL,THRELL,TWOAEL,or THRAEL
C 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6)
C                 Added CONELL (two concentric ellipsoids) as target
C                 option.
C 94.06.20 (PJF): Added code to handle NEWTMP
C 94.12.02 (BTD): Added options 
C                    LB1991 (Dungey-Bohren 1991 polarizability)
C                    LR1994 (Lumme-Rahola 1994 polarizability)
C 95.05.26 (BTD): Corrected construction of orthogonal polarization
C                 state for case where E01 is complex (e.g.,
C                 circular polarization)
C 95.06.14 (BTD): Added code to check that user is not requesting
C                 f_ml when illuminating target with other then
C                 linearly polarized light
C 95.06.19 (BTD): Added argument CMDSOL to allow selection of
C                 different CCG methods
C                 Added argument CMDTRQ to allow torque calculations
C                 to be skipped.
C 96.01.05 (BTD): Added shape options BLOCKS and DW1996
C 96.01.25 (BTD): Added shape option TWOSPH
C 96.01.25 (BTD): Disable code added 95.06.14 so that user can
C                 calculate f_ml even when illuminating target with
C                 elliptically polarized light.
C 96.10.18 (BTD): Changed option NEWTMP to GPFAFT (Generalized Prime
C                 Factor Algorithm for Fourier Transform).
C 96.11.06 (BTD): Added provision to 
C                 (1) produce fatal error if CXE01(1).NE.(0.,0.)
C                 (2) normalize CXE01 if necessary
C 96.11.14 (PJF): cbinflag for binary file
C 96.11.15 (PJF): netCDF netflag
C 96.11.21 (BTD): modified handling of CBINFLAG and CNETFLAG to
C                 be consistent with other option flags
C 98.12.21 (BTD): changed dimension of CFLPAR from CHARACTER*40 to
C                 CHARACTER*60 to allow longer file names
C                 (also changed in DDSCAT.f and dielec.f)
C end history
C Copyright (C) 1993,1994,1995,1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C Arguments:
      CHARACTER
     &   CALPHA*(*),CDIEL*(*),CFLPAR*(*),CMDSOL*(*),CMDFFT*(*),
     &   CMDTRQ*(*),CSHAPE*(*), cbinflag*(*), cnetflag*(*)
      INTEGER
     &   ICTHM,IDVERR,IDVOUT,INIT,IOPAR,IORTH,IPHM,IWRKSC,
     &   MXBETA,MXCOMP,MXMEM,MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,
     &   NBETA,NCOMP,NPHI,NRAD,NSCA,NWAV,NTHETA
      CHARACTER*60 CFLEPS(MXCOMP)
      REAL
     &   BETAMI,BETAMX,DEGRAD,PHIMIN,PHIMAX,THETMI,THETMX,TOL
      REAL
     &   AEFFA(MXRAD),PHIN(MXSCA),SHPAR(6),THETAN(MXSCA),WAVEA(MXWAV)
      COMPLEX CXE01(3),CXE02(3)
C
C Local variables:
      CHARACTER CDIVID*3,CLINE*70,CMSGNM*70
      INTEGER J,NSCA0
      REAL
     &   AEFEND,AEFINI,DELTA,DTHETA,E1,PHI1,THETA1,THETA2,
     &   WAVEND,WAVINI
C
C External routines:
      EXTERNAL DIVIDE,ERRMSG,WRIMSG
C
C***********************************************************************
      OPEN (UNIT=IOPAR,FILE=CFLPAR,STATUS='OLD')
C***********************************************************************
C
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG('REAPAR',CLINE)
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
C
C    Specify whether torques are to be calculated:
C
C    CMDTRQ*6 = 'DOTORQ' -  calculate torque on grain
C             = 'NOTORQ' -  do not calculate torque on grain
C
      READ(IOPAR,FMT=*,ERR=40)CMDTRQ
      IF(CMDTRQ.EQ.'dotorq')CMDTRQ='DOTORQ'
      IF(CMDTRQ.EQ.'notorq')CMDTRQ='NOTORQ'
      IF(CMDTRQ.EQ.'DOTORQ')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDTRQ,' - compute torques '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSEIF(CMDTRQ.EQ.'NOTORQ')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDTRQ,' - do not compute torques '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDTRQ')
      ENDIF
C
C    Define method used for iterative solution of complex linear equations
C
C    CMDSOL*6 = 'PETRKP' -  Petravic & Kuo-Petravic method
C             = 'PBCGST' -  PIM BiConjugate Gradient with Stabilization
C
      READ(IOPAR,FMT=*,ERR=40)CMDSOL
      IF(CMDSOL.EQ.'petrkp')CMDSOL='PETRKP'
      IF(CMDSOL.EQ.'pbcgst')CMDSOL='PBCGST'
      IF(CMDSOL.EQ.'PETRKP'.OR.
     &   CMDSOL.EQ.'PBCGST')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDSOL,' - CCG Method  '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDSOL')
      ENDIF
C
C    Define FFT method:
C
C    CMDFFT*6 = 'BRENNR' -  Use Brenner's FOURX FFT routine.
C             = 'TMPRTN' -  Use Temperton's FFT routine.
C             = 'GPFAFT' -  GPFA code of Temperton
C             = 'CONVEX' -  Use native Convex veclib routine C3DFFT.
C
      READ(IOPAR,FMT=*,ERR=40)CMDFFT
      IF(CMDFFT.EQ.'BRENNR'.OR.
     &   CMDFFT.EQ.'TMPRTN'.OR.
     &   CMDFFT.EQ.'CONVEX'.OR.
     &   CMDFFT.EQ.'GPFAFT')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDFFT,' - Solution Method  '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDFFT')
      ENDIF
C*** Check whether compiled with enough memory for TMPRTN option:
      IF(CMDFFT.EQ.'TMPRTN'.AND.MXMEM.EQ.0)THEN
         CALL ERRMSG('FATAL','REAPAR',
     &   ' Must recompile with MXMEM=1 to use TMPRTN option')
      ENDIF
      IF(CMDFFT.NE.'TMPRTN'.AND.MXMEM.EQ.1)THEN
         CALL ERRMSG('WARNING','REAPAR',
     &   ' You do not need MXMEM=1 with BRENNR,CONVEX, or GPFAFT')
      ENDIF
C***********************************************************************
C
C    Define prescription for computing polarizabilities:
C
C    CALPHA*6 = 'DRAI88' - Draine (1988) prescription
C             = 'GOBR88' - Goedecke & Obrien (1988) prescription
C             = 'LATTDR' - Lattice Dispersion Relation
C             = 'LDRISO' - Isotropized Lattice Dispersion Relation
C             = 'DB1991' - Dungey & Bohren (1991) prescription
C             = 'LR1994' - Lumme & Rahola (1994) prescription
C
      READ(IOPAR,FMT=*,ERR=40)CALPHA
      IF(CALPHA.EQ.'DRAI88')THEN
         CALL WRIMSG('REAPAR',
     &               'DRAI88 - Draine (1988) prescription for alpha')
      ELSEIF(CALPHA.EQ.'GOBR88')THEN
         CALL WRIMSG('REAPAR',
     &      'GOBR88 - Goedecke & OBrien (1988) prescription for alpha')
      ELSEIF(CALPHA.EQ.'LATTDR')THEN
         CALL WRIMSG('REAPAR',
     &      'LATTDR - Lattice Dispersion Relation for alpha')
      ELSEIF(CALPHA.EQ.'LDRISO')THEN
         CALL WRIMSG('REAPAR',
     &     'LATTDR - Isotropized Lattice Dispersion Relation for alpha')
      ELSEIF(CALPHA.EQ.'DB1991')THEN
         CALL WRIMSG('REAPAR',
     &     'DB1991 - Dungey & Bohren (1991) prescription for alpha')
      ELSEIF(CALPHA.EQ.'LR1994')THEN
         CALL WRIMSG('REAPAR',
     &     'LR1994 - Lumme & Rahola (1994) prescription for alpha')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CALPHA')
      ENDIF
C
C binary file flag
      READ(IOPAR,FMT=*,ERR=40)CBINFLAG
      IF(CBINFLAG.EQ.'allbin')CBINFLAG='ALLBIN'
      IF(CBINFLAG.EQ.'oribin')CBINFLAG='ORIBIN'
      IF(CBINFLAG.EQ.'notbin')CBINFLAG='NOTBIN'
      IF(CBINFLAG.EQ.'ALLBIN'
     &   .OR.CBINFLAG.EQ.'ORIBIN'
     &   .OR.CBINFLAG.EQ.'NOTBIN')THEN
         WRITE(CMSGNM,FMT='(A,A)')CBINFLAG,
     &                            ' - Unformatted binary dump option'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong definition of CBINFLAG')
      ENDIF
C
C binary file flag
      READ(IOPAR,FMT=*,ERR=40)CNETFLAG
      IF(CNETFLAG.EQ.'allcdf')CNETFLAG='ALLCDF'
      IF(CNETFLAG.EQ.'oricdf')CNETFLAG='ORICDF'
      IF(CNETFLAG.EQ.'notcdf')CNETFLAG='NOTCDF'
      IF(CNETFLAG.EQ.'ALLCDF'  
     &   .OR.CNETFLAG.EQ.'ORICDF' 
     &   .OR.CNETFLAG.EQ.'NOTCDF')THEN
         WRITE(CMSGNM,FMT='(A,A)')CNETFLAG,
     &                            ' - netCDF file option'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong definition of CNETFLAG')
      ENDIF
C
C***********************************************************************
C
C    Define shape:
C
C    CSHAPE*6 = 'FRMFIL'     read shape data from file
C             = 'RCTNGL'     make rectangular solid
C             = 'ELLIPS'     make ellipsoidal solid
C             = 'CYLNDR'     make cylindrical solid
C             = 'HEXGON'     make hexagonal prism
C             = 'TETRAH'     make regular tetrahedron
C             = 'UNICYL'     make cylinder of unixaxial material
C             = 'ANIELL'     make ellipsoid of anisotropic material
C             = 'TWOELL'     make two touching ellipsoids of materials 1,2
C             = 'TWOAEL'     make two touching anisotropic ellipsoids of
C                            materials 1-6
C             = 'THRELL'     make three touching isotropic ellipsoids of
C                            materials 1,2,3
C             = 'THRAEL'     make three touching anisotropic ellipsoids of
C                            materials 1-9
C             = 'CONELL'     make two concentric ellipsoids of
C                            materials 1,2
C             = 'BLOCKS'     make target out of cubic blocks defined by
C                            data in file 'blocks.par'
C             = 'DW1996'     make 13-cube target used by Draine &
C                            Weingartner 1996
C             = 'TWOSPH'     make two touching spheroids with symmetry axes at
C                            specified angle
C
      READ(IOPAR,FMT=*,ERR=40)CSHAPE
      IF(    CSHAPE.EQ.'FRMFIL'
     &   .OR.CSHAPE.EQ.'RCTNGL'
     &   .OR.CSHAPE.EQ.'ELLIPS'
     &   .OR.CSHAPE.EQ.'CYLNDR'
     &   .OR.CSHAPE.EQ.'HEXGON'
     &   .OR.CSHAPE.EQ.'TETRAH'
     &   .OR.CSHAPE.EQ.'UNICYL'
     &   .OR.CSHAPE.EQ.'ANIELL'
     &   .OR.CSHAPE.EQ.'TWOELL'
     &   .OR.CSHAPE.EQ.'TWOAEL'
     &   .OR.CSHAPE.EQ.'THRELL'
     &   .OR.CSHAPE.EQ.'THRAEL'
     &   .OR.CSHAPE.EQ.'CONELL'
     &   .OR.CSHAPE.EQ.'BLOCKS'
     &   .OR.CSHAPE.EQ.'DW1996'
     &   .OR.CSHAPE.EQ.'TWOSPH')THEN
         WRITE(CMSGNM,FMT='(A,A)')CSHAPE,' - Shape definition '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong shape directive ')
      ENDIF
C
C Read shape parameters
C Need 3 shape parameters for all options except 
C      FRMFIL (here skip a line, later read target from file)
C      TETRAH, DW1996 (1 shape parameter)
C      CYLNDR, HEXGON, UNICYL (2 shape parameters)
C      TWOSPH (5 shape parameters)
C      CONELL (6 shape parameters)
C
      IF(CSHAPE.EQ.'FRMFIL')THEN
         READ(IOPAR,FMT=*,ERR=40)
      ELSEIF(
     &   CSHAPE.EQ.'TETRAH'.OR.
     &   CSHAPE.EQ.'DW1996')THEN
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1)
      ELSEIF(
     &   CSHAPE.EQ.'CYLNDR'.OR.
     &   CSHAPE.EQ.'HEXGON'.OR.
     &   CSHAPE.EQ.'UNICYL')THEN
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1),SHPAR(2)
      ELSEIF(CSHAPE.EQ.'TWOSPH')THEN
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1),SHPAR(2),SHPAR(3),
     &                           SHPAR(4),SHPAR(5)
      ELSEIF(CSHAPE.EQ.'CONELL')THEN
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1),SHPAR(2),SHPAR(3),
     &                           SHPAR(4),SHPAR(5),SHPAR(6)
      ELSE
         READ(IOPAR,FMT=*,ERR=40)SHPAR(1),SHPAR(2),SHPAR(3)
      ENDIF
C***********************************************************************
C
C   Obtain names of file(s) containing dielectric function(s)
C   NCOMP = number of different dielectric functions
C   CFLEPS(1-NCOMP) = names of files containing dielectric functions
C
      READ(IOPAR,FMT=*,ERR=40)NCOMP
C
C*** Check that MXCOMP is large enough *********************************
      IF(NCOMP.GT.MXCOMP)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP > MXCOMP: must increase MXCOMP in DDSCAT')
C
C*** Check that NCOMP=2 if CSHAPE=UNICYL *******************************
C                     3           ANIELL
C                     2           TWOELL
C                     3           THRELL
C                     6           TWOAEL
C                     9           THRAEL
C                     2           CONELL
C                     2           TWOSPH
      IF(CSHAPE.EQ.'UNICYL'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option UNICYL')
      IF(CSHAPE.EQ.'ANIELL'.AND.NCOMP.NE.3)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 3 for option ANIELL')
      IF(CSHAPE.EQ.'TWOELL'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option TWOELL')
      IF(CSHAPE.EQ.'THRELL'.AND.NCOMP.NE.3)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 3 for option THRELL')
      IF(CSHAPE.EQ.'TWOAEL'.AND.NCOMP.NE.6)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 6 for option TWOAEL')
      IF(CSHAPE.EQ.'THRAEL'.AND.NCOMP.NE.9)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 9 for option THRAEL')
      IF(CSHAPE.EQ.'CONELL'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option CONELL')
      IF(CSHAPE.EQ.'TWOSPH'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option TWOSPH')
C***********************************************************************
      READ(IOPAR,FMT=*,ERR=40)CDIEL
      IF(CDIEL.EQ.'TABLES')THEN
         DO 1000 J=1,NCOMP
             READ(IOPAR,FMT=*,ERR=40)CFLEPS(J)
 1000    CONTINUE
      ELSEIF(CDIEL.EQ.'H2OICE'.OR.CDIEL.EQ.'H2OLIQ')THEN
         IF(NCOMP.GT.1)CALL ERRMSG('FATAL','REAPAR',
     &                              'H2OICE/LIQ with NCOMP>1?')
      ELSE
         CALL ERRMSG('FATAL','REAPAR','Unrecognized option for CDIEL')
      ENDIF
C***********************************************************************
C
C    Define INITIALIZATION:
C
C    INIT = 0 to start with |X0>=0
C           1 to obtain |X0> from 4th-order expansion in polarizability
C           2 to read |X0> from file solvp.in
C
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      READ(IOPAR,FMT=*,ERR=40)INIT
      IF(INIT.EQ.0)THEN
         CALL WRIMSG('REAPAR',
     &               'INIT=0 to start with |X0>=0 (CCG method)')
      ELSEIF(INIT.EQ.1)THEN
         CALL WRIMSG('REAPAR',
     &         'INIT=1 to obtain |X0> from 4th-order expansion (CCG)')
      ELSEIF(INIT.EQ.2)THEN
         CALL WRIMSG('REAPAR',
     &        'INIT=2 to read |X0> from file solvp.in')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong value of INIT')
      ENDIF
C***********************************************************************
C
C    Define error tolerance:
C
C    TOL= maximum acceptable value of |Ax-E|/|E|
C
      READ(IOPAR,FMT=*,ERR=40)TOL
      IF(TOL.GT.1.E-15.AND.TOL.LT.1.E-1)THEN
         WRITE(CMSGNM,FMT='(1P,E10.3,A)')TOL,
     &         ' = TOL = max. acceptable normalized residue |Ax-E|/|E|'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('WARNING','REAPAR',' Strange value of TOL ')
      ENDIF
C***********************************************************************
C
C    Define NUMBER OF THETA AND PHI VALUES FOR EVALUATION OF CSCA AND G
C
C    ICTHM = number of thetan values to use in evaluation of CSCA, G
C            (must be odd; recommend ICTHM=33)
C    IPHM  = number of phin values to use in evaluation of CSCA, G
C            (even or odd; recommend IPHM=12 or more)
C
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      READ(IOPAR,FMT=*)ICTHM
      IF((ICTHM+1)/2*2 .NE. (ICTHM+1))THEN
         CALL ERRMSG('FATAL','REAPAR',' ICTHM SHOULD BE ODD ')
      ELSE
         WRITE(CMSGNM,FMT='(I4,A)')ICTHM,
     &' - ICTHM; number of THETAN values for calc.of g and Qsca by SCAT'
         CALL WRIMSG('REAPAR',CMSGNM)
      ENDIF
      READ(IOPAR,FMT=*)IPHM
      WRITE(CMSGNM,FMT='(I4,A)')IPHM,
     &' - IPHM; number of PHIN values for calc. of g and Qsca by SCAT'
      CALL WRIMSG('REAPAR',CMSGNM)
C***********************************************************************
C
C    Define WAVELENGTH :
C
C    WAVINI = first wavelength (physical units)
C    WAVEND = last wavelength (physical units)
C    NWAV   = number of wavelengths
C    CDIVID = 'LIN', 'LOG', or 'INV' for equal increments in
C             wavelength, log(wavelength), or frequency
C
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      READ(IOPAR,FMT=*,ERR=40)WAVINI,WAVEND,NWAV,CDIVID
      WRITE(CMSGNM,FMT='(I3,A,F7.4,A,F7.4)')
     &      NWAV,' wavelengths from ',WAVINI,' to ',WAVEND
      CALL WRIMSG('REAPAR',CMSGNM)
      CALL DIVIDE(CDIVID,WAVINI,WAVEND,NWAV,MXWAV,WAVEA)
C***********************************************************************
C
C    Define AEFF = radius of equal-volume sphere (physical units)
C
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      READ(IOPAR,FMT=*)AEFINI,AEFEND,NRAD,CDIVID
      WRITE(CMSGNM,FMT='(I3,A,F7.4,A,F7.4)')
     &      NRAD,' eff. radii from ',AEFINI,' to ',AEFEND
      CALL WRIMSG('REAPAR',CMSGNM)
      CALL DIVIDE(CDIVID,AEFINI,AEFEND,NRAD,MXRAD,AEFFA)
C***********************************************************************
C
C    Define incident polarizations (in Lab Frame)
C    It is assumed that incident radiation is along x axis in Lab Frame
C
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
C Read complex polarization vector CXE01=e01 (normalize if necessary).
      READ(IOPAR,FMT=*,ERR=40)CXE01
      E1=SQRT(CXE01(1)*CONJG(CXE01(1)))
      IF(E1.NE.0.)THEN
         CALL ERRMSG('FATAL','REAPAR',' CXE01(1) must be zero!')
      ENDIF
C Normalize:
      E1=SQRT(CXE01(2)*CONJG(CXE01(2))+CXE01(3)*CONJG(CXE01(3)))
      CXE01(2)=CXE01(2)/E1
      CXE01(3)=CXE01(3)/E1
C Construct orthogonal normalized polarization vector CXE02=e02
C using xhat cross e01* = e02
C 
      CXE02(1)=(0.,0.)
      CXE02(2)=-CONJG(CXE01(3))
      CXE02(3)=CONJG(CXE01(2))
C
C IORTH=1 to calculate only for single polarization
C      =2 to also calculate for orthogonal polarization
      READ(IOPAR,FMT=*,ERR=40)IORTH
C
C***********************************************************************
C
C    Specify whether or not to write ".sca" files
C
C IWRKSC=0 to NOT write ".sca" file for each target orientation
C       =1 to write ".sca" file for each target orientation
      READ(IOPAR,FMT=*,ERR=40)IWRKSC
C
C***********************************************************************
C
C    Read information determining target rotations
C
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
      READ(IOPAR,FMT=*)BETAMI,BETAMX,NBETA
      READ(IOPAR,FMT=*)THETMI,THETMX,NTHETA
      READ(IOPAR,FMT=*)PHIMIN,PHIMAX,NPHI
C
C*** Check that values of NBETA,NTHETA,NPHI are OK:
      IF(NBETA.GT.MXBETA)
     &   CALL ERRMSG('FATAL','REAPAR',' NBETA>MXBETA: must recompile')
      IF(NPHI.GT.MXPHI)
     &   CALL ERRMSG('FATAL','REAPAR',' NPHI>MXPHI: must recompile')
      IF(NTHETA.GT.MXTHET)
     &   CALL ERRMSG('FATAL','REAPAR',' NTHETA>MXTHET: must recompile')
C
C If NPHI>1, then set IORTH=2 regardless of value input.
      IF(IORTH.EQ.1.AND.NPHI.GT.1)THEN
         IORTH=2
         CALL WRIMSG('REAPAR',
     &               'Set IORTH=2 since NPHI>1 ')
      ENDIF
C
      IF(IORTH.EQ.1)THEN
         CALL WRIMSG('REAPAR',
     &               'Calculate only for single polarization ')
      ELSEIF(IORTH.EQ.2)THEN
         CALL WRIMSG('REAPAR',
     &               'Do orthogonal polarization for each case ')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' WRONG VALUE OF IORTH ')
      ENDIF
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')BETAMI,BETAMX,
     &  ' Range of BETA values ; NBETA =',NBETA
      CALL WRIMSG('REAPAR',CMSGNM)
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')THETMI,THETMX,
     &  ' Range of THETA values; NTHETA=',NTHETA
      CALL WRIMSG('REAPAR',CMSGNM)
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')PHIMIN,PHIMAX,
     &  ' Range of PHI values ;   NPHI =',NPHI
      CALL WRIMSG('REAPAR',CMSGNM)
C Convert from degrees to radians
      BETAMI=BETAMI/DEGRAD
      BETAMX=BETAMX/DEGRAD
      THETMI=THETMI/DEGRAD
      THETMX=THETMX/DEGRAD
      PHIMIN=PHIMIN/DEGRAD
      PHIMAX=PHIMAX/DEGRAD
C***********************************************************************
C
C    Specify scattering directions to be calculated
C    THETAN,PHIN = Direction of n from n0 in calculation of the
C                  scattering matrix; cos(THETAN) is n0 \dot n
C                  and PHIN is azimuthal angle of n from Lab xy plane
C                  Note: THETA1, THETA2, and PHI for each scattering
C                  plane are entered in degrees, and immediately 
C                  converted to radians.  Arbitrary number
C                  of scattering planes may be considered.
C
      NSCA=0
      READ(IOPAR,FMT=*,ERR=40)CLINE
      CALL WRIMSG(' ',CLINE)
 22   READ(IOPAR,FMT=*,ERR=40,END=25)PHI1,THETA1,THETA2,DTHETA
      WRITE(CMSGNM,FMT='(3F7.1,A)')PHI1,THETA1,THETA2,
     &  ' = phi, theta_min, theta_max for scattering plane'
      CALL WRIMSG('REAPAR',CMSGNM)
C Convert to radians:
      PHI1=PHI1/DEGRAD
      THETA1=THETA1/DEGRAD
      THETA2=THETA2/DEGRAD
      DTHETA=DTHETA/DEGRAD
C Allow for possibility that user did not enter correct sign for
C DTHETA (if I did it, others will too...)
      IF(THETA2.LT.THETA1)DTHETA=-ABS(DTHETA)
C compute theta values for this scattering plane
      NSCA0=1
      DELTA=THETA2-THETA1
      IF(DELTA.NE.0)NSCA0=1+INT(DELTA/DTHETA+0.5)
C Check that there is enough storage space:
      IF((NSCA+NSCA0).GT.MXSCA)THEN
         WRITE(IDVOUT,FMT='(I6,I6,A)')MXSCA,NSCA0,
     &         ' =MXSCA,NSCA0 (dirs in this scatt. plane)'
         CALL ERRMSG('FATAL','REAPAR',
     &               'MXSCA too small in DDSCAT')
      ENDIF
      THETAN(NSCA+1)=THETA1
      IF(NSCA0.GT.2)THEN
         DO 23 J=2,NSCA0-1
            THETAN(NSCA+J)=THETA1+(J-1)*DTHETA
 23      CONTINUE
      ENDIF
      THETAN(NSCA+NSCA0)=THETA2
      DO 24 J=1,NSCA0
         PHIN(NSCA+J)=PHI1
 24   CONTINUE
      NSCA=NSCA+NSCA0
      WRITE(CMSGNM,FMT='(I4,A)')NSCA0,
     &  ' = number of scattering angles in this scattering plane'
      CALL WRIMSG('REAPAR',CMSGNM)
      GOTO 22
 25   CONTINUE
C
C Check that if user has requested computation of f_ml, user has
C also requested linearly-polarized incident radiation.
C 96.01.25 (BTD) We have disabled this "protection".  So long as user
C is aware that when using elliptical incident polarization the
C f_ml are not the "usual" ones with index l referring to linearly
C polarized incident modes, there is not reason not to allow user
C to calculate f_ml for the the scattered radiation.
C
C      IF(NSCA.GT.0)THEN
C         DO 26 J=1,3
C            IF(AIMAG(CXE01(J)).NE.0.)CALL ERRMSG('FATAL','REAPAR',
C     &      'pol. vector E01 is complex: DDSCAT cannot compute f_ml, so 
C     &do not ask it to!')
C 26      CONTINUE
C      ENDIF
C
      CLOSE (IOPAR)
      RETURN
   40 CONTINUE
      CALL ERRMSG('FATAL','REAPAR',' Error reading ddscat.par file')
      RETURN
      END

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
C
C     timeit_null
C
C This version of timeit is a dummy which does not provide any
C timing information.
C 94/06/20 (PJF) add dtime to the formal parameters
C
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      CHARACTER CMSGTM*(*)
C Local variables:
      CHARACTER CSTA*3,CMSGNM*70
C***********************************************************************
      DATA CSTA/'ONE'/
      IF(CSTA.EQ.'ONE')THEN
         CSTA='TWO'
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         WRITE(CMSGNM,FMT='(A,A)')'Timing results for: ',CMSGTM
         CALL WRIMSG('TIMEIT',CMSGNM)
         IF(CMSGTM(1:7).NE.'NOPRINT'.AND.CMSGTM(1:7).NE.'noprint')THEN
            WRITE(CMSGNM,FMT='(A)')
     &         'Dummy timing routine: no timings available'
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE NAMER(IWAV,IRAD,IDIR,CFLSCA,CFLAVG)
C***********************************************************************
C Purpose: to generate file names for specific (wavelength,
C                                               size,
C                                               incident direction)
C Present version allows up to 100 wavelengths, (00-99)
C                              100 sizes        (00-99)
C                             1000 directions   (000-999)
C Given:
C         IWAV=integer (0-99) identifying wavelength
C         IRAD=integer (0-99) identifying size
C         IDIR=integer (0-999) identifying direction
C Returns:
C          CFLSCA=name for output file containing Qext,Qabs,Qpha,Qsca,g
C                 and fml values for selected directions
C          CFLAVG=name for output file for given wavelength and size,
C                 containing scattering etc. averaged over inc.dir.
C
C B.T.Draine, Princeton Univ. Observatory, 1988
C History:
C 90/11/21 (BTD): Modified to allow 3 digits to identify direction
C                 and to change indices to begin from w00r00k000.sca
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      INTEGER IDIR,IDIR0,IRAD,IRAD0,IWAV,IWAV0
      CHARACTER CFLSCA*14,CFLAVG*13
C
C Local variables:
      CHARACTER A1*1,A2*1,A3*1,EXT*4,ZSCA*14,ZAVG*13
      CHARACTER N(10)*1,V1(2)*1,V2(2)*1,V3(3)*1,W(14)*1
C
C Equivalences:
      EQUIVALENCE (A1,W(1)),(V1,W(2)),(A2,W(4)),(V2,W(5)),(A3,W(7)),
     $            (V3,W(8)),(EXT,W(11))
      EQUIVALENCE (W,ZSCA)
      EQUIVALENCE (W,ZAVG)
C
C DATA statements:
      DATA N/'0','1','2','3','4','5','6','7','8','9'/
C***********************************************************************
C*** Filename CFLSCA will be of the form w01r01k001
C     (for IWAV=2,IRAD=2,IDIR=2)
C
      A1='w'
      A2='r'
      A3='k'
C*** Set IWAV0=IWAV-1 to run over range 0-99
C    Set IRAD0=IRAD-1 to run over range 0-99
C    Set IDIR0=IDIR-1 to run over range 0-999
      IWAV0=IWAV-1
      IRAD0=IRAD-1
      IDIR0=IDIR-1
      V1(1)=N(IWAV0/10+1)
      V1(2)=N(IWAV0-10*(IWAV0/10)+1)
      V2(1)=N(IRAD0/10+1)
      V2(2)=N(IRAD0-10*(IRAD0/10)+1)
      V3(1)=N(IDIR0/100+1)
      V3(2)=N((IDIR0-100*(IDIR0/100))/10+1)
      V3(3)=N(IDIR0-10*(IDIR0/10)+1)
      EXT='.sca'
      CFLSCA=ZSCA
C*** CFLAVG is of slightly different form,
C    e.g., w00r00ori.avg
      A3='o'
      V3(1)='r'
      V3(2)='i'
      V3(3)='.'
      EXT='avg '
      CFLAVG=ZAVG
      RETURN
C
      END

      SUBROUTINE DIVIDE(CDIVID,X1,X2,NX,MXARY,ARY)
C Arguments:
      REAL X1,X2
      INTEGER MXARY,NX
      CHARACTER CDIVID*3
      REAL ARY(MXARY)
C
C Local variables:
      INTEGER I
      REAL DELTA
C
C External Subroutines:
      EXTERNAL ERRMSG,WRIMSG
C
C Intrinsic Functions:
      INTRINSIC REAL
C***********************************************************************
C Given:
C       CDIVID='LIN','INV', or 'LOG'
C       X1 = lower limit to interval
C       X2 = upper limit to interval
C       NX = number of elements
C       MXARY=dimensioning information for array ARY
C
C Returns:
C       ARY(1-NX)=vector of points with
C                 ARY(1)=X1
C                 ARY(NX)=X2
C                 ARY(J) values spaced either
C                        linearly (if CDIVID.EQ.'LIN')
C                        linearly in 1/X (if CDIVID.EQ.'INV')
C                        logarithmically (if CDIVID.EQ.'LOG')
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      IF(NX.GT.MXARY)THEN
         CALL ERRMSG('FATAL','DIVIDE','  NX .GT. MXARY ')
      ENDIF
C      IF(X1.GT.X2)THEN
C         CALL ERRMSG('FATAL','DIVIDE','  X1 .GT. X2 ')
C      ENDIF
      IF(NX.LT.1)THEN
         CALL ERRMSG('FATAL','DIVIDE','  NX .LT. 1 ')
      ENDIF
      IF(NX.EQ.1)THEN
         CALL WRIMSG('DIVIDE',' Only one element initialized ')
         ARY(1)=X1
      ELSE
         IF(CDIVID.EQ.'LIN')THEN
            DELTA=(X2-X1)/REAL(NX-1)
            DO 10 I=1,NX
               ARY(I)=X1+DELTA*REAL(I-1)
   10       CONTINUE
         ELSEIF(CDIVID.EQ.'INV')THEN
            DELTA=(1./X2-1./X1)/REAL(NX-1)
            DO 20 I=1,NX
               ARY(I)=1./(1./X1+DELTA*REAL(I-1))
   20       CONTINUE
         ELSEIF(CDIVID.EQ.'LOG')THEN
            DELTA=ALOG(X2/X1)/REAL(NX-1)
            DO 30 I=1,NX
               ARY(I)=EXP(ALOG(X1)+DELTA*REAL(I-1))
   30       CONTINUE
         ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE EVALE(CXE00,AKD,IXYZ0,MXNAT,MXN3,NAT,NAT0,NX,NY,NZ,CXE)
C*** Arguments:
      INTEGER MXN3,MXNAT,NAT,NAT0,NX,NY,NZ
      INTEGER*2 IXYZ0(MXNAT,3)
      REAL AKD(3)
C Note: CXE should be dimensioned to CXE(NAT,3) in this routine
C       so that first 3*NAT elements of CXE are employed.
C       XYZ0 should be dimensioned to 
      COMPLEX CXE(NAT,3),CXE00(3)
C
C***  Local variables:
      COMPLEX CXFAC,CXI
      REAL GPI,X,X1,X2
      INTEGER IA,IX,IY,IZ,M
C
C*** Intrinsic functions:
      INTRINSIC ATAN,EXP,REAL
C
C*** Data statements:
      DATA CXI/(0.,1.)/
C***********************************************************************
C
C Given:   CXE00(1-3)=Incident E field at origin (complex) at t=0
C          AKD(1-3)=(kx,ky,kz)*d for incident wave (d=lattice spacing)
C          IXYZ0(1-NAT0,3)=x/d,y/d,z/d for each of NAT0 physical dipoles
C          MXNAT,MXN3=dimensioning information
C          NAT0=number of dipoles in physical target
C          NAT=number of locations at which to calculate CXE
C
C Returns: CXE(1-NAT,3)=incident E field at NAT locations at t=0
C
C B.T.Draine, Princeton Univ. Obs., 88.05.09
C History:
C 90.11.06 (BTD): Modified to pass array dimension.
C 90.11.29 (BTD): Modified to allow option for either
C                   physical locations only (NAT=NAT0), or
C                   extended dipole array (NAT>NAT0)
C 90.11.30 (BTD): Corrected error for case NAT>NAT0
C 90.11.30 (BTD): Corrected another error for case NAT>NAT0
C 90.12.03 (BTD): Change ordering of XYZ0 and CXE
C 90.12.05 (BTD): Corrected error in dimensioning of CXE
C 90.12.10 (BTD): Remove XYZ0, replace with IXYZ0
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
      GPI=4.*ATAN(1.)
C
C Evaluate electric field vector at each dipole location.
C
C If NAT=NAT0, then evaluate E only at occupied sites.
C If NAT>NAT0, then evaluate E at all sites.
C
      IF(NAT.EQ.NAT0)THEN
         DO 10 IA=1,NAT0
            X=0.
            DO 5 M=1,3
               X=X+AKD(M)*IXYZ0(IA,M)
    5       CONTINUE
            CXFAC=EXP(CXI*X)
            DO 7 M=1,3
               CXE(IA,M)=CXE00(M)*CXFAC
    7       CONTINUE
   10    CONTINUE
      ELSE
         IA=0
         DO 20 IZ=1,NZ
            X1=AKD(3)*REAL(IZ)
            DO 19 IY=1,NY
               X2=X1+AKD(2)*REAL(IY)
               DO 18 IX=1,NX
                  IA=IA+1
                  X=X2+AKD(1)*REAL(IX)
                  CXFAC=EXP(CXI*X)
                  DO 17 M=1,3
                     CXE(IA,M)=CXE00(M)*CXFAC
   17             CONTINUE
   18          CONTINUE
   19       CONTINUE
   20    CONTINUE
      ENDIF
      RETURN
C
      END

      SUBROUTINE DIAGL(U,V,IPAR)
C cg package
C Left preconditioning subroutine - division by diagonal
C Arguments:
      COMPLEX U(*), V(*)
      INTEGER IPAR(*)
C
C Common variables:
      CHARACTER*6 CMETHD
      INTEGER
     &   IDVOUT,MXMEMF,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,
     &   NAT,NAT0,NAT3,NX,NY,NZ
      COMPLEX CXADIA(1)
C-----------------------------------------------------------------------
      COMMON /M2/ CXADIA
      COMMON /M6/ MXNATF, MXNXF, MXNYF, MXNZF, NAT, NAT3, NAT0, 
     $  NX, NY, NZ, MXMEMF, MXN3F, IDVOUT, CMETHD
C-----------------------------------------------------------------------
      CALL CDIV(U,V,CXADIA,NAT3)
      RETURN
      END
      SUBROUTINE CDIV(U,V,CXA,N)
C Arguments:
      INTEGER N
      COMPLEX U(*), V(*), CXA(*)
C
C Local variables:
      INTEGER I
C
C cg package 
C needed by left preconditioning subroutine
      DO 10 I=1,N
        V(I)=U(I)/CXA(I)
 10   CONTINUE
      RETURN
      END
      SUBROUTINE MATVEC(CXX, CXY, IPAR)
C Arguments:
      COMPLEX CXX(*), CXY(*), IPAR(*)
C Common:
      INTEGER*2 iocc(1)
      INTEGER
     &   IDVOUT,MXMEMF,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,
     &   NAT,NAT0,NAT3,NX,NY,NZ
      CHARACTER*6 CMETHD
      REAL AKR(3)
      COMPLEX CXADIA(1),CXZC(1), CXZW(1)
C-----------------------------------------------------------------------
      COMMON /M1/ AKR, /M2/ CXADIA, /M3/ CXZC, /M4/CXZW, /M5/ IOCC
      COMMON /M6/ MXNATF, MXNXF, MXNYF, MXNZF, NAT, NAT3, NAT0, 
     &  NX, NY, NZ, MXMEMF, MXN3F, IDVOUT, CMETHD
C-----------------------------------------------------------------------
C
C***********************************************************************
C matvec  --> cxy = A cxx         'N'
C tmatvec --> cxy = A' cxx        'T'
C cmatvec --> cxy = conjg(A') cxx  'C'
C 
C Notice that DDSCAT has cases 'N' and 'C' implemented in CPROD
C Notice, however, that in DDSCAT 'T'='N'.
C Some CG methods use cases N, C (like Petravic).
C Some CG methods use cases N, T (like PIM)
C Some CG use all three products N, C, T  (parts of CCGPAK)
C
C Information about matrix A is transfered via commons /m1/-/m6/ with
C the main program. Arrays cxadia, cxzc, cxzwm, iocc are properly
C dimensioned inside "cprod". You may get warning during the compilation
C about "misaligned common". Ignore these. Also notice mxnat-f,
C mxn3-f,mxnx-f, mxny-f, mxnz-f. These are defined by "parameter
C statement" in main code and this is the reason why they have "f" suffix.
C
C ipar - information array, not used, defined for compatibility
C***********************************************************************
      CALL CPROD(AKR,CMETHD,'N',CXADIA,
     &           CXX,CXY,CXZC,CXZW,
     &           IDVOUT,IOCC,MXN3f,MXNATf,MXNXf,MXNYf,MXNZf,
     &           NAT,NAT0,NAT3,NX,NY,NZ)
      RETURN
      END

      SUBROUTINE CMATVEC(CXX, CXY, IPAR)
C Arguments:
      COMPLEX CXX(*), CXY(*), IPAR(*)
C
C Common:
      INTEGER*2 iocc(1)
      INTEGER
     &   IDVOUT,MXMEMF,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,
     &   NAT,NAT0,NAT3,NX,NY,NZ
      CHARACTER*6 CMETHD
      REAL akr(3)
      COMPLEX CXADIA(1),CXZC(1), CXZW(1)
C-----------------------------------------------------------------------
      COMMON /M1/ AKR, /M2/ CXADIA, /M3/ CXZC, /M4/CXZW, /M5/ IOCC
      COMMON /M6/ MXNATF, MXNXF, MXNYF, MXNZF, NAT, NAT3, NAT0, 
     &  NX, NY, NZ, MXMEMF, MXN3F, IDVOUT, CMETHD
C-----------------------------------------------------------------------
C Local variables:
C***********************************************************************
C matvec  --> cxy = A cxx   
C tmatvec --> cxy = A' cxx   
C cmatvec --> cxy = conjg(A') cxx   
C***********************************************************************
      CALL CPROD(AKR,CMETHD,'C',CXADIA,
     &           CXX,CXY,CXZC,CXZW,
     &           IDVOUT,IOCC,MXN3f,MXNATf,MXNXf,MXNYf,MXNZf,
     &           NAT,NAT0,NAT3,NX,NY,NZ)
      RETURN
      END

      SUBROUTINE CPROD(AK,CMETHD,CWHAT,CXADIA,
     &                 CXX,CXY,CXZC,CXZW,
     &                 IDVOUT,IOCC,MXN3,MXNAT,MXNX,MXNY,MXNZ,
     &                 NAT,NAT0,NAT3,NX,NY,NZ)
C
C If CWHAT = 'N', this returns CXY(j)=A(j,k)*CXX(k) (sum over k)
C          = 'C', this returns CXY(j)=conjg(A(k,j))*CXX(k) (sum over k)
C
C It is assumed that matrix A(j,k) is symmetric
C Diagonal elements of A(j,k) are in vector ADIAG(j)
C Off-diagonal elements of A(j,k) are produced internally by
C   subroutine ESELF, which uses 3d-FFT to accomplish convolution
C   of CXX with A-matrix.
C
C Original version of CPROD created by P.J.Flatau, Colorado State Univ.
C Subsequently modified by B.T.Draine, Princeton Univ. Obs.
C History:
C 90/11/ 4 (BTD): Major modification to incorporate FFT method (FFT
C                 computations are handled by ESELF).
C 90/11/ 8 (BTD): Remove DO...ENDDO structures; renumber DO...CONTINUEs
C 90/11/21 (BTD): Remove "CCGMVM" option: only FFT stuff retained.
C 90/12/03 (BTD): No longer necessary to change ordering of CXX and CXY
C 90/12/05 (BTD): Changed call to ESELF to eliminate MXNX,MXNY,MXNZ
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C*** Arguments:
      INTEGER IDVOUT,MXN3,MXNAT,MXNX,MXNY,MXNZ,
     &        NAT,NAT0,NAT3,NX,NY,NZ
      CHARACTER CMETHD*6,CWHAT*1
      INTEGER*2 IOCC(MXNAT)
      REAL AK(3)
      COMPLEX CXADIA(MXN3),
     &        CXX(MXN3),CXY(MXN3),CXZC(NX+1,NY+1,NZ+1,6),
     &        CXZW(MXNX*MXNY*MXNZ,*)
C
C*** Local variables:
      INTEGER J
      REAL AKD
C
C Intrinsic functions:
      INTRINSIC CONJG
C
C***********************************************************************
      AKD=SQRT(AK(1)*AK(1)+AK(2)*AK(2)+AK(3)*AK(3))
C We assume that input vector CXX has zeroes for elements corresponding
C to vacuum sites.
      IF(CWHAT.EQ.'N')THEN
C**********************************************************************
C
          CALL ESELF(CMETHD,CXX,NX,NY,NZ,AKD,CXZC,CXZW,CXY)
C
C*************************************************************************
C ESELF omitted contribution from diagonal terms: add these.
C Also remember that ESELF computes -A_jk*x_k
          DO 160 J=1,NAT3
              CXY(J)=CXADIA(J)*CXX(J)-CXY(J)
  160     CONTINUE
C
C***
C
      ELSEIF(CWHAT.EQ.'C')THEN
C Need to temporarily replace CXX by conjg(CXX)
          DO 170 J=1,NAT3
              CXX(J)=CONJG(CXX(J))
  170     CONTINUE
C**********************************************************************
C
          CALL ESELF(CMETHD,CXX,NX,NY,NZ,AKD,CXZC,CXZW,CXY)
C
C************************************************************************
C
C ESELF omitted contribution from diagonal terms: add these.
C Also remember that ESELF computed -A_jk*conjg(x_k), while
C we seek to compute conjg(A_kj)* x_k.  Since A_kj=A_jk, we have
C conjg(A_kj)*x_k=conjg(A_jk*conjg(x_k))
          DO 230 J=1,NAT3
              CXY(J)=CXADIA(J)*CXX(J)-CXY(J)
              CXY(J)=CONJG(CXY(J))
  230     CONTINUE
C Restore CXX:
          DO 240 J=1,NAT3
              CXX(J)=CONJG(CXX(J))
  240     CONTINUE
      ELSE
          WRITE(IDVOUT,FMT=*)' Error in CPROD: CWHAT= ',CWHAT
      ENDIF
C
C*** Now must "clean" product vector CXY:
C    (zero out elements corresponding to vacuum sites)
C
      IF(NAT0.LT.NAT)CALL NULLER(CXY,IOCC,MXNAT,MXN3,NAT)
      RETURN
      END

      SUBROUTINE SCAT(AK,AKS,EM1,EM2,E02,CMDTRQ,
     &    CBKSCA,CSCA,CSCAG,CTRQIN,CTRQSC,
     &    CXE,CXE00,CXF1L,CXF2L,CXP,CXSCR1,CXSCR2,CXSCR3,CXSCR4,
     &    ICTHM,IPHIM,MXN3,MXNAT,MXSCA,NAT,NAT3,NDIR,
     &    PHIN,SCRRS1,SCRRS2,THETAN,IXYZ)
C
C Arguments:
C
      CHARACTER CMDTRQ*6
      REAL CBKSCA,CSCA,E02
      INTEGER ICTHM,IPHIM,MXN3,MXNAT,MXSCA,NAT,NAT3,NDIR
      INTEGER*2 IXYZ(MXNAT,3)
      COMPLEX CXE(NAT,3),CXE00(3),CXF1L(MXSCA),CXF2L(MXSCA),CXP(NAT,3),
     &        CXSCR1(MXN3),CXSCR2(MXN3),CXSCR3(MXN3),CXSCR4(MXNAT,3)
      REAL AK(3),AKS(3,MXSCA),CSCAG(3),CTRQIN(3),CTRQSC(3),
     &     EM1(3,MXSCA),EM2(3,MXSCA),
     &     PHIN(MXSCA),SCRRS1(NAT,3),SCRRS2(MXNAT),THETAN(MXSCA)
C
C Local variables:
C
      COMPLEX CXI,CXSCL1,CXSCL2,CXSCL3
      REAL AK2,AK3,AKK,CONST,COSPHI,COSTH,DCOSTH,DPHI,EINC,ES2,
     &     PI,PHI,RRR,SINPHI,SINTH,TERM,W,WTH
      INTEGER ICOSTH,IPHI,IPHM,J,K,ND
      COMPLEX CXBS(3),CXES(3),CXTRM(3)
      REAL AKS0(3),AKS1(3),AKS2(3),AKSN(3),CTRQSCTF(3),XYZCM(3)
C
C Intrinsic functions:
C
      INTRINSIC COS,EXP,MIN,SIN,SQRT,CONJG,REAL
C
C Data statements:
C
      DATA CXI/(0.,1.)/
C***********************************************************************
C
C SCAT computes energy radiated by array of oscillating dipoles
C and corresponding scattering properties if oscillations are in
C response to incident E field.
C
C Given:
C     AK(1-3) = KX,KY,KZ = components of incident k-vector in TF
C     AKS(3,MXSCA)=scattered k vectors in TF
C     CMDTRQ = 'DOTORQ' to calculate torques
C            = 'NOTORQ' to skip calculation of torques
C     EM1(3,MXSCA)=pol.vector 1 for each scattering direction in TF
C     EM2(3,MXSCA)=pol.vector 2 for each scattering direction in TF
C     E02 = |E_0|^2 , where E_0 = incident complex E field
C     NAT = number of dipoles
C     NAT3 = 3*NAT
C     IXYZ(NAT,1-3) = x/d, y/d, z/d (integers) for dipoles 1-NAT
C     CXE(1-NAT,1-3) = components of E field at each dipole at t=0
C     CXE00(1-3) = (complex) reference polarization vector
C     CXP(1-NAT,1-3) = components of polarization of each dipole
C     ICTHM = number of THETA values for calculation of CSCA and G
C             (ICTHM must be odd; recommend ICTHM > 5*(2*pi*a/lambda)
C              for accuracy)
C     IPHIM = number of PHI values for calculation of CSCA and G
C     NDIR = number of directions at which scattering matrix elements
C            are to be computed
C     THETAN(1-NDIR) : scattering angle (radians);
C                      cos(THETAN) = n0 dot n
C                      *** BTD 98.11.18: THETAN is not used ***
C     PHIN(1-NDIR)   : scattering angle (radians);
C                      *** BTD 98.11.18: PHIN is not used ***
C
C Returns:
C     CBKSCA=differential scattering cross section for theta=pi
C            (lattice units)
C     CSCA = scattering cross section (lattice units)
C     CSCAG(1) = CSCA*<cos(theta)> , where theta=scattering angle
C     CSCAG(2) = CSCA*<sin(theta)cos(phi)>
C     CSCAG(3) = CSCA*<sin(theta)sin(phi)>
C     CTRQIN(1-3)=cross section for torque on grain due to incident
C                 E and B fields,
C                 for torque in directions x,y,z assuming incident 
C                 radiation is along x direction, 
C                 and "reference pol state" is in y direction.
C     CTRQSC(1-3)=cross section for torque on grain due to scattered
C                 E and B fields,
C                 for torque in directions x,y,z assuming incident 
C                 radiation is along x direction, 
C                 and "reference pol state" is in y direction
C                 Here "torque cross section" is defined so that
C                 torque(1-3)=(momentum flux)*(1/k)*C_torque(1-3)
C                 Total torque cross section=CTRQIN+CTRQSC
C     CXF1L(NDIR)=f_{1L} for direction NDIR
C     CXF2L(NDIR)=f_{2L} for direction NDIR
C                 where f_{1L} connects incident polarization L to
C                 outgoing theta polarization (E in scattering plane)
C                 f_{2L} connects incident polarization L to outgoing phi
C                 polarization (E perpendicular to scattering plane)
C                 This is same f_{ml} notation as used by Draine (1988;
C                 Ap.J., 333, 848).
C
C Notes:
C     AKS0(1-3)=k_s=scattered k vector (lattice units)
C     AKSN(1-3)=k_s/|k_s|=unit vector in scattering direction
C Scratch vectors introduced to permit vectorization:
C     SCRRS1 = real vector of length.GE.3*NAT
C     SCRRS2 = real vector of length.GE.NAT
C     CXSCR1 = complex scratch array of length 3*MXNAT
C     CXSCR2 = complex scratch array of length 3*MXNAT
C     CXSCR3 = complex scratch array of length 3*MXNAT
C     CXSCR4 = complex scratch array of length 3*MXNAT
C
C B.T.Draine, Princeton Univ. Obs., 87.01.04
C History:
C 88.06.29 (BTD): modified
C 89.11.28 (BTD): modified
C 90.11.02 (BTD): modified to enable use with vacuum sites.
C 90.11.20 (BTD): corrected error in calculation of f_ml (missing
C                 factor of k).
C 90.12.03 (BTD): changed ordering of XYZ0 and CXP
C                 eliminated cxe0 from argument list
C 90.12.10 (BTD): replaced XYZ0 with IXYZ0 to reduce memory use
C 91.08.14 (BTD): add CBKSCA to argument list for SCAT
C                 add code to eliminate sum over phi when theta=0 or pi
C                 add code to calculate CBKSCA
C 94.04.04 (BTD): removed superfluous CMPLX( ) operation from 2 lines
C                 in DO 200 loop. Also added new variable TERM to move
C                 some computation out of last DO loop.
C 95.06.14 (BTD): modified to compute moments <sin(theta)cos(phi)>
C                 and <sin(theta)sin(phi)> of scattered radiation
C                 added code to compute torque on grain relative to
C                 grain centroid XYZCM(1-3)
C                 NOTE: handling of grain centroid is not as efficient
C                 as it should be.  Can be recoded to reduce number
C                 of computations.
C 95.06.15 (BTD): modified to compute absorption contribution to
C                 torque on grain.
C                 added CXE and CTRQIN to argument list
C 95.06.15 (BTD): corrected errors found by Joseph Weingartner
C 95.06.16 (BTD): more corrections
C 95.06.20 (BTD): added argument CMDTRQ to allow torque calculations
C                 to be skipped if not desired.
C 95.06.22 (BTD): added factor CXI in terms appearing in evaluation
C                 of scattered torque
C 95.06.29 (BTD): Added loop to compute AKS0(1-3) for special cases
C                 theta-0 and 180. Error found by J. Weingartner.
C 95.07.20 (BTD): Add scratch vector SCRRS2
C                 Add scratch array CXSCR4 to argument list
C                 Rewrite to make torque computation more efficient:
C                 move as many calculations as possible out of loops 
C                 over scattering directions:
C                 SCRRS1 now used to store coords relative to centroid
C                 SCRRS2 now used to store (k_s dot r_j)
C                 CXSCR4 is needed to store (p_j cross r_j)
C 95.07.21 (BTD): Rewrite (again!) to make the correspondence
C                 to notation of Draine & Weingartner more apparent.
C                 This involved changing various definitions by
C                 factors of k, and change of sign of CXBS
C 95.07.24 (BTD): Corrected errors in evaluation of both scattering
C                 torque and incident torque
C 95.07.28 (BTD): Reenabled computation of CBKSCA
C 98.11.18 (BTD): Edited comments
C
C Copyright (C) 1993,1994,1995,1998 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      PI=4.*ATAN(1.)
C
C ICTHM,IPHIM determine angular grid used for calculation of total
C scattering cross section and G=<cos(theta)>
C ICTHM=number of theta values for which scattering is evaluated
C       (0 to pi)
C IPHIM=number of phi values for which scattering is evaluated
C       (0 to 2*pi)
C Note: ICTHM must be odd as Simpson's rule integration is employed.
C Check whether ICTHM is odd, and increase by 1 if not.
C
      IF(ICTHM.EQ.2*(ICTHM/2))ICTHM=ICTHM+1
C
C Incident k vector AK defines one axis (for spherical integration)
C Use (real part of) reference polarization vector CXE00 to define
C second coordinate axis.
C Construct third coordinate axis by taking cross product of first
C two axes.
C AKS1, AKS2 = vectors of length equal to AK lying along second and
C              third coordinate axes.
C
      AK2=AK(1)*AK(1)+AK(2)*AK(2)+AK(3)*AK(3)
      AKK=SQRT(AK2)
      AK3=AKK*AK2
      AKS1(1)=REAL(CXE00(1))
      AKS1(2)=REAL(CXE00(2))
      AKS1(3)=REAL(CXE00(3))
C
C EINC = magnitude of (real part of) reference electric field
C
      EINC=SQRT(AKS1(1)**2+AKS1(2)**2+AKS1(3)**2)
      IF(EINC.LE.0.)CALL ERRMSG('FATAL','SCAT',
     &                          'CXE00 IS PURE IMAGINARY!')
      RRR=AKK/EINC
      AKS1(1)=RRR*AKS1(1)
      AKS1(2)=RRR*AKS1(2)
      AKS1(3)=RRR*AKS1(3)
      AKS2(1)=(AK(2)*AKS1(3)-AK(3)*AKS1(2))/AKK
      AKS2(2)=(AK(3)*AKS1(1)-AK(1)*AKS1(3))/AKK
      AKS2(3)=(AK(1)*AKS1(2)-AK(2)*AKS1(1))/AKK
C
      DCOSTH=2./REAL(ICTHM-1)
      DPHI=2.*PI/REAL(IPHIM)
      CSCA=0.
      DO K=1,3
         CSCAG(K)=0.
         CTRQSCTF(K)=0.
      ENDDO
C
C CONST = multiplicative factor entering weights
C factor 2/(ICTHM-1) = d(cos(theta))
C factor 2*pi/IPHIM = d(phi)
C factor 3 in denom from Simpson's rule (later mult. by 1,4,2..)
C Use Simpson's rule integration over d(cos(theta))
C
      CONST=4.*PI/ (3.*REAL((ICTHM-1)*IPHIM))
C
C Note that for cos(theta)=-1 or 1 we do not need to sum over phi,
C so treat these two directions separately
C
      IF(CMDTRQ.EQ.'DOTORQ')THEN
C
C***********************************************************************
C Additional quantities required for torque computations
C XYZCM(1-3) = coordinates of grain centroid
C SCRRS1(J,K)= r_j = coordinates of dipole J relative to centroid.
C CXSCR3(J) = r_j dot p_j
C CXSCR4(J,1-3) = p_j cross r_j
C
         DO K=1,3
            XYZCM(K)=0.
            DO J=1,NAT
               XYZCM(K)=XYZCM(K)+IXYZ(J,K)
            ENDDO
            XYZCM(K)=XYZCM(K)/NAT
         ENDDO
         DO K=1,3
            DO J=1,NAT
               SCRRS1(J,K)=IXYZ(J,K)-XYZCM(K)
            ENDDO
         ENDDO
         DO J=1,NAT
            CXSCR3(J)=(0.,0.)
            DO K=1,3
               CXSCR3(J)=CXSCR3(J)+SCRRS1(J,K)*CXP(J,K)
            ENDDO
         ENDDO
         DO J=1,NAT
            CXSCR4(J,1)=CXP(J,2)*SCRRS1(J,3)-CXP(J,3)*SCRRS1(J,2)
            CXSCR4(J,2)=CXP(J,3)*SCRRS1(J,1)-CXP(J,1)*SCRRS1(J,3)
            CXSCR4(J,3)=CXP(J,1)*SCRRS1(J,2)-CXP(J,2)*SCRRS1(J,1)
         ENDDO
C***********************************************************************
      ELSE
         DO K=1,3
            DO J=1,NAT
               SCRRS1(J,K)=IXYZ(J,K)
            ENDDO
         ENDDO
      ENDIF
C
C Proceed to sum over scattering angles:
C
      DO ICOSTH=1,ICTHM
         IPHM=IPHIM
         WTH=4.
         IF(ICOSTH.GT.2*(ICOSTH/2))WTH=2.
C
C In special case ICOSTH=1 or ICTHM, we have theta=0 or pi,
C and the angle phi becomes irrelevant.  In this case we
C need only one value of phi, so we set IPHM=1 and adjust weights
C accordingly.
C
         IF(ICOSTH.EQ.1.OR.ICOSTH.EQ.ICTHM)THEN
            WTH=IPHIM
            IPHM=1
         ENDIF
         COSTH=1.-REAL(ICOSTH-1)*DCOSTH
         SINTH=SQRT(1.-MIN(COSTH*COSTH,1.))
C
C Evaluate total weight factor W
C
         W=CONST*WTH
         DO IPHI=1,IPHM
            PHI=DPHI*(REAL(IPHI)-0.5)
            SINPHI=SIN(PHI)
            COSPHI=COS(PHI)
C
C Compute scattered k vector AKS0(1-3)
C Initialize CXES(1-3) = scattered electric field
C
            DO  K=1,3
               AKS0(K)=COSTH*AK(K)+SINTH*
     &                 (COSPHI*AKS1(K)+SINPHI*AKS2(K))
               CXES(K)=(0.,0.)
            ENDDO
C
C Compute normalized scattering vector = nhat
C
            DO K=1,3
               AKSN(K)=AKS0(K)/AKK
            ENDDO
C
C Now compute CXES(1-3) = sum_j[p_j-nhat(nhat dot p_j)]exp[-ik_s dot x_j]
C      =(r/k*k)*exp(-ikr+iwt)*E(k_s,r,t)
C      where E(k_s,r,t) is complex electric field vector propagating
C      with wave vector k_s, at distance r from origin
C Notation:
C    If CMDTRQ='DOTORQ', then r_j = position relative to centroid XYZCM
C    If CMDTRQ='NOTORQ', then r_j = original lattice coords, and XYZCM=0.
C Note that since we are not concerned with overall phase shifts for
C evaluation of forces and torques, we do NOT need to worry about change 
C in phase resulting from using two different definitions of r_j when
C computing phase factors exp[-i k_s dot r_j]
C 
            DO J=1,NAT
C
C CXSCR1(J) = nhat dot p(j)
C
               CXSCR1(J)=(0.,0.)
               DO K=1,3
                  CXSCR1(J)=CXSCR1(J)+AKSN(K)*CXP(J,K)
               ENDDO
C
C SCRRS2(J) = nhat dot r(j)
C
               SCRRS2(J)=0.
               DO K=1,3
                  SCRRS2(J)=SCRRS2(J)+SCRRS1(J,K)*AKSN(K)
               ENDDO
C
C CXSCR2(J) = exp(-i*k_s dot r_j) factor for atom j
C
               CXSCR2(J)=EXP(-CXI*AKK*SCRRS2(J))
C
C CXES(1-3) = sum_j[p_j-nhat(nhat dot p_j)]exp[-ik_s dot x_j]
C
               DO K=1,3
                  CXES(K)=CXES(K)+(CXP(J,K)-AKSN(K)*CXSCR1(J))*
     &                    CXSCR2(J)
               ENDDO
            ENDDO
C
            IF(CMDTRQ.EQ.'DOTORQ')THEN
C***********************************************************************
C Additional terms required to compute torque on grain
C Have already computed
C CXES(1-3)=sum_j[p_j - k_s*(k_s dot p_j)/|k|^2]exp[-ik_s dot x_j]
C             where p_j = polarization of dipole j
C                   x_j = position of dipole j rel. to CM
C                   k_s = scattered k vector
C
C CXBS = -nhat cross CXES  = -(r/k*k)*exp(-ikr+iwt)*B(k_s,r,t)
C
               CXBS(1)=AKSN(3)*CXES(2)-AKSN(2)*CXES(3)
               CXBS(2)=AKSN(1)*CXES(3)-AKSN(3)*CXES(1)
               CXBS(3)=AKSN(2)*CXES(1)-AKSN(1)*CXES(2)
C
C CXSCL1 = sum_j p_j dot (r_j cross nhat)*exp(-i*k_s dot r_j)
C        = nhat dot sum_j (p_j cross r_j)*exp(-i*k_s dot r_j)
C recall that have previously evaluated
C CXSCR2(J) = exp(-i*k_s dot r_j) factor for atom j
C CXSCR4(J,K)=p_j cross r_j
C
               CXSCL1=(0.,0.)
               DO K=1,3
                  CXTRM(K)=(0.,0.)
               ENDDO
               DO K=1,3
                  DO J=1,NAT
                     CXTRM(K)=CXTRM(K)+CXSCR2(J)*CXSCR4(J,K)
                  ENDDO
                  CXSCL1=CXSCL1+AKSN(K)*CXTRM(K)
               ENDDO
C
C CXSCL2 = sum_j[(r_j dot p_j) - 
C                 (nhat dot p_j)*((nhat dot r_j) + 2i/k_s)]*
C                 exp(-i*k_s dot r_j)
C Have previously computed
C CXSCR1(J) = nhat dot p(j)
C CXSCR2(J) = exp(-i*k_s dot r_j) factor for atom j
C CXSCR3(J) = r_j dot p_j
C SCRRS2(J) = nhat dot r(j)
C
               CXSCL2=(0.,0.)
               DO J=1,NAT
                  CXSCL2=CXSCL2+CXSCR2(J)*(
     &                   CXSCR3(J)-CXSCR1(J)*(SCRRS2(J)+2.*CXI/AKK))
               ENDDO
C
C Note following notational correspondence:
C    present    Draine & Weingartner (1996)
C    -------    ---------------------------
C     CXES   =        V_E
C     CXBS   =        V_B
C    CXSCL1  =        S_B
C    CXSCL2  =        S_E
C
C***********************************************************************
            ENDIF
C
C Have completed computation of vector CXES(1-3) and terms to calculate
C angular momentum flux for scattering direction (THETA,PHI).
C CTRQSCTF(K) is "torque cross section" due to "scattered radiation"
C resulting in torque in lattice direction k (i.e., in "target
C frame".  After CTRQSCTF has been evaluated, we will compute CTRQSC in
C the "scattering frame", where the radiation is incident along x,
C and the "reference polarization state" is along the y direction.
C
            ES2=0.0
            DO K=1,3
               ES2=ES2+CXES(K)*CONJG(CXES(K))
            ENDDO
            CSCA=CSCA+W*ES2
            CSCAG(1)=CSCAG(1)+W*COSTH*ES2
            CSCAG(2)=CSCAG(2)+W*SINTH*COSPHI*ES2
            CSCAG(3)=CSCAG(3)+W*SINTH*SINPHI*ES2
            IF(CMDTRQ.EQ.'DOTORQ')THEN
               DO K=1,3
                  CTRQSCTF(K)=CTRQSCTF(K)-
     &               W*REAL(CONJG(CXBS(K))*CXSCL2+CONJG(CXES(K))*CXSCL1)
               ENDDO
            ENDIF
         ENDDO
C
C Save backscattering cross section:
C
         IF(ICOSTH.EQ.ICTHM)CBKSCA=AK2*AK2*ES2/E02
      ENDDO
C
C***********************************************************************
C
      CSCA=AK2*AK2*CSCA/E02
C
C Convert CSCAG and CTRQSCTF to cross sections measured in lattice units:
C
      DO K=1,3
         CSCAG(K)=AK2*AK2*CSCAG(K)/E02
      ENDDO
      IF(CMDTRQ.EQ.'DOTORQ')THEN
C
C***********************************************************************
C Compute the two contributions to the torque on the target:
C (1) torque due to E and B fields of incident radiation (CTRQIN)
C (2) torque due to E and B fields of scattered radiation (CTRQSC)
C These are first computed in the target frame, then transformed to
C the lab frame (frame where incident radiation propagates along
C the x axis, and "reference pol. state 1" is along the y axis).
C
         DO K=1,3
            CTRQSCTF(K)=AK2*AK2*CTRQSCTF(K)/E02
         ENDDO
C
C CTRQSCTF(1-3) is the vector torque cross section/|k| measured in the
C target frame.  We now compute CTRQSC(1-3)=the vector torque cross
C section in the "scattering frame", where the radiation is incident along
C the x axis, and the "reference polarization state" (at t=0) is
C linearly polarized along the y axis.
C Note that the following computation introduces an additional factor
C of |k|.
C
         CTRQSC(1)=AK(1)*CTRQSCTF(1)+AK(2)*CTRQSCTF(2)+AK(3)*CTRQSCTF(3)
         CTRQSC(2)=AKS1(1)*CTRQSCTF(1)+AKS1(2)*CTRQSCTF(2)+
     &             AKS1(3)*CTRQSCTF(3)
         CTRQSC(3)=AKS2(1)*CTRQSCTF(1)+AKS2(2)*CTRQSCTF(2)+
     &             AKS2(3)*CTRQSCTF(3)
C
C Now compute vector torque cross section due to incident radiation:
C
         DO K=1,3
            CTRQIN(K)=0.
         ENDDO
C
C Redefine scratch vector CXSCR1:
C CXSCR1(J)=conjg(p_j) dot E_0j at t=0
C
         DO J=1,NAT
            CXSCR1(J)=0.
            DO K=1,3
               CXSCR1(J)=CXSCR1(J)+CONJG(CXP(J,K))*CXE(J,K)
            ENDDO
         ENDDO
         CXSCL1=0.
         CXSCL2=0.
         CXSCL3=0.
C
C Compute CXSCL1,CXSCL2,CXSCL3=components of the torque due to
C incident E and B fields in the target frame.
C 95.06.22 (BTD): added factor CXI in r cross k term appearing in
C                 evaluations of CXSCL1,CXSCL2,CXSCL2
C 95.07.21 (BTD): corrected sign mistake (+CXI -> -CXI)
C 95.07.24 (BTD): changed def. of CXSCR1 to agree with paper,
C                 changed calc. of CXSCLn to more closely mirror paper,
C                 and changed AKS0 to AK
C
         DO J=1,NAT
            CXSCL1=CXSCL1+CONJG(CXP(J,2))*CXE(J,3)-
     &                    CONJG(CXP(J,3))*CXE(J,2)-CXI*
     &             (AK(2)*SCRRS1(J,3)-AK(3)*SCRRS1(J,2))*CXSCR1(J)
            CXSCL2=CXSCL2+CONJG(CXP(J,3))*CXE(J,1)-
     &                    CONJG(CXP(J,1))*CXE(J,3)-CXI*
     &             (AK(3)*SCRRS1(J,1)-AK(1)*SCRRS1(J,3))*CXSCR1(J)
            CXSCL3=CXSCL3+CONJG(CXP(J,1))*CXE(J,2)-
     &                    CONJG(CXP(J,2))*CXE(J,1)-CXI*
     &             (AK(1)*SCRRS1(J,2)-AK(2)*SCRRS1(J,1))*CXSCR1(J)
         ENDDO
C
C Compute CTRQIN(1-3)=2*components of torque due to incident E and B
C fields (in lab frame), expressed as a cross section:
C
         CTRQIN(1)=AK(1)*REAL(CXSCL1)+AK(2)*REAL(CXSCL2)+
     &             AK(3)*REAL(CXSCL3)
         CTRQIN(2)=AKS1(1)*REAL(CXSCL1)+AKS1(2)*REAL(CXSCL2)+
     &             AKS1(3)*REAL(CXSCL3)
         CTRQIN(3)=AKS2(1)*REAL(CXSCL1)+AKS2(2)*REAL(CXSCL2)+
     &             AKS2(3)*REAL(CXSCL3)
         DO K=1,3
            CTRQIN(K)=4.*PI*CTRQIN(K)/E02
         ENDDO
      ENDIF
C
C***********************************************************************
C
      IF(NDIR.LE.0)RETURN
C
C*** Calculate the 2 matrix elements FM1 for selected directions
C F1L(NDIR) is to the polarization state e1 (E in scattering plane)
C F2L(NDIR) is to the polarization state e2 (E perp. to scatt. plane)
C
C IMPORTANT NOTE: If the incident radiation is not linearly polarized,
C with zero imaginary component to the polarization vector, then the
C F1L and F2L computed here are NOT the "usual" f_ml, which
C describe scattering from linearly polarized states l to linearly
C polarized states m.
C If one wishes to reconstruct the "usual" f_ml even when computing
C with elliptically polarized light, then one must add additional
C code to the routine SCAT to reconstruct the f_ml from the F1L and
C F2L computed here.
C
      TERM=AK3/SQRT(E02)
      DO ND=1,NDIR
         CXF1L(ND)=(0.0,0.0)
         CXF2L(ND)=(0.0,0.0)
         DO J=1,NAT
            CXSCR2(J)=(0.0,0.0)
            CXSCR3(J)=(0.0,0.0)
            DO K=1,3
               CXSCR2(J)=CXSCR2(J)+CXP(J,K)*EM1(K,ND)
               CXSCR3(J)=CXSCR3(J)+CXP(J,K)*EM2(K,ND)
            ENDDO
         ENDDO
         DO J=1,NAT
            CXSCR1(J)=EXP(-CXI*(AKS(1,ND)*IXYZ(J,1)+
     &                          AKS(2,ND)*IXYZ(J,2)+
     &                          AKS(3,ND)*IXYZ(J,3)))
            CXF1L(ND)=CXF1L(ND)+CXSCR2(J)*CXSCR1(J)
            CXF2L(ND)=CXF2L(ND)+CXSCR3(J)*CXSCR1(J)
         ENDDO
C
C   Units: Dipole polarizations are in units of [E]*d**3, where d=lattice
C          spacing, and [E]=dimensions of E field
C          Therefore, up to this point CXF1L, CXF2L are in units
C          of [E]*d**3
C          Now multiply by AK3/SQRT(E02) (units of 1/([E]d**3)) to get
C          dimensionless result.
C
         CXF1L(ND)=CXF1L(ND)*TERM
         CXF2L(ND)=CXF2L(ND)*TERM
      ENDDO
      RETURN
C
      END

      PROGRAM DDSCAT
C**********************************************************************
C
C    DDSCAT is a program to use the Discrete Dipole Approximation (DDA)
C    to calculate the absorption and scattering properties of targets
C    of arbitrary geometry and dielectric properties.  The only
C    approximation is that the target may be approximated by an array
C    of point dipoles on a cubic lattice.
C    DDA theory and validity criteria are presented by B. T. Draine
C    (1988; Astrophys. J. 333, pp. 848-872).
C    The original version of DDSCAT was developed by B. T. Draine,
C    Princeton University Observatory.
C
C    Subsequent versions  of DDSCAT were jointly developed by
C    B. T. Draine (Princeton University Observatory) and
C    P. J. Flatau (University of California, San Diego, Scripps Inst.
C                  of Oceanography, La Jolla)
C
C    DDSCAT (Version 5a) includes the following features:
C    1. Optional generation of target arrays for to approximate several
C       standard target shapes, including
C       a. ellipsoid (sphere is special case)
C       b. cylindrical prism
C       c. rectangular prism
C       d. hexagonal prism
C       e. regular tetrahedron
C       f. cylindrical prism with anisotropic diel. tensor ("UNICYL")
C          (uniaxial material with crystal axis = cylinder axis)
C       g. ellipsoid with anisotropic diel. tensor ("ANIELL")
C       h. two touching ellipsoids with either isotropic or aniostropic
C          dielectric tensors ("TWOELL" or "TWOAEL")
C       i. three thouching ellipsoids with either isotropic or aniostropic
C          dielectric constants ("THRELL" or "THRAEL")
C       j. two concentric ellipsoids ("CONELL")
C    2. Alternatively, program may read in target array properties from
C       ascii file.
C    3. User may easily specify target orientation with respect to
C       incident plane wave.
C    4. Solution is found iteratively using Complex Conjugate Gradient
C       methods.
C    5. User may select FFT implementation:
C       a. Brenner's implementation;
C       b. Temperton's implementation;
C       c. Convex vector library implementation (if on Convex);
C       d. GPFA code of Temperton (recommended for general use).
C    6. User may select prescription for determining dipole
C       polarizabilities:
C       a. Lattice Dispersion Relation ("LATTDR"; this is recommended)
C       b. Isotropized Lattice Dispersion Relation ("LDRISO");
C       c. Prescription of Goedecke & O'Brien (1988) ("GOBR88");
C       d. Clausius-Mossotti with Radiative Reaction, as used by
C          Draine (1988) ("DRAI88").
C    7. Automatic computation of cross sections for:
C       a. absorption;
C       b. extinction;
C       c. scattering;
C       d. vector radiation pressure;
C       e. vector torque.
C    8. User may easily specify scattering directions for which
C       scattering matrixs is to be computed.
C    9. Automatic computation of orientational averages, with
C       orientation weights provided by simple subroutine.
C   10. Multicomponent targets are allowed.
C   11. Anisotropic dielectric tensors are allowed, although with
C       the restriction that the principal axes must be aligned with
C       the xyz directions in the "target frame".
C   12. Wavelength-dependent dielectric functions are read from user-
C       provided files, with automatic interpolation if necessary.
C   13. Automatic looping over radii and wavelengths if desired.
C    
C History:
C Note: Overall history of significant changes to the DDSCAT package may
C       be found in the comments in subroutine version.f .
C Here we limit comments to changes to this program module, DDSCAT.f:
C 90.11.30 (BTD): Removed LSC3 portion of CXSC complex scratch space.
C 90.12.03 (BTD): Reordered vectors.
C                 Removed LSC2 and LSC1 portions of CXSC scratch space.
C 90.12.21 (BTD): Added code to create output files
C                 'qtable' (summary of Q values)
C                 'mtable' (summary of diel. func. for material 1)
C 91.01.03 (BTD): Added MXBETA,MXPHI,MXTHET to argument list for REAPAR
C 91.01.05 (BTD): Changed I4 -> I7 in format statements 9010,9011.
C                 Set IOSHP=-1 to suppress printing of target.out file.
C 91.05.08 (BTD): Added CALPHA to argument lists for REAPAR and ALPHA
C                 and added CALPHA to various WRITE statements.
C 91.05.23 (BTD): Added IWRKSC to arg. list for REAPAR and use it to
C                 control creation of wAArBBkCCC.sca files
C                 Move lines calculating G.
C                 Move code writing to qtable and mtable.
C                 Added IDVOUT to argument list for TARGET
C 91.08.14 (BTD): Add QBKSCA to arg. list for GETFML
C                 Modify code to print out Q_bk
C 91.08.15 (BTD): Provide different headings for qtable depending on
C                 whether IORTH=1 or 2 (add statement 9043).
C 91.09.17 (BTD): Remove calls to ALPHA and EVALA (needed to move these
C                 to subroutine GETFML since alpha from Lattice
C                 Dispersion Relation depends on propagation direction
C                 and polarization state)
C                 Add CALPHA,CXEPS,ICOMP,MXCOMP to argument list for
C                 GETFML (information required by ALPHA)
C 91.11.12 (BTD): Added variable IDVSHP to argument list for TARGET
C                 (device number for REASHP to use in reading shape file)
C 93.01.15 (BTD): Divided output file qtable into 2 files:
C                 qtable (containing Q_ext,Q_abs,Q_sca,g,Q_bk) and
C                 qtable2 (containing Q_pha, Q_pol, Q_cpol)
C 93.01.16 (BTD): Modify so that qtable, qtable2, and mtable are closed
C                 after writing, and reopened for each new write
C 93.01.20 (BTD): Add MXNX, MXNY, MXNZ to argument list for subroutine
C                 EXTEND to permit checking of target size against
C                 maximum allowed dimensions
C 93.03.11 (BTD): Deleted all code associated with unused variable
C                 CMACHN (originally included to identify machine/OS)
C 93.03.12 (BTD): Changed CDESCR*60 -> CDESCR*67
C                 Moved WRITE(IDVOUT,9010) to subr. TARGET
C 93.06.02 (BTD): Corrected error in FORMAT statement 9045
C 93.06.03 (BTD): Corrected error in computation of angle-averaged
C                 backscattering cross section QBKSUM(JO) (had neglected
C                 to reset sum to zero for each new target).
C 93.09.28 (BTD): Add "fix" to work around Sun compiler/OS bug (see
C                 description below.
C 93.12.15 (BTD): Corrected calculation of PPOL.  Added comments on
C                 correspondence between our notation and elements
C                 of 2x2 amplitude scattering matrix and 4x4 Mueller
C                 scattering matrix.
C 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6) to
C                 allow up to 6 shape parameters
C 94.06.20 (PJF): Comment about NEWTMP FFT and corresponding changes
C                 in reapar, eself, extend.  Add FFT timing code
C                 TSTFFT to distribution and changes to cxfft3 and 
C                 timeit routines.
C 94.12.20 (BTD): Introduce subroutine VERSION to set value of
C                 variable CSTAMP.  version.f will now serve as
C                 location to maintain log of significant code
C                 changes.
C 95.06.15 (BTD): Changed CSTAMP from character*11 to character*22
C                 to include a date.
C 95.06.14 (BTD): Create version 5x.1 for internal use.
C                 Version 5x.1 computes vector force and torque
C                 on grain due to incident radiation.
C                 Changed QSCATG(2) to QSCAG(3,2) to allow for
C                 asymmetric scattering by target.
C                 Added variable QTRQSC(1-3,1-2) and added to
C                 argument list of GETFML
C                 Replaced variable GSUM(1-2) to QSCGSUM(1-3,1-2)
C                 Added variables QTRQAB(1-3,1-2) and 
C                 QTRQABSUM(1-3,1-2)
C 95.06.20 (PJF+: Introduce changes into DDSCAT in order to support
C           BTD): use of modular iterative solvers (e.g., CCG).
C               : add CMDSOL to argument list to specify method
C                 of solution
C               : add CMDTRQ to argument list of REAPAR and GETFML
C 95.07.10 (BTD): deleted redundant declarations of NAT,NAT0,NAT3,
C                 NX,NY,NZ (already declared in COMMON/M6/
C 95.07.20 (BTD): added new scratch array SCRRS2(MXNAT) for use in
C                 torque calculations in SCAT
C 95.07.27 (BTD): Added new scratch variable CXSCR1 for GETFML to
C                 use for storing first polarization solution while
C                 solving for second.
C 96.01.26 (BTD): Replaced IX0,IY0,IZ0 by IXYZ0
C                 (with simultaneous change in TARGET)
C 96.02.23 (BTD): Modified format statements to get additional digits
C                 for a_1, a_2, k vector, and pol. vectors.
C 96.11.05 (BTD): Modified to remove various computations to
C                 subroutines GETMUELLER and WRITESCA
C 96.11.14 (PJF): Add TIMERS, MXTIMERS, NTIMERS 
C                 Add cbinflag, cbinfile, IOBIN (binary file)
C                 Add cbinflag to formal parameters of REAPAR routine
C                 Remove GETSET routine calls
C 96.11.15 (PJF): Add cnetflag, cnetfile to reapar call. Add netCDF close
C 96.11.21 (BTD): Declared IDNC,NTIMERS,etc.
C                 Removed call to NCCLOS
C                 Added call to WRITESCA in order to call WRITENET in
C                 order to call NCCLOS in order to close netCDF file
C 96.12.02 (BTD): initialized smori to zero before looping over
C                 orientations
C                 eliminated variables S1212,S222,CX1112,CX1122,
C                 CX1221,CX1222,CX2122
C 97.07.24 (BTD): Changed argument list for GETMUELLER, replacing
C                 PHI by PHIN, in order to correct error in computation
C                 of Mueller matrix elements and amplitude scattering
C                 matrix elements (see GETMUELLER).
C 98.11.16 (BTD): creation of version 5a9
C                 see version.f for description of code modifications
C 98.12.21 (BTD): changed dimension of CFLPAR from CHARACTER*40 to
C                 CHARACTER*60 to allow longer file names
C                 (also changed in reapar.f and dielec.f)
CC end history
C Copyright (C) 1993,1994,1995,1996,1997,1998 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C    Adjustable Parameters:
C
C    MXNX   = max. extent of target in x direction
C    MXNY   =                          y
C    MXNZ   =                          z
C    MXMEM  = 0 to use Brenner FFT only, 1 to allow use of Temperton FFT
C    MXCOMP = max. number of different dielectric functions
C    MXTHET = max. number of target  rotation angles THETA
C    MXBETA = max. number of target rotation angles BETA
C    MXPHI  = max. number of target rotation angles PHI
C    MXSCA  = max. number of scattered directions
C    MXRAD  = max. number of radii
C    MXWAV  = max. number of wavelengths
C    MXWAVT = max. number of wavelengths in dielectric tables
C
C*** Set parameter MXMEM ***********************************************
      INTEGER MXMEM
      PARAMETER(MXMEM=0)
C      PARAMETER(MXMEM=1)
C
C*** Set parameters MXNX,MXNY,MXNZ *************************************
      INTEGER MXNX,MXNY,MXNZ
      PARAMETER(MXNX=8,MXNY=8,MXNZ=8)
C      PARAMETER(MXNX=12,MXNY=12,MXNZ=12)
C      PARAMETER(MXNX=16,MXNY=16,MXNZ=16)
C      PARAMETER(MXNX=12,MXNY=18,MXNZ=18)
C      PARAMETER(MXNX=16,MXNY=24,MXNZ=24)
C      PARAMETER(MXNX=20,MXNY=20,MXNZ=20)
C      PARAMETER(MXNX=24,MXNY=24,MXNZ=24)
C      PARAMETER(MXNX=25,MXNY=25,MXNZ=25)
C      PARAMETER(MXNX=32,MXNY=32,MXNZ=32)
C      PARAMETER(MXNX=36,MXNY=36,MXNZ=36)
C      PARAMETER(MXNX=24,MXNY=48,MXNZ=42)
C      PARAMETER(MXNX=40,MXNY=40,MXNZ=40)
C      PARAMETER(MXNX=48,MXNY=16,MXNZ=16)
C      PARAMETER(MXNX=48,MXNY=48,MXNZ=48)
C      PARAMETER(MXNX=72,MXNY=72,MXNZ=72)
C      PARAMETER(MXNX=96,MXNY=32,MXNZ=32)
C
C*** Set parameters MXCOMP,MXTHET,MXBETA,MXPHI,MXRAD,MXWAV,MXWAVT,MXSCA
      INTEGER MXCOMP
      PARAMETER(MXCOMP=9)
      INTEGER MXTHET,MXBETA,MXPHI 
      PARAMETER(MXTHET=100,MXBETA=100,MXPHI=100)
      INTEGER MXRAD,MXWAV,MXWAVT
      PARAMETER(MXRAD=100,MXWAV=100,MXWAVT=1500)
      INTEGER MXSCA
      PARAMETER(MXSCA=1000)
      INTEGER MXTIMERS,NTIMERS
      PARAMETER (MXTIMERS=20, NTIMERS=12)

C
C*** Derived Parameters: **********************************************
      INTEGER MXNAT,MXN3
      PARAMETER(MXNAT=MXNX*MXNY*MXNZ,MXN3=3*MXNAT)
      INTEGER MXCXSC
C MXCXSC specifies required complex scratch array CXSC
C increase from 7*MXN3 required by PETR 
C           to 10*MXN3 required by PIMCBICGSTAB method 
C                 (PIM Complex BiConjugate Gradient with Stabilization)
      PARAMETER(MXCXSC=10*MXN3)
C
C
C Common variables (required for communication with the
C conjugate gradient package):
C
      CHARACTER CMDFFT*6
      INTEGER IDVOUT,MXMEMF,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,
     &        NAT,NAT3,NAT0,NX,NY,NZ
      INTEGER*2 IOCC(MXNAT)
      REAL AKR(3)
      COMPLEX
     &   CXADIA(MXN3),
     &   CXZC(MXNX+1,MXNY+1,MXNZ+1,6),
     &   CXZW(2*MXNX,2*MXNY,2*MXNZ,3+MXMEM)
C-----------------------------------------------------------------------
      COMMON/M1/AKR
      COMMON/M2/CXADIA
      COMMON/M3/CXZC
      COMMON/M4/CXZW
      COMMON/M5/IOCC
      COMMON/M6/MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT3, 
     &          NAT0,NX,NY,NZ,MXMEMF,MXN3F,IDVOUT,CMDFFT
C-----------------------------------------------------------------------
C
C Local variables:
C
      CHARACTER CMDSOL*6,CMDTRQ*6
C
      COMPLEX CXEN
C
      REAL
     &   AEFF,AK1,AK3,BETAD,BETAMI,BETAMX,BETMID,BETMXD,
     &   DEGRAD,FREQ,
     &   PHID,PHIMAX,PHIMID,PHIMIN,PHIMXD,PI,PIA2,
     &   THETAD,THETMI,THETMX,THTMID,THTMXD,TOL,
     &   WAVE,XX
C
C Target Properties:
C AEFF=aeff=effective radius of target (physical units)
C PIA2=pi*(aeff/d)**2=pi*(3*NAT/4*pi)**(2/3)
C
C Incident Wave Properties:
C AK1=(k*d), where k=2*pi/wave=propagation vector and d=dipole spacing
C AK3=(k*d)**3
C AKE2=(k*d \dot E0), where E0 is incident polarization vector
C WAVE=wavelength (in vacuo) in physical units
C XX=k*aeff=2*pi*aeff/wave
C
C Scattering Properties:
C G=<cos(theta)> for scattered radiation
C QSCGSUM(1-3,1-2)=running (weighted) sum of g(1-3)*Q_sca
C           over target orientations, for incident polarizations 1-2,
C           where
C           g(1)=<cos(theta)> for scattered radiation
C           g(2)=<sin(theta)cos(phi)> for scattered radiation
C           g(3)=<sin(theta)sin(phi)> for scattered radiation
C           theta is measured relative to incident direction
C           phi is measured relative to x,y plane (Lab Frame)
C QPHA(1-2)=(phaseshift cross section)/(pi*aeff**2)
C QEXSUM(1-2)=running sum of QEXT over target orientations
C QABSUM(1-2)=running sum of QABS over target orientations
C QBKSUM(1-2)=running sum of QBKSCA over target orientations
C QSCSUM(1-2)=running sum of QSCA over target orientations
C QTRQSCSUM(1-3,1-2)=running sum of QTRQSC(1-3,1-2) over target orientations
C THETND=scattering angle theta in degrees
C PHIND=scattering angle phi in degrees
C SINPHI=sin(phi)
C DEPOLR=depolarization ratio for scattered of initially polarized
C        light into direction theta,phi
C PPOL=percentage polarization for scattering of initially unpolarized
C      light into direction theta,phi
C
      INTEGER
     &   IBETA,ICTHM,IDIR,IDNC,IDVERR,IDVSHP,INIT,IOPAR,IORI,IORTH,
     &   ILIN10,ILIN12,IOBIN,IOSHP,IPHI,IPHIM,IRAD,ITASK,ITHETA,
     &   IWAV,IWRKSC,
     &   J,JO,
     &   LACE,LAXI,LCLM,LGI,LPI,LQI,LSC0,
     &   NBETA,NCOMP,NORI,NPHI,NRAD,NSCAT,NTHETA,
     &   NWAV
C
C NAT=number of dipoles in target
C NAT3=3*NAT
C NBETA=number of different beta values for target orientation
C NTHETA=number of different theta values for target orientation
C NPHI=number of different phi values for target orientation
C NORI=NBETA*NTHETA*NPHI=total number of target orientations
C NSCAT=number of different scattering directions for each orientation
C NWAV=number of different wavelengths
C NRAD=number of different target radii
C INIT=0,1,2 for choice of initial vector |x0> in complex conjugate gradient
C      method
C IORTH=1 or 2 to do 1 or 2 incident polarizations
C IWRKSC=0 or 1 to suppress or generate "wAArBBkCCC.sca" files for each
C        target orientation
C NRXY=total number of elements of CXAOFF
C NX=x-length of extended target
C NY=y-length of extended target
C NZ=z-length of extended target
C
      CHARACTER
     &   CALPHA*6,CDIEL*6,CSHAPE*6,CSTAMP*22,
     &   CFLAVG*13,CFLPAR*13,CFLSCA*14,CFLSHP*13,CDESCR*67,
     &   cbinflag*6, cbinfile*14, cnetflag*6, cnetfile*14
      CHARACTER*60 CFLEPS(MXCOMP)
C     ..
C     .. Local Arrays ..
      COMPLEX
     &   CX1121(MXSCA),
     &   CXALPH(MXN3),
     &   CXE(MXN3),CXE01(3),CXE02(3),
     &   CXE01R(3),CXE02R(3),CXEPS(MXCOMP),
     &   CXF11(MXSCA),CXF12(MXSCA),CXF21(MXSCA),CXF22(MXSCA),
     &   CXRFR(MXCOMP),CXS1(MXSCA),CXS2(MXSCA),CXS3(MXSCA),CXS4(MXSCA),
     &   CXSC(MXCXSC),CXSCR1(MXN3),CXXI(MXN3)
C
C Arrays describing target properties:
C CXADIA(1-3*NAT)=diagonal elements of A matrix
C CXEPS(1-MXCOMP)=dielectric const. for each of MXCOMP materials
C CXREFR(1-3)=complex refractive index at current wavelength
C CXALPH(1-3*NAT)=diagonal elements of dipole polarizability tensor alpha
C
C Arrays describing incident radiation:
C CXE01(1-3)=incident polarization vector e01 prior to target rotation
C CXE02(1-3)=incident polarization vector e02 prior to target rotation
C CXE01R(1-3)=rotated incident polarization vector e01 in Target Frame
C CXE02R(1-3)=rotated incident polarization vector e02 in Target Frame
C CXE0R(1-3)=incident polarization vector (=CXE01R or CXE02R) being used
C CXE(1-3*NAT)=incident electric field vector in Target Frame
C
C Array describing polarization of target for one incident wave:
C CXXI(1-3*NAT)=polarization vector at each dipole
C
C Arrays describing scattering properties of target:
C CXFF11(1-NSCAT)=scattering matrix element f11 for each of NSCAT directions
C CXFF12(1-NSCAT)=                          f12
C CXFF21(1-NSCAT)=                          f21
C CXFF22(1-NSCAT)=                          f22
C CX1121(1-NSCAT)=sum of f11* \times f21 over orientations
C
C Scratch arrays:
C CXSC(1-MXCXSC)=scratch array used by DDACCG
C
      INTEGER*2 ICOMP(MXN3),ISCR1(MXN3),IXYZ0(MXNAT,3)
C
C IXYZ0(1-NAT0,1-3)=x/d,y/d,z/d for dipoles 1-NAT0 in real target
C
C Scratch arrays:
C ISCR1,ISCR2,ISCR3,ISCR4 (used by EXTEND)
C
C
      REAL
     &   A1(3),A2(3),AEFFA(MXRAD),AKSR(3,MXSCA),
     &   BETA(MXBETA),
     &   E1A(MXWAVT),E2A(MXWAVT),EM1(3,MXSCA),EM1R(3,MXSCA),
     &   EM2(3,MXSCA),EM2R(3,MXSCA),EN0R(3),ENSC(3,MXSCA),
     &   PHI(MXPHI),PHIN(MXSCA),
     &   QABS(2),QABSUM(2),QBKSCA(2),QBKSUM(2),QEXT(2),
     &   QEXSUM(2),QPHA(2),QPHSUM(2),QSCAT(2),QSCAG(3,2),QSCGSUM(3,2),
     &   QSCSUM(2),QTRQAB(3,2),QTRQSC(3,2),
     &   QTRQABSUM(3,2),QTRQSCSUM(3,2),
     &   S1111(MXSCA),S2121(MXSCA),
     &   SCRRS1(MXN3),SCRRS2(MXNAT),SHPAR(6),SM(MXSCA,4,4),
     &   SMORI(MXSCA,4,4),THETA(MXTHET),THETAN(MXSCA),
     &   WAVEA(MXWAV),WGTA(MXTHET,MXPHI),WGTB(MXBETA),WVA(MXWAVT),
     &   TIMERS(MXTIMERS)
C
C Arrays describing target properties:
C A1(1-3)=initial direction of target axis a1 in Lab Frame
C A2(1-3)=initial direction of target axis a2 in Lab Frame
C AEFFA(1-NRAD)=values of effective radius of target (physical units)
C SHPAR(1-6)=up to 6 parameters for defining target geometry
C
C Arrays describing target rotation:
C THETA(1-NTHETA)=desired values of target rotation angle theta
C BETA(1-NBETA)=desired values of target rotation angle beta
C PHI(1-NPHI)=desired values of target rotation angle phi
C WGTA(1-NTHETA,1-NPHI)=weight factor for each orientation of target
C                       axis a1 in Lab Frame
C WGTB(1-NBETA)=weight factor for rotation of target around a1
C Arrays describing incident wave:
C WAVEA(1-NWAV)=values of wavelength (physical units)
C EN0R(3)=unit vector in direction of incidence in (rotated) Target
C         Frame
C AKR(3)=k*d vector in (rotated) Target Frame
C
C Arrays describing scattering properties:
C ENSC(1-3,1-NSCAT)=scattering vectors in Lab Frame
C AKSR(1-3,1-NSCAT)=scattering k-vectors in Target Frame
C EM1(1-3,1-NSCAT)=scattering polarization state 1 in Lab Frame
C EM2(1-3,1-NSCAT)=scattering polarization state 2 in Lab Frame
C EM1R(1-3,1-NSCAT)=scattering polarization state 1 in Target Frame
C EM1R(1-3,1-NSCAT)=scattering polarization state 2 in Target Frame
C THETAN(1-NSCAT)=values of theta for NSCAT scattering directions nhat
C                 at which scattering matrix fml is to be calculated
C PHIN(1-NSCAT)=values of phi for scattering NSCAT directions nhat at
C               which scattering matrix fml is to be calculated
C S1111(1-NSCAT)=sum of |f11|**2 over target orientations
C S2121(1-NSCAT)=       |f21|**2
C QABS(1-2)=(absorption cross section)/(pi*aeff**2) for 2 polarizations
C QBKSCA(1-2)=4*pi*(diff.scatt.cross section for theta=pi)/(pi*aeff**2)
C             for 2 polarizations
C QEXT(1-2)=(extinction cross section)/(pi*aeff**2)
C QSCA(1-2)=(scattering cross section)/(pi*aeff**2)=QEXT-QABS
C QSCAT(1-2)=(scattering cross section)/(pi*aeff**2) estimated by SCAT
C
C Scratch array:
C SCRRS1(1-3*NAT)=scratch array used by DDACCG and SCAT
C SCRRS2(1-NAT)=scratch array used by SCAT
C
C External subroutines:
      EXTERNAL DIELEC,EVALA,NAMER,REAPAR
C
C Intrinsic functions:
      INTRINSIC ATAN,SQRT,CONJG,REAL
C
C Set device numbers:
C IDVOUT = device number for running I/O
C          on Sun4OS, IDVOUT=0 produces unbuffered output to standard
C                              output
C                     IDVOUT=6 produces buffered output to standard
C                              output
C IDVERR = device number for error messages
C IOPAR = device number for reading ddscat.par file
C IOSHP = device number for writing target.out (IOSHP<0 to suppress)
C IDVSHP = device number for reading shape file
      DATA IDVOUT/0/
      DATA IDVERR/0/
      DATA IDVSHP/10/
      DATA IOPAR/1/
      DATA IOSHP/-1/
C VMS version:
C      DATA CFLPAR,CFLSHP/'DDSCAT.PAR','SHAPE.DAT'/
C unix version:
      DATA CFLPAR,CFLSHP/'ddscat.par','shape.dat'/
C*** BTD 93.09.28: Workaround ******************************************
C    Problem with Sun Fortran V1.4 (1 Mar 1991) running under SunOS4.1.1
C    on Sparc IPX with tmpfs (cohabitation of /tmp and swap on same disk
C    partition).
C    Symptom: without this fix, the value of IDVOUT was "stochastic"
C    from one compilation of DDSCAT.f to another, instead of being
C    initialized to 0 by DATA statement above.  It has not been possible
C    to understand why/where this problem is occuring, but it appears to
C    be either a compiler or operating system bug.  Work around this by
C    adding line explicitly (re-)initializing IDVOUT:
      IDVOUT=0
C***********************************************************************
      CALL VERSION(CSTAMP)
      WRITE(IDVOUT,FMT=9000)CSTAMP,MXNX,MXNY,MXNZ,MXMEM
C
C Initialize various variables in common blocks which are derived
C from parameters:
C
      MXNATF=MXNAT
      MXNXF=MXNX
      MXNYF=MXNY
      MXNZF=MXNZ
      MXMEMF=MXMEM
      MXN3F=MXN3
C     ..
C Pseudo names of scratch array  positions:
      LACE=1
      LAXI=1*MXN3+1
      LCLM=2*MXN3+1
      LGI=3*MXN3+1
      LPI=4*MXN3+1
      LQI=5*MXN3+1
      LSC0=6*MXN3+1
C
      PI=4.*ATAN(1.)
      DEGRAD=180./PI
C
C
C**** Read program control parameters
C CMDFFT=choice of solution methods
C CSHAPE=description of shape
C SHPAR(1-6)= up to 6 parameters for defining target geometry
C INIT=selection of |x0> in CCG method
C TOL=error tolerance in CCG method
C ICTHM=number of theta values for computation of CSCA and G by SCAT
C IPHIM=number of phi values for computation of CSCA and G by SCAT
C MXWAV=dimensioning information for array WAVEA
C NWAV=number of wavelengths to be used
C WAVEA(1-NWAV)=wavelengths (physical units)
C MXRAD=dimensioning information for array AEFFA
C NRAD=number of radii to be used
C AEFFA(1-NRAD)=effective radii (physical units)
C IORTH=1 or 2 for 1 or 2 incident polarization states to be used
C NBETA=number of beta values to be used for target orientation
C BETAMI=minimum value of beta (radians)
C BETAMX=maximum value of beta (radians)
C NTHETA=number of theta values to be used for target orientation
C THETMI=minimum value of theta (radians)
C THETMX=maximum value of theta (radians)
C NPHI=number of phi values to be used for target orientation
C PHIMIN=minimum value of phi (radians)
C PHIMAX=maximum value of phi (radians)
C DEGRAD=degrees/radian (conversion factor)
C MXSCA=dimensioning information for arrays PHIN, THETAN
C NSCAT=number of scattered directions for computation of fml
C THETAN(1-NSCAT)=theta values (radians) for scattered directions
C PHIN(1-NSCAT)=phi values (radians) for scattered directions
C
      CALL REAPAR(cbinflag, cnetflag, AEFFA,
     &            BETAMI,BETAMX,
     &            CALPHA,CDIEL,CFLEPS,CFLPAR,CMDSOL,CMDFFT,CSHAPE,
     &            CMDTRQ,CXE01,CXE02,
     &            DEGRAD,
     &            ICTHM,IDVERR,IDVOUT,INIT,IOPAR,IORTH,IPHIM,IWRKSC,
     &            MXBETA,MXCOMP,MXMEM,MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,
     &            NBETA,NCOMP,NPHI,NRAD,NSCAT,NTHETA,NWAV,
     &            PHIMIN,PHIMAX,PHIN,
     &            THETAN,THETMI,THETMX,TOL,
     &            WAVEA,SHPAR)
C
      NORI=NTHETA*NBETA*NPHI
C Compute angles in degrees for printout
      BETMID=DEGRAD*BETAMI
      BETMXD=DEGRAD*BETAMX
      THTMID=DEGRAD*THETMI
      THTMXD=DEGRAD*THETMX
      PHIMID=DEGRAD*PHIMIN
      PHIMXD=DEGRAD*PHIMAX
C
C*** Obtain scattering vectors and scattering pol. vectors in Lab Frame
C
      CALL SCAVEC(MXSCA,NSCAT,THETAN,PHIN,CXE01,ENSC,EM1,EM2)
C
C*** Specify target properties
C
C A1(1-3)=target axis 1 in Target Frame
C A2(1-3)=target axis 2 in Target Frame
C
      CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &            SHPAR,NAT0,IXYZ0,ICOMP,IDVOUT,MXN3,NAT3)
C
C NAT0=number of dipoles in "real" target
C*** Extend target to rectangular volume suitable for FFT
C
      CALL EXTEND(CMDFFT,ICOMP,ISCR1,IDVERR,IDVOUT,IOCC,
     &            IXYZ0(1,1),IXYZ0(1,2),IXYZ0(1,3),
     &            MXNX,MXNY,MXNZ,MXNAT,MXN3,NAT,NAT0,NAT3,NX,NY,NZ)
C
C Note: IXYZ0(1-NAT0,1-3) contain coordinates of occupied lattice sites.
C
      WRITE(IDVOUT,FMT=9011)NAT,NX,NY,NZ
C
C**** Specify target orientations
C
C MXBETA=dimensioning information for array BETA of beta values
C MXTHET=dimensioning information for array THETA of theta values
C MXPHI=dimensioning information for array PHI of phi values
C BETAMI,BETAMX=minimum,maximum beta values (radians)
C THETMI,THETMX=minimum,maximum theta values (radians)
C PHIMIN,PHIMAX=minimum,maximum phi values (radians)
C BETA(1-NBETA)=beta values for target orientations (radians)
C THETA(1-NTHETA)=theta values for target orientations (radians)
C PHI(1-NPHI)=phi values for target orientations (radians)
C WGTA(1-NTHETA,1-NPHI)=weight for each orientation of axis a1 in LF
C WGTB(1-NBETA)=weight for each rotation of target around a1
C
      CALL ORIENT(BETAMI,BETAMX,THETMI,THETMX,PHIMIN,PHIMAX,
     &            MXBETA,MXTHET,MXPHI,NBETA,NTHETA,NPHI,
     &            BETA,THETA,PHI,WGTA,WGTB)
C
C*** Open file 'qtable' for summary of Q values and
C              'mtable' for summary of refractive indices
C
      OPEN(UNIT=10,FILE='qtable',STATUS='UNKNOWN')
      OPEN(UNIT=11,FILE='mtable',STATUS='UNKNOWN')
      OPEN(UNIT=12,FILE='qtable2',STATUS='UNKNOWN')
C why not use cbinfile ? and open it in writesca ?
      IOBIN=51
      OPEN(UNIT=IOBIN,file='dd.bin',form='unformatted')
C
C*** Write out header for 'qtable', 'qtable2', and 'mtable' files
      WRITE(10,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0,CDIEL
      ILIN10=7
      WRITE(10,FMT=9021)(CFLEPS(J),J=1,NCOMP)
      ILIN10=ILIN10+NCOMP
      WRITE(12,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0,CDIEL
      ILIN12=7
      WRITE(12,FMT=9021)(CFLEPS(J),J=1,NCOMP)
      ILIN12=ILIN12+NCOMP
      IF(IORTH.EQ.1)THEN
         WRITE(10,FMT=9043)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA,
     &                     PHIMID,PHIMXD,NPHI,NORI,IORTH
         ILIN10=ILIN10+6
         WRITE(12,FMT=9045)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA,
     &                     PHIMID,PHIMXD,NPHI,NORI,IORTH
         ILIN12=ILIN12+6
      ELSE
         WRITE(10,FMT=9044)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA,
     &                     PHIMID,PHIMXD,NPHI,NORI,IORTH
         ILIN10=ILIN10+6
         WRITE(12,FMT=9046)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA,
     &                  PHIMID,PHIMXD,NPHI,NORI,IORTH
         ILIN12=ILIN12+6
      ENDIF
      CLOSE(10)
      CLOSE(12)
      WRITE(11,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0,CDIEL
      WRITE(11,FMT=9021)(CFLEPS(J),J=1,NCOMP)
      WRITE(11,FMT=9048)
C
C*** Loop over wavelengths:
C
      DO IWAV=1,NWAV
         WAVE=WAVEA(IWAV)
C
C*** Determine dielectric properties of target
C
         CALL DIELEC(CDIEL,WAVE,IDVOUT,CFLEPS,CXEPS,
     &               MXCOMP,MXWAVT,NCOMP,E1A,E2A,WVA)
C
C*** Obtain complex polarizabilities
C
         DO J=1,NCOMP
            CXRFR(J)=SQRT(CXEPS(J))
            WRITE(IDVOUT,FMT=9031)CXRFR(J),CXEPS(J),J
         ENDDO
C
C**** Loop over grain sizes:
C
         DO IRAD=1,NRAD
            AEFF=AEFFA(IRAD)
            XX=2.*PI*AEFF/WAVE
            WRITE(IDVOUT,FMT=9032)AEFF,WAVE,XX
C
C Compute AK1=length of k vector in "natural" units=k*d
C (natural unit of length = d = lattice spacing)
C Remember that NAT = number of dipoles including "vacuum" sites in
C                     extended target
C               NAT0= number of dipoles in "real" target
            AK1=XX*(4.*PI/(3.*REAL(NAT0)))**(1./3.)
            AK3=AK1**3
C PIA2=pi*(aeff/d)**2
            PIA2=PI*(.75*NAT0/PI)**(2./3.)
C
C*** Initialize various sums over target orientation.
            DO JO=1,IORTH
               QSCSUM(JO)=0.
               QABSUM(JO)=0.
               QEXSUM(JO)=0.
               QBKSUM(JO)=0.
               QPHSUM(JO)=0.
               DO J=1,3
                  QSCGSUM(J,JO)=0.
                  QTRQABSUM(J,JO)=0
                  QTRQSCSUM(J,JO)=0.
               ENDDO
            ENDDO
            DO IDIR=1,NSCAT
               S1111(IDIR)=0.
               S2121(IDIR)=0.
               CX1121(IDIR)=(0.,0.)
            ENDDO
            DO J=1,4
               DO JO=1,4
                  DO IDIR=1,NSCAT
                     SMORI(IDIR,JO,J)=0.
                  ENDDO
               ENDDO
            ENDDO
C
C Loop over target orientations (target rotations in Lab Frame)
C (actually, loop over lab rotations in Target Frame)
C
            IORI=0
            DO ITHETA=1,NTHETA
               THETAD=THETA(ITHETA)*DEGRAD
               DO IBETA=1,NBETA
                  BETAD=BETA(IBETA)*DEGRAD
                  DO IPHI=1,NPHI
                     PHID=PHI(IPHI)*DEGRAD
                     IORI=IORI+1
C
C**** Obtain propagation vectors, polarization vectors, and scattering
C     vectors in Target Frame for desired target rotation in Lab Frame
C
                     CALL ROTATE(A1,A2,AK1,CXE01,CXE02,BETA(IBETA),
     &                           THETA(ITHETA),PHI(IPHI),EN0R,
     &                           CXE01R,CXE02R,
     &                           MXSCA,NSCAT,ENSC,EM1,EM2,
     &                           AKSR,EM1R,EM2R)
C
                     DO J=1,3
                        AKR(J)=AK1*EN0R(J)
                     ENDDO
C
                     CALL NAMER(IWAV,IRAD,IORI,CFLSCA,CFLAVG)
C
                     CALL GETFML(AKR,AK3,AKSR,
     &     CALPHA,CMDSOL,CMDFFT,CMDTRQ,
     &     CXADIA,CXALPH,CXE,CXE01R,CXE02R,CXEPS,
     &     CXF11,CXF12,CXF21,CXF22,CXXI,CXSC,CXSCR1,CXZC,CXZW,
     &     EM1R,EM2R,
     &     ICOMP,ICTHM,IDVOUT,INIT,IOCC,IORTH,IPHI,IPHIM,ITASK,IXYZ0,
     &     LACE,LAXI,LCLM,LGI,LPI,LQI,LSC0,
     &     MXCOMP,MXCXSC,MXMEM,MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPHI,MXSCA,
     &     NAT,NAT0,NAT3,NSCAT,NX,NY,NZ,
     &     PHI,PHIN,PIA2,
     &     QABS,QBKSCA,QEXT,QPHA,QSCAT,QSCAG,QTRQAB,QTRQSC,
     &     SCRRS1,SCRRS2,THETAN,TOL,TIMERS, MXTIMERS, NTIMERS)
C
C
C Compute Mueller scattering matrix
C
                     CALL GETMUELLER(IBETA,IORTH,IPHI,ITHETA,MXBETA,
     &                               MXSCA,MXPHI,MXTHET,NSCAT,
     &                               CMDTRQ,PHIN,SM,SMORI,
     &                               S1111,S2121,
     &                               CX1121,CXE01,CXE02,
     &                               CXF11,CXF12,CXF21,CXF22,
     &                               CXS1,CXS2,CXS3,CXS4,
     &                               QABS,QABSUM,QBKSCA,QBKSUM,QEXSUM,
     &                               QEXT,QPHA,QPHSUM,QSCAG,QSCAT,
     &                               QSCGSUM,QSCSUM,QTRQAB,QTRQABSUM,
     &                               QTRQSC,QTRQSCSUM,WGTA,WGTB)
C
C----------------------------------------------------------------------
C**** Choose whether or not to write out scattering properties for
C     current orientation; conditional may be replaced if desired.
C
C**** If IWRKSC=1, write scattering properties of current orientation:
                     IF(IWRKSC.EQ.1)THEN
                        CALL WRITESCA(MXNX,MXNY,MXNZ,
     &                  NX,NY,NZ,ICOMP,IXYZ0,MXNAT,MXN3,NAT,NAT3,
     &                  WAVEA,MXWAV,NWAV,AEFFA,MXRAD,NRAD,ITHETA,
     &                  IBETA,IPHI,THETA,MXTHET,NTHETA,BETA,MXBETA,
     &                  NBETA,PHI,MXPHI,NPHI,
     &                  TIMERS,MXTIMERS,NTIMERS,CBINFILE,IOBIN,
     &                  CBINFLAG,CNETFILE,IDNC,CNETFLAG,
     &                  ICTHM,ILIN10,ILIN12,IORI,IORTH,
     &                  IPHIM,IRAD,IWAV,MXCOMP,MXSCA,NAT0,
     &                  NCOMP,NORI,NSCAT,
     &                  CALPHA,CDESCR,CFLAVG,CFLSCA,
     &                  CMDFFT,CMDTRQ,CSHAPE,CSTAMP,
     &                  AEFF,AK1,AKR,BETAD,BETMID,BETMXD,
     &                  PHID,PHIMID,PHIMXD,THETAD,THTMID,
     &                  THTMXD,TOL,WAVE,XX,
     &                  A1,A2,PHIN,QABS,QABSUM,QBKSCA,
     &                  QBKSUM,QEXSUM,QEXT,QPHA,QPHSUM,
     &                  QSCAG,QSCAT,QSCGSUM,QSCSUM,QTRQAB,
     &                  QTRQABSUM,QTRQSC,QTRQSCSUM,
     &                  S1111,S2121,SM,SMORI,THETAN,
     &                  CX1121,CXE01,CXE01R,CXE02,
     &                  CXE02R,CXEPS,CXRFR,
     &                  CXF11,CXF21,CXF12,CXF22)
                     ENDIF
                  ENDDO
C
C*** Have completed loop over target orientation IPHI
C
               ENDDO
C
C*** Have completed loop over target orientation IBETA
C
            ENDDO
C
C*** Have completed loop over target orientation ITHETA
C*** Have completed all loops over target orientations
C
C*** Write dielectric information to 'mtable'
            FREQ=1.E4/WAVE
            CXEN=SQRT(CXEPS(1))
            WRITE(11,FMT=9058)WAVE,FREQ,CXEN,CXEPS(1)

C Set IORI=0 prior to calling WRITESCA in order to print orientational
C averages
C
            IORI=0
C
C******** Now calculate and print out orientational averages **********
C
            CALL WRITESCA(MXNX,MXNY,MXNZ,
     &                    NX,NY,NZ,ICOMP,IXYZ0,MXNAT,MXN3,NAT,NAT3,
     &                    WAVEA,MXWAV,NWAV,AEFFA,MXRAD,NRAD,ITHETA,
     &                    IBETA,IPHI,THETA,MXTHET,NTHETA,BETA,MXBETA,
     &                    NBETA,PHI,MXPHI,NPHI,
     &                    TIMERS,MXTIMERS,NTIMERS,CBINFILE,IOBIN,
     &                    CBINFLAG,CNETFILE,IDNC,CNETFLAG,
     &                    ICTHM,ILIN10,ILIN12,IORI,IORTH,
     &                    IPHIM,IRAD,IWAV,MXCOMP,MXSCA,NAT0,
     &                    NCOMP,NORI,NSCAT,
     &                    CALPHA,CDESCR,CFLAVG,CFLSCA,
     &                    CMDFFT,CMDTRQ,CSHAPE,CSTAMP,
     &                    AEFF,AK1,AKR,BETAD,BETMID,BETMXD,
     &                    PHID,PHIMID,PHIMXD,THETAD,THTMID,
     &                    THTMXD,TOL,WAVE,XX,
     &                    A1,A2,PHIN,QABS,QABSUM,QBKSCA,
     &                    QBKSUM,QEXSUM,QEXT,QPHA,QPHSUM,
     &                    QSCAG,QSCAT,QSCGSUM,QSCSUM,QTRQAB,
     &                    QTRQABSUM,QTRQSC,QTRQSCSUM,
     &                    S1111,S2121,SM,SMORI,THETAN,
     &                    CX1121,CXE01,CXE01R,CXE02,
     &                    CXE02R,CXEPS,CXRFR,
     &                    CXF11,CXF21,CXF12,CXF22)

         ENDDO
C
C*** Have completed loop over target size
C
      ENDDO
C
C*** Have completed loop over wavelengths
C
C close binary file (this perhaps should be moved to writesca)
      CLOSE(IOBIN)
      IF(CNETFLAG.NE.'NOTCDF')THEN
         CALL WRIMSG('DDSCAT',' close NetCDF')
         CNETFLAG='NCCLOS'
         CALL WRITESCA(MXNX,MXNY,MXNZ,
     &                 NX,NY,NZ,ICOMP,IXYZ0,MXNAT,MXN3,NAT,NAT3,
     &                 WAVEA,MXWAV,NWAV,AEFFA,MXRAD,NRAD,ITHETA,
     &                 IBETA,IPHI,THETA,MXTHET,NTHETA,BETA,MXBETA,
     &                 NBETA,PHI,MXPHI,NPHI,
     &                 TIMERS,MXTIMERS,NTIMERS,CBINFILE,IOBIN,
     &                 CBINFLAG,CNETFILE,IDNC,CNETFLAG,
     &                 ICTHM,ILIN10,ILIN12,IORI,IORTH,
     &                 IPHIM,IRAD,IWAV,MXCOMP,MXSCA,NAT0,
     &                 NCOMP,NORI,NSCAT,
     &                 CALPHA,CDESCR,CFLAVG,CFLSCA,
     &                 CMDFFT,CMDTRQ,CSHAPE,CSTAMP,
     &                 AEFF,AK1,AKR,BETAD,BETMID,BETMXD,
     &                 PHID,PHIMID,PHIMXD,THETAD,THTMID,
     &                 THTMXD,TOL,WAVE,XX,
     &                 A1,A2,PHIN,QABS,QABSUM,QBKSCA,
     &                 QBKSUM,QEXSUM,QEXT,QPHA,QPHSUM,
     &                 QSCAG,QSCAT,QSCGSUM,QSCSUM,QTRQAB,
     &                 QTRQABSUM,QTRQSC,QTRQSCSUM,
     &                 S1111,S2121,SM,SMORI,THETAN,
     &                 CX1121,CXE01,CXE01R,CXE02,
     &                 CXE02R,CXEPS,CXRFR,
     &                 CXF11,CXF21,CXF12,CXF22)
       ENDIF
C      
      STOP 'Program DDSCAT terminates normally.'
C
 9000 FORMAT(' >DDSCAT --- ',A,/,
     &       '             compiled with MXNX=',I3,' MXNY=',I3,
     &       ' MXNZ=',I3,' MXMEM=',I1)
 9011 FORMAT(7X,I7,' = NAT  = number of dipoles in extended target',/,
     &       7X,3I4,' = x,y,z length of extended target (Targ. Frame)')
 9020 FORMAT(' DDSCAT --- ',A,/,' TARGET ---',A,/,
     &       ' ',A,' --- method of solution ',/,
     &       ' ',A,' --- prescription for polarizabilities',/,
     &       ' ',A,' --- shape ',/,
     &       ' NAT0 = ',I7,' = number of dipoles',/,
     &       ' ',A,' --- source of dielectric function')
 9021 FORMAT(' ',A)
 9031 FORMAT(' n= (',F7.4,' , ',F7.4,'),  epsilon= (',F8.4,' , ',F7.4,
     &       ')  for material',I2)
 9032 FORMAT('  AEFF=',F10.5,' =',' effective radius (physical units)',
     &       /,'  WAVE=',F10.5,' = wavelength (physical units)',/,
     &       '   K*A=',F10.5,' = 2*pi*aeff/lambda')
 9043 FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2,/,
     &       2F8.3,' = theta_min, theta_max; NTHETA=',I2,/,
     &       2F8.3,' = phi_min, phi_max   ;   NPHI =',I2,/,
     &       ' Results averaged over ',I3,' target orientations',/,
     &       '                   and ',I3,' incident polarizations',/,
     &       '   aeff       wave      Q_ext     Q_abs     Q_sca    ',
     &       'g=<cos>    Q_bk')
 9044 FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2,/,
     &       2F8.3,' = theta_min, theta_max; NTHETA=',I2,/,
     &       2F8.3,' = phi_min, phi_max   ;   NPHI =',I2,/,
     &       ' Results averaged over ',I3,' target orientations',/,
     &       '                   and ',I3,' incident polarizations',/,
     &       '   aeff       wave      Q_ext     Q_abs     Q_sca    ',
     &       'g=<cos>    Q_bk')
 9045 FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2,/,
     &       2F8.3,' = theta_min, theta_max; NTHETA=',I2,/,
     &       2F8.3,' = phi_min, phi_max   ;   NPHI =',I2,/,
     &       ' Results averaged over ',I3,' target orientations',/,
     &       '                   and ',I3,' incident polarizations',/,
     &       '   aeff       wave      Q_pha')
 9046 FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2,/,
     &       2F8.3,' = theta_min, theta_max; NTHETA=',I2,/,
     &       2F8.3,' = phi_min, phi_max   ;   NPHI =',I2,/,
     &       ' Results averaged over ',I3,' target orientations',/,
     &       '                   and ',I3,' incident polarizations',/,
     &       '   aeff       wave      Q_pha      Q_pol      Q_cpol')
 9048 FORMAT(' wave(um)   f(cm-1)     Re(m)     Im(m)    Re(eps)   ',
     &       'Im(eps)')
 9058 FORMAT(1PE10.4,E11.4,4E10.3)
C
      END

      SUBROUTINE EXTEND(CMETHD,ICOMP,ICOMP2,IDVERR,IDVOUT,IOCC,IX,IY,IZ,
     &                  MXNX,MXNY,MXNZ,MXNAT,MXN3,NAT,NAT0,NAT3,
     &                  NX,NY,NZ)
C Arguments:
      CHARACTER*6 CMETHD
      INTEGER
     &   IDVERR,IDVOUT,MXNAT,MXN3,MXNX,MXNY,MXNZ,
     &   NAT,NAT0,NAT3,NX,NY,NZ
      INTEGER*2
     &   ICOMP(MXN3),ICOMP2(MXN3),IOCC(MXNAT),
     &   IX(MXNAT),IY(MXNAT),IZ(MXNAT)
C Local parameters:
      INTEGER MX235
      PARAMETER(MX235=136)
C Local variables:
      INTEGER IXA,IXMAX,IXMIN,IYA,IYMAX,IYMIN,
     &        IZA,IZMAX,IZMIN,JA,JA2,NXY
      INTEGER NF235(MX235)
      SAVE NF235
C***********************************************************************
C Given:
C    NAT0 = number of dipoles in real target
C    IX(1-NAT0) = x-index of dipoles in desired target
C    IY(1-NAT0) = y-index of dipoles in desired target
C    IZ(1-NAT0) = z-index of dipoles in desired target
C    ICOMP(1-NAT0,1-3) = composition info. for dipoles in desired target
C                       [with storage locations according to
C                        dimensioning ICOMP(MXNAT,3) ]
C    MXNX,MXNY,MXNZ = maximum allowed target size in x,y,z directions
C    MXNAT,MXN3 = dimensioning information
C
C Returns:
C    NAT = number of dipoles in extended target = NX*NY*NZ
C    NAT3 = 3*NAT
C    IX(1-NAT0) = x-index of dipoles in reordered physical target
C    IY(1-NAT0) = y-index of dipoles in reordered physical target
C    IZ(1-NAT0) = z-index of dipoles in reordered physical target
C    ICOMP(1-NAT,1-3) = composition inf. for dipoles (ICOMP=0 if vacant)
C                       [with storage locations according to
C                        dimensioning ICOMP(NAT,3) ]
C    NX = range of IX values (1 to NX)
C    NY = range of IY values (1 to NY)
C    NZ = range of IZ values (1 to NZ)
C
C Note: it is necessary to reorder IX,IY,IZ because DDSCAT calls routine
C    REDUCE to take list of polarizations for "extended" target and
C    collapse it to list of polarizations for "physical" target.
C    Similarly, REDUCE is also used to collapse vector of incident E
C    and vector of polarizabilities.
C
C B.T.Draine, Princeton Univ. Obs., 90.10.30
C History:
C 90.11. 8 (BTD): Changed DO...ENDDO to DO #...# CONTINUE
C 90.11.30 (BTD): Cosmetic changes.
C 90.11.30 (BTD): Modify to choose NX,NY,NZ from NF235.
C 90.12.05 (BTD): Change argument list; correct bug.
C 90.12.07 (BTD): Previous version was stupidly written. Rewritten.
C 90.12.13 (BTD): Corrected data list for NF235. Modified to allow
C                 CMETHD='CONVEX' option.
C 92.06.01 (BTD+PJF): Corrected major flaw in EXTEND: previous version
C                 neglected to reorder elements of IX,IY,IZ to
C                 correspond to possible reordering of occupied sites
C                 when extended target is constructed.  This error was
C                 previously overlooked because ordering was fortuitously
C                 unchanged by extend for targets generated by TARREC,
C                 TARELL, TARCYL, TARHEX.  Note that differential
C                 scattering cross sections computed previously using
C                 DDSCAT ver4a and using TARTET are not correct.
C 92.09.09 (BTD): extended values of NF235 up to 1024, and added
C                 warning if calling with IXMAX,IYMAX,or IZMAX > 1024
C 93.01.20 (BTD): added MXNX,MXNY,MXNZ to argument list and
C                 added tests to ensure that target is consistent with
C                 limits MXNX,MXNY,MXNZ
C 93.03.12 (BTD): extended NF235 up to 4096
C 94.06.20 (PJF): added code for NEWTMP 3D FFT
C 96.10.18 (BTD): changed NEWTMP to GPFAFT (Generalized Prime Factor
C                 Algorithm for Fourier Transform).
C end history
C Copyright (C) 1993,1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Elements of NF235 are numbers.le.4096  which can be factored by 2,3,5:
      DATA NF235/2,3,4,5,6,8,9,10,12,15,16,18,20,24,25,27,30,32,36,40,
     &     45,48,50,54,60,64,72,75,80,81,90,96,100,108,120,125,128,135,
     &     144,150,160,162,180,192,200,216,225,240,243,250,256,270,288,
     &     300,320,324,360,375,384,400,405,432,450,480,486,500,512,540,
     &     576,600,625,640,648,675,720,729,750,768,800,810,864,900,960,
     &     972,1000,1024,1080,1125,1152,1200,1215,1250,1280,1296,1350,
     &     1440,1458,1500,1536,1600,1620,1728,1800,1875,1920,1944,2000,
     &     2025,2048,2160,2187,2250,2304,2400,2430,2500,2560,2592,2700,
     &     2880,2916,3000,3072,3125,3200,3240,3375,3456,3600,3645,3750,
     &     3840,3888,4000,4050,4096/
C*** First determine max., min values of input IX,IY,IZ:
      IXMIN=IX(1)
      IXMAX=IX(1)
      IYMIN=IY(1)
      IYMAX=IY(1)
      IZMIN=IZ(1)
      IZMAX=IZ(1)
      DO 100 JA=2,NAT0
         IF(IX(JA).LT.IXMIN)IXMIN=IX(JA)
         IF(IX(JA).GT.IXMAX)IXMAX=IX(JA)
         IF(IY(JA).LT.IYMIN)IYMIN=IY(JA)
         IF(IY(JA).GT.IYMAX)IYMAX=IY(JA)
         IF(IZ(JA).LT.IZMIN)IZMIN=IZ(JA)
         IF(IZ(JA).GT.IZMAX)IZMAX=IZ(JA)
  100 CONTINUE
C
C*** Now shift so that IX runs from 1 to IXMAX-IXMIN+1, etc.
      DO 110 JA=1,NAT0
         IX(JA)=IX(JA)+1-IXMIN
         IY(JA)=IY(JA)+1-IYMIN
         IZ(JA)=IZ(JA)+1-IZMIN
  110 CONTINUE
      IXMAX=IXMAX-IXMIN+1
      IYMAX=IYMAX-IYMIN+1
      IZMAX=IZMAX-IZMIN+1
C
      IF(IXMAX.LE.MXNX.AND.IYMAX.LE.MXNY.AND.IZMAX.LE.MXNZ)THEN
         WRITE(IDVOUT,6100)IXMAX,IYMAX,IZMAX
      ELSE
         WRITE(IDVOUT,6200)IXMAX,IYMAX,IZMAX,MXNX,MXNY,MXNZ
         CALL ERRMSG('FATAL','EXTEND',
     &   ' need to change MXNX,MXNY,MXNZ in DDSCAT and recompile')
      ENDIF
C
C*** Now determine NX,NY,NZ
      IF(CMETHD.EQ.'BRENNR')THEN
C Using FOURX: no restriction on NX,NY,NZ:
         NX=IXMAX
         NY=IYMAX
         NZ=IZMAX
      ELSEIF(CMETHD.EQ.'TMPRTN'.OR.CMETHD.EQ.'CONVEX'
     $   .OR.CMETHD.EQ.'GPFAFT')THEN
C Using Temperton's routine CFFT99F or Convex veclib routine C3DFFT or
C Temperton's new GPFA routine:
C     NX,NY,NZ must be factorable by 2,3,5  !!
C We require that NX,NY,NZ be selected from list NF235
C Check that list is long enough:
         IF(IXMAX.GT.NF235(MX235))THEN
            WRITE(IDVERR,*)'EXTEND> Error: IXMAX=',IXMAX,
     &                     '.gt.NF235(MX235)=',NF235(MX235)
            CALL ERRMSG('FATAL','EXTEND',
     &                  ' need to add to NF235 in EXTEND')
         ELSEIF(IYMAX.GT.NF235(MX235))THEN
            WRITE(IDVERR,*)'EXTEND> Error: IYMAX=',IYMAX,
     &                     '.gt.NF235(MX235)=',NF235(MX235)
            CALL ERRMSG('FATAL','EXTEND',
     &                  ' need to add to NF235 in EXTEND')
         ELSEIF(IZMAX.GT.NF235(MX235))THEN
            WRITE(IDVERR,*)'EXTEND> Error: IZMAX=',IZMAX,
     &                     '.gt.NF235(MX235)=',NF235(MX235)
            CALL ERRMSG('FATAL','EXTEND',
     &                  ' need to add to NF235 in EXTEND')
         ENDIF
         NX=0
         NY=0
         NZ=0
         DO 115 JA=1,MX235
            IF(IXMAX.LE.NF235(JA).AND.NX.EQ.0)NX=NF235(JA)
            IF(IYMAX.LE.NF235(JA).AND.NY.EQ.0)NY=NF235(JA)
            IF(IZMAX.LE.NF235(JA).AND.NZ.EQ.0)NZ=NF235(JA)
  115    CONTINUE
      ENDIF
      IF(NX.GT.MXNX.OR.NY.GT.MXNY.OR.NZ.GT.MXNZ)THEN
         WRITE(IDVOUT,6300)NX,NY,NZ,MXNX,MXNY,MXNZ
         CALL ERRMSG('FATAL','EXTEND',
     &   ' need to change MXNX,MXNY,MXNZ in DDSCAT and recompile')
      ENDIF
      NAT=NX*NY*NZ
      NAT3=3*NAT
C
C*** Now extend target: generate vectors of dipole properties
C        ICOMP(jx,jy,jz,1-3)=ICOMP(ja,1-3)=ICOMP(ja3)
C        IOCC(jx,jy,jz)=IOCC(ja)
C    with indices jx,jy,jz running from 1-NX,1-NY,1-NZ
C              or ja          "     "   1-(NX*NY*NZ)
C              or ja3         "     "   1-(3*NX*NY*NZ)
C
C
C First initialize ICOMP and IOCC to zero:
      DO 200 JA2=1,NAT
         IOCC(JA2)=0
         ICOMP2(JA2)=0
         ICOMP2(JA2+NAT)=0
         ICOMP2(JA2+2*NAT)=0
  200 CONTINUE
C Now reset values at occupied sites
      NXY=NX*NY
      DO 300 JA=1,NAT0
         JA2=IX(JA)+NX*(IY(JA)-1)+NXY*(IZ(JA)-1)
         IOCC(JA2)=1
         ICOMP2(JA2)=ICOMP(JA)
         ICOMP2(JA2+NAT)=ICOMP(JA+MXNAT)
         ICOMP2(JA2+2*NAT)=ICOMP(JA+2*MXNAT)
  300 CONTINUE
C
C Now overwrite original ICOMP
      DO 400 JA=1,NAT3
         ICOMP(JA)=ICOMP2(JA)
  400 CONTINUE
C
C Now reorder IX,IY,IZ to correspond to new ordering of occupied sites
      JA=0
      DO 500 JA2=1,NAT
         IF(IOCC(JA2).EQ.1)THEN
            JA=JA+1
            IXA=1+MOD(JA2-1,NX)
            IYA=1+MOD(JA2-IXA,NXY)/NX
            IZA=1+(JA2-IXA-NX*(IYA-1))/NXY
            IX(JA)=IXA
            IY(JA)=IYA
            IZ(JA)=IZA
         ENDIF
  500 CONTINUE
      RETURN
 6100 FORMAT(' >EXTEND: target extent in x,y,z directions =',I3,',',I3,
     &       ',',I3,' (in Target Frame)')
 6200 FORMAT(' >EXTEND: Fatal error!:',/,
     &       '          target extent in x,y,z directions =',I3,',',I3,
     &       ',',I3,/,
     &       '          exceeds dimension limits MXNX,MXNY,MXNZ=',I3,
     &       ',',I3,',',I3)
 6300 FORMAT(' >EXTEND: Fatal error after extending target!:',/,
     &       '          Extended target extent in x,y,z directions =',
     &       I3,',',I3,',',I3,/,
     &       '          exceeds dimension limits MXNX,MXNY,MXNZ=',I3,
     &       ',',I3,',',I3)
      END

      SUBROUTINE REASHP(CFLSHP,IDVOUT,IDVSHP,A1,A2,CDESCR,MXNAT,NAT,
     &                  IXYZ,ICOMP,MXN3,NAT3)
C Arguments:
      INTEGER IDVOUT,IDVSHP,MXNAT,NAT,MXN3,NAT3
      CHARACTER CDESCR*67,CFLSHP*(*)
      INTEGER*2 IXYZ(MXNAT,3),ICOMP(MXNAT,3)
      REAL A1(3),A2(3)
C Local variables:
      INTEGER J,JJ
C***********************************************************************
C Given:
C    CFLSHP = name of (unformatted) file containing target description
C    IDVSHP  = device number to use in reading this file
C    IDVOUT = device number to use for "running" output
C    MXNAT,MXN3 = dimensioning information
C Returns:
C    A1(3)  = target axis 1
C    A2(3)  = target axis 2
C    CDESCR = string describing target
C    NAT    = number of dipoles in target
C    NAT3   = 3*NAT
C    IXYZ(1-NAT,1-3) = lattice coordinates of dipoles
C    ICOMP(1-NAT,1-3)= composition for directions x,y,z (in Target
C                      Frame) of dipoles 1-NAT.
C
C Note: It is expected that many users will wish to modify this routine
C       to be consistent with whatever target generation software they
C       use.  However, as an example (and for test purposes) this routine
C       is supplied with code compatible with the "target.out" files which
C       are generated by the "calltarget" program when called for
C       homogenous isotropic targets (shape.dat files do not include
C       information on target composition).
C       Also provided below (commented out) are
C       * a module of code appropriate for reading formatted target.out
C         file generated by the routine tarcel.f (concentric ellipsoids)
C         as an example of an inhomogeneous target.
C       * a module of code appropriate for reading an unformatted 
C         "shape.dat" file for a general target, assuming user's
C         target generation routine writes an unformatted file with
C         the same structure.
C
C
C***********************************************************************
C History:
C 91.05.02 (BTD): Added IDVOUT to argument list.
C 91.05.23 (BTD): Added A1, A2 to argument list.
C 91.11.11 (BTD): Modified for compatibility with WRITE statements in
C                 program CALLTARGET; Changed dimensioning of ICOMP from
C                 ICOMP(MXN3) to ICOMP(MXNAT,3)
C 93.09.24 (BTD): Modified to include examples of READ statements
C                 for both unformatted and formatted shape.dat files.
C                 Leave the formatted example (compatible with the
C                 "target.out" files generated by "calltarget") in effect.
C 95.04.07 (BTD): Changed CDESCR*60 -> CDESCR*67 for compatibility with
C                 calling routine TARGET
C 95.05.15 (BTD): Changed  READ(DVSHP,FMT='(A60)') to ..(A67)..
C                 Added module for inhomogeneous/anisotropic targets
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C end history
C
C Copyright (C) 1993,1995,1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C Enable following module of code if "shape.dat" file has been written
C in formatted form consistent with the "target.out" files generated by
C routines tar2el.f, tar3el.f, tarcyl.f, tarell.f, tarhex.f, tarrec.f,
C and tartet.f (in particular, this assumes homogeneous target):
C
      OPEN(UNIT=IDVSHP,FILE=CFLSHP,STATUS='OLD',FORM='FORMATTED')
      READ(IDVSHP,FMT='(A67)')CDESCR
      READ(IDVSHP,*)NAT
      READ(IDVSHP,*)A1
      READ(IDVSHP,*)A2
      READ(IDVSHP,*)
      READ(IDVSHP,*)(JJ,IXYZ(J,1),IXYZ(J,2),IXYZ(J,3),J=1,NAT)
      DO 0200 JJ=1,3
         DO 0100 J=1,NAT
            ICOMP(J,JJ)=1
 0100    CONTINUE
 0200 CONTINUE
      CLOSE(IDVSHP)
C
C***********************************************************************
C
C Enable following module of code if "shape.dat" file has been written
C in formatted form consistent with the "target.out" files generated by
C routine tarcel.f (inhomogenous target):
C
C      OPEN(UNIT=IDVSHP,FILE=CFLSHP,STATUS='OLD',FORM='FORMATTED')
C      READ(IDVSHP,FMT='(A67)')CDESCR
C      READ(IDVSHP,*)NAT
C      READ(IDVSHP,*)A1
C      READ(IDVSHP,*)A2
C      READ(IDVSHP,*)
C      READ(IDVSHP,*)(JJ,IXYZ(J,1),IXYZ(J,2),IXYZ(J,3),
C     &               ICOMP(J,1),ICOMP(J,2),ICOMP(J,3),J=1,NAT)
C      CLOSE(IDVSHP)
C
C***********************************************************************
C
C Enable following module of code if "shape.dat" file has been written
C in unformatted form consistent with these read statements:
C
C      INTEGER JX,JY,JZ
C      OPEN(UNIT=IDVSHP,FILE=CFLSHP,STATUS='OLD',FORM='UNFORMATTED')
C      READ(IDVSHP)CDESCR,NAT,A1,A2
C      READ(IDVSHP)((IXYZ(JX,JY),JX=1,NAT),JY=1,3),
C     &            ((ICOMP(J,JJ),J=1,NAT),JJ=1,3)
C      CLOSE(IDVSHP)
C
C***********************************************************************
      NAT3=3*NAT
      RETURN
      END

      SUBROUTINE ROTATE(A1,A2,AK1,CXE01,CXE02,BETA,THETA,PHI,
     &                  EN0R,CXE01R,CXE02R,MXSCA,NSCAT,ENSC,EM1,EM2,
     &                  AKSR,EM1R,EM2R)
C Arguments:
      INTEGER MXSCA,NSCAT
      REAL AK1, BETA, THETA, PHI
      REAL A1(3), A2(3), AKSR(3,MXSCA),
     &     EM1(3,MXSCA), EM1R(3,MXSCA), EM2(3,MXSCA),
     &     EM2R(3,MXSCA), EN0R(3), ENSC(3,MXSCA)
      COMPLEX CXE01(3),CXE02(3),CXE01R(3),CXE02R(3)
C Local variables
      INTEGER I
      REAL BETA0, PHI0, SINTHE, THETA0
      REAL RM1(3,3),RM2(3,3),RM3(3,3),VEC(3)
C***********************************************************************
C Given:
C       A1(1-3)=axis 1 of (original, unrotated) target
C       A2(1-3)=axis 2 of (original, unrotated) target
C       AK1=magnitude of k vector
C       CXE01(1-3)=original incident polarization vector 1
C       CXE02(1-3)=original incident polarization vector 2
C       BETA=angle (radians) through which target is to be rotated
C            around target axis A1
C       THETA=angle (radians)which target axis A1 is to make with
C            Lab x-axis
C       PHI=angle (radians) between Lab x,A1 plane and Lab x,y plane
C       ENSC(1-3,1-NSCAT)=scattering directions in Lab Frame
C       EM1(1-3,1-NSCAT)=scattering polarization vector 1 in Lab Frame
C       EM2(1-3,1-NSCAT)=scattering polarization vector 2 in Lab Frame
C
C Returns:
C       EN0R(1-3)=incident propagation vector in Target Frame
C       CXE01R(1-3)=incident polariz. vector 1 in Target Frame
C       CXE02R(1-3)=incident polariz. vector 2 in Target Frame
C       AKSR(1-3,1-NSCAT)=scattering k vectors in Target Frame
C       EM1R(1-3,1-NSCAT)=scattering pol. vector 1 in Target Frame
C       EM2R(1-3,1-NSCAT)=scattering pol. vector 2 in Target Frame
C
C Purpose:
C       In the Lab Frame, we hold the propagation direction (x-axis)
C       and incident polarization vectors (CXE01 and CXE02) fixed,
C       and rotate target to an orientation specified by the three
C       angles BETA,THETA,PHI.
C       However, computations in the main program DDSCAT are carried out
C       in the Target Frame, in which the target is held fixed and the
C       propagation vectors and polarization vectors are rotated.
C       Hence, this routine computes the incident propagation vector,
C       scattering propagation vectors, and associated polarization
C       vectors in the Target Frame.
C
C B. T. Draine, Princeton Univ. Obs., 89.11.20
C History:
C 91.04.22 (BTD) Eliminated vector A1R and removed superfluous line
C                computing A1R
C 96.11.03 (BTD) Corrected comments
C end history
C
C Copyright (C) 1996, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C** Determine the orientation angles for original unrotated target:
      THETA0=ACOS(A1(1))
      SINTHE=SIN(THETA0)
      IF(SINTHE.NE.0.)THEN
         PHI0=ACOS(A1(2)/SIN(THETA0))
      ELSE
C** If sin(THETA0)=0, we will arbitrarily assume PHI0=0
         PHI0=0.
      ENDIF
      IF(SINTHE.NE.0.)THEN
         BETA0=ACOS(-A2(1)/SINTHE)
      ELSE
         BETA0=ACOS(A2(2))
      ENDIF
C
C**** First rotate the target through angle PHI-PHI0 around x axis
C    (i.e., rotate the lab through angle PHI0-PHI around x axis)
C** obtain rotation matrix:
      VEC(1)=1.
      VEC(2)=0.
      VEC(3)=0.
      CALL ROT2(VEC,PHI0-PHI,RM1)
C
C**** Now rotate the target through angle THETA-THETA0 around axis
C     VEC = xaxis cross a1
C     (i.e., rotate the lab through angle THETA0-THETA around
C     xaxis cross a1 )
C** first compute rotation axis
      VEC(1)=0.
      VEC(2)=-A1(3)
      VEC(3)=A1(2)
C*** For special case where a1=xaxis, we want rotation axis=a1 cross a2
      IF((VEC(2)**2+VEC(3)**2).LT.1.E-10)THEN
         VEC(2)=A1(3)*A2(1)-A1(1)*A2(3)
         VEC(3)=A1(1)*A2(2)-A1(2)*A2(1)
      ENDIF
      CALL ROT2(VEC,THETA0-THETA,RM2)
      CALL MULT3(RM2,RM1,RM3)
C**** Now rotate the target through angle BETA-BETA0 around a1
C     (i.e., rotate the lab through angle BETA0-BETA around a1)
      CALL ROT2(A1,BETA0-BETA,RM1)
      CALL MULT3(RM1,RM3,RM2)
C
C**** RM2 is now the full rotation matrix
C
C**** Now rotate all required vectors:
C Incident propagation vector:
      VEC(1)=1.
      VEC(2)=0.
      VEC(3)=0.
      CALL PROD3(RM2,VEC,EN0R)
C Incident polarization vectors:
      CALL PROD3C(RM2,CXE01,CXE01R)
      CALL PROD3C(RM2,CXE02,CXE02R)
C Scattering vectors:
      CALL PROD3V(RM2,ENSC,AKSR,NSCAT,MXSCA)
      DO 50 I=1,NSCAT
         AKSR(1,I)=AK1*AKSR(1,I)
         AKSR(2,I)=AK1*AKSR(2,I)
         AKSR(3,I)=AK1*AKSR(3,I)
   50 CONTINUE
C Scattering polarization vectors:
      CALL PROD3V(RM2,EM1,EM1R,NSCAT,MXSCA)
      CALL PROD3V(RM2,EM2,EM2R,NSCAT,MXSCA)
      RETURN
      END

      SUBROUTINE TARCYL(A1,A2,A,B,CDESCR,IOSHP,MXNAT,NAT,IXYZ)
C***********************************************************************
C Purpose: to construct cylindrical target from "atoms", with cylinder
C axis along x axis.
C Input:
C        A = cylinder length (in units of lattice spacing d)
C        B = cylinder diameter (in units of lattice spacing d)
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT = dimensioning information
C Returns:
C        A1(1-3) = unit vector along cylinder axis
C        A2(1-3) = unit vector perpendicular to cylinder axis
C        CDESCR = string describing target (up to 67 chars.)
C        NAT = number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms in target
C
C B.T.Draine, Princeton Univ. Obs., 87.04.03
C History:
C 89.12.21 (BTD): Modified for use by ddscat 89.12.21
C 90.12.03 (BTD): Modified for conformity with other target routines
C 91.01.05 (BTD): Changed I4 -> I7 when printing NAT
C 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
C 93.03.12 (BTD): Changed CDESCR*(*) -> CDESCR*67
C 95.04.07 (BTD): Corrected error in code which affected target
C                 construction for 4.5<B<5.5, 6.5<B<7.5, ...
C                 In these cases code was construction target with
C                 diameter 4, 6, ... dipoles
C                 This error was discovered by Tao Du
C 96.01.25 (BTD): Modified for conformity with DDSCAT.5a
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C end history
C Copyright (C) 1993,1995,1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Scalar arguments:
      CHARACTER CDESCR*67
      INTEGER MXNAT,NAT
      REAL A,B
C Array arguments:
      INTEGER*2 IXYZ(MXNAT,3)
      REAL A1(3),A2(3)
C Local scalars:
      INTEGER IAXIS,IOSHP,JX,JY,JZ,
     &    NB,NBD,NBMAX,NBMIN,NFAC,NLAY,
     &    NX1,NX2,NY1,NY2,NZ1,NZ2
      LOGICAL IN
      REAL ASPR,PI,REFF2,ROFF,X,XOFF,Y,YOFF,Z,ZOFF
C
      PI=4.*ATAN(1.)
C
C Earlier version allowed choice of axis direction.
C Here we require cylinder axis to be x axis
C
      IAXIS=1
C
C Determine limits for testing x,y,z values
C In case of disk axis, run from I=1 to I=INT(A+0.5)
C In radial directions, place atoms as follows:
C     If B is close to even number
C          x = i + 0.5
C          with i running from -int((b+.5)/2) to int((b+.5)/2)-1
C     If B is close to odd number
C          x = i
C          with i running from -int((b+.5)/2) to int((b+.5)/2)
C
      NBD=INT(B+0.5)
      NB=INT(NBD/2)
      IF(NBD.EQ.2*(NBD/2))THEN
         ROFF=0.5
         NBMIN=-NB
         NBMAX=NB-1
      ELSE
         ROFF=0.
         NBMIN=-NB
         NBMAX=NB
      ENDIF
C
      DO 0100 JX=1,3
         A1(JX)=0.
         A2(JX)=0.
 0100 CONTINUE
         NX1=NBMIN
         NX2=NBMAX
         NY1=NBMIN
         NY2=NBMAX
         NZ1=NBMIN
         NZ2=NBMAX
         XOFF=ROFF
         YOFF=ROFF
         ZOFF=ROFF
      IF(IAXIS.EQ.1)THEN
         A1(1)=1.
         A2(2)=1.
         XOFF=0.
         NX1=1
         NX2=INT(A+0.5)
      ELSEIF(IAXIS.EQ.2)THEN
         A1(2)=1.
         A2(3)=1.
         YOFF=0.
         NY1=1
         NY2=INT(A+0.5)
      ELSEIF(IAXIS.EQ.3)THEN
         A1(3)=1.
         A2(1)=1.
         ZOFF=0.
         NZ1=1
         NZ2=INT(A+0.5)
      ENDIF
      NAT=0
      DO 1200 JZ=NZ1,NZ2
         Z=REAL(JZ)+ZOFF
         DO 1100 JY=NY1,NY2
            Y=REAL(JY)+YOFF
            DO 1000 JX=NX1,NX2
               X=REAL(JX)+XOFF
               CALL TESTCYL(X,Y,Z,A,B,IAXIS,IN)
               IF(IN)THEN
                  NAT=NAT+1
                  IF(NAT.GT.MXNAT)THEN
                      CALL ERRMSG('FATAL','TARCYL',' NAT.GT.MXNAT')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDIF
 1000       CONTINUE
 1100   CONTINUE
 1200 CONTINUE
C
C NLAY = number of layers in cylinder
C NFAC = number of atoms in slice
      NLAY=INT(A+0.5)
      NFAC=NAT/NLAY
C REFF2=EFFECTIVE RADIUS**2 OF DISK
      REFF2=REAL(NFAC)/PI
C ASPR=ASPECT RATIO (LENGTH/DIAMETER)
      ASPR=0.5*REAL(NLAY)/SQRT(REFF2)
      WRITE(CDESCR,FMT='(A,I7,A,I4,A,I4,A,F7.4)')
     &    ' Cyl.prism, NAT=',NAT,' NFAC=',NFAC,' NLAY=',NLAY,
     &    ' asp.ratio=',ASPR
C
      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)A,B,IAXIS,NAT,A1,A2
         DO 40 JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3)
   40    CONTINUE
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
 6100 FORMAT(' IAXIS=',I2,/,' A=',F7.3,/,' B=',F7.3,/,' NAT=',I4)
 9020 FORMAT(' >TARELL  cylindrical target: Length=',F8.4,
     &' Diameter=',F8.4,' IAXIS=',I1,/,
     &I7,' = NAT',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &'     JA  IX  IY  IZ')
 9030 FORMAT(I7,3I4)
      END
      SUBROUTINE TESTCYL(X,Y,Z,A,B,IAXIS,IN)
C Scalar arguments:
      INTEGER IAXIS
      LOGICAL IN
      REAL A,B,X,Y,Z
C Local scalars:
      REAL R2,S
      IN=.FALSE.
      IF(IAXIS.EQ.1)THEN
         S=X
         R2=Y*Y+Z*Z
      ELSEIF(IAXIS.EQ.2)THEN
         S=Y
         R2=X*X+Z*Z
      ELSEIF(IAXIS.EQ.3)THEN
         S=Z
         R2=X*X+Y*Y
      ENDIF
      IF(R2.GT.0.25*B*B)RETURN
      IF(S.LT.1.)RETURN
      IF(S.GT.INT(A+.5))RETURN
      IN=.TRUE.
      RETURN
      END

      SUBROUTINE TARHEX(A1,A2,A,B,CDESCR,IOSHP,MXNAT,NAT,IXYZ)
C Scalar arguments:
      CHARACTER CDESCR*67
      INTEGER IOSHP,MXNAT,NAT
      INTEGER*2 IXYZ(MXNAT,3)
      REAL A,B
C Array arguments:
      REAL A1(3),A2(3)
C Local scalars:
      CHARACTER CMSGNM*70
      INTEGER JA,JX,JY,JZ,NA,NB,NC,NFAC,NLAY,NMX,NMY,NMZ
      LOGICAL IN
      REAL ACM,ASPR,BCM,BEFF,CCM,X,Y,Z
C***********************************************************************
C Routine to construct hexagonal prism from "atoms"
C Input:
C        A=prism length/d
C        B=width of one hexagonal edge/d
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT=dimensioning information (max number of atoms)
C Output:
C        A1(1-3)=unit vector (1,0,0) defining target axis 1 (prism axis)
C        A2(1-3)=unit vector (0,1,0) defining target axis 2 (normal to
C                one of the rectangular faces.
C        NAT=number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
C        CDESCR=string describing target (up to 67 chars.)
C
C B.T.Draine, Princeton Univ. Obs., 87.04.03
C
C History:
C 90.12.02 (BTD): IOSHP is now output device for target.out
C                 (and is now closed before returning)
C 90.12.14 (BTD): Rewritten so that atoms are always on integral sites
C                 but CM coords may be either integral or half-integral
C 91.01.05 (BTD): Change I4 -> I7 when printing NAT.
C 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
C 92.09.09 (BTD+PJF): in output, NLAY was too large by factor 2 and NFAC
C                 too small by factor of 2: now fixed.
C 93.03.12 (BTD): Changed CDESCR*(*) -> CDESCR*67
C 95.07.13 (BTD): Simplify: restrict to case where prism axis is in
C                 x direction and y axis is normal to a rectangular
C                 face.
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C 96.02.23 (BTD): Delete PI (unused)
C 97.04.28 (BTD): Initialize NAT=0 (failure to do so reported by
C                 Michael Wolff).
C end history
C
C Copyright (C) 1993,1995,1996,1997 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      DO 0100 JA=1,3
         A1(JA)=0.
         A2(JA)=0.
 0100 CONTINUE
      A1(1)=1.
      A2(2)=1.
C
C A = prism length
C B = prism "diameter"
C       B/2 = length of one side of hexagon
C       B= distance between opposite vertices=max.diameter of hexagon
C       for hexagon, area=(3/8)*SQRT(3)*B**2
C       for hex prism, volume=A*area=(3/8)*SQRT(3)*A*B**2
C Now determine limits for testing x,y,z values
C Along axis, run from 1 to NA=INT(A+0.5)
C Perp. to axis, run from 1 to NB=INT(B+0.5)
      NA=INT(A+0.5)
      NB=INT(B+0.5)
      NC=INT(.5*SQRT(3.)*B+0.5)
C ACM="center" of figure in axial direction
C BCM="center" of figure in B direction
C CCM="center" of figure in C direction
      ACM=REAL(NA)/2.+0.5
      BCM=REAL(NB)/2.+0.5
      CCM=REAL(NC)/2.+0.5
      NMX=NA
      NMY=NC
      NMZ=NB
      NAT=0
      DO 1200 JZ=1,NMZ
         Z=REAL(JZ)
         DO 1100 JY=1,NMY
            Y=REAL(JY)
            DO 1000 JX=1,NMX
               X=REAL(JX)
               CALL TESTHEX(ACM,BCM,CCM,A,B,X,Y,Z,IN)
               IF(IN)THEN
                  NAT=NAT+1
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDIF
 1000       CONTINUE
 1100    CONTINUE
 1200 CONTINUE
C Now compute some geometric properties of pseudo-hexagonal prism
C   NLAY = number of layers = effective length of prism/d
C   NFAC = number of atoms in one hexagonal face
      NLAY=INT(A)
      NFAC=NAT/NLAY
C BEFF = effective length of hexagonal size/d
C        computed for hexagon of area NFAC*d**2
C                                     =(3/2)*SQRT(3)*BEFF**2
C Note: for hexagon, vertex-vertex diameter = 2*BEFF
      BEFF=.6204032*SQRT(FLOAT(NFAC))
C ASPR = effective aspect ratio of target = length/(2*BEFF)
      ASPR=.5*FLOAT(NLAY)/BEFF
C Note: string CDESCR will be printed by subr. TARGET
      WRITE(CDESCR,FMT='(A,I7,A)')' Hexagonal prism of NAT=',NAT,
     &                             ' dipoles'
C Here print any additional target info which is desired by using
C subroutine WRIMSG
      WRITE(CMSGNM,FMT='(A,3F7.4,A)')
     &    ' A1 = (',A1,') = hexagon symmetry axis'
      CALL WRIMSG('TARHEX',CMSGNM)
      WRITE(CMSGNM,FMT='(A,3F7.4,A)')
     &    ' A2 = (',A2,') = center-vertex axis'
      CALL WRIMSG('TARHEX',CMSGNM)
      WRITE(CMSGNM,FMT='(A,I7,A,I4,A,I4,A,F7.4)')
     &    ' NAT=',NAT,' NFAC=',NFAC,' NLAY=',NLAY,' aspect ratio=',ASPR
      CALL WRIMSG('TARHEX',CMSGNM)
      WRITE(CDESCR,FMT='(A,I7,A,I4,A,I4,A,F7.4)')
     &    ' Hex prism,NAT=',NAT,' NFAC=',NFAC,' NLAY=',NLAY,
     &    ' asp.ratio=',ASPR
C Now store atom coordinates in file
      IF(IOSHP.GT.0)THEN
          OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
C*** 3 lines of general description allowed:
          WRITE(IOSHP,9020)A,B,NAT,A1,A2
C***
          DO 2000 JX=1,NAT
              WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3)
 2000     CONTINUE
          CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
 9020 FORMAT(' Hexagonal Prism:  A=',F7.4,' B=',F7.4,/,
     &I7,'= NAT. Prism axis along x, one rect. face. normal to y',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &'     JA  IX  IY  IZ')
 9030 FORMAT(I7,3I4)
      END
      SUBROUTINE TESTHEX(ACM,BCM,CCM,A,B,X,Y,Z,IN)
C Arguments:
      REAL ACM,BCM,CCM,A,B,X,Y,Z
      LOGICAL IN
C Local variables:
      REAL AX,Q,U,V
C
C*** ACM,BCM,CCM=location of center in A,B,C directions
C    A direction is along axis
C    B direction is vertex to vertex of hexagon
C    C direction is face to face of hexagon
C
      AX=X
      U=Y-CCM
      V=Z-BCM
      IN=.FALSE.
C*** Test along axis:
      IF(2.*ABS(AX-ACM).GT.A)RETURN
C*** Test along C direction
C .4330127=SQRT(3)/4
      IF(ABS(U).GT.0.4330127*B)RETURN
C*** Now test whether closer to CM than line bounding edge
C .5773503=1/SQRT(3)
      Q=0.5*ABS(U)+0.8660254*ABS(V)
      IF(Q.GT.0.4330127*B)RETURN
      IN=.TRUE.
      RETURN
      END

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
C
C     timeit_vms
C 94.06.20 (PJF) add dtime to the formal parameters
C 96.06.19 (PJF) modified to suppress printing if CMSGTM='noprint'
C This version of TIMEIT is for VMS systems.
C
C Copyright (C) 1993,1995 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
c***********************************************************************
C     .. Scalar Arguments ..
      CHARACTER CMSGTM* (*)
C     ..
C     .. Local Scalars ..
      REAL DTIME, OLDTIM, TIME
      INTEGER IAD
      CHARACTER CSTA*3, CMSGNM*70
C     ..
C     .. External Subroutines ..
      EXTERNAL LIB$INIT_TIMER, LIB$SHOW_TIMER, WRIMSG
C     ..
C     .. Data statements ..
      DATA CSTA/'ONE'/
C     ..
      IF(CSTA.EQ.'ONE')THEN
         CSTA='TWO'
         IAD=0
         CALL LIB$INIT_TIMER(IAD)
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         IF(CMSGTM(1:7).NE.'NOPRINT'.AND.CMSGTM(1:7).NE.'noprint')THEN
            CALL LIB$SHOW_TIMER(IAD,2)
            WRITE(CMSGNM,FMT='(A,A)')' Timing results for: ',CMSGTM
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE ORIENT(BETAMI,BETAMX,THETMI,THETMX,PHIMIN,PHIMAX,
     &                  MXBETA,MXTHET,MXPHI,NBETA,NTHETA,NPHI,
     &                  BETA,THETA,PHI,WGTA,WGTB)
C Arguments:
      INTEGER MXBETA,MXTHET,MXPHI,NBETA,NTHETA,NPHI
      REAL BETAMI,BETAMX,THETMI,THETMX,PHIMIN,PHIMAX
      REAL BETA(MXBETA),THETA(MXTHET),PHI(MXPHI),
     &     WGTA(MXTHET,MXPHI),WGTB(MXBETA)
C Local variables:
      INTEGER I,J
      REAL DELTA,WG
C***********************************************************************
C Given:
C        BETAMI=minimum value of beta (radians)
C        BETAMX=maximum value of beta (radians)
C        THETMI=minimum value of theta (radians)
C        THETMX=maximum value of theta (radians)
C        PHIMIN=minimum value of phi (radians)
C        PHIMAX=maximum value of phi (radians)
C        MXBETA,MXTHET,MXPHI=parameters for dimensioning of arrays
C                             BETA,THETA,PHI
C        NBETA=desired number of values of beta
C        NTHETA=desired number of values of theta
C        NPHI=desired number of values of PHI
C Returns:     
C        BETA(1-NBETA)=beta values (radians)
C        THETA(1-NTHETA)=theta values (radians)
C        PHI(1-NPHI)=phi values (radians)
C        WGTA(1-NTHETA,1-NPHI)=weighting of each orientation of target
C                              axis a1 in Lab Frame
C                              (sum of weights = 1)
C        WGTB(1-NBETA)=weighting of each rotation of target around a1
C                              (sum of weights = 1)
C            Note: it is assumed that target orientation weight function
C                  can be factored into WGTA*WGTB -- i.e., that rotations
C                  around a1 are decoupled from orientation of a1.
C
C Purpose: to generate list of desired target orientations
C
C Definitions: beta=angle of rotation of target around target axis a1
C                   (beta=0 is defined to be such that a2 lies in a1-x
C                    plane, with a2 in direction of increasing theta)
C              theta=angle between target axis a1 and x axis
C                   (0.le.theta.le.pi)
C              phi=angle of rotation of axis a1 around axis
C              (phi=0 is defined to be such that a1 lies in xy plane)
C Present version assumes:
C        beta to be uniformly distributed between BETAMI and BETAMX
C        cos(theta) to be uniformly distributed between cos(THETMI) and
C                   cos(THETMX)
C        phi to be uniformly distributed between PHIMIN and PHIMAX
C
C Values assigned to BETA and PHI are midpoints of uniform intervals in
C beta and phi
C Note that if NBETA=1, BETA is set to midpoint of range in phi
C Likewise, if NPHI=1, PHI is set to midpoint of range in phi
C
C If NTHETA=1: specify a single value of THETA
C        cos(theta)=0.5*(cos(thetami)+cos(thetamx))
C
C If NTHETA>1:
C    If NTHETA is even: 
C       divide range of cos(theta) into NTHETA equal intervals
C       set THETA to midpoints of these intervals
C       give intervals equal weights
C    If NTHETA is odd:
C       divide range of cos(theta) into NTHETA-1 equal intervals
C       set THETA to endpoints of these intervals; first value of
C       THETA is THETAMI and last value of THETA is THETAMX
C
C Note: values chosen for beta, phi are at midpoints of
C        uniform intervals
C
C B.T.Draine, Princeton Univ. Obs., 89.11.20
C History:
C 92.04.01 (BTD) Modify to allow Simpson's rule or trapezoidal rule
C                for integration over cos(theta).
C 99.03.01 (BTD) Modified to properly assign THETA values when NPHI>1
C                Code up to this time was not consistent with
C                description in UserGuide.  This problem was brought
C                to my attention by Miroslav Kocifaj
C                (Miroslav.Kocifaj@swh.sk).
C 99.03.05 (BTD) Corrected errors in assignment of THETA values.
C                Thanks to Miroslav Kocifaj for detecting these.
C 99.04.30 (BTD) Corrected errors in assignment of BETA and
C                PHI values when BETAMI.ne.0 or PHIMIN.ne.0
C                These errors (inadvertent omission of BETAMI and
C                PHIMIN from expressions assigning BETA(J) and PHI(J))
C                were introduced in 99.03.05 revision.
C                Thanks to Henriette Lemke for calling attention to
C                these errors.
C Copyright (C) 1993,1999 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C Assign values to BETA:
C
      DELTA=(BETAMX-BETAMI)/REAL(NBETA)
      DO J=1,NBETA
         BETA(J)=BETAMI+DELTA*(REAL(J)-0.5)
      ENDDO
C
C Assign values to THETA:
C
      IF(NTHETA.EQ.2*(NTHETA/2))THEN
C
C THETA is even:
C
        DELTA=(COS(THETMX)-COS(THETMI))/REAL(NTHETA)
        DO J=1,NTHETA
           THETA(J)=ACOS(COS(THETMI)+DELTA*(REAL(J)-0.5))
        ENDDO
      ELSE
C
C THETA is odd:
C
         IF(NTHETA.EQ.1)THEN
            THETA(1)=ACOS(0.5*(COS(THETMI)+COS(THETMX)))
         ELSE
            DELTA=(COS(THETMX)-COS(THETMI))/REAL(NTHETA-1)
            THETA(1)=THETMI
            THETA(NTHETA)=THETMX
            DO J=2,NTHETA-1
               THETA(J)=ACOS(COS(THETMI)+DELTA*REAL(J-1))
            ENDDO
         ENDIF
      ENDIF
C
C Assign values to PHI:
C
      DELTA=(PHIMAX-PHIMIN)/REAL(NPHI)
      DO J=1,NPHI
         PHI(J)=PHIMIN+DELTA*(REAL(J)-0.5)
      ENDDO
C
C** Specify weight factors WGTA, WGTB
C   (Note: weight function WGTA = 4*pi*P/(NTHETA*NPHI), where
C    P=(probability/solid angle) of orientation in direction THETA,PHI .
C    The orientational averaging program automatically samples uniformly
C    in cos(theta) to allow for d(solid angle)=sin(theta)d(theta)d(phi).
C
C   Present version assumes random orientations.
C
C   When NTHETA is >1 and even, we use trapezoidal integration
C   When NTHETA is >1 and odd, we use Simpson's rule integration.
C
      IF(NTHETA.EQ.1.OR.NTHETA.EQ.2*(NTHETA/2))THEN
C
C either 1 or even number of theta values: midpoints of intervals
C
         WG=1./REAL(NTHETA*NPHI)
         DO J=1,NPHI
            DO I=1,NTHETA
               WGTA(I,J)=WG
            ENDDO
         ENDDO
      ELSE
C
C odd number >1 of theta values: use Simpson's rule weighting
C
         WG=1./REAL(3*(NTHETA-1)*NPHI)
         DO J=1,NPHI
            WGTA(1,J)=WG
            WGTA(NTHETA,J)=WG
         ENDDO
         WG=4./REAL(3*(NTHETA-1)*NPHI)
         DO I=2,NTHETA,2
            DO J=1,NPHI
               WGTA(I,J)=WG
            ENDDO
         ENDDO
         IF(NTHETA.GE.5)THEN
            WG=2./REAL(3*(NTHETA-1)*NPHI)
            DO I=3,NTHETA-1,2
               DO J=1,NPHI
                  WGTA(I,J)=WG
               ENDDO
            ENDDO
         ENDIF
      ENDIF
C
C Assign weights for rotation angle beta:
C
      WG=1./REAL(NBETA)
      DO I=1,NBETA
         WGTB(I)=WG
      ENDDO
C
      RETURN
      END

      SUBROUTINE ALPHA(CALPHA,CXALPH,CXE0R,CXEPS,ICOMP,AKR,NAT0,NAT3,
     &                 MXCOMP,MXN3)
C*** Arguments:
      CHARACTER*6 CALPHA
      INTEGER MXN3,MXCOMP,NAT0,NAT3
      COMPLEX CXALPH(MXN3),CXE0R(3),CXEPS(MXCOMP)
      INTEGER*2 ICOMP(MXN3)
      REAL AKR(3)
C
C*** Local Variables:
      CHARACTER CMSGNM*70
      INTEGER IC,L
      COMPLEX CXI,CXRR
      REAL AK1,AK2,B1,B2,EMKD,PI,SUM
      DATA CXI/(0.,1.)/
C***********************************************************************
C Given:
C       CALPHA = 'LATTDR' or 'DRAI88' or 'GOBR88' or 'LDRISO'
C                to specify method ('LATTDR' is recommended)
C       CXE0R(1-3) = polarization vector in lattice coordinates
C                    (assumed to be normalized)
C       CXEPS(1-NCOMP)=distinct values of dielectric constant
C       ICOMP(1-NAT3)=composition identifier for each lattice site and
C                     direction (ICOMP=0 if lattice site is unoccupied)
C       MXCOMP = dimensioning information
C       MXN3 = dimensioning information
C       NAT0 = number of sites in original target (i.e., nonvacuum sites)
C       NAT3 = 3*number of sites in extended target (including vacuum
C              sites)
C Returns:
C       CXALPHA(1-NAT3)=(polarizability/d^3) for each of 3 directions at
C                       each lattice site
C***
C If CALPHA = LATTDR:
C    Compute dipole polarizability using "Lattice Dispersion Relation"
C    of Draine & Goodman (1993,ApJ,March 10).  It is required that
C    polarizability be such that an infinite lattice of such dipoles
C    reproduce the continuum dispersion relation for radiation
C    propagating with direction and polarization of radiation incident
C    on the DDA target.  This is the recommended option.
C
C If CALPHA = DRAI88:
C    Compute dipole polarizability using
C           (1) eq. (2.03) of Draine (1988) (Clausius-Mossotti plus
C               radiative reaction correction)
C
C If CALPHA = GOBR88:
C    Compute dipole polarizability using
C           (1) radiative reaction correction from Draine (1988)
C           (2) O[(kd)^2] correction term used by
C               Goedecke & OBrien (1988) and Hage & Greenberg (1990)
C
C If CALPHA = LDRISO:
C    Compute dipole polarizability using "Isotropized Lattice Dispersion
C    Relation" of Draine & Goodman (1993,ApJ,March 10).  This replaces
C    direction- and polarization-dependent term in Lattice Dispersion
C    Relation with the average value for random direction and polarization.
C
C***
C    Note: CXALPH = polarizability/d^3
C    In the event that ICOMP=0, then we set CXALPH=1.
C***********************************************************************
C B.T.Draine, Princeton Univ. Obs.
C History:
C 90. 9.13 (BTD): Corrected error in DO loop limit.
C 90.11. 1 (BTD): Special treatment for "vacuum" sites in order
C                 to allow FFT treatment.
C 90.11. 2 (BTD): Set CXALPH=(1.,0.) at vacuum sites.
C 91. 4.30 (BTD): Modified to include both O[(kd)^2] correction term
C                 from Goedecke & Obrien (1988) in addition to
C                 radiative reaction correction.
C 91. 5. 7 (BTD): Modified to allow easy choice among three methods
C                 for computing polarizability.
C 91. 5. 7 (BTD): Added call to WRIMSG to record which method in use
C 91.05.08 (BTD): Added CALPHA to argument list.
C 91.05.09 (BTD): Added printing of kd and magnitude of correction
C                 terms.
C 91.05.13 (BTD): Experiment with use of approximate directional
C                 average for coefficient of CXEPS in Lattice
C                 Disperision Relation theory
C 91.05.13 (BTD): Corrected error in radiative reaction correction
C                 (error presumably introduced during last week)
C 91.05.14 (BTD): Added separate options LDRXYZ and LDRAVG
C 91.05.15 (BTD): Added option LDR000 to omit CXEPS-dependent
C                 correction term
C 91.05.30 (BTD): Changed LDRXYZ -> LDR100
C                 Added option LDR111
C 91.09.12 (BTD): Corrected error in numerical coefficient for
C                 LDRAVG case
C 91.09.17 (BTD): Eliminate options LDR000,LDRXYZ,LDRAVG
C                 Introduce option LATTDR (LATTice Dispersion Relation)
C                 which includes explicit dependence
C                 on direction and polarization state
C                 remove AK1 from argument list
C                 add AKR, CXE0R to argument list
C 92.05.14 (BTD): Introduce option LDRISO to experiment with
C                 using average directional correction term
C                 rather than using correction for incident direction
C                 and polarization
C 92.05.16 (BTD): Correct error in LDRISO option: average SUM should be
C                 3/15 rather than 4/15
C
C Copyright (C) 1993,1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      PI=4.*ATAN(1.)
      AK2=AKR(1)*AKR(1)+AKR(2)*AKR(2)+AKR(3)*AKR(3)
      AK1=SQRT(AK2)
      CXRR=-(AK1*AK2/1.5)*CXI
C*** EMKD = |m|*k_0*d , where |m|=refractive index
C                             k_0 = wave vector in vacuo
C                             d = lattice spacing
      EMKD=SQRT(CABS(CXEPS(1)))*AK1
C
C***********************************************************************
C*** Draine 1988:
C
      IF(CALPHA.EQ.'DRAI88')THEN
         WRITE(CMSGNM,FMT='(A,F6.4)')
     &         'Clausius-Mossotti plus radiative reaction for |m|kd=',
     &         EMKD
         CALL WRIMSG('ALPHA ',CMSGNM)
         DO 1000 L=1,NAT3
            IC=ICOMP(L)
            IF(IC.GT.0)THEN
C*** First compute Clausius-Mossotti polarizability:
               CXALPH(L)=(.75/PI)*(CXEPS(IC)-1.)/(CXEPS(IC)+2.)
C*** Now correct this for
C    (1) radiative-reaction
               CXALPH(L)=CXALPH(L)/(1.+CXALPH(L)*CXRR)
            ELSEIF(IC.EQ.0)THEN
C To avoid divisions by zero, etc., set CXALPH=1 for vacuum sites.
               CXALPH(L)=1.
            ENDIF
 1000    CONTINUE
         RETURN
C
C***********************************************************************
C*** Goedecke & OBrien 1988:
C
      ELSEIF(CALPHA.EQ.'GOBR88')THEN
         B1=-(4.*PI/3.)**(1./3.)*AK2
         WRITE(CMSGNM,FMT='(A,F6.4)')
     &         'Goedecke & OBrien (1988) correction for |m|kd=',EMKD
         CALL WRIMSG('ALPHA ',CMSGNM)
         DO 2000 L=1,NAT3
            IC=ICOMP(L)
            IF(IC.GT.0)THEN
C*** First compute Clausius-Mossotti polarizability:
               CXALPH(L)=(.75/PI)*(CXEPS(IC)-1.)/(CXEPS(IC)+2.)
C*** Now correct this for
C    (1) O[(kd)**2] correction from Goedecke and Obrien (1988)
               CXALPH(L)=CXALPH(L)/(1.+CXALPH(L)*B1)
C    (2) radiative-reaction
               CXALPH(L)=CXALPH(L)/(1.+CXALPH(L)*CXRR)
            ELSEIF(IC.EQ.0)THEN
C To avoid divisions by zero, etc., set CXALPH=1 for vacuum sites.
               CXALPH(L)=1.
            ENDIF
 2000    CONTINUE
         RETURN
C
C***********************************************************************
C*** Lattice dispersion relation
C
      ELSEIF(CALPHA.EQ.'LATTDR')THEN
         WRITE(CMSGNM,FMT='(A,F6.4)')
     &         'Lattice dispersion relation for |m|k_0d=',EMKD
         CALL WRIMSG('ALPHA ',CMSGNM)
C*** Compute sum (a_j*e_j)^2 , where a_j=unit propagation vector
C                                    e_j=unit polarization vector
         SUM=0.
         DO 2700 L=1,3
            SUM=SUM+(AKR(L)*CABS(CXE0R(L)))**2
 2700    CONTINUE
         SUM=SUM/AK2
         B1=-1.8915316*AK2
         B2=(0.1648469-1.7700004*SUM)*AK2
         DO 3000 L=1,NAT3
            IC=ICOMP(L)
            IF(IC.GT.0)THEN
C*** First compute Clausius-Mossotti polarizability:
               CXALPH(L)=(.75/PI)*(CXEPS(IC)-1.)/(CXEPS(IC)+2.)
C*** Determine polarizability by requiring that infinite lattice of
C    dipoles have dipersion relation of continuum.
               CXALPH(L)=CXALPH(L)/(1.+CXALPH(L)*(B1+CXEPS(IC)*B2))
C*** Radiative-reaction correction:
               CXALPH(L)=CXALPH(L)/(1.+CXALPH(L)*CXRR)
            ELSEIF(IC.EQ.0)THEN
C To avoid divisions by zero, etc., set CXALPH=1 for vacuum sites.
               CXALPH(L)=1.
            ENDIF
 3000    CONTINUE
         RETURN
      ELSEIF(CALPHA.EQ.'LDRISO')THEN
         WRITE(CMSGNM,FMT='(A,F6.4)')
     &         'Isotropic Lattice disp. rel. for |m|k_0d=',EMKD
         CALL WRIMSG('ALPHA ',CMSGNM)
C*** Compute sum (a_j*e_j)^2 , where a_j=unit propagation vector
C                                    e_j=unit polarization vector
C    Here experiment by taking average value of sum (a_j*e_j)^2 = 1/5
         SUM=0.2D0
         B1=-1.8915316*AK2
         B2=(0.1648469-1.7700004*SUM)*AK2
         DO 4000 L=1,NAT3
            IC=ICOMP(L)
            IF(IC.GT.0)THEN
C*** First compute Clausius-Mossotti polarizability:
               CXALPH(L)=(.75/PI)*(CXEPS(IC)-1.)/(CXEPS(IC)+2.)
C*** Determine polarizability by requiring that infinite lattice of
C    dipoles have dipersion relation of continuum.
               CXALPH(L)=CXALPH(L)/(1.+CXALPH(L)*(B1+CXEPS(IC)*B2))
C*** Radiative-reaction correction:
               CXALPH(L)=CXALPH(L)/(1.+CXALPH(L)*CXRR)
            ELSEIF(IC.EQ.0)THEN
C To avoid divisions by zero, etc., set CXALPH=1 for vacuum sites.
               CXALPH(L)=1.
            ENDIF
 4000    CONTINUE
         RETURN
      ENDIF
      END

      SUBROUTINE WRITESCA(MXNX,MXNY,MXNZ,NX,NY,NZ,ICOMP,IXYZ0,MXNAT,
     &                    MXN3,NAT,NAT3,WAVEA,MXWAV,NWAV,AEFFA,MXRAD,
     &                    NRAD,ITHETA,IBETA,IPHI,THETA,MXTHET,NTHETA,
     &                    BETA,MXBETA,NBETA,PHI,MXPHI,NPHI,TIMERS,
     &                    MXTIMERS,NTIMERS,CBINFILE,IOBIN,CBINFLAG,
     &                    CNETFILE,IDNC,CNETFLAG,ICTHM,ILIN10,ILIN12,
     &                    IORI,IORTH,IPHIM,IRAD,IWAV,MXCOMP,MXSCA,NAT0,
     &                    NCOMP,NORI,NSCAT,CALPHA,CDESCR,CFLAVG,CFLSCA,
     &                    CMDFFT,CMDTRQ,CSHAPE,CSTAMP,AEFF,AK1,AKR,
     &                    BETAD,BETMID,BETMXD,PHID,PHIMID,PHIMXD,THETAD,
     &                    THTMID,THTMXD,TOL,WAVE,XX,A1,A2,PHIN,QABS,
     &                    QABSUM,QBKSCA,QBKSUM,QEXSUM,QEXT,QPHA,QPHSUM,
     &                    QSCAG,QSCAT,QSCGSUM,QSCSUM,QTRQAB,QTRQABSUM,
     &                    QTRQSC,QTRQSCSUM,S1111,S2121,SM,SMORI,THETAN,
     &                    CX1121,CXE01,CXE01R,CXE02,CXE02R,CXEPS,CXRFR,
     &                    CXF11,CXF21,CXF12,CXF22)

C     .. Scalar Arguments ..
      REAL AEFF,AK1,BETAD,BETMID,BETMXD,PHID,PHIMID,PHIMXD,THETAD,
     &     THTMID,THTMXD,TOL,WAVE,XX
      INTEGER IBETA,ICTHM,IDNC,ILIN10,ILIN12,IOBIN,IORI,IORTH,IPHI,
     &        IPHIM,IRAD,ITHETA,IWAV,MXBETA,MXCOMP,MXN3,MXNAT,MXNX,MXNY,
     &        MXNZ,MXPHI,MXRAD,MXSCA,MXTHET,MXTIMERS,MXWAV,NAT,NAT0,
     &        NAT3,NBETA,NCOMP,NORI,NPHI,NRAD,NSCAT,NTHETA,NTIMERS,NWAV,
     &        NX,NY,NZ
      CHARACTER CALPHA*6,CBINFLAG*6,CMDFFT*6,CMDTRQ*6,CNETFLAG*6,
     &          CSHAPE*6,CFLAVG*13,CBINFILE*14,CFLSCA*14,CNETFILE*14,
     &          CSTAMP*22,CDESCR*67
C     .. Array Arguments ..
      COMPLEX CX1121(MXSCA),CXE01(3),CXE01R(3),CXE02(3),CXE02R(3),
     &        CXEPS(MXCOMP),CXF11(MXSCA),CXF12(MXSCA),CXF21(MXSCA),
     &        CXF22(MXSCA),CXRFR(MXCOMP)
      REAL A1(3),A2(3),AEFFA(MXRAD),AKR(3),BETA(MXBETA),PHI(MXPHI),
     &     PHIN(MXSCA),QABS(2),QABSUM(2),QBKSCA(2),QBKSUM(2),QEXSUM(2),
     &     QEXT(2),QPHA(2),QPHSUM(2),QSCAG(3,2),QSCAT(2),QSCGSUM(3,2),
     &     QSCSUM(2),QTRQAB(3,2),QTRQABSUM(3,2),QTRQSC(3,2),
     &     QTRQSCSUM(3,2),S1111(MXSCA),S2121(MXSCA),SM(MXSCA,4,4),
     &     SMORI(MXSCA,4,4),THETA(MXTHET),THETAN(MXSCA),
     &     TIMERS(MXTIMERS),WAVEA(MXWAV)
      INTEGER*2 ICOMP(MXN3),IXYZ0(MXNAT,3)
C     .. Local Scalars ..
      COMPLEX CXVAR1
      REAL DEGRAD,PHIND,PPOL,RVAR1,RVAR2,RVAR3,THETND
      INTEGER I,J,ND
C     .. Local Arrays ..
      REAL G(2),QAV(17)
C     .. External Subroutines ..
      EXTERNAL NAMER,WRITEBIN,WRITENET
C     .. Intrinsic Functions ..
      INTRINSIC CONJG,SQRT
C     .. Save statement ..
      SAVE DEGRAD
C     .. Data statements ..
      DATA DEGRAD/57.29578/
C***********************************************************************
C
C Purpose of this module is to collect a lot of the output code into
C a single module.
C
C History:
C 96.11.14 (PJF) added binary write options (see also info in
C                "versions.f" about IDL postprocessing)
C                possible "chackpointing" could be done here "close(iobin)"
C                open(iobin,file=cbinfile,form='unformatted',access='append')
C                (which is non-standard Fortran 77 (but standard in F90)
C                open(iobin,file=cbinfile,form='unformatted',status='old')
C 96.11.21 (BTD) added call to WRITENET if called with CNETFLAG='NCCLOS'
C                in order to get call to NCCLOS out of DDSCAT.f
C 98.11.16 (BTD) corrected CX01R -> CXE01R in argument list of WRITEBIN
C end history
C
C Copyright (C) 1996,1998 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C If CNETFLAG = 'NCCLOS' then call WRITESCA to
C                             call WRITENET to
C                             call NCCLOS to close netCDF files
      IF(CNETFLAG.EQ.'NCCLOS')THEN
         CALL WRITENET(CNETFILE,IDNC,CNETFLAG,CSTAMP,CDESCR,CMDFFT,
     &                 CALPHA,CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,MXBETA,
     &                 MXPHI,MXN3,MXNAT,MXSCA,MXTIMERS,IORTH,NX,NY,NZ,
     &                 NAT0,NAT,NAT3,NSCAT,NCOMP,NORI,NWAV,NRAD,NTHETA,
     &                 NPHI,NBETA,NTIMERS,MXNX,MXNY,MXNZ,MXCOMP,
     &                 BETMID,BETMXD,THTMID,THTMXD,PHIMID,PHIMXD,ICTHM,
     &                 IPHIM,TOL,WAVEA,AEFFA,THETA,BETA,PHI,A1,A2,
     &                 ICOMP,IXYZ0,IWAV,IRAD,ITHETA,IBETA,IPHI,IORI,
     &                 AEFF,WAVE,XX,AK1,BETAD,THETAD,PHID,AKR,CXE01R,
     &                 CXE02R,CXRFR,CXEPS,QEXT,QABS,QSCAT,G,QBKSCA,
     &                 QPHA,QAV,QTRQAB,QTRQSC,SM,SMORI,PHIN,THETAN,
     &                 TIMERS)
         RETURN
      ENDIF
C If IORI > 0, then write out scattering properties for this specific
C target orientation.
      IF(IORI.GT.0)THEN
C*** Compute g=<cos(theta)>
          DO 12 J=1,IORTH
              G(J)=QSCAG(1,J)/QSCAT(J)
   12     CONTINUE
          CALL NAMER(IWAV,IRAD,IORI,CFLSCA,CFLAVG)
          OPEN(UNIT=8,FILE=CFLSCA,STATUS='UNKNOWN')
          WRITE(8,FMT=9030)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0
          WRITE(8,FMT=9032)AEFF,WAVE,XX
          WRITE(8,FMT=9031)(CXRFR(ND),CXEPS(ND),ND,ND=1,NCOMP)
          WRITE(8,FMT=9033)TOL,ICTHM,IPHIM,A1,A2
          WRITE(8,FMT=9035)AKR,CXE01R,CXE02R
          WRITE(8,FMT=9040)BETAD,THETAD,PHID
          WRITE(8,FMT=9050)QEXT(1),QABS(1),QSCAT(1),G(1),QBKSCA(1),
     &      QPHA(1)
          IF(IORTH.EQ.1)THEN
Cflatau  assign "missing value" value if there is only one polarization
              DO 13 I=1,17
                  QAV(I)=-999.
   13         CONTINUE
              QEXT(2)=-999.
              QABS(2)=-999.
              QSCAT(2)=-999.
              QBKSCA(2)=-999.
              QPHA(2)=-999.
              G(2)=-999.
              DO 14 J=1,3
                  QSCAG(J,2)=-999.
   14         CONTINUE
C endif "IF(IORTH.EQ.1)THEN"
          END IF


          IF(IORTH.EQ.2)THEN
              QAV(1)=.5*(QEXT(1)+QEXT(2))
              QAV(2)=.5*(QABS(1)+QABS(2))
              QAV(3)=.5*(QSCAT(1)+QSCAT(2))
              QAV(4)=.5*(QSCAG(1,1)+QSCAG(1,2))/QAV(3)
              QAV(5)=.5*(QBKSCA(1)+QBKSCA(2))
              QAV(6)=.5*(QPHA(1)+QPHA(2))
              QAV(7)=QEXT(1)- QEXT(2)
              QAV(8)=QPHA(1)- QPHA(2)
              DO 16 J=1,3
                  QAV(8+J)=.5*(QSCAG(J,1)+QSCAG(J,2))
   16         CONTINUE
              IF(CMDTRQ.EQ.'DOTORQ')THEN
                  DO 17 J=1,3
                      QAV(11+J)=.5*(QTRQAB(J,1)+QTRQAB(J,2))
                      QAV(14+J)=.5*(QTRQSC(J,1)+QTRQSC(J,2))
   17             CONTINUE
              ENDIF

              WRITE(8,FMT=9055)QEXT(2),QABS(2),QSCAT(2),G(2),
     &          QBKSCA(2),QPHA(2),(QAV(J),J=1,8)
          ENDIF

          WRITE(8,FMT=9150)(QSCAG(J,1),J=1,3)
          IF(IORTH.EQ.2)THEN
              WRITE(8,FMT=9155)(QSCAG(J,2),J=1,3),(QAV(J),J=9,11)
          ENDIF

          IF(CMDTRQ.EQ.'DOTORQ')THEN
              WRITE(8,FMT=9250)(QTRQAB(J,1),J=1,3),
     &          (QTRQSC(J,1),J=1,3)
              IF(IORTH.EQ.2)WRITE(8,FMT=9255)(QTRQAB(J,2),J=1,3),
     &            (QTRQSC(J,2),J=1,3),(QAV(J),J=12,17)

          ELSE
CFLATAU --->DRAINE is j=1 set for IORTH=1 ???? in QTRQAB, QTRQSC ??
C add missing value code (set to -999.)
              DO 19 I=1,3
                  DO 21 J=1,2
                      QTRQAB(I,J)=-999.
                      QTRQSC(I,J)=-999.
   21             CONTINUE
   19         CONTINUE
C endif "IF(CMDTRQ.EQ.'DOTORQ')THEN"
          ENDIF

          IF(IORTH.EQ.1)THEN
              WRITE(8,FMT=9060)
              DO 22 ND=1,NSCAT
C convert scattering angles to degrees
                  PHIND=DEGRAD*PHIN(ND)
                  THETND=DEGRAD*THETAN(ND)
                  RVAR1=CONJG(CXF11(ND))*CXF11(ND)
                  RVAR2=CONJG(CXF21(ND))*CXF21(ND)
                  CXVAR1=CONJG(CXF11(ND))*CXF21(ND)
                  WRITE(8,FMT=9070)ND,THETND,PHIND,RVAR1,RVAR2,CXVAR1
   22         CONTINUE

          ELSE IF(IORTH.EQ.2)THEN
              WRITE(8,FMT=9080)
              DO 27 ND=1,NSCAT
C convert scattering angles to degrees
                  PHIND=DEGRAD*PHIN(ND)
                  THETND=DEGRAD*THETAN(ND)
C
C Compute PPOL = degree of linear polarization of scattered light
C for incident unpolarized light
C
                  PPOL=SQRT(SM(ND,2,1)**2+SM(ND,3,1)**2)/
     &                   SM(ND,1,1)
                  WRITE(8,FMT=9090)THETND,PHIND,SM(ND,1,1),SM(ND,2,1),
     &              SM(ND,3,1),SM(ND,4,1),SM(ND,1,2),SM(ND,1,3),PPOL
   27         CONTINUE
C endif "IF(IORTH.EQ.1)THEN"
          ENDIF

          CLOSE(8)
C
      ELSE
C This module writes out results from orientational averaging.
C (arrive here when called with IORI=0)
C
          OPEN(UNIT=8,FILE=CFLAVG,STATUS='UNKNOWN')
          WRITE(8,FMT=9030)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0
          WRITE(8,FMT=9032)AEFF,WAVE,XX
          WRITE(8,FMT=9031)(CXRFR(ND),CXEPS(ND),ND,ND=1,NCOMP)
          WRITE(8,FMT=9033)TOL,ICTHM,IPHIM,A1,A2
          RVAR1=AK1
          RVAR2=0.
          RVAR3=0.
          WRITE(8,FMT=9037)RVAR1,RVAR2,RVAR3,CXE01,CXE02
          WRITE(8,FMT=9042)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA,
     &      PHIMID,PHIMXD,NPHI,NORI,IORTH
C
          RVAR1=QSCGSUM(1,1)/QSCSUM(1)
          WRITE(8,FMT=9050)QEXSUM(1),QABSUM(1),QSCSUM(1),RVAR1,
     &      QBKSUM(1),QPHSUM(1)
          IF(IORTH.EQ.1)THEN
              WRITE(8,FMT=9150)(QSCGSUM(J,1),J=1,3)
              IF(CMDTRQ.EQ.'DOTORQ')WRITE(8,
     &            FMT=9250)(QTRQABSUM(J,1),J=1,3),
     &            (QTRQSCSUM(J,1),J=1,3)
              WRITE(8,FMT=9060)
              DO 28 ND=1,NSCAT
C Convert scattering angles to degrees
                  PHIND=DEGRAD*PHIN(ND)
                  THETND=DEGRAD*THETAN(ND)
                  WRITE(8,FMT=9070)ND,THETND,PHIND,S1111(ND),
     &              S2121(ND),CX1121(ND)
   28         CONTINUE
C
C*** Write orientationally-averaged Q values (except Qpha) to 'qtable':
              OPEN(UNIT=10,FILE='qtable',STATUS='OLD')
              DO 31 ND=1,ILIN10
                  READ(10,FMT=*)
   31         CONTINUE
              RVAR1=QSCGSUM(1,1)/QSCSUM(1)
              WRITE(10,FMT=9056)AEFF,WAVE,QEXSUM(1),QABSUM(1),
     &          QSCSUM(1),RVAR1,QBKSUM(1)
              ILIN10=ILIN10+1
              CLOSE(10)
              OPEN(UNIT=12,FILE='qtable2',STATUS='OLD')
              DO 32 ND=1,ILIN12
                  READ(12,FMT=*)
   32         CONTINUE
              WRITE(12,FMT=9057)AEFF,WAVE,QPHSUM(1)
              ILIN12=ILIN12+1
              CLOSE(12)

          ELSE IF(IORTH.EQ.2)THEN
              RVAR1=QSCGSUM(1,2)/QSCSUM(2)
              QAV(1)=.5*(QEXSUM(1)+QEXSUM(2))
              QAV(2)=.5*(QABSUM(1)+QABSUM(2))
              QAV(3)=.5*(QSCSUM(1)+QSCSUM(2))
              QAV(4)=.5*(QSCGSUM(1,1)+QSCGSUM(1,2))/QAV(3)
              QAV(5)=.5*(QBKSUM(1)+QBKSUM(2))
              QAV(6)=.5*(QPHSUM(1)+QPHSUM(2))
              QAV(7)=QEXSUM(1)- QEXSUM(2)
              QAV(8)=QPHSUM(1)- QPHSUM(2)
              DO 38 J=1,3
                  QAV(8+J)=.5*(QSCGSUM(J,1)+QSCGSUM(J,2))
   38         CONTINUE
              IF(CMDTRQ.EQ.'DOTORQ')THEN
                  DO 41 J=1,3
                      QAV(11+J)=.5*(QTRQABSUM(J,1)+QTRQABSUM(J,2))
                      QAV(14+J)=.5*(QTRQSCSUM(J,1)+QTRQSCSUM(J,2))
   41             CONTINUE
              ENDIF

              WRITE(8,FMT=9055)QEXSUM(2),QABSUM(2),QSCSUM(2),RVAR1,
     &          QBKSUM(2),QPHSUM(2),(QAV(J),J=1,8)
              WRITE(8,FMT=9150)(QSCGSUM(J,1),J=1,3)
              WRITE(8,FMT=9155)(QSCGSUM(J,2),J=1,3),(QAV(J),J=9,11)
              IF(CMDTRQ.EQ.'DOTORQ')THEN
                  WRITE(8,FMT=9250)(QTRQABSUM(J,1),J=1,3),
     &              (QTRQSCSUM(J,1),J=1,3)
                  WRITE(8,FMT=9255)(QTRQABSUM(J,2),J=1,3),
     &              (QTRQSCSUM(J,2),J=1,3),(QAV(J),J=12,17)
              ENDIF
C
C*** Write orientationally-averaged Q values (except Qpha) to 'qtable':
              OPEN(UNIT=10,FILE='qtable',STATUS='OLD')
              DO 46 ND=1,ILIN10
                  READ(10,FMT=*)
   46         CONTINUE
              WRITE(10,FMT=9056)AEFF,WAVE,QAV(1),QAV(2),QAV(3),QAV(4),
     &          QAV(5)
              ILIN10=ILIN10+1
              CLOSE(10)
              OPEN(UNIT=12,FILE='qtable2',STATUS='OLD')
              DO 47 ND=1,ILIN12
                  READ(12,FMT=*)
   47         CONTINUE
              WRITE(12,FMT=9057)AEFF,WAVE,QAV(6),QAV(7),QAV(8)
              ILIN12=ILIN12+1
              CLOSE(12)
C
              WRITE(8,FMT=9080)
              DO 48 ND=1,NSCAT
C Convert scattering angles to degrees
                  PHIND=DEGRAD*PHIN(ND)
                  THETND=DEGRAD*THETAN(ND)
C Compute PPOL = degree of linear polarization of scattered light
C for incident unpolarized light (Bohren & Huffman p. 382)
                  PPOL=SQRT(SMORI(ND,2,1)**2+SMORI(ND,3,1)**2)/
     &                   SMORI(ND,1,1)
                  WRITE(8,FMT=9090)THETND,PHIND,SMORI(ND,1,1),
     &              SMORI(ND,2,1),SMORI(ND,3,1),SMORI(ND,4,1),
     &              SMORI(ND,1,2),SMORI(ND,1,3),PPOL

   48         CONTINUE

          ENDIF

          CLOSE(8)
      ENDIF

C write FORTRAN unformatted file
      IF(CBINFLAG.NE.'NOTBIN')THEN
          CALL WRITEBIN(CBINFLAG,CBINFILE,IOBIN,CSTAMP,CDESCR,CMDFFT,
     &                  CALPHA,CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,MXBETA,
     &                  MXPHI,MXN3,MXNAT,MXSCA,MXTIMERS,IORTH,NX,NY,NZ,
     &                  NAT0,NAT,NAT3,NSCAT,NCOMP,NORI,NWAV,NRAD,NTHETA,
     &                  NPHI,NBETA,NTIMERS,MXNX,MXNY,MXNZ,MXCOMP,
     &                  BETMID,BETMXD,THTMID,THTMXD,PHIMID,PHIMXD,ICTHM,
     &                  IPHIM,TOL,WAVEA,AEFFA,THETA,BETA,PHI,A1,A2,
     &                  ICOMP,IXYZ0,IWAV,IRAD,IORI,AEFF,WAVE,XX,AK1,
     &                  BETAD,THETAD,PHID,AKR,CXE01R,CXE02R,CXRFR,CXEPS,
     &                  QEXT,QABS,QSCAT,G,QBKSCA,QPHA,QAV,QTRQAB,QTRQSC,
     &                  SM,PHIN,THETAN,TIMERS)
C endif "if(cbinflag.ne.'NOTCDF') then"
      ENDIF

      IF(CNETFLAG.NE.'NOTCDF')THEN
          CALL WRITENET(CNETFILE,IDNC,CNETFLAG,CSTAMP,CDESCR,CMDFFT,
     &                  CALPHA,CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,MXBETA,
     &                  MXPHI,MXN3,MXNAT,MXSCA,MXTIMERS,IORTH,NX,NY,NZ,
     &                  NAT0,NAT,NAT3,NSCAT,NCOMP,NORI,NWAV,NRAD,NTHETA,
     &                  NPHI,NBETA,NTIMERS,MXNX,MXNY,MXNZ,MXCOMP,
     &                  BETMID,BETMXD,THTMID,THTMXD,PHIMID,PHIMXD,ICTHM,
     &                  IPHIM,TOL,WAVEA,AEFFA,THETA,BETA,PHI,A1,A2,
     &                  ICOMP,IXYZ0,IWAV,IRAD,ITHETA,IBETA,IPHI,IORI,
     &                  AEFF,WAVE,XX,AK1,BETAD,THETAD,PHID,AKR,CXE01R,
     &                  CXE02R,CXRFR,CXEPS,QEXT,QABS,QSCAT,G,QBKSCA,
     &                  QPHA,QAV,QTRQAB,QTRQSC,SM,SMORI,PHIN,THETAN,
     &                  TIMERS)
C endif "if(cnetflag.ne.'NOTCDF') then "
      ENDIF

      RETURN

 9030 FORMAT (' DDSCAT --- ',A,/,' TARGET ---',A,/,' ',A,
     &       ' --- method of solution ',/,' ',A,
     &       ' --- prescription for polarizabilies',/,' ',A,
     &       ' --- shape ',/,' NAT0 = ',I7,' = number of dipoles')
 9031 FORMAT (' n= (',F7.4,' , ',F7.4,'),  epsilon= (',F8.4,' , ',F7.4,
     &       ')  for material',I2)
 9032 FORMAT ('  AEFF=',F10.5,' =',' effective radius (physical units)',
     &       /,'  WAVE=',F10.5,' = wavelength (physical units)',/,
     &       '   K*A=',F10.5,' = 2*pi*aeff/lambda')
 9033 FORMAT ('   TOL=',1P,E10.3,' = error tolerance for CCG method',/,
     &       ' ICTHM=',I3,' = theta values used in comp. of Qsca,g',/,
     &       ' IPHIM=',I3,' = phi values used in comp. of Qsca,g',/,1X,
     &       0P,'(',F8.5,2F9.5,') = target axis A1 in Target Frame',/,
     &       1X,'(',F8.5,2F9.5,') = target axis A2 in Target Frame')
 9035 FORMAT (1X,'(',F8.5,2F9.5,') = k vector (latt. units) in TF',/,1X,
     &       3 ('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 1 in TF',/,1X,
     &       3 ('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 2 in TF')
 9037 FORMAT (1X,'(',F8.5,2F9.5,
     &       ') = k vector (latt. units) in Lab Frame',/,1X,
     &       3 ('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 1 in LF',/,1X,
     &       3 ('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 2 in LF')
 9040 FORMAT (' BETA =',F7.3,' = rotation of target around A1',/,
     &       ' THETA=',F7.3,' = angle between A1 and k',/,'  PHI =',
     &       F7.3,' = rotation of A1 around k')
 9042 FORMAT (2F8.3,' = beta_min, beta_max ;  NBETA =',I2,/,2F8.3,
     &       ' = theta_min, theta_max; NTHETA=',I2,/,2F8.3,
     &       ' = phi_min, phi_max   ;   NPHI =',I2,/,
     &       ' Results averaged over ',I3,' target orientations',/,
     &       '                   and ',I3,' incident polarizations')
 9050 FORMAT (10X,'Qext',6X,'Qabs',7X,'Qsca',5X,'g=<cos>',4X,'Qbk',7X,
     &       'Qpha',/,1X,'JO=1: ',1P,3E10.3,E11.3,2E10.3)
 9055 FORMAT (1X,'JO=2: ',1P,3E10.3,E11.3,2E10.3,/,1X,'mean: ',3E10.3,
     &       E11.3,2E10.3,/,1X,'Qpol= ',E10.3,35X,'dQpha=',E10.3)
 9056 FORMAT (1P,E10.4,E11.4,3E10.3,E11.3,E10.3)
 9057 FORMAT (1P,E10.4,E11.4,3E11.3)
 9060 FORMAT ('**** Selected scattering directions ',
     &       ' [note: incident pol state 1 is FIXED!]',/,
     &       ' ND THETA   PHI <|f11|^2> <|f21|^2> Re<f11*f21>',
     &       ' Im<f11*f21>')
 9070 FORMAT (I3,2F6.1,1P,2E10.3,2E11.3)
C 9080 FORMAT(' ***************** Selected scattering directions *****',
C     &       '************',/,
C     &       ' ND THETA   PHI <|f11|^2> <|f21|^2> <|f12|^2> ',
C     &       '<|f22|^2>  DEPOLR    PPOL')
 9080 FORMAT (12X,'** Mueller matrix elements for selected scattering ',
     &       'directions **',/,
     &       'theta   phi   S_11       S_21       S_31       S_41',
     &       '       S_12       S_13      Pol.')
 9090 FORMAT (F5.1,F6.1,1P,E10.3,1P,5E11.3,0P,F9.5)
 9150 FORMAT (8X,'Qsca*g(1)  Qsca*g(2)  Qsca*g(3)',/,1X,'JO=1:',1P,
     &       3E11.3)
 9155 FORMAT (1X,'JO=2:',1P,3E11.3,/,1X,'mean:',1P,3E11.3)
 9250 FORMAT (8X,'Qtrqab(1)  Qtrqab(2)  Qtrqab(3)  ',
     &       'Qtrqsc(1)  Qtrqsc(2)  Qtrqsc(3)',/,1X,'JO=1:',1P,6E11.3)
 9255 FORMAT (1X,'JO=2:',1P,6E11.3,/,1X,'mean:',1P,6E11.3)

      END

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
C
C     timeit_cray
C
C CRAY version. Call to second is executed.
C 94.06.20 (PJF) add dtime to the formal parameters
C 95.06.19 (PJF) modified to suppress printing if CMSGTM='noprint'
C Copyright (C) 1993,1995 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C     .. Scalar Arguments ..
      CHARACTER CMSGTM* (*)
C     ..
C     .. Local Scalars ..
      REAL DTIME, OLDTIM
      CHARACTER CSTA*3, CMSGNM*70
C
C     ..
C
      save csta, time1
C     .. Data statements ..
      DATA CSTA/'ONE'/
C     ..
      IF(CSTA.EQ.'ONE')THEN
         CSTA='TWO'
         call second(time1)
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         CALL SECOND(TIME2)
         DTIME=TIME2-TIME1
         IF(CMSGTM(1:7).NE.'NOPRINT'.AND.CMSGTM(1:7).NE.'noprint')THEN
            WRITE(CMSGNM,FMT='(A,A)')' Timing results for: ',CMSGTM
            CALL WRIMSG('TIMEIT',CMSGNM)
            WRITE(CMSGNM,FMT='(G15.6, A)')DTIME,' CPU time (in secs) '
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE VERSION(CSTAMP)
C Arguments:
      CHARACTER CSTAMP*22
      CSTAMP='DDSCAT.5a.9 [99.03.05]'
C*******************************************************************************
C History of major changes to DDSCAT package:
C 90.12.21 (BTD): Added code to DDSCAT to create output files
C                 'qtable' (summary of Q values)
C                 'mtable' (summary of diel. func. for material 1)
C 91.08.14 (BTD): Add QBKSCA to arg. list for GETFML
C                 Modify code to print out Q_bk
C 91.08.15 (BTD): Provide different headings for qtable depending on
C                 whether IORTH=1 or 2 (add statement 9043 to DDSCAT).
C 91.09.17 (BTD): Remove calls to ALPHA and EVALA in DDSCAT (needed to 
C                 move these to subroutine GETFML since alpha from Lattice
C                 Dispersion Relation depends on propagation direction
C                 and polarization state)
C                 Add CALPHA,CXEPS,ICOMP,MXCOMP to argument list for
C                 GETFML (information required by ALPHA)
C 91.11.12 (BTD): Added variable IDVSHP to argument list for TARGET
C                 (device number for REASHP to use in reading shape file)
C 93.01.15 (BTD): Modified DDSCAT to divided output file qtable into 2 files:
C                 qtable (containing Q_ext,Q_abs,Q_sca,g,Q_bk) and
C                 qtable2 (containing Q_pha, Q_pol, Q_cpol)
C 93.01.16 (BTD): Modify DDSCAT so that qtable, qtable2, and mtable are closed
C                 after writing, and reopened for each new write
C 93.01.20 (BTD): Add MXNX, MXNY, MXNZ to argument list for subroutine
C                 EXTEND to permit checking of target size against
C                 maximum allowed dimensions
C 93.03.11 (BTD): Deleted all code associated with unused variable
C                 CMACHN (originally included to identify machine/OS)
C 93.03.12 (BTD): Changed CDESCR*60 -> CDESCR*67
C                 Moved WRITE(IDVOUT,9010) to subr. TARGET
C 93.06.02 (BTD): Corrected error in FORMAT statement 9045 in DDSCAT
C 93.06.03 (BTD): Corrected error in computation of angle-averaged
C                 backscattering cross section QBKSUM(JO) in DDSCAT (had
C                 neglected to reset sum to zero for each new target).
C 93.09.28 (BTD): Add "fix" in DDSCAT.f to work around Sun compiler/OS 
C                 bug (see description below.
C 93.12.15 (BTD): Corrected calculation of PPOL in DDSCAT.f  Added 
C                 comments on correspondence between our notation and
C                 elements of 2x2 amplitude scattering matrix and 4x4 
C                 Mueller scattering matrix.
C 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6) to
C                 allow up to 6 shape parameters in DDSCAT, REAPAR, 
C                 TARGET.
C 94.06.20 (PJF): Version 4c.1:
C                 Modifications to various routines to support use of
C                 GPFA FFT code of Temperton by specifying option
C                 NEWTMP in ddscat.par.  Changes made in
C                 cxfft3, eself, extend, reapar
C                 Add FFT timing code TSTFFT to distribution.
C                 Change made to timeit_xxx routines for compatibility
C                 with TSTFFT
C 94.12.20 (BTD): Add subroutine VERSION to consolidate log of
C                 significant changes to DDSCAT package.
C 95.04.07 (BTD): REASHP: Changed CDESCR*60->CDESCR*67 for compatibility
C                         with calling routine TARGET
C                 TARCYL: corrected error in code
C 95.05.15 (BTD): REASHP: Corrected READ statement
C                         added module for inhomogeneous/anisotropic
C                         targets.
C 95.05.26 (BTD): REAPAR: corrected construction of orthogonal
C                         polarization when E01 is complex (e.g.,
C                         circular polarization).
C 95.06.14 (BTD): REAPAR: added code to check that user is not requesting
C                         computation of f_ml when using other than
C                         linearly polarized E01
C 95.06.14 (BTD): Version 5a.1: first development
C                 Differs from version 4d in computing:
C                 full radiation pressure force (transverse components,
C                 in additional to longitudinal component computed
C                 previously);
C                 Torque due to scattering and absorption of radiation
C                 as measured by "vector torque cross section".
C                 Changes made in:
C                 DDSCAT
C                 GETFML (including argument list)
C                 SCAT (including argument list)
C                 VERSION (CSTAMP is now CHARACTER*22, so that a date
C                    can be attached to version number)
C 95.06.15 (BTD): Added CXE to argument list of SCAT
C                 Added new control parameters
C                 CMDSOL (to choose solution method)
C                 CMDTRQ (to choose whether or not to compute torques)
C 95.06.20 (PJF+: Major modification of DDSCAT and GETFML to support
C           BTD): use of modular iterative solvers (e.g., CCGPACK and
C                 PIM routines).
C               : add CMDSOL to argument list to specify method
C                 of solution, with "supported" options
C                 PETRKP = Petravic&Kuo-Petravic CCG routine (from 
C                          CCGPACK, coded by P.J. Flatau based on 
C                          earlier code by B.T. Draine)
C                 PBCGST = Preconditioned Biconjugate Gradient with 
C                          Stabilization (from PIM package, coded by
C                          R. Dias da Cunha and T. Hopkins)
C               : add CMDTRQ to argument list of REAPAR and GETFML
C 95.07.21 (BTD): Major revision to subroutine SCAT
C                 Added additional scratch arrays to DDSCAT,GETFML,SCAT
C 95.07.24 (BTD): Corrected errors in SCAT
C 95.08.14 (BTD): Modified GETFML and PROGRESS to include
C                 COMMON/NORMRES/ERRSCAL to allow renormalization of
C                 error |Ax-b| relative to |b|.
C 96.01.05 (BTD): Version 5a.2:
C                 Differs from version 5a.1 in including
C                 shape options BLOCKS and DW1996, including
C                 automatic calculation of principal axes A1 and A2
C                 with largest and second-largest moment of inertia
C                 eigenvalue and eigenvector problem is solved using
C                 routines BALANC, BALBAK, EIGV, ELMHS0, ELTRN0, HQR2,
C                 IPMPAR, and SPMPAR taken from the Naval Surface 
C                 Warfare Center Library of Mathematics Subroutines.
C 96.01.25 (BTD): Added shape option TWOSPH (routine TAR2SP, and
C                 modifications to TARGET,REAPAR).
C 96.02.23 (BTD): Subroutine PRINAXIS now carries out calculation of
C                 principal axes and eigenvalues of moment of inertia
C                 for arbitary grain shape (if invoked by appropriate
C                 "target generation" subroutine), and prints out
C                 3 principal axes and eigenvalues
C 96.10.17 (BTD): Version 5a.3: 
C                 Added NAT0 to argument list for routine ALPHA.
C                 This required modification of ALPHA and GETFML.
C 96.10.18 (BTD): Changed NEWTMP to GPFAFT (for Generalized Prime
C                 Factor Algorithm for Fourier Transform).
C 96.11.06 (BTD): Version 5a.4:
C                 Removed code from DDSCAT and moved to subroutines
C                 GETMUELLER and WRITESCA
C                 Changed definition of scattering angle phi.
C                 Previously, phi was measured from plane containing
C                 incident k vector and Re(CXE01)
C                 Henceforth, phi is measured from Lab x,y plane
C                 (incident radiation is along x axis).
C                 This involved changes to SCAVEC
C                 Modified GETMUELLER so that for IORTH=2 it
C                 automatically computes the complete Mueller scattering
C                 matrix for each target orientation, and for the
C                 orientational average.
C                 Modified WRITESCA so that it writes out selected
C                 elements of the Mueller matrix.
C 96.11.14 (PJF): Add timers(mxtimers), ntimers to DDSCAT and getfml
C                 timers contains information about CPU times of 
C                 various parts of the code and informations needed
C                 for timming (e.g. number of iterations)
C                 Further changes of "WRITESCA" to include binary
C                 file option. This should be of use, for example, 
C                 for users of IDL.
C                 Added "cbinflag" to DDSCA, reapar. Added
C                 "cbinfile", "iobin" and "open" unformatted file in DDSCAT
C                 "close(iobin) in DDSCAT.
C                 Removed "getset" routine. Hardwired "ioerr" in
C                 "errmsg", and "ioout" in "wrimsg". 
C                 Combined all "rotation" code in rot.2
C                 Added dd.pro package for DDSCAT output postprocessing.
C                 The package includes IDL reading code of binary
C                 DDSCAT file and Bohren and Huffman Mie routine coded in IDL.
C                 Added 10,000 lines of LAPACK code to solve 3x3
C                 eigenvalue problem. Removed NSWC l(eispack)
C                 driver because (a) it contains ald r1mach
C                 tedious to support code (b) because LAPACK is
C                 more modern. 
C                 Add several *.ps files to doc and BibTeX
C                 bibliography of recent DDA references.
C 96.11.15 (PJF): Added NetCDF binary option to "writesca.f"
C                 One needs "include" in writesca.f which is non-standard
C                 in FORTRAN77 but will probably work on all architectures.
C                 Also -lnetcdf flag is needed during the loading step
C                 if NetCDF is being used. Otherwise  "empty" NetCDF routines
C                 should be substittuted to satisfy loader (c.f. dummynetcdf.f)
C                 "ncclose" is executed from DDSCAT.f instead of writesca.f
C                 NetCDF is available from http://www.unidata.ucar.edu/
C                 for most popular computers. 
C                 Added "writebin.f" and "writecdf.f" for 5a7
C 96.11.21 (BTD): moved NCCLOS to WRITENET so that all dependence on
C                 netCDF is through subroutine WRITENET
C                 This required changes to DDSCAT,WRITESCA, and
C                 WRITENET, and adding additional call to WRITESCA
C                 from DDSCAT, and additional call to WRITENET from
C                 WRITESCA
C                 added variable IDVOUT2 to COMMON/NORMERR to permit
C                 device number for standard output to be passed to
C                 subroutine PROGRESS
C 96.12.02 (BTD): Corrected error in DDSCAT.f : SMORI was not
C                 initialized, and hence was incorrect except (possibly)
C                 for first wavelength and radius.
C                 Also eliminated some superfluous variables from
C                 DDSCAT.f
C 97.04.28 (BTD): Corrected bug in TARHEX: NAT was not initialized to 0
C 97.06.04 (BTD): Corrected bug in TARGET, affecting only target option
C                 "UNICYL" (target composition was not being set
C                 correctly).
C 97.07.24 (BTD): Corrected bug in GETMUELLER: was using PHI rather
C                 than PHIN in computation of amplitude scattering
C                 matrix and Mueller matrix from f_ml computed by
C                 GETFML.  Required change in GETMUELLER argument,
C                 list, with corresponding change required in DDSCAT.f
C                 Also corrected bugs in GETMUELLER pertaining to
C                 computation of Mueller matrix elements S_14 and
C                 S_31.  Note that because S_31 was incorrect, PPOL
C                 (evaluated in WRITESCA) was numerically incorrect.
C--------------- end version 5a8  -------------------------------------
C                following modifications resulted in version 5a9
C 98.10.07 (BTD) Rewrote cgcommon.f, function SCNRM2,
C                because g77 optimization generates bad code
C                complicated code replaced with simple code
C 98.10.08 (BTD) modified cgcommon.f, subroutine PROGRESS,
C                to keep track of minimum error, and to
C                note when new error minimum is attained.  This is
C                to observe convergence behavior of PBCGST.
C 98.10.26 (BTD) modified subroutine PROGRESS in cgcommon.f
C                to also print information on
C                rate of convergence (variable RATE).
C 98.10.27 (BTD) modified subroutine SMACHCONS in cgcommon.f
C                because Solaris compiler complained about value of
C                OVERFLOW parameter.  Reduced by factor 2
C 98.11.16 (BTD) Corrected error in value of CXE01R passed to WRITEBIN
C                for binary write option.
C 98.12.07 (BTD) Found and corrected bug reported by Timo Nousiainen 
C                (tpnousia@lumi.meteo.helsinki.fi) which caused Mueller
C                matrix elements S_12 and S_13 to be computed 
C                due to inconsistency in definition of f_ml.  Removed
C                code in GETFML which had been inserted to change
C                f_ml to refer to "usual" incident pol states l=1,2
C                whereas GETFML assumed that incident pol states
C                l=1,2 were those specified by the user in ddscat.par
C                Stick with this latter convention.
C                Modified GETMUELLER so that Mueller matrix elements
C                are computed correctly even when user-specified
C                incident polarization state CXE01 is not linearly
C                polarized.
C 98.12.07 (BTD) Edited UserGuide to give more detailed (and now correct)
C                discussion of computation of Mueller matrix elements
C                from the f_ml.
C 98.12.07 (BTD) Inserted (commented out) code into getfml to allow
C                verification of final error in approximate solution
C                to confirm reliability of error reported by iteration
C                machinery.  After confirming that these errors appear
C                to be reasonable, code was commented out, but can be
C                reactivated at future date if repetition of such tests
C                is desired.
C 99.03.01 (BTD) rewrote subroutine orient.f to make it handle odd
C                NTHETA as described in the UserGuide
C 99.03.05 (BTD) corrected errors in new orient.f
C 99.04.30 (BTD) corrected new errors in orient.f (introduced in
C                99.03.05 revision)
C end history
C
C Copyright (C) 1993,1994,1995,1996,1997,1998,1999 
C B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      RETURN
      END

      SUBROUTINE CXFFT3N(C,MX,MY,MZ,ISIGN)
C Parameters:
      INTEGER MXTRIG
      PARAMETER(MXTRIG=1000)
C Arguments:
      INTEGER ISIGN,MX,MY,MZ
      REAL C(*)
C
C Local scalars:
      INTEGER INC,IND,JUMP,K,LOT,MXOLD,MYOLD,MZOLD
C Local arrays:
      REAL TRIG1(MXTRIG),TRIG2(MXTRIG),TRIG3(MXTRIG)
      SAVE TRIG1,TRIG2,TRIG3,MXOLD,MYOLD,MZOLD
C***********************************************************************
C Interface routine for "Generalized Prime Factor Algorithm" FFT code
C of Temperton.
C Interface written by P.J.Flatau
C
C History:
C
C***********************************************************************
      data mxold, myold, mzold/0,0,0/
      if(mx.ne.mxold .or. my.ne.myold .or. mz.ne.mzold) then
        mxold=mx
        myold=my
        mzold=mz
        CALL SETGPFA(trig1,mX)
        CALL SETGPFA(trig2,mY)
        CALL SETGPFA(trig3,mZ)
      endif
C --- first dimension
      INC=2
      JUMP=2*MX
      LOT=MY*MZ
      CALL GPFA(C(1),c(2),TRIG1,INC,JUMP,MX,LOT,ISIGN)
C --- second dimension
      INC=MX*2
      JUMP=2
      LOT=MX
C --- one plane at a time
      DO 10 K=1,MZ
      ind=1+2*MX*MY*(K-1)
         CALL GPFA(C(IND),C(IND+1),TRIG2,INC,JUMP,
     &               MY,LOT,ISIGN)
   10 CONTINUE
C --- third dimension
      INC=MX*MY*2
      JUMP=2
      LOT=MX*MY
      CALL GPFA(C(1),C(2),TRIG3,INC,JUMP,MZ,LOT,
     &          ISIGN)
      RETURN
      END

      PROGRAM CALLTARGET
C
C Program CALLTARGET is used to generate target arrays using target
C generation routines employed by DDSCAT.
C
C B.T.Draine, Princeton Univ. Obs., 91/1/1
C History:
C 91.05.24 (BTD): Modified to allow entry target names in lower case
C 91.07.16 (BTD): Replaced DO...ENDDO with DO #...# CONTINUE
C 92.12.16 (BTD): Added IDVSHP to argument list of TARGET
C 93.01.07 (BTD): Added options TWOELL and TWOAEL
C 94.05.15 (BTD): Added option CONELL
C 95.12.11 (BTD): Added option BLOCKS
C 96.01.04 (BTD): Added option DW1996
C 96.01.25 (BTD): Added option TWOSPH
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ here and in TARGET
C                 Added calls to SIZER
C 96.01.29 (BTD): Support selection of principal axis calculation
C                 in TAR2SP via SHPAR(6)
C 97.04.25 (BTD): Added option BLK_AN
C 97.04.30 (BTD): Removed code offering choice on target axis for
C                 HEXGON option (target axis now hardwired within
C                 TARHEX)
C end history
C
C Copyright (C) 1993,1994,1995,1996,1997 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C Adjustable parameters:
C    MXNAT=max.number of dipoles in target
      INTEGER MXNAT
      PARAMETER(MXNAT=200000)
C Derived parameters:
      INTEGER MXN3
      PARAMETER(MXN3=3*MXNAT)
C Variables:
      CHARACTER CDESCR*67,CFLSHP*13,CSHAPE*6
      INTEGER IDVSHP,IDVOUT,IOSHP,J,JJ,NAT,NAT3
      INTEGER LXYZ(3)
      INTEGER*2 IXYZ(MXNAT,3),ICOMP(MXNAT,3)
      REAL ERR,F,PI,RGYR2,RXY,RXZ,RYX,RYZ,RZX,RZY,
     &     X,XCM,Y,YCM,Z,ZCM
      REAL A1(3),A2(3),SHPAR(6)
      DOUBLE PRECISION DX,DY,DZ,X2,Y2,Z2
C
C***********************************************************************
      DATA IDVOUT/0/,IOSHP/15/
      PI=4.*ATAN(1.)
C Define variables CFLSHP and IDVSHP to please flint:
      CFLSHP='none'
      IDVSHP=999
 1000 WRITE(IDVOUT,*)'What shape? (Enter choice in quotes) Choices:'
      WRITE(IDVOUT,*)'  BLK_AN = construct from anisotropic cubic ',
     &               'blocks, input from "blocks.par"'
      WRITE(IDVOUT,*)'  BLOCKS = construct from cubic blocks, input ',
     &               'from file "blocks.par"'
      WRITE(IDVOUT,*)'  CONELL = two concentric ellipsoids'
      WRITE(IDVOUT,*)'  CYLNDR = cylinder'
      WRITE(IDVOUT,*)'  DW1996 = 13 cube target used by Draine & ',
     &               'Weingartner (1996)'
      WRITE(IDVOUT,*)'  ELLIPS = ellipsoid'
      WRITE(IDVOUT,*)'  HEXGON = hexagonal prism'
      WRITE(IDVOUT,*)'  RCTNGL = rectangular solid'
      WRITE(IDVOUT,*)'  SPHERE = sphere'
      WRITE(IDVOUT,*)'  TETRAH = regular tetrahedron'
      WRITE(IDVOUT,*)'  THRAEL = three collinear touching anisotropic ',
     &               'ellipsoids'
      WRITE(IDVOUT,*)'  THRELL = three collinear touching ellipsoids'
      WRITE(IDVOUT,*)'  TWOAEL = two touching anisotropic ellipsoids'
      WRITE(IDVOUT,*)'  TWOELL = two touching isotropic ellipsoids'
      WRITE(IDVOUT,*)'  TWOSPH = two touching spheroids (with angle ',
     &               'phi between symm. axes'
      READ(*,*)CSHAPE
      IF(CSHAPE.EQ.'TETRAH'.OR.CSHAPE.EQ.'tetrah')THEN
         CSHAPE='TETRAH'
         DO 1100 J=1,100
            WRITE(IDVOUT,*)'Enter tetrahedron side length ',
     &                     ' (0 to stop)'
            READ(*,*)SHPAR(1)
            SHPAR(2)=SHPAR(1)
            SHPAR(3)=SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(*,6000)SHPAR(1),NAT
 1100    CONTINUE
         STOP
      ELSEIF(CSHAPE.EQ.'SPHERE'.OR.CSHAPE.EQ.'sphere')THEN
         CSHAPE='SPHERE'
         DO 1200 J=1,100
            WRITE(IDVOUT,*)'Enter sphere diameter (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)stop
            SHPAR(2)=SHPAR(1)
            SHPAR(3)=SHPAR(1)
            CSHAPE='ELLIPS'
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            RGYR2=0.
            XCM=0.
            YCM=0.
            ZCM=0.
            DO 1150 JJ=1,NAT
               X=IXYZ(JJ,1)
               Y=IXYZ(JJ,2)
               Z=IXYZ(JJ,3)
               XCM=XCM+X
               YCM=YCM+Y
               ZCM=ZCM+Z
               RGYR2=RGYR2+X*X+Y*Y+Z*Z+0.25
 1150       CONTINUE
            XCM=XCM/REAL(NAT)
            YCM=YCM/REAL(NAT)
            ZCM=ZCM/REAL(NAT)
            RGYR2=RGYR2/REAL(NAT)-XCM**2-YCM**2-ZCM**2
            F=(5./3.)*(4.*PI/REAL(3.*NAT))**(2./3.)*RGYR2
            WRITE(*,6100)SHPAR(1),SHPAR(2),SHPAR(3),NAT,F
 1200       CONTINUE
         STOP
      ELSEIF(CSHAPE.EQ.'ELLIPS'.OR.CSHAPE.EQ.'ellips')THEN
         CSHAPE='ELLIPS'
         DO 1300 J=1,100
            WRITE(IDVOUT,*)'Enter ellipsoid diameters xv,yv,zv',
     &                     ' (0,0,0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0.)stop
            CSHAPE='ELLIPS'
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            XCM=0.
            YCM=0.
            ZCM=0.
            DO 1250 JJ=1,NAT
               X=IXYZ(JJ,1)
               Y=IXYZ(JJ,2)
               Z=IXYZ(JJ,3)
               XCM=XCM+X
               YCM=YCM+Y
               ZCM=ZCM+Z
 1250       CONTINUE
            XCM=XCM/REAL(NAT)
            YCM=YCM/REAL(NAT)
            ZCM=ZCM/REAL(NAT)
            X2=0.
            Y2=0.
            Z2=0.
            DO 1260 JJ=1,NAT
               DX=IXYZ(JJ,1)-XCM
               DY=IXYZ(JJ,2)-YCM
               DZ=IXYZ(JJ,3)-ZCM
               X2=X2+DX*DX
               Y2=Y2+DY*DY
               Z2=Z2+DZ*DZ
 1260       ENDDO
            X2=X2/NAT+1./12.
            Y2=Y2/NAT+1./12.
            Z2=Z2/NAT+1./12.
            ERR=20.*PI*SQRT(5.*X2*Y2*Z2)/(3.*NAT)-1.
            RXY=SQRT(X2/Y2)
            RYZ=SQRT(Y2/Z2)
            RZX=SQRT(Z2/X2)
            RYX=1./RXY
            RZY=1./RYZ
            RXZ=1./RZX
            X2=2.*SQRT(5.*X2)
            Y2=2.*SQRT(5.*Y2)
            Z2=2.*SQRT(5.*Z2)
            WRITE(*,6200)SHPAR(1),SHPAR(2),SHPAR(3),NAT,X2,Y2,Z2,ERR,
     &                   RYX,RZX,RYZ,RXY,RXZ,RZY
 1300    CONTINUE
         STOP
      ELSEIF(CSHAPE.EQ.'CYLNDR'.OR.CSHAPE.EQ.'cylndr')THEN
         CSHAPE='CYLNDR'
         DO 1400 J=1,100
            WRITE(IDVOUT,*)'Enter cylinder length (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter cylinder diameter'
            READ(*,*)SHPAR(2)
            WRITE(IDVOUT,*)'Enter 1,2,3 for axis along x,y,z'
            READ(*,*)SHPAR(3)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
 1400    CONTINUE
         STOP
      ELSEIF(CSHAPE.EQ.'RCTNGL'.OR.CSHAPE.EQ.'rctngl')THEN
         CSHAPE='RCTNGL'
         DO 1500 J=1,100
            WRITE(IDVOUT,*)'Enter x-length (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter y-length'
            READ(*,*)SHPAR(2)
            WRITE(IDVOUT,*)'Enter z-length'
            READ(*,*)SHPAR(3)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
 1500    CONTINUE
      ELSEIF(CSHAPE.EQ.'HEXGON'.OR.CSHAPE.EQ.'hexgon')THEN
         CSHAPE='HEXGON'
         DO 1600 J=1,100
            WRITE(IDVOUT,*)'Enter length (along symmetry axis)',
     &                     ' (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter hexagon diameter = 2*side width'
            READ(*,*)SHPAR(2)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
 1600    CONTINUE
      ELSEIF(CSHAPE.EQ.'TWOELL'.OR.CSHAPE.EQ.'twoell')THEN
         CSHAPE='TWOELL'
         DO 1700 J=1,100
            WRITE(IDVOUT,*)'Enter length of one ellipsoid in x, y, z',
     &                     ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
 1700    CONTINUE
      ELSEIF(CSHAPE.EQ.'TWOAEL'.OR.CSHAPE.EQ.'twoael')THEN
         CSHAPE='TWOAEL'
         DO 1800 J=1,100
            WRITE(IDVOUT,*)'Enter length of one ellipsoid in x, y, z',
     &                     ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
 1800    CONTINUE
      ELSEIF(CSHAPE.EQ.'THRELL'.OR.CSHAPE.EQ.'threll')THEN
         CSHAPE='THRELL'
         DO 1900 J=1,100
            WRITE(IDVOUT,*)'Enter length of one ellipsoid in x, y, z',
     &                     ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
 1900    CONTINUE
      ELSEIF(CSHAPE.EQ.'THRAEL'.OR.CSHAPE.EQ.'thrael')THEN
         CSHAPE='THRAEL'
         DO 2000 J=1,100
            WRITE(IDVOUT,*)'Enter length of one ellipsoid in x, y, z',
     &                     ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,*)'NAT=',NAT
 2000    CONTINUE
      ELSEIF(CSHAPE.EQ.'CONELL'.OR.CSHAPE.EQ.'conell')THEN
         CSHAPE='CONELL'
         DO 2100 J=1,100
            WRITE(IDVOUT,*)'Enter length of outer ellipsoid in x,y,z',
     &                     'directions (lattice units) (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            WRITE(IDVOUT,*)'Enter length of inner ellipsoid in x,y,z',
     &                     'directions (lattice units)'
            READ(*,*)SHPAR(4),SHPAR(5),SHPAR(6)
            IF(SHPAR(4).LE.SHPAR(1).AND.
     &         SHPAR(5).LE.SHPAR(2).AND.
     &         SHPAR(6).LE.SHPAR(3))THEN
               CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,
     &              MXNAT,SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
               CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            ELSE
               WRITE(IDVOUT,*)'Input error: inner ellipsoid is not ',
     &                        'contained within outer ellipsoid'
            ENDIF
 2100    CONTINUE
      ELSEIF(CSHAPE.EQ.'BLOCKS'.OR.CSHAPE.EQ.'blocks')THEN
         CSHAPE='BLOCKS'
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,
     &               MXNAT,SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSEIF(CSHAPE.EQ.'BLK_AN'.OR.CSHAPE.EQ.'blk_an')THEN
         CSHAPE='BLK_AN'
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,
     &               MXNAT,SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSEIF(CSHAPE.EQ.'DW1996'.OR.CSHAPE.EQ.'dw1996')THEN
         CSHAPE='DW1996'
         WRITE(0,*)'Enter block size (lattice units)'
         READ(*,*)SHPAR(1)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,
     &               MXNAT,SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSEIF(CSHAPE.EQ.'TWOSPH'.OR.CSHAPE.EQ.'twosph')THEN
         CSHAPE='TWOSPH'
         WRITE(0,*)'Enter length a_1 and diameter b_1 of 1st spheroid'
         READ(*,*)SHPAR(1),SHPAR(2)
         WRITE(0,*)'Enter length a_2 and diameter b_2 of 2nd spheroid'
         READ(*,*)SHPAR(3),SHPAR(4)
         WRITE(0,*)'Enter angle phi (deg) between axes a_1 and a_2'
         READ(*,*)SHPAR(5)
         WRITE(0,*)'Enter PRINAX=0 for a_1=(1,0,0),a_2=(0,1,0) in TF'
         WRITE(0,*)'            =1 for a_1,a_2=principal axes'
         READ(*,*)SHPAR(6)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,
     &               MXNAT,SHPAR,NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
      ELSE
         WRITE(IDVOUT,*)'Do not know how to make shape = ',CSHAPE
         GOTO 1000
      ENDIF
 6000 FORMAT(' AX=',F7.4,' NAT=',I7)
 6100 FORMAT(' AX=',F7.4,' AY=',F7.4,' AZ=',F7.4,' NAT=',I7,' F=',F10.6)
 6200 FORMAT('    XV =',F7.4,'    YV =',F7.4,'    ZV =',F7.4,
     &       ' NAT=',I8,/,
     &       ' 2a_eff=',F7.4,' 2b_eff=',F7.4,' 2c_eff=',F7.4,
     &       ' err=',F8.7,/,
     &       '   y:x =',F7.4,'   z:x =',F7.4,'   y:z =',F7.4,/,
     &       '   x:y =',F7.4,'   x:z =',F7.4,'   z:y =',F7.4)
      END

      SUBROUTINE C3DFFT(CZ,I1,I2,I3,I4,I5,I6,I7)
C***********************************************************************
C    Note: This module should NOT be linked into DDSCAT when
C    running on a Convex with the vector library -- in that case
C    link with the -lveclib flag and use the native Convex C3DFFT
C    routine.
C    On other systems, however, you need to link in this routine
C    to avoid an error message from the compiler.
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      COMPLEX CZ(1)
      INTEGER I1,I2,I3,I4,I5,I6,I7
      CALL ERRMSG('FATAL','C3DFFT',' CONVEX option but dummy routine!')
      RETURN
      END

      SUBROUTINE WRITENET(CNETFILE,IDNC,CNETFLAG,CSTAMP,CDESCR,CMDFFT,
     +                    CALPHA,CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,
     +                    MXBETA,MXPHI,MXN3,MXNAT,MXSCA,MXTIMERS,IORTH,
     +                    NX,NY,NZ,NAT0,NAT,NAT3,NSCAT,NCOMP,NORI,NWAV,
     +                    NRAD,NTHETA,NPHI,NBETA,NTIMERS,MXNX,MXNY,MXNZ,
     +                    MXCOMP,BETMID,BETMXD,THTMID,THTMXD,
     +                    PHIMID,PHIMXD,ICTHM,IPHIM,TOL,WAVEA,AEFFA,
     +                    THETA,BETA,PHI,A1,A2,ICOMP,IXYZ0,IWAV,IRAD,
     +                    ITHETA,IBETA,IPHI,IORI,AEFF,WAVE,XX,AK1,BETAD,
     +                    THETAD,PHID,AKR,CXE01R,CXE02R,CXRFR,CXEPS,
     +                    QEXT,QABS,QSCAT,G,QBKSCA,QPHA,QAV,QTRQAB,
     +                    QTRQSC,SM,SMORI,PHIN,THETAN,TIMERS)
C***********************************************************************
C Subroutine  "writenet" writes NetCDF portable binary  file
C to file cnetfile ('dd.cdf')
C
C To use netCDF option (a) set "include" statement in this routine to
C proper location of "netcdf.inc"  (b) set "ddscat.par"
C variable "cnetflag" to 'ALLCDF' or 'ORICDF', (c) modify Makefile to link
C with NetCDF library, e.g. (-L/netcdf/location -lnetcdf)
C
C Original version created by P.J.Flatau, University of California, SD
C History:
C 96.11.15 (PJF): First version of NetCDF  (Wolff's request)
C                 5a6 ---> 5a7 Converted to subroutine.
C 96.11.21 (PJF): Add IF(CNEFLAG.EQ.'ALLCDF')THEN and ENDIF
C 96.11.21 (BTD): Removed second occurrence of MXSCA in argument list
C                 here and call from WRITESCA
C 96.11.21 (BTD): added call to NCCLOS if called with CNETFLAG='NCCLOS'
C                 in order to get call to NCCLOS out of DDSCAT.f
C end history
C Copyright (C) 1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C IMPORTANT warning:
C NetCDF "include" statement. "include" is NOT standard FORTRAN 77.
C For location of "netcdf.inc" ask your system administrator.
C Flatau's system:
C      include '/usr/local/netcdf-2.4.2/include/netcdf.inc'
C Draine's system:
      include '/u/flatau/netcdf-2.4.3/include/netcdf.inc'
C***********************************************************************
C     .. Scalar Arguments ..
      REAL AEFF,AK1,BETAD,BETMID,BETMXD,PHID,PHIMID,PHIMXD,THETAD,
     +     THTMID,THTMXD,TOL,WAVE,XX
      INTEGER IBETA,ICTHM,IDNC,IORI,IORTH,IPHI,IPHIM,IRAD,ITHETA,IWAV,
     +        MXBETA,MXCOMP,MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPHI,MXRAD,MXSCA,
     +        MXTHET,MXTIMERS,MXWAV,NAT,NAT0,NAT3,NBETA,NCOMP,NORI,NPHI,
     +        NRAD,NSCAT,NTHETA,NTIMERS,NWAV,NX,NY,NZ
      CHARACTER CALPHA*6,CMDFFT*6,CMDTRQ*6,CNETFLAG*6,CSHAPE*6,
     +          CNETFILE*14,CSTAMP*22,CDESCR*67
C     .. Array Arguments ..
      COMPLEX CXE01R(3),CXE02R(3),CXEPS(MXCOMP),CXRFR(MXCOMP)
      REAL A1(3),A2(3),AEFFA(MXRAD),AKR(3),BETA(MXBETA),G(2),PHI(MXPHI),
     +     PHIN(MXSCA),QABS(2),QAV(17),QBKSCA(2),QEXT(2),QPHA(2),
     +     QSCAT(2),QTRQAB(3,2),QTRQSC(3,2),SM(MXSCA,4,4),
     +     SMORI(MXSCA,4,4),THETA(MXTHET),THETAN(MXSCA),
     +     TIMERS(MXTIMERS),WAVEA(MXWAV)
      INTEGER*2 ICOMP(MXN3),IXYZ0(MXNAT,3)
C     .. Local Scalars ..
      INTEGER ID17,ID2,ID3,IDA1,IDA2,IDAEFF,IDAEFFA,IDAK1,IDBETA,
     +        IDBETMID,IDBETMXD,IDC22,IDC6,IDC67,IDCALPHA,IDCDESCR,
     +        IDCMDFFT,IDCMDTRQ,IDCSHAPE,IDCSTAMP,IDCXRFR,IDG,IDICOMP,
     +        IDICTHM,IDIORTH,IDIPHIM,IDIX0,IDIY0,IDIZ0,IDNAT,IDNAT0,
     +        IDNAT3,IDNBETA,IDNCOMP,IDNORI,IDNPHI,IDNRAD,IDNSCAT,
     +        IDNTHETA,IDNTIMERS,IDNWAV,IDNX,IDNY,IDNZ,IDONE,IDPHI,
     +        IDPHIMID,IDPHIMXD,IDPHIN,IDQABS,IDQAV,IDQBKSCA,IDQEXT,
     +        IDQPHA,IDQSCAT,IDQTRQAB,IDQTRQSC,IDSM11,IDSM12,IDSM13,
     +        IDSM14,IDSM21,IDSM22,IDSM23,IDSM24,IDSM31,IDSM32,IDSM33,
     +        IDSM34,IDSM41,IDSM42,IDSM43,IDSM44,IDSMORI11,IDSMORI12,
     +        IDSMORI13,IDSMORI14,IDSMORI21,IDSMORI22,IDSMORI23,
     +        IDSMORI24,IDSMORI31,IDSMORI32,IDSMORI33,IDSMORI34,
     +        IDSMORI41,IDSMORI42,IDSMORI43,IDSMORI44,IDTHETA,IDTHETAN,
     +        IDTHTMID,IDTHTMXD,IDTOL,IDWAVE,IDWAVEA,IDXX,IENTRY,IERR
C (defined in netcdf.inc)      +        NCCHAR,NCCLOB,NCFLOAT,NCLONG,NCSHORT
C     .. Local Arrays ..
      INTEGER ICOUNT(7),IDDIM(7),ISTART(7)
C     .. External Functions ..
C (defined in netcdf.inc)       INTEGER NCCRE,NCDDEF,NCVDEF
C (defined in netcdf.inc)      EXTERNAL NCCRE,NCDDEF,NCVDEF
C     .. External Subroutines ..
      EXTERNAL NCAPTC,NCENDF,NCVPT,NCVPT1,NCVPTC,WRIMSG
C     .. Save statement ..
      SAVE IENTRY,IDQEXT,IDQABS,IDQSCAT,IDG,IDQBKSCA,IDQPHA,IDQAV,
     +     IDQTRQAB,IDQTRQSC,IDSM11,IDSM12,IDSM13,IDSM14,IDSM21,IDSM22,
     +     IDSM23,IDSM24,IDSM31,IDSM32,IDSM33,IDSM34,IDSM41,IDSM42,
     +     IDSM43,IDSM44,IDSMORI11,IDSMORI12,IDSMORI13,IDSMORI14,
     +     IDSMORI21,IDSMORI22,IDSMORI23,IDSMORI24,IDSMORI31,IDSMORI32,
     +     IDSMORI33,IDSMORI34,IDSMORI41,IDSMORI42,IDSMORI43,IDSMORI44,
     +     IDWAVE,IDAEFF,IDXX,IDAK1,IDCXRFR
C     .. Data statements ..

      DATA IENTRY/0/

C 1) IENTRY=0 defines first entry to this routine. All NetCDF
C    dimensions will be  defined in this step. This part of the
C     code is never executed again.NetCDF "id" variables are saved.
C 2) iori=0. Routine is called for iwav, irad, itheta, ibeta, iphi
C    These 5 variables can be split to two groups:
C    ("iwav", "irad") and ("itheta", "iphi", "ibeta").
C    The second group defines orientations of target and is also
C    defined by variable "iori". If "iori=0"  the code
C    finished all specified ntheta, nbeta, nphi orientations
C    and it is time to write orientational averages.
C 3) If iori .ne. 0 we cycle over orientations and iwav, irad.
C    Many-dimensional arrays are stored on disk.

      IF(CNETFLAG.EQ.'NCCLOS')THEN
         CALL NCCLOS(IDNC,IERR)
         RETURN
      ENDIF
      IF (IENTRY.EQ.0) THEN
          CALL WRIMSG('WRITENET',' First entry to NetCDF write')
          IENTRY = 1
C this dd.cdf should be "cnetfile"
          IDNC = NCCRE('dd.cdf',NCCLOB,IERR)
C NetCDF dimensions
C character variables
          IDC6 = NCDDEF(IDNC,'c6',6,IERR)
          IDC67 = NCDDEF(IDNC,'c67',67,IERR)
          IDC22 = NCDDEF(IDNC,'c22',22,IERR)
          IDCALPHA = NCVDEF(IDNC,'calpha',NCCHAR,1,IDC6,IERR)
          IDCDESCR = NCVDEF(IDNC,'cdescr',NCCHAR,1,IDC67,IERR)
          IDCMDFFT = NCVDEF(IDNC,'cmdfft',NCCHAR,1,IDC6,IERR)
          IDCMDTRQ = NCVDEF(IDNC,'cmdtrq',NCCHAR,1,IDC6,IERR)
          IDCSHAPE = NCVDEF(IDNC,'cshape',NCCHAR,1,IDC6,IERR)
          IDCSTAMP = NCVDEF(IDNC,'cstamp',NCCHAR,1,IDC22,IERR)
C single variables
          IDONE = NCDDEF(IDNC,'one',1,IERR)
          IDIORTH = NCVDEF(IDNC,'iorth',NCLONG,1,IDONE,IERR)
          IDBETMID = NCVDEF(IDNC,'betmid',NCFLOAT,1,IDONE,IERR)
          IDBETMXD = NCVDEF(IDNC,'betmxd',NCFLOAT,1,IDONE,IERR)
          IDTHTMID = NCVDEF(IDNC,'thtmid',NCFLOAT,1,IDONE,IERR)
          IDTHTMXD = NCVDEF(IDNC,'thtmxd',NCFLOAT,1,IDONE,IERR)
          IDPHIMID = NCVDEF(IDNC,'phimid',NCFLOAT,1,IDONE,IERR)
          IDPHIMXD = NCVDEF(IDNC,'phimxd',NCFLOAT,1,IDONE,IERR)
          IDICTHM = NCVDEF(IDNC,'icthm',NCLONG,1,IDONE,IERR)
          IDIPHIM = NCVDEF(IDNC,'iphim',NCLONG,1,IDONE,IERR)
          IDTOL = NCVDEF(IDNC,'tol',NCFLOAT,1,IDONE,IERR)
C dimensions arrays
          IDNX = NCDDEF(IDNC,'nx',NX,IERR)
          IDNY = NCDDEF(IDNC,'ny',NY,IERR)
          IDNZ = NCDDEF(IDNC,'nz',NZ,IERR)
          IDNAT0 = NCDDEF(IDNC,'nat0',NAT0,IERR)
          IDNAT = NCDDEF(IDNC,'nat',NAT,IERR)
          IDNAT3 = NCDDEF(IDNC,'nat3',NAT3,IERR)
          IDNSCAT = NCDDEF(IDNC,'nscat',NSCAT,IERR)
          IDNCOMP = NCDDEF(IDNC,'ncomp',NCOMP,IERR)
          IDNORI = NCDDEF(IDNC,'nori',NORI,IERR)
          IDNWAV = NCDDEF(IDNC,'nwav',NWAV,IERR)
          IDNRAD = NCDDEF(IDNC,'nrad',NRAD,IERR)
          IDNTHETA = NCDDEF(IDNC,'ntheta',NTHETA,IERR)
          IDNPHI = NCDDEF(IDNC,'nphi',NPHI,IERR)
          IDNBETA = NCDDEF(IDNC,'nbeta',NBETA,IERR)
          IDNTIMERS = NCDDEF(IDNC,'ntimers',NTIMERS,IERR)
          ID2 = NCDDEF(IDNC,'two',2,IERR)
          ID3 = NCDDEF(IDNC,'three',3,IERR)
          ID17 = NCDDEF(IDNC,'seventeen',17,IERR)
C arrays
          IDWAVEA = NCVDEF(IDNC,'wavea',NCFLOAT,1,IDNWAV,IERR)
          CALL NCAPTC(IDNC,IDWAVEA,'long_name',NCCHAR,16,
     +                'wavelength array',IERR)
          IDAEFFA = NCVDEF(IDNC,'aeffa',NCFLOAT,1,IDNRAD,IERR)
          CALL NCAPTC(IDNC,IDAEFFA,'long_name',NCCHAR,22,
     +                'effective radius array',IERR)
          IDTHETA = NCVDEF(IDNC,'theta',NCFLOAT,1,IDNTHETA,IERR)
          CALL NCAPTC(IDNC,IDTHETA,'long_name',NCCHAR,38,
     +                'theta (target orientation angle array)',IERR)
          IDBETA = NCVDEF(IDNC,'beta',NCFLOAT,1,IDNBETA,IERR)
          CALL NCAPTC(IDNC,IDBETA,'long_name',NCCHAR,37,
     +                'beta (target orientation angle array)',IERR)
          IDPHI = NCVDEF(IDNC,'phi',NCFLOAT,1,IDNPHI,IERR)
          CALL NCAPTC(IDNC,IDPHI,'long_name',NCCHAR,36,
     +                'phi (target orientation angle array)',IERR)

          IDA1 = NCVDEF(IDNC,'a1',NCFLOAT,1,ID3,IERR)
          CALL NCAPTC(IDNC,IDA1,'long_name',NCCHAR,24,
     +                'target definition vector',IERR)
          IDA2 = NCVDEF(IDNC,'a2',NCFLOAT,1,ID3,IERR)
          CALL NCAPTC(IDNC,IDA2,'long_name',NCCHAR,24,
     +                'target definition vector',IERR)
          IDICOMP = NCVDEF(IDNC,'icomp',NCSHORT,1,IDNAT3,IERR)
          CALL NCAPTC(IDNC,IDICOMP,'long_name',NCCHAR,39,
     +                'dipole composition definition (0-empty)',IERR)
C let as split ixyz0
          IDIX0 = NCVDEF(IDNC,'ix0',NCSHORT,1,IDNAT,IERR)
          IDIY0 = NCVDEF(IDNC,'iy0',NCSHORT,1,IDNAT,IERR)
          IDIZ0 = NCVDEF(IDNC,'iz0',NCSHORT,1,IDNAT,IERR)
C declare "running" variables dimensions
cc         WRITE(IOBIN) IWAV, IRAD, IORI, (timers(i), i=1,ntimers)
cc         WRITE(iobin) AEFF,WAVE,XX, AK1, BETAD,THETAD,PHID,
cc     $         AKR, CXE01R, CXE02R,
cc     $         (CXRFR(i), i=1, ncomp), (cxeps(i),i=1, ncomp)
cc         WRITE(iobin) QEXT, QABS, QSCAT, G, QBKSCA, QPHA, QAV,
cc     $               QTRQAB, QTRQSC
c          idone=ncddef(idnc,'one',1,ierr)
c          idiorth=ncvdef(idnc,'iorth',nclong,1, idone,ierr)
C
          IDDIM(1) = IDNWAV
          IDWAVE = NCVDEF(IDNC,'wave',NCFLOAT,1,IDDIM,IERR)
          IDDIM(1) = IDNRAD
          IDAEFF = NCVDEF(IDNC,'aeff',NCFLOAT,1,IDDIM,IERR)
          IDDIM(1) = IDNWAV
          IDDIM(2) = IDNRAD
          IDXX = NCVDEF(IDNC,'xx',NCFLOAT,2,IDDIM,IERR)
          IDAK1 = NCVDEF(IDNC,'ak1',NCFLOAT,2,IDDIM,IERR)
C cxrfr is complex but NetCDF doesn't support complex:
          IDDIM(1) = IDNWAV
          IDDIM(2) = ID2
          IDDIM(3) = IDNCOMP
          IDCXRFR = NCVDEF(IDNC,'cxrfr',NCFLOAT,3,IDDIM,IERR)
          IDDIM(1) = IDNWAV
          IDDIM(2) = IDNRAD
          IDDIM(3) = IDNSCAT
          IDSMORI11 = NCVDEF(IDNC,'smori11',NCFLOAT,3,IDDIM,IERR)
          IDSMORI12 = NCVDEF(IDNC,'smori12',NCFLOAT,3,IDDIM,IERR)
          IDSMORI13 = NCVDEF(IDNC,'smori13',NCFLOAT,3,IDDIM,IERR)
          IDSMORI14 = NCVDEF(IDNC,'smori14',NCFLOAT,3,IDDIM,IERR)
          IDSMORI21 = NCVDEF(IDNC,'smori21',NCFLOAT,3,IDDIM,IERR)
          IDSMORI22 = NCVDEF(IDNC,'smori22',NCFLOAT,3,IDDIM,IERR)
          IDSMORI23 = NCVDEF(IDNC,'smori23',NCFLOAT,3,IDDIM,IERR)
          IDSMORI24 = NCVDEF(IDNC,'smori24',NCFLOAT,3,IDDIM,IERR)
          IDSMORI31 = NCVDEF(IDNC,'smori31',NCFLOAT,3,IDDIM,IERR)
          IDSMORI32 = NCVDEF(IDNC,'smori32',NCFLOAT,3,IDDIM,IERR)
          IDSMORI33 = NCVDEF(IDNC,'smori33',NCFLOAT,3,IDDIM,IERR)
          IDSMORI34 = NCVDEF(IDNC,'smori34',NCFLOAT,3,IDDIM,IERR)
          IDSMORI41 = NCVDEF(IDNC,'smori41',NCFLOAT,3,IDDIM,IERR)
          IDSMORI42 = NCVDEF(IDNC,'smori42',NCFLOAT,3,IDDIM,IERR)
          IDSMORI43 = NCVDEF(IDNC,'smori43',NCFLOAT,3,IDDIM,IERR)
          IDSMORI44 = NCVDEF(IDNC,'smori44',NCFLOAT,3,IDDIM,IERR)
C real 6-7 dimensional cases
          IDDIM(1) = IDNWAV
          IDDIM(2) = IDNRAD
          IDDIM(3) = IDNTHETA
          IDDIM(4) = IDNBETA
          IDDIM(5) = IDNPHI
          IDDIM(6) = ID2
          IDQEXT = NCVDEF(IDNC,'qext',NCFLOAT,6,IDDIM,IERR)
          IDQABS = NCVDEF(IDNC,'qabs',NCFLOAT,6,IDDIM,IERR)
          IDQSCAT = NCVDEF(IDNC,'qscat',NCFLOAT,6,IDDIM,IERR)
          IDG = NCVDEF(IDNC,'g',NCFLOAT,6,IDDIM,IERR)
          IDQBKSCA = NCVDEF(IDNC,'qbksca',NCFLOAT,6,IDDIM,IERR)
          IDQPHA = NCVDEF(IDNC,'qpha',NCFLOAT,6,IDDIM,IERR)
          IDDIM(6) = ID17
          IDQAV = NCVDEF(IDNC,'qav',NCFLOAT,6,IDDIM,IERR)
          IDDIM(6) = ID3
          IDDIM(7) = ID2
          IDQTRQAB = NCVDEF(IDNC,'qtrqab',NCFLOAT,7,IDDIM,IERR)
          IDQTRQSC = NCVDEF(IDNC,'qtrqsc',NCFLOAT,7,IDDIM,IERR)
          IDDIM(6) = IDNSCAT
          IF(CNETFLAG.EQ.'ALLCDF')THEN
             IDSM11 = NCVDEF(IDNC,'sm11',NCFLOAT,6,IDDIM,IERR)
             IDSM12 = NCVDEF(IDNC,'sm12',NCFLOAT,6,IDDIM,IERR)
             IDSM13 = NCVDEF(IDNC,'sm13',NCFLOAT,6,IDDIM,IERR)
             IDSM14 = NCVDEF(IDNC,'sm14',NCFLOAT,6,IDDIM,IERR)
             IDSM21 = NCVDEF(IDNC,'sm21',NCFLOAT,6,IDDIM,IERR)
             IDSM22 = NCVDEF(IDNC,'sm22',NCFLOAT,6,IDDIM,IERR)
             IDSM23 = NCVDEF(IDNC,'sm23',NCFLOAT,6,IDDIM,IERR)
             IDSM24 = NCVDEF(IDNC,'sm24',NCFLOAT,6,IDDIM,IERR)
             IDSM31 = NCVDEF(IDNC,'sm31',NCFLOAT,6,IDDIM,IERR)
             IDSM32 = NCVDEF(IDNC,'sm32',NCFLOAT,6,IDDIM,IERR)
             IDSM33 = NCVDEF(IDNC,'sm33',NCFLOAT,6,IDDIM,IERR)
             IDSM34 = NCVDEF(IDNC,'sm34',NCFLOAT,6,IDDIM,IERR)
             IDSM41 = NCVDEF(IDNC,'sm41',NCFLOAT,6,IDDIM,IERR)
             IDSM42 = NCVDEF(IDNC,'sm42',NCFLOAT,6,IDDIM,IERR)
             IDSM43 = NCVDEF(IDNC,'sm43',NCFLOAT,6,IDDIM,IERR)
             IDSM44 = NCVDEF(IDNC,'sm44',NCFLOAT,6,IDDIM,IERR)
          ENDIF
          IDPHIN = NCVDEF(IDNC,'phin',NCFLOAT,1,IDNSCAT,IERR)
          CALL NCAPTC(IDNC,IDPHIN,'long_name',NCCHAR,16,
     +                'scattering angle',IERR)
          IDTHETAN = NCVDEF(IDNC,'thetan',NCFLOAT,1,IDNSCAT,IERR)
          CALL NCAPTC(IDNC,IDTHETAN,'long_name',NCCHAR,16,
     +                'scattering angle',IERR)
          CALL NCENDF(IDNC,IERR)
C write characters
          CALL NCVPTC(IDNC,IDCALPHA,1,6,CALPHA,6,IERR)
          CALL NCVPTC(IDNC,IDCDESCR,1,67,CDESCR,67,IERR)
          CALL NCVPTC(IDNC,IDCMDFFT,1,6,CMDFFT,6,IERR)
          CALL NCVPTC(IDNC,IDCMDTRQ,1,6,CMDTRQ,6,IERR)
          CALL NCVPTC(IDNC,IDCSHAPE,1,6,CSHAPE,6,IERR)
          CALL NCVPTC(IDNC,IDCSTAMP,1,22,CSTAMP,22,IERR)
C write single variables:
          CALL NCVPT1(IDNC,IDIORTH,1,IORTH,IERR)
          CALL NCVPT1(IDNC,IDBETMID,1,BETMID,IERR)
          CALL NCVPT1(IDNC,IDBETMXD,1,BETMXD,IERR)
          CALL NCVPT1(IDNC,IDTHTMID,1,THTMID,IERR)
          CALL NCVPT1(IDNC,IDTHTMXD,1,THTMXD,IERR)
          CALL NCVPT1(IDNC,IDPHIMID,1,PHIMID,IERR)
          CALL NCVPT1(IDNC,IDPHIMXD,1,PHIMXD,IERR)
          CALL NCVPT1(IDNC,IDICTHM,1,ICTHM,IERR)
          CALL NCVPT1(IDNC,IDIPHIM,1,IPHIM,IERR)
          CALL NCVPT1(IDNC,IDTOL,1,TOL,IERR)
C write arrays
          CALL NCVPT(IDNC,IDWAVEA,1,NWAV,WAVEA,IERR)
          CALL NCVPT(IDNC,IDAEFFA,1,NRAD,AEFFA,IERR)
          CALL NCVPT(IDNC,IDTHETA,1,NTHETA,THETA,IERR)
          CALL NCVPT(IDNC,IDBETA,1,NBETA,BETA,IERR)
          CALL NCVPT(IDNC,IDPHI,1,NPHI,PHI,IERR)
          CALL NCVPT(IDNC,IDA1,1,3,A1,IERR)
          CALL NCVPT(IDNC,IDA2,1,3,A2,IERR)
          CALL NCVPT(IDNC,IDICOMP,1,NAT3,ICOMP,IERR)
C print, idix0
          CALL NCVPT(IDNC,IDIX0,1,NAT,IXYZ0(1,1),IERR)
          CALL NCVPT(IDNC,IDIY0,1,NAT,IXYZ0(1,2),IERR)
          CALL NCVPT(IDNC,IDIZ0,1,NAT,IXYZ0(1,3),IERR)
          CALL NCVPT(IDNC,IDPHIN,1,NSCAT,PHIN,IERR)
          CALL NCVPT(IDNC,IDTHETAN,1,NSCAT,THETAN,IERR)
C endif      "if(ientry .eq. 0) then"
      END IF


      IF (IORI.NE.0 .AND. CNETFLAG.EQ.'ALLCDF') THEN
C NetCDF option --- running variables
C first 5 dimensions are always the same:
C define "lower left"  corner of the (many dimensional) box

C some stuff will be written over and over
          ISTART(1) = IWAV
          ICOUNT(1) = 1
          CALL NCVPT(IDNC,IDWAVE,ISTART,ICOUNT,WAVE,IERR)
          ISTART(1) = IRAD
          ICOUNT(1) = 1
          CALL NCVPT(IDNC,IDAEFF,ISTART,ICOUNT,AEFF,IERR)
          ISTART(1) = IWAV
          ISTART(2) = IRAD
          ICOUNT(1) = 1
          ICOUNT(2) = 1
          CALL NCVPT(IDNC,IDXX,ISTART,ICOUNT,XX,IERR)
          CALL NCVPT(IDNC,IDAK1,ISTART,ICOUNT,AK1,IERR)
          ISTART(1) = IWAV
          ISTART(2) = 1
          ISTART(3) = 1
          ICOUNT(1) = 1
          ICOUNT(2) = 2
          ICOUNT(3) = NCOMP
          CALL NCVPT(IDNC,IDCXRFR,ISTART,ICOUNT,CXRFR,IERR)
C
          ISTART(1) = IWAV
          ISTART(2) = IRAD
          ISTART(3) = ITHETA
          ISTART(4) = IBETA
          ISTART(5) = IPHI
          ISTART(6) = 1
          ISTART(7) = 1
C define how many elements to write
          ICOUNT(1) = 1
          ICOUNT(2) = 1
          ICOUNT(3) = 1
          ICOUNT(4) = 1
          ICOUNT(5) = 1
          ICOUNT(6) = 2
          CALL NCVPT(IDNC,IDQEXT,ISTART,ICOUNT,QEXT,IERR)
          CALL NCVPT(IDNC,IDQABS,ISTART,ICOUNT,QABS,IERR)
          CALL NCVPT(IDNC,IDQSCAT,ISTART,ICOUNT,QSCAT,IERR)
          CALL NCVPT(IDNC,IDG,ISTART,ICOUNT,G,IERR)
          CALL NCVPT(IDNC,IDQBKSCA,ISTART,ICOUNT,QBKSCA,IERR)
          CALL NCVPT(IDNC,IDQPHA,ISTART,ICOUNT,QPHA,IERR)
          ICOUNT(6) = 17
          CALL NCVPT(IDNC,IDQAV,ISTART,ICOUNT,QAV,IERR)
          ICOUNT(6) = 3
          ICOUNT(7) = 2
          CALL NCVPT(IDNC,IDQTRQAB,ISTART,ICOUNT,QTRQAB,IERR)
          CALL NCVPT(IDNC,IDQTRQSC,ISTART,ICOUNT,QTRQSC,IERR)
C Muller matrix (IDL handles only 7 dimensions) - so 16 ncvpt's
          ICOUNT(6) = NSCAT
          CALL NCVPT(IDNC,IDSM11,ISTART,ICOUNT,SM(1,1,1),IERR)
          CALL NCVPT(IDNC,IDSM12,ISTART,ICOUNT,SM(1,1,2),IERR)
          CALL NCVPT(IDNC,IDSM13,ISTART,ICOUNT,SM(1,1,3),IERR)
          CALL NCVPT(IDNC,IDSM14,ISTART,ICOUNT,SM(1,1,4),IERR)
          CALL NCVPT(IDNC,IDSM21,ISTART,ICOUNT,SM(1,2,1),IERR)
          CALL NCVPT(IDNC,IDSM22,ISTART,ICOUNT,SM(1,2,2),IERR)
          CALL NCVPT(IDNC,IDSM23,ISTART,ICOUNT,SM(1,2,3),IERR)
          CALL NCVPT(IDNC,IDSM24,ISTART,ICOUNT,SM(1,2,4),IERR)
          CALL NCVPT(IDNC,IDSM31,ISTART,ICOUNT,SM(1,3,1),IERR)
          CALL NCVPT(IDNC,IDSM32,ISTART,ICOUNT,SM(1,3,2),IERR)
          CALL NCVPT(IDNC,IDSM33,ISTART,ICOUNT,SM(1,3,3),IERR)
          CALL NCVPT(IDNC,IDSM34,ISTART,ICOUNT,SM(1,3,4),IERR)
          CALL NCVPT(IDNC,IDSM41,ISTART,ICOUNT,SM(1,4,1),IERR)
          CALL NCVPT(IDNC,IDSM42,ISTART,ICOUNT,SM(1,4,2),IERR)
          CALL NCVPT(IDNC,IDSM43,ISTART,ICOUNT,SM(1,4,3),IERR)
          CALL NCVPT(IDNC,IDSM44,ISTART,ICOUNT,SM(1,4,4),IERR)
C endif   "if(iori. ne. 0  .and. cnetflag.eq.'ALLCDF') then"
      END IF

C Here only for iori=0. Write smori to netCDF:
      IF (IORI.EQ.0) THEN
          ISTART(1) = IWAV
          ISTART(2) = IRAD
          ISTART(3) = 1
          ICOUNT(1) = 1
          ICOUNT(2) = 1
          ICOUNT(3) = NSCAT
          CALL NCVPT(IDNC,IDSMORI11,ISTART,ICOUNT,SMORI(1,1,1),IERR)
          CALL NCVPT(IDNC,IDSMORI12,ISTART,ICOUNT,SMORI(1,1,2),IERR)
          CALL NCVPT(IDNC,IDSMORI13,ISTART,ICOUNT,SMORI(1,1,3),IERR)
          CALL NCVPT(IDNC,IDSMORI14,ISTART,ICOUNT,SMORI(1,1,4),IERR)
          CALL NCVPT(IDNC,IDSMORI21,ISTART,ICOUNT,SMORI(1,2,1),IERR)
          CALL NCVPT(IDNC,IDSMORI22,ISTART,ICOUNT,SMORI(1,2,2),IERR)
          CALL NCVPT(IDNC,IDSMORI23,ISTART,ICOUNT,SMORI(1,2,3),IERR)
          CALL NCVPT(IDNC,IDSMORI24,ISTART,ICOUNT,SMORI(1,2,4),IERR)
          CALL NCVPT(IDNC,IDSMORI31,ISTART,ICOUNT,SMORI(1,3,1),IERR)
          CALL NCVPT(IDNC,IDSMORI32,ISTART,ICOUNT,SMORI(1,3,2),IERR)
          CALL NCVPT(IDNC,IDSMORI33,ISTART,ICOUNT,SMORI(1,3,3),IERR)
          CALL NCVPT(IDNC,IDSMORI34,ISTART,ICOUNT,SMORI(1,3,4),IERR)
          CALL NCVPT(IDNC,IDSMORI41,ISTART,ICOUNT,SMORI(1,4,1),IERR)
          CALL NCVPT(IDNC,IDSMORI42,ISTART,ICOUNT,SMORI(1,4,2),IERR)
          CALL NCVPT(IDNC,IDSMORI43,ISTART,ICOUNT,SMORI(1,4,3),IERR)
          CALL NCVPT(IDNC,IDSMORI44,ISTART,ICOUNT,SMORI(1,4,4),IERR)
c endif    "if(iori.eq.0) then
      END IF

      RETURN

      END

      program ddscat
      parameter (nwav=2, nscat=10)
      real data(nscat)
      complex cxdata(nscat)

       do 10 iwav=1, nwav
         do 20 iscat=1, nscat
          data(iscat)=iscat+(iwav-1)*10
          cxdata(iscat)=cmplx(iscat+(iwav-1)*10, iwav)
 20    continue
      call writessca(nwav, nscat, data, cxdata, cxdata,
     $       iwav,  idnc)
 10   continue

      print*, ' close ', idnc
      call ncclos(idnc, ierr)
      stop
      end

      subroutine writessca(nwav, nscat, data, 
     $         cxdata,  realcxdata, iwav,  idnc)
      include '/usr/local/netcdf-2.4.2/include/netcdf.inc'
      integer istart(7), icount(7), iddim(7)
      real data(nscat)
      complex cxdata(nscat)
      real realcxdata(2,nscat)

      data ientry/0/
      if(ientry.eq.0) then
          ientry=1
          idnc=nccre('test.cdf',ncclob,ierr)
C dimensions
          idnwav=ncddef(idnc,'nwav',nwav,ierr)
          idnscat=ncddef(idnc,'nscat',nscat,ierr)
          id2=ncddef(idnc,'two',2,ierr)
C variables
          iddim(1)=idnwav
          iddim(2)=idnscat
          iddata=ncvdef(idnc,'data',ncfloat,2,iddim,ierr)

          iddim(1)=id2
          iddim(2)=idnscat
          idre=ncvdef(idnc,'datare',ncfloat,2,iddim,ierr)
          call ncendf(idnc,ierr)
      endif

         istart(1)=iwav
         istart(2)=1
         icount(1)=1
         icount(2)=nscat

         print*, ' ncvpt ', istart(1), istart(2), icount(1), icount(2)
c         call ncvpt(idnc, iddata, istart, icount, data, ierr)
C try to dump complex (dump every other one) ??


         do 10 i=1, nscat
          print*, cxdata(i), realcxdata(1,i), realcxdata(2,i)
 10      continue

         istart(1)=1
         istart(2)=1
         icount(1)=2
         icount(2)=nscat
         call ncvpt(idnc, idre, istart, icount, cxdata, ierr)


      return
      end

      SUBROUTINE TAR2SP(A1,A2,A_1,B_1,A_2,B_2,PHI,PRINAX,
     &                   CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
C***********************************************************************
C Routine to construct two touching spheroids from "atoms"
C    First spheroid has symmetry axis in y direction.
C    Second spheroid is displaced in x direction, with symmetry
C    axis in yz plane, in direction ey*cos(phi)+ez*sin(phi).
C    Separation between centroids=(B_1+B_2)/2
C   
C Input:
C        A_1=length/d of 1st spheroid along symm.axis    (d=lattice spacing)
C        A_2=length/d of 2nd spheroid along symm.axis
C        B_1=diameter/d of 1st spheroid
C        B_2=diameter/d of 2nd spheroid
C        PHI=angle (deg) specifying relative orientation of spheroids
C        PRINAX=0. to set A1=(1,0,0),A2=(0,1,0) in Target Framee
C              =1. to set A1,A2=principal axes of largest and second 
C                               largest moment of inertia 
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT=dimensioning information (max number of atoms)
C Output:
C        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Frame
C        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Frame
C        NAT=number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
C        ICOMP(1-NAT,1-3)=1 for sites within first spheroid
C                        =2 for sites within second spheroid
C        CDESCR=description of target (up to 67 characters)
C
C B.T.Draine, Princeton Univ. Obs.
C History:
C 96.01.25 (BTD) First written.
C 96.01.26 (BTD) Replaced IX,IY,IZ by IXYZ
C 96.01.29 (BTD) Modified to add PRINAX to argument list, and
C                call to PRINAXIS to determine principal axes if
C                PRINAX=1.
C end history
C
C Copyright (C) 1996, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C** Arguments:
      CHARACTER CDESCR*67
      INTEGER IOSHP,MXNAT,NAT
      INTEGER*2 ICOMP(MXNAT,3),IXYZ(MXNAT,3)
      REAL A_1,A_2,B_1,B_2,PHI,PRINAX
      REAL A1(3),A2(3)
C** Local variables:
      CHARACTER CMSGNM*70
      INTEGER JA,JX,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2,
     &   NAT1,NAT2
      REAL AX2,AY2,AZ2,FXX,FYY,FYZ,FZZ,
     &   R,RX2,RXY2,RYZ2,RZ2,X,XOFF,Y,YOFF,Z,ZOFF
C***********************************************************************
c*** diagnostic
      write(0,*)'entered tar2sp, ioshp=',ioshp
      write(0,*)'a_1,b_1,a_2,b_2=',a_1,b_1,a_2,b_2
c***
C
C Routine to construct pseudo-spheroidal target aray.
C With occupied array sites contained within spheroidal surface
C defined by (X/A_1)**2+(Y/B_1)**2+(Z/B_1)**2=0.25
C Ideal volume V=(pi/6)*A_1*B_1*B_1
C
C Dipoles are located at sites
C (x,y,z)=(I+XOFF,J+YOFF,Z+KOFF), I,J,K=integers
C                                 XOFF,YOFF,ZOFF=constants
C
C Criterion for choosing XOFF:
C If B_1+B_2 is close to an even integer, take XOFF=1/2
C If B_1+B_2 is close to an odd integer, take XOFF=0
C
      JX=INT(B_1+B_2+.5)
      IF(2*(JX/2).EQ.JX)THEN
         XOFF=0.5
      ELSE
         XOFF=0.
      ENDIF
C 
C Criteria for YOFF and ZOFF are designed to optimize approximation
C for first spheroid, which is aligned with x,y,z axes.
C (Second spheroid need not be).
C Criterion for YOFF:
C If A_1 is close to an even integer, take YOFF=1/2
C IF A_1 is close to an odd integer, take YOFF=0
      JY=INT(A_1+.5)
      IF(2*(JY/2).EQ.JY)THEN
         YOFF=0.5
      ELSE
         YOFF=0.
      ENDIF
C
C Similar criterion for ZOFF:
C If B_1 is close to an even integer, take ZOFF=1/2
C If B_1 is close to an odd integer, take ZOFF=0
      JZ=INT(B_1+.5)
      IF(2*(JZ/2).EQ.JZ)THEN
         ZOFF=0.5
      ELSE
         ZOFF=0.
      ENDIF
C
      NAT=0
C             
C Determine list of occupied sites in first spheroid
C
      LMX1=-INT(.5*B_1+.5)
      LMX2=INT(.5*B_1-.25)
      LMY1=-INT(.5*A_1+.5)
      LMY2=INT(.5*A_1-.25)
      LMZ1=-INT(.5*B_1+.5)
      LMZ2=INT(.5*B_1-.25)
      AX2=B_1*B_1
      AY2=A_1*A_1
      AZ2=B_1*B_1
      DO 0300 JZ=LMZ1,LMZ2
         Z=REAL(JZ)+ZOFF
         RZ2=Z*Z/AZ2
         IF(RZ2.LT.0.25)THEN
            DO 0200 JY=LMY1,LMY2
               Y=REAL(JY)+YOFF
               RYZ2=RZ2+Y*Y/AY2
               IF(RYZ2.LT.0.25)THEN
                  DO 0100 JX=LMX1,LMX2
                     X=REAL(JX)+XOFF
                     R=RYZ2+X*X/AX2
                     IF(R.LT.0.25)THEN
                        NAT=NAT+1
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                     ENDIF
 0100             CONTINUE
               ENDIF
 0200       CONTINUE
         ENDIF
 0300 CONTINUE
      NAT1=NAT
C
C Determine occupied sites in second spheroid
C
      LMX1=INT(.5*B_1-.5)
      LMX2=INT(.5*B_1+B_2-.25)
      LMY1=-INT(.5*MAX(A_2,B_2)+.5)
      LMY2=INT(.5*MAX(A_2,B_2)-.25)
      LMZ1=LMY1
      LMZ2=LMY2
      FXX=1./B_2**2
      FYY=(COS(3.1415927*PHI/180.)/A_2)**2+
     &    (SIN(3.1415927*PHI/180.)/B_2)**2
      FZZ=(SIN(3.1415927*PHI/180.)/A_2)**2+
     &    (COS(3.1415927*PHI/180.)/B_2)**2
      FYZ=2.*SIN(3.1415927*PHI/180.)*COS(3.1415927*PHI/180.)*
     &    (1./A_2**2-1./B_2**2)
c*** diagnostic
      write(0,*)'lmx1,lmx2=',lmx1,lmx2
      write(0,*)'lmy1,lmy2=',lmy1,lmy2
      write(0,*)'lmz1,lmz2=',lmz1,lmz2
      write(0,*)'fxx,fyy,fzz,fyz=',fxx,fyy,fzz,fyz
c***
      DO 0600 JX=LMX1,LMX2
         X=REAL(JX)+XOFF
         RX2=FXX*(X-.5*(B_1+B_2))**2
         IF(RX2.LT.0.25)THEN
            DO 0500 JY=LMY1,LMY2
               Y=REAL(JY)+YOFF
               RXY2=RX2+FYY*Y*Y
               DO 0400 JZ=LMZ1,LMZ2
                  Z=REAL(JZ)+ZOFF
                  R=RXY2+FZZ*Z*Z+FYZ*Y*Z
                  IF(R.LT.0.25)THEN
C Site is occupied:
                     NAT=NAT+1
                     IXYZ(NAT,1)=JX
                     IXYZ(NAT,2)=JY
                     IXYZ(NAT,3)=JZ
                  ENDIF
 0400          CONTINUE
 0500       CONTINUE
         ENDIF
 0600 CONTINUE
      NAT2=NAT-NAT1
      IF(NAT.GT.MXNAT)THEN
          CALL ERRMSG('FATAL','TARELL',' NAT.GT.MXNAT ')
      ENDIF
C
      DO 0900 JX=1,3
         DO 0700 JA=1,NAT1
            ICOMP(JA,JX)=1
 0700    CONTINUE
         DO 0800 JA=NAT1+1,NAT
            ICOMP(JA,JX)=1
 0800    CONTINUE 
 0900 CONTINUE
C
C Specify target axes A1 and A2
C If PRINAX=0. then
C    A1=(1,0,0) in target frame
C    A2=(0,1,0) in target frame
C If PRINAX=1. then
C    A1,A2 are principal axes of largest,second largest moment of
C    inertia
      IF(PRINAX.LE.0.)THEN
         DO 0010 JX=1,3
            A1(JX)=0.
            A2(JX)=0.
 0010    CONTINUE
         A1(1)=1.
         A2(2)=1.
      ELSE
         CALL PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,A1,A2)
      ENDIF
C
C***********************************************************************
C Write target description into string CDESCR
      WRITE(CDESCR,FMT='(A,I7,A,I7,A,I7,A)')
     &      ' Spheroids with',NAT1,'+',NAT2,'=',NAT,' dipoles'
C***********************************************************************
      CMSGNM=CDESCR
      CALL WRIMSG('TAR2SP',CMSGNM)
      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)A_1,B_1,A_2,B_2,PHI,NAT,NAT1,NAT2,A1,A2
         DO 40 JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3)
   40    CONTINUE
         CLOSE(UNIT=IOSHP)
      ENDIF

      RETURN
 9020 FORMAT(' >TAR2SP: touching spheroids, A_1,B_2,A_2,B_2,PHI=',5F8.4,
     &/,3I7,' = NAT,NAT1,NAT2',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &'     JA  IX  IY  IZ')
 9030 FORMAT(I7,3I4)
      END

      SUBROUTINE ROT2(A,THETA,RM)
C***********************************************************************
C This subroutine finds the (3 by 3) rotation matrix for the
C given axis (vector) --- a and the rotation angle --- theta.
C On input:
C a(3)    --- axis of rotation  (vector, any length)
C theta   --- angle of rotation (in radians) around vector a
C On output:
C rm(3,3) --- rotation matrix such that new vector v2 is obtained
C             from the old vector v1 by the transformation:
C             v2 = rm \dot v1
C (If more rotations are needed: generate matrices rm with the
C help of this subroutine and (matrix) multiply them before
C performing v2 = rm \dot v1.)
C
C Reference:
C Leubner, C., 1977,  Coordinate-free  rotation operator,
C Am. J. Phys. 47, 727---729.
C
C History:
C Written by PJF, May 1989, for use in the rotation-averaged
C DDA calculations.
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C pre-calculate some stuff:
C     .. Scalar Arguments ..
      REAL THETA
C     ..
C     .. Array Arguments ..
      REAL A(3), RM(3,3)
C     ..
C     .. Local Scalars ..
      REAL ANORM, CT, ST
      INTEGER I, J
C     ..
C     .. Local Arrays ..
      REAL AHAT(3)
C     ..
C     .. External Subroutines ..
      EXTERNAL XNORM3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC COS, SIN
C     ..
      CT = COS(THETA)
      ST = SIN(THETA)
      CALL XNORM3(A,ANORM)
      AHAT(1) = A(1)/ANORM
      AHAT(2) = A(2)/ANORM
      AHAT(3) = A(3)/ANORM
C  cos(\theta) {\bf 1}  term:
      RM(1,1) = CT
      RM(2,2) = CT
      RM(3,3) = CT
C Skew-term  a \times {\bf 1}:
      RM(1,2) = -ST*AHAT(3)
      RM(1,3) = ST*AHAT(2)
      RM(2,1) = ST*AHAT(3)
      RM(2,3) = -ST*AHAT(1)
      RM(3,1) = -ST*AHAT(2)
      RM(3,2) = ST*AHAT(1)
C aa-dyadic (outer-product):
      DO 20 I = 1, 3
          DO 10 J = 1, 3
              RM(I,J) = RM(I,J) + (1.-CT)*AHAT(J)*AHAT(I)
   10     CONTINUE
   20 CONTINUE
      RETURN
      END
      SUBROUTINE XNORM3(A,XN)
C auxiliary for "rotation" routines
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C     .. Scalar Arguments ..
      REAL XN
C     ..
C     .. Array Arguments ..
      REAL A(3)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C     ..
      XN = SQRT(A(1)**2+A(2)**2+A(3)**2)
      RETURN
      END
      SUBROUTINE MULT3(A,B,C)
C***********************************************************************
C Purpose:
C Given:  A(I,J)= 3x3 matrix
C         B(J,K)= 3x3 matrix
C Returns:C(I,K)= matrix product of A and B
C This is auxilary for "rotation" routines
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
***********************************************************************
C Arguments:
      REAL A(3,3),B(3,3),C(3,3)
C Local variables:
      REAL S
      INTEGER I,J,K
C
      DO 30 J = 1, 3
          DO 20 I = 1, 3
              S = 0.
              DO 10 K = 1, 3
                  S = S + A(I,K)*B(K,J)
   10         CONTINUE
              C(I,J) = S
   20     CONTINUE
   30 CONTINUE
      RETURN
      END
      SUBROUTINE PROD3(RM,VIN,VOUT)
C Given:  RM(I,J)=3x3 matrix
C         VIN(J)=3-vector
C Returns:VOUT(I)=RM*VIN
C 
C Auxiliary for "rotation" routines
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments;
      REAL RM(3,3), VIN(3), VOUT(3)
C Local variables:
      INTEGER I,J
C
      DO 20 I = 1, 3
         VOUT(I) = 0.
         DO 10 J = 1, 3
            VOUT(I) = VOUT(I) + RM(I,J)*VIN(J)
   10    CONTINUE
   20 CONTINUE
      RETURN
      END
      SUBROUTINE PROD3C(RM,CVIN,CVOUT)
C Arguments:
      REAL RM(3,3)
      COMPLEX CVIN(3),CVOUT(3)
C Local variables:
      INTEGER I,J
C Given:
C       RM=3x3 rotation matrix
C       CVIN=complex 3-vector
C Computes:
C       CVOUT=RM \dot CVIN
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      DO 20 I=1,3
         CVOUT(I)=(0.,0.)
         DO 10 J=1,3
            CVOUT(I)=CVOUT(I)+RM(I,J)*CVIN(J)
 10      CONTINUE
 20   CONTINUE
      RETURN
      END
      SUBROUTINE PROD3V(RM,VIN,VOUT,NV,NVMAX)
C Arguments:
      INTEGER NV,NVMAX
      REAL RM(3,3),VIN(3,NVMAX),VOUT(3,NVMAX)
C Local variables:
      INTEGER I,J,N
C Given:
C       RM = 3x3 rotation matrix
C       VIN = NV 3-vectors
C Computes:
C       VOUT=RM \dot VIN for each of the NV 3-vectors
C
C Copyright (C) 1993,1996 B.T. Draine and P.J. Flatau
C History
C 96.08.09 (BTD) trivial modification to remove obsolescent construct.
C end history
C This code is covered by the GNU General Public License.
C***********************************************************************
      DO 20 I=1,3
         DO 10 N=1,NV
            VOUT(I,N)=0.
 10      CONTINUE
 20   CONTINUE
C
      DO 50 I=1,3
         DO 40 J=1,3
            DO 30 N=1,NV
               VOUT(I,N)=VOUT(I,N)+RM(I,J)*VIN(J,N)
 30         CONTINUE
 40      CONTINUE
 50   CONTINUE
      RETURN
      END

      SUBROUTINE TAR3EL(A1,A2,AX,AY,AZ,CDESCR,IOSHP,MXNAT,NAT,IXYZ)
C***********************************************************************
C Routine to construct three collinear touching ellipsoids from "atoms"
C Input:
C        AX=(x-length of one ellipsoid)/d    (d=lattice spacing)
C        AY=(y-length of one ellipsoid)/d
C        AZ=(z-length of one ellipsoid)/d
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT=dimensioning information (max number of atoms)
C Output:
C        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Frame
C        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Frame
C        NAT=number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
C        CDESCR=description of target (up to 67 characters)
C Note: atoms 1       - NAT/3   are in first ellipsoid
C             NAT/3+1 - 2*NAT/3 are in second ellipsoid
C             2*NAT/3+1 - NAT   are in third ellipsoid
C Ellipsoids are displaced from one another in x-direction
C First ellipsoid is at smallest x values, third at largest
C B.T.Draine, Princeton Univ. Obs.
C
C History:
C 93.01.20 (BTD) adapted from tar2el.f
C 93.03.12 (BTD) changed CDESCR*(*) -> CDESCR*67
C 96.01.26 (BTD) Replaced IX,IY,IZ by IXYZ
C end history
C
C Copyright (C) 1993,1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C** Arguments:
      CHARACTER CDESCR*67
      INTEGER IOSHP,MXNAT,NAT
      INTEGER*2 IXYZ(MXNAT,3)
      REAL AX,AY,AZ
      REAL A1(3),A2(3)
C** Local variables:
      CHARACTER CMSGNM*70
      INTEGER JA,JX,JXMAX,JXMIN,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2,NAT2
      REAL AX2,AY2,AZ2,R,RYZ2,RZ2,X,XOFF,Y,YOFF,Z,ZOFF
C***********************************************************************
C
C Routine to construct pseudo-ellipsoidal target aray.
C With occupied array sites contained within ellipsoidal surface
C defined by (X/AX)**2+(Y/AY)**2+(Z/AZ)**2=0.25
C Ideal volume V=(pi/6)*AX*AY*AZ
C
C Dipoles are located at sites
C (x,y,z)=(I+XOFF,J+YOFF,Z+KOFF), I,J,K=integers
C                                 XOFF,YOFF,ZOFF=constants
C
C For sphere: call with AX=AY=AZ
C For spheroid: call with AX=AY (or AY=AZ or AX=AZ)
C B.T.Draine, Princeton Univ. Obs., 88/8/12
C
C
C Criterion for choosing XOFF:
C If AX is close to an even integer, take XOFF=1/2
C If AX is close to an odd integer, take XOFF=0
C
      JX=INT(AX+.5)
      IF(2*(JX/2).EQ.JX)THEN
         XOFF=0.5
      ELSE
         XOFF=0.
      ENDIF
C Similar criterion for YOFF:
      JY=INT(AY+.5)
      IF(2*(JY/2).EQ.JY)THEN
         YOFF=0.5
      ELSE
         YOFF=0.
      ENDIF
C Similar criterion for ZOFF:
      JZ=INT(AZ+.5)
      IF(2*(JZ/2).EQ.JZ)THEN
         ZOFF=0.5
      ELSE
         ZOFF=0.
      ENDIF
C
      LMX1=-INT(.5*AX+.5)
      LMX2=INT(.5*AX-.25)
      LMY1=-INT(.5*AY+.5)
      LMY2=INT(.5*AY-.25)
      LMZ1=-INT(.5*AZ+.5)
      LMZ2=INT(.5*AZ-.25)
      AX2=AX*AX
      AY2=AY*AY
      AZ2=AZ*AZ
      NAT=0
C
C Specify target axes A1 and A2
C Previous convention: A1 along longest dimension
C                      A2 along intermediate dimension
C New convention: A1=(1,0,0) in target frame
C                 A2=(0,1,0) in target frame
      DO 0010 JX=1,3
         A1(JX)=0.
         A2(JX)=0.
 0010 CONTINUE
      A1(1)=1.
      A2(2)=1.
C             
C Determine list of occupied sites in first ellipsoid
C
      JXMAX=LMX1
      JXMIN=LMX2
      DO 0300 JZ=LMZ1,LMZ2
         Z=REAL(JZ)+ZOFF
         RZ2=Z*Z/AZ2
         IF(RZ2.LT.0.25)THEN
            DO 0200 JY=LMY1,LMY2
               Y=REAL(JY)+YOFF
               RYZ2=RZ2+Y*Y/AY2
               IF(RYZ2.LT.0.25)THEN
                  DO 0100 JX=LMX1,LMX2
                     X=REAL(JX)+XOFF
                     R=RYZ2+X*X/AX2
                     IF(R.LT.0.25)THEN
C Site is occupied:
                        NAT=NAT+1
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                        IF(NAT.GT.1)THEN
                           IF(JX.GT.JXMAX)JXMAX=JX
                           IF(JX.LT.JXMIN)JXMIN=JX
                        ELSE
                           JXMAX=JX
                           JXMIN=JX
                        ENDIF
                     ENDIF
 0100             CONTINUE
               ENDIF
 0200       CONTINUE
         ENDIF
 0300 CONTINUE
C
C Now create duplicate second and third ellipsoids
      JXMAX=JXMAX-JXMIN+1
      DO 0400 JA=1,NAT
         IXYZ(NAT+JA,1)=IXYZ(JA,1)+JXMAX
         IXYZ(NAT+JA,2)=IXYZ(JA,2)
         IXYZ(NAT+JA,3)=IXYZ(JA,3)
         IXYZ(2*NAT+JA,1)=IXYZ(JA,1)+2*JXMAX
         IXYZ(2*NAT+JA,2)=IXYZ(JA,2)
         IXYZ(2*NAT+JA,3)=IXYZ(JA,3)
 0400 CONTINUE
      NAT=3*NAT
      IF(NAT.GT.MXNAT)THEN
         CALL ERRMSG('FATAL','TARELL',' NAT.GT.MXNAT ')
      ENDIF
C***********************************************************************
C Write target description into string CDESCR
      NAT2=NAT/3
      IF(AX.EQ.AY.AND.AX.EQ.AZ)THEN
         WRITE(CDESCR,FMT='(A,I7,A)')' Three spheres, each containing',
     &      NAT2,' dipoles'
      ELSE
         WRITE(CDESCR,FMT='(A,I7,A)')' Three ellipsoids, each ',
     &      'containing',NAT2,' dipoles'
      ENDIF
C***********************************************************************
      CMSGNM=CDESCR
      CALL WRIMSG('TARELL',CMSGNM)
      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)AX,AY,AZ,NAT,XOFF,YOFF,ZOFF,A1,A2
         DO 40 JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3)
   40    CONTINUE
         CLOSE(UNIT=IOSHP)
      ENDIF

      RETURN
 9020 FORMAT(' >TARELL  ellipsoidal grain; AX,AY,AZ=',3F8.4,/,
     &I7,3F8.4,' = NAT,XOFF,YOFF,ZOFF',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &'     JA  IX  IY  IZ')
 9030 FORMAT(I7,3I4)
      END

      SUBROUTINE TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,
     &                  SHPAR,NAT,IXYZ,ICOMP,IDVOUT,
     &                  MXN3,NAT3)
C
C Arguments:
      CHARACTER CDESCR*67,CFLSHP*13,CSHAPE*6
      INTEGER IDVOUT,IDVSHP,IOSHP,MXNAT,NAT,MXN3,NAT3
      REAL A1(3),A2(3),SHPAR(6)
      INTEGER*2 IXYZ(MXNAT,3),ICOMP(MXNAT,3)
      EXTERNAL ERRMSG,REASHP,TARCYL,TARELL,TARHEX,TARREC,TARTET
C
C Local variables:
      INTEGER BLKSIZ,IPRINAX,J,J1,L,NBLOCKS
      INTEGER XYZB(3,100)
C
C***********************************************************************
C Given:
C    CSHAPE = string describing target geometry; will determine which
C             "shape" routine is invoked.  Current options are:
C             RCTNGL, ELLIPS, CYLNDR, HEXGON, TETRAH, UNICYL, ANIELL,
C             TWOELL, TWOAEL, FRMFIL, THRELL, THRAEL, CONELL, BLOCKS,
C             DW1996, TWOSPH
C    IOSHP = device number for "target.out" file
C          = -1 to suppress printing of "target.out"
C    SHPAR(1-6) = up to 6 parameters defining target geometry
C    MXNAT = limit on largest allowed value of NAT
C    MXN3  = 3*MXNAT
C    IDVOUT = 1 to print out information on target shape
C            -1 to suppress printing information on target shape
C    CFLSHP = name of target shape file if CSHAPE='FRMFIL'
C    IDVSHP = device number to use to read target shape if
C             CSHAPE='FRMFIL'
C Returns:
C    A1,A2 = two 3-vectors defining initial target orientation
C    CDESCR = string describing target
C    NAT = number of dipoles in target
C    NAT3 = 3*NAT
C    IXYZ(1-NAT,1-3)=integers fixing x,y,z coordinates of
C         occupied sites in target
C    ICOMP(1-NAT,1-3)=composition for E in x,y,z direction at each site
C
C P.J.Flatau, Colorado State University
C B.T.Draine, Princeton Univ. Observatory
C History:
C 90.11.08 (BTD): Changed DO...ENDDO to DO #...# CONTINUE
C 90.12.02 (BTD): Changed ordering of data in ICOMP
C 90.12.14 (BTD): Changed option MKRECT -> RCTNGL
C 91.05.02 (BTD): Added IDVOUT to argument list
C                 Added IDVOUT to argument list for subr. REASHP
C 91.05.23 (BTD): Added A1,A2 to arg. list for subr. REASHP
C 91.11.12 (BTD): Added IDVSHP to arg. list for TARGET and REASHP
C 92.09.21 (BTD): Added option UNIELL (uniaxial ellipsoid)
C 93.01.07 (BTD): Added option TWOELL (two touching ellipsoids,
C                 consisting of materials 1 and 2)
C 92.01.07 (BTD): Added option TWOAEL (two touching anisotropic
C                 ellipsoids, 1st with diel.fnc.1,2,3 along x,y,z
C                 2nd with diel.fnc.4,5,6 along x,y,z
C 92.01.19 (BTD): Added option THRELL (three touching anisotropic
C                 ellipsoids, 1st with diel.fnc.1,2,3 along x,y,z
C                 2nd with diel.fnc.4,5,6 along x,y,z
C                 3rd with diel.fnc.7,8,9 along x,y,z
C 93.03.12 (BTD): Changed CDESCR*60 -> CDESCR*67
C                 Moved WRITE(IDVOUT,9010) from DDSCAT to TARGET
C 93.12.14 (BTD): Corrected handling of THRELL (had assigned
C                 ICOMP=1 to 50% of sites, ICOMP=2 to other 50%)
C 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6) to
C                 allow up to 6 shape parameters
C                 Added call to TARCEL to generate two concentric
C                 ellipsoids
C 94.03.21 (BTD): Changed "CONCEL" to "CONELL" for consistency with
C                 REAPAR
C 95.12.11 (BTD): Modified to handle "BLOCKS" as target option, using
C                 subroutine TARBLOCKS
C 96.01.04 (BTD): Modified to handle "DW1996" as target option
C 96.01.25 (BTD): Modified to handle "TWOSPH" as target option
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C 96.01.29 (BTD): Added variable IPRINAX to control choice of axes A1,A2
C                 in option BLOCKS
C 97.06.04 (BTD): Corrected bug in handling of option "UNICYL" -- was
C                 not setting composition correctly after changing REAPAR
C                 so that no longer had choice of cylinder axis.
C                 Cylinder axis is always in x direction in target frame.
C                 Thanks for Mike Wolff for calling attention to the
C                 bug.
C end history
C
C Copyright (C) 1993,1994,1995,1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C********************************************************************
      IF(CSHAPE.EQ.'RCTNGL')THEN
         CALL TARREC(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ)
C Homogeneous target:
         DO 100 J=1,NAT
            DO 95 l=1,3
               ICOMP(J,L)=1
   95       CONTINUE
  100    CONTINUE
      ELSEIF(CSHAPE.EQ.'ELLIPS')THEN
         CALL TARELL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ)
C Homogeneous target:
         DO 110 J=1,NAT
            DO 105 L=1,3
               ICOMP(J,L)=1
  105       CONTINUE
  110    CONTINUE
      ELSEIF(CSHAPE.EQ.'CYLNDR')THEN
         CALL TARCYL(A1,A2,SHPAR(1),SHPAR(2),CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ)
C Homogeneous target:
         DO 120 J=1,NAT
            DO 115 L=1,3
               ICOMP(J,L)=1
  115       CONTINUE
  120    CONTINUE
      ELSEIF(CSHAPE.EQ.'HEXGON')THEN
         CALL TARHEX(A1,A2,SHPAR(1),SHPAR(2),CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ)
C Homogeneous target:
         DO 130 J=1,NAT
            DO 125 L=1,3
               ICOMP(J,L)=1
  125       CONTINUE
  130    CONTINUE
      ELSEIF(CSHAPE.EQ.'TETRAH')THEN
         CALL TARTET(A1,A2,SHPAR(1),CDESCR,IOSHP,MXNAT,NAT,IXYZ)
C Homogeneous target:
         DO 140 J=1,NAT
            DO 135 L=1,3
               ICOMP(J,L)=1
  135       CONTINUE
  140    CONTINUE
      ELSEIF(CSHAPE.EQ.'UNICYL')THEN
         CALL TARCYL(A1,A2,SHPAR(1),SHPAR(2),CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ)
C Cylinder axis is in x direction in Target Frame.
C Assume c axis to be parallel to cylinder axis
C Assume component 1 to be dielectric const. for E par. c axis
C Assume component 2 to be dielectric const. for E perp. c axis
         DO 150 J=1,NAT
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=2
 150     CONTINUE
C
      ELSEIF(CSHAPE.EQ.'ANIELL')THEN
         CALL TARELL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ)
C Dielectric constants 1,2,3 for E along directions x,y,z in Target Frame
         DO 160 J=1,NAT
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=3
 160     CONTINUE
C
C TWOELL -> two touching identical ellipsoids, of materials 1 and 2
C           second ellipsoid is displaced from first in x-direction
      ELSEIF(CSHAPE.EQ.'TWOELL')THEN
         CALL TAR2EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ)
         J1=NAT/2
         DO 165 J=1,J1
            ICOMP(J,1)=1
            ICOMP(J,2)=1
            ICOMP(J,3)=1
 165     CONTINUE
         DO 166 J=J1+1,NAT
            ICOMP(J,1)=2
            ICOMP(J,2)=2
            ICOMP(J,3)=2
 166     CONTINUE
C
C TWOAEL -> two touching identical ellipsoids with anisotropic
C           functions.
C           second ellipsoid is displaced from first in x-direction
C           1st ellipsoid has dielectric fcns 1,2,3 in x,y,z dirs.
C           2nd ellipsoid has dielectric fcns 4,5,6 in x,y,z dirs.
      ELSEIF(CSHAPE.EQ.'TWOAEL')THEN
         CALL TAR2EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ)
         J1=NAT/2
         DO 175 J=1,J1
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=3
 175     CONTINUE
         DO 176 J=J1+1,NAT
            ICOMP(J,1)=4
            ICOMP(J,2)=5
            ICOMP(J,3)=6
 176     CONTINUE
C
C THRELL -> three touching identical ellipsoids, of materials 1,2,3
C           second ellipsoid is displaced from first in +x-direction
C           third ellipsoid is displaced from second in +x-direction
      ELSEIF(CSHAPE.EQ.'THRELL')THEN
         CALL TAR3EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ)
         J1=NAT/3
         DO 185 J=1,J1
            ICOMP(J,1)=1
            ICOMP(J,2)=1
            ICOMP(J,3)=1
 185     CONTINUE
         DO 186 J=J1+1,2*J1
            ICOMP(J,1)=2
            ICOMP(J,2)=2
            ICOMP(J,3)=2
 186     CONTINUE
         DO 187 J=2*J1+1,NAT
            ICOMP(J,1)=3
            ICOMP(J,2)=3
            ICOMP(J,3)=3
 187     CONTINUE
C
C THRAEL -> three touching identical ellipsoids with anisotropic
C           functions.
C           second ellipsoid is displaced from first in x-direction
C           1st ellipsoid has dielectric fcns 1,2,3 in x,y,z dirs.
C           2nd ellipsoid has dielectric fcns 4,5,6 in x,y,z dirs.
C           3rd ellipsoid has dielectric fcns 7,8.9 in x,y,z dirs.
      ELSEIF(CSHAPE.EQ.'THRAEL')THEN
         CALL TAR3EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),CDESCR,IOSHP,
     &               MXNAT,NAT,IXYZ)
         J1=NAT/3
         DO 195 J=1,J1
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=3
 195     CONTINUE
         DO 196 J=J1+1,2*J1
            ICOMP(J,1)=4
            ICOMP(J,2)=5
            ICOMP(J,3)=6
 196     CONTINUE
         DO 197 J=2*J1+1,NAT
            ICOMP(J,1)=7
            ICOMP(J,2)=8
            ICOMP(J,3)=9
 197     CONTINUE
C
C CONELL -> two concentric ellipsoids with isotropic dielectric functions
C           1 (inner) and 2 (outer)
      ELSEIF(CSHAPE.EQ.'CONELL')THEN
         CALL TARCEL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5),
     &               SHPAR(6),CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
C
C TAR2SP -> two touching spheroids
C
      ELSEIF(CSHAPE.EQ.'TWOSPH')THEN
         CALL TAR2SP(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5),
     &               SHPAR(6),CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
C
C BLOCKS -> target is constructed from identical cubic blocks
C           locations of blocks, and size of blocks (lattice units)
C           is specified in file 'blocks.par'
C           file structure:
C              target description
C              IPRINAX = 0 (a1=100,a2=010) or 1 (a1,a2=principal axes)
C              N = number of blocks
C              SIZE = width of one block, in lattice units
C              X Y Z = location of block 1 (in units of block width)
C              ...
C              X Y Z =    "     "    "   N  "   "    "    "     "
C
      ELSEIF(CSHAPE.EQ.'BLOCKS')THEN
         OPEN(UNIT=IDVSHP,FILE='blocks.par',STATUS='OLD',
     &        FORM='FORMATTED')
         READ(IDVSHP,FMT='(A67)')CDESCR
         READ(IDVSHP,*)IPRINAX
         READ(IDVSHP,*)NBLOCKS
         READ(IDVSHP,*)BLKSIZ
         DO J=1,NBLOCKS
            READ(IDVSHP,*)XYZB(1,J),XYZB(2,J),XYZB(3,J)
         ENDDO
         CLOSE(IDVSHP)
         CALL TARBLOCKS(A1,A2,NBLOCKS,BLKSIZ,XYZB,IPRINAX,IOSHP,
     &                  CDESCR,MXNAT,NAT,IXYZ,ICOMP)
C
C Homogeneous target:
C
         DO J=1,NAT
            DO L=1,3
               ICOMP(J,L)=1
            ENDDO
         ENDDO
C
C DW1996 -> the 13-cube target studied by Draine & Weingartner 1996
C           SHPAR(1)=width per block in lattice units
C
      ELSEIF(CSHAPE.EQ.'DW1996')THEN
         IPRINAX=1
         NBLOCKS=13
         BLKSIZ=SHPAR(1)
         XYZB(1,1)=0.
         XYZB(2,1)=1.
         XYZB(3,1)=0.
         XYZB(1,2)=1.
         XYZB(2,2)=1.
         XYZB(3,2)=0.
         XYZB(1,3)=0.
         XYZB(2,3)=2.
         XYZB(3,3)=0.
         XYZB(1,4)=1.
         XYZB(2,4)=2.
         XYZB(3,4)=0.
         XYZB(1,5)=0.
         XYZB(2,5)=1.
         XYZB(3,5)=1.
         XYZB(1,6)=1.
         XYZB(2,6)=1.
         XYZB(3,6)=1.
         XYZB(1,7)=0.
         XYZB(2,7)=2.
         XYZB(3,7)=1.
         XYZB(1,8)=1.
         XYZB(2,8)=2.
         XYZB(3,8)=1.
         XYZB(1,9)=2.
         XYZB(2,9)=1.
         XYZB(3,9)=0.
         XYZB(1,10)=2.
         XYZB(2,10)=2.
         XYZB(3,10)=0.
         XYZB(1,11)=0.
         XYZB(2,11)=0.
         XYZB(3,11)=1.
         XYZB(1,12)=0.
         XYZB(2,12)=0.
         XYZB(3,12)=2.
         XYZB(1,13)=0.
         XYZB(2,13)=1.
         XYZB(3,13)=2.
         CALL TARBLOCKS(A1,A2,NBLOCKS,BLKSIZ,XYZB,IPRINAX,IOSHP,
     &                  CDESCR,MXNAT,NAT,IXYZ,ICOMP)
         CDESCR='13-cube target used by Draine & Weingartner 1996'
C Homogeneous target:
         DO J=1,NAT
            DO L=1,3
               ICOMP(J,L)=1
            ENDDO
         ENDDO
C
C add any other specific shape routines here
C
      ELSEIF(CSHAPE.EQ.'FRMFIL')THEN
         CALL REASHP(CFLSHP,IDVOUT,IDVSHP,A1,A2,CDESCR,MXNAT,NAT,
     &                IXYZ,ICOMP,MXN3,NAT3)
      ELSE
         CALL ERRMSG('FATAL','TARGET',
     &               ' Uknown shape requested: check ddscat.par')
      ENDIF
C Check to see that arrays are large enough
      IF(NAT.GT.MXNAT)CALL ERRMSG('FATAL','TARGET',
     &                ' MXNAT < NAT; must increase MXNAT in DDSCAT')
C Write out target description
      WRITE(IDVOUT,FMT=9010)CDESCR,NAT
C
C Before returning, compute:
C
      NAT3=3*NAT
      RETURN
 9010 FORMAT(' >TARGET:',A,/,
     &       7X,I7,' = NAT0 = number of dipoles in target')
      END

      SUBROUTINE EVALQ(CXALPH,AK,NAT3,E02,CXE,CXP,CABS,CEXT,CPHA,MXN3,
     &                 IMETHD)
C*** Arguments:
      REAL CABS,CEXT,CPHA
      INTEGER IMETHD,MXN3,NAT3
      COMPLEX CXE(MXN3),
     &        CXP(MXN3),
     &        CXALPH(MXN3)
      REAL AK(3)
C
C*** Local variables:
      COMPLEX CXA,CXI
      REAL AK1,AK2,AK3,ALPHA2,ALPHSQ,E02,PI,RABS
      INTEGER J
C
C*** Intrinsic functions:
      INTRINSIC AIMAG,CONJG,REAL,SQRT
C
C*** SAVE statements:
      SAVE CXI
C
C*** Data statements:
C
      DATA CXI/(0.,1.)/
C***********************************************************************
C
C Given: CXALPH(1-NAT3) = polarizability vector
C        AK(1-3) = (k_x,k_y,k_z)*d (d=lattice spacing)
C        NAT3 = 3*number of dipoles
C        E02 = |E_0|^2 , where E_0 = incident complex E field.
C        CXE(1-NAT3) = components of E field at each dipole
C        CXP(1-NAT3) = components of polarization vector at each dipole
C        IMETHD = 0 or 1
C Finds: CEXT = extinction cross section /d**2
C  and, if IMETHD=1, also computes
C        CPHA = phase-lag cross section /d**2
C        CABS = absorption cross section /d**2
C        
C Note: present definition of CPHA is 1/2 of Martin's definition
C
C B.T.Draine, Princeton Univ. Obs., 87/1/4
C
C History:
C 88.04.28 (BTD): modifications
C 90.11.02 (BTD): modified to allow use of vacuum sites (now pass E02
C                 from calling routine instead of evaluating it here)
C 90.12.13 (BTD): modified to use IMETHD flag, to allow "fast" calls
C                 in which only CEXT is computed.
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Initialization:
C Compute magnitude of kd
C
      CEXT=0.
      CABS=0.
      CPHA=0.
      PI=4.*ATAN(1.)
      AK2=0.
      DO 10 J=1,3
         AK2=AK2+AK(J)*AK(J)
   10 CONTINUE
      AK1=SQRT(AK2)
      AK3=AK1*AK2
C
C Initialization complete.
      IF(IMETHD.EQ.0)THEN
C*** Compute CEXT:
         DO 20 J=1,NAT3
            CEXT=CEXT+AIMAG(CXP(J))*REAL(CXE(J))
     &               -REAL(CXP(J))*AIMAG(CXE(J))
   20    CONTINUE
         CEXT=4.*PI*AK1*CEXT/E02
      ELSEIF(IMETHD.EQ.1)THEN
C Compute CABS
         DO 40 J=1,NAT3
            ALPHA2=AIMAG(CXALPH(J))
            ALPHSQ=CONJG(CXALPH(J))*CXALPH(J)
c*** diagnostic
c      if(alphsq.le.0.)then
c         write(0,*)'in evalq, having trouble, nat3=',nat3
c         write(0,*)'j=',j,' cxalpha(j)=',cxalph(j)
c      endif
c***
            RABS=ALPHA2/ALPHSQ-AK3/1.5
            CABS=CABS+CONJG(CXP(J))*CXP(J)*RABS
   40    CONTINUE
         CABS=4.*PI*AK1*CABS/E02
C Compute CEXT and CPHA
         CXA=(0.,0.)
         DO 50 J=1,NAT3
            CXA=CXA+CXP(J)*CONJG(CXE(J))
   50    CONTINUE
         CEXT=4.*PI*AK1*AIMAG(CXA)/E02
         CPHA=2.*PI*AK1*REAL(CXA)/E02
      ENDIF
      RETURN
C
      END

      SUBROUTINE WRIMSG(CSUBRT,CMSGNM)
C Standard procedure for writing messages
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C
C History:
C 96.11.14 (PJF) Remove "getset" and hardwire" ioout"
C 96.11.20 (BTD) change IOOUT to IDVOUT
C***********************************************************************
C     .. Scalar Arguments ..
      CHARACTER CMSGNM* (*), CSUBRT* (*)
C     ..
C     .. Local Scalars ..
      INTEGER IDVOUT
      SAVE IDVOUT
C     ..
C Note: on some systems (e.g., Solaris) IDVOUT=0 generates unbuffered
C output to "standard output".  On other systems IDVOUT=0 may not be
C valid; then set IDVOUT=6 to get "standard output", probably buffered.
C
      DATA IDVOUT/0/
      WRITE (IDVOUT,FMT=9000) CSUBRT, CMSGNM
 9000 FORMAT (' >',A,' ',A)
      RETURN
      END

      SUBROUTINE TARTET(A1,A2,AX,CDESCR,IOSHP,MXNAT,NAT,IXYZ)
C
C** Arguments:
      CHARACTER CDESCR*67
      INTEGER IOSHP,MXNAT,NAT
      INTEGER*2 IXYZ(MXNAT,3)
      REAL AX
      REAL A1(3),A2(3)
C** Local variables:
      INTEGER I,IMAX,IMIN,J,JMAX,JMIN,JX,K,KMAX,KMIN
      REAL FY,S,X,XOFF,Y,YMAX,YMIN,YOFF,Z,ZMAX,ZMAX0,ZOFF
C***********************************************************************
C
C Routine to construct regular tetrahedral target array
C one of the faces is parallel to the y-z plane
C one of the edges of this face is parallel to x-y plane
C
C Input:
C        AX = length of one edge of tetrahedron
C        IOSHP=device number for "target.out" file
C             =-1 to suppress printing of "target.out"
C        MXNAT = dimensioning information
C Returns:
C        A1(1-3) = unit vector (1,0,0) (along one axis of tetrahedron)
C        A2(1-3) = unit vector (0,1,0)
C        CDESCR = string describing target (up to 67 chars.)
C        NAT = number of atoms in target
C        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms in target
C
C Occupied array sites are those within tetrahedral surface
C Size:
C    S=length of each side of tetrahedron
C    Volume = S**3/(6*sqrt(2))
C Orientation:
C    Center of mass is at origin.
C    One face is parallel to yz plane.
C    Projection onto yz plane has vertex on y axis.
C    S=length of one side (in lattice units)
C    Vertices are at
C    A=( sqrt(3/8),         0,    0)*S
C    B=(-sqrt(1/24), sqrt(1/3),    0)*S
C    C=(-sqrt(1/24),-sqrt(1/12),-1/2)*S
C    D=(-sqrt(1/24),-sqrt(1/12), 1/2)*S
C Length in x direction = S*sqrt(2/3)
C           y           = S*sqrt(3)/2
C           z           = S
C Angle(AOB)=arccos(-1/3)=109.4712 deg.
C OA=OB=OC=OD=sqrt(3/8)*S
C Occupied sites are assumed to be located at
C (X,Y,Z)=(I+XOFF,J+YOFF,K+ZOFF)
C where I,J,K are integers, and XOFF,YOFF,ZOFF are constants.
C Program sets XOFF,YOFF,ZOFF depending on choice of parameter S.
C
C Criterion for choosing XOFF:
C    Base of tetrahedron is located at x = -sqrt(1/24)*S
C    Let IMIN be value of I for this plane
C    Choose XOFF so that IMIN+XOFF = -sqrt(1/24)*S + 0.5
C    with -0.5 < XOFF < 0.5
C Criterion for choosing YOFF:
C    One edge of tetrahedron is located at y= -S/(2*sqrt(3))
C    Let JMIN be value of J for this line
C    Choose YOFF so that JMIN+YOFF = -S/sqrt(12) + 0.5
C Criterion for choosing ZOFF:
C    One edge of tetrahedron is parallel to z axis
C    Choose ZOFF in order to have number of dipoles along
C    this edge as close as possible to S
C    e.g., if S=odd integer, then take ZOFF=0 to place dipoles
C          at integral locations
C          if S=even integer, then take ZOFF=1/2 to place dipoles
C          at half-integral locations
C
C B.T.Draine, Princeton Univ. Obs., 90.10.30
C History:
C 90.11.08 (BTD): Changed DO...ENDDO to DO #...# CONTINUE
C 90.11.09 (BTD): Corrected error in location of center of mass.
C 91.01.05 (BTD): Change I4 -> I7 when printing NAT.
C 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
C 95.07.13 (BTD): Eliminated unused arguments AY,AZ
C 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
C end history
C
C Copyright (C) 1993,1995,1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      S=AX
C Set XOFF (and IMIN,IMAX):
      IMIN=-INT(S*SQRT(1./24.))
      XOFF=0.5-S*SQRT(1./24.)-IMIN
      IMAX=IMIN+INT(S*SQRT(2./3.)+0.5)-1
C Set YOFF (and JMIN,JMAX):
      JMIN=-INT(S/SQRT(12.))
      YOFF=0.5-S/SQRT(12.)-JMIN
      JMAX=JMIN+INT(S*SQRT(.75)+0.5)-1
C Set ZOFF (and KMIN,KMAX):
C Determine whether S is closest to even or odd integer.
C  (Temporarily let KMIN be integer which S is closest to)
      KMIN=INT(S+0.5)
C If KMIN is even, then ZOFF=0.5
C If KMIN is odd, then ZOFF=0.
      ZOFF=0.
      IF(KMIN-2*(KMIN/2).EQ.0)ZOFF=0.5
      KMIN=-INT(0.5*S+ZOFF)
      KMAX=KMIN+INT(S+0.5)-1
C
C Determine list of occupied sites.
      NAT=0
      DO 30 I=IMIN,IMAX
         X=REAL(I)+XOFF
C YMAX=largest value of Y which can occur for this X value
C YMIN=smallest value of Y which can occur for this X value
C ZMAX0=largest value of Z which can occur for this X value
         YMAX=S*SQRT(3./16.)-X/SQRT(2.)
         YMIN=-S*SQRT(3./64.)+X/SQRT(8.)
         ZMAX0=3.*S/8.-X*SQRT(3./8.)
         DO 20 J=JMIN,JMAX
            Y=REAL(J)+YOFF
            IF(Y.GE.YMIN.AND.Y.LE.YMAX)THEN
C ZMAX=largest value of Z which can occur for this (X,Y)
               FY=(Y-YMIN)/(YMAX-YMIN)
               ZMAX=(1.-FY)*ZMAX0
               DO 10 K=KMIN,KMAX
                  Z=REAL(K)+ZOFF
                  IF(ABS(Z).LE.ZMAX)THEN
C Site is occupied:
                     NAT=NAT+1
                     IF(NAT.GT.MXNAT)THEN
                        CALL ERRMSG('FATAL','TARTET',
     &                              ' NAT.GT.MXNAT ')
                     ENDIF
                     IXYZ(NAT,1)=I
                     IXYZ(NAT,2)=J
                     IXYZ(NAT,3)=K
                  ENDIF
  10           CONTINUE
            ENDIF
  20     CONTINUE
  30  CONTINUE
C
C*** Specify vectors A1 and A2 which will define target orientation
C    A1 is initially along x-axis
C    A2 is initially along y-axis
      A1(1)=1.
      A1(2)=0.
      A1(3)=0.
      A2(1)=0.
      A2(2)=1.
      A2(3)=0.
C
      WRITE(CDESCR,FMT='(A,I7,A)')' Tetrahedron of NAT=',NAT,' dipoles'
      IF(IOSHP.GE.0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)S,NAT,XOFF,YOFF,ZOFF,A1,A2
         DO 40 JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3)
   40    CONTINUE
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
 9020 FORMAT(' >TARTET  tetrahedral grain: S=',F8.3,/,
     &I7,3F8.4,' =NAT, XOFF,YOFF,ZOFF',/,
     &3F9.4,' = A_1 vector',/,
     &3F9.4,' = A_2 vector',/,
     &'     JA  IX  IY  IZ')
 9030 FORMAT(I7,3I4)
      END

      SUBROUTINE FOURX(DATA,NN,NDIM,ISIGN)
C Modified by PJF 11/17/1990
C to conform to DDSCAT needs:
c
c     the cooley-tukey fast fourier transform in usasi basic fortran
c
c     transform(j1,j2,,,,) = sum(data(i1,i2,,,,)*w1**((i2-1)*(j2-1))
c                                 *w2**((i2-1)*(j2-1))*,,,),
c     where i1 and j1 run from 1 to nn(1) and w1=exp(isign*2*pi=
c     sqrt(-1)/nn(1)), etc.  there is no limit on the dimensionality
c     (number of subscripts) of the data array.  if an inverse
c     transform (isign=+1) is performed upon an array of transformed
c     (isign=-1) data, the original data will reappear.
c     multiplied by nn(1)*nn(2)*,,,  the array of input data must be
c     in complex format.  however, if all imaginary parts are zero (i.e.
c     the data are disguised real) running time is cut up to forty per-
c     cent.  (for fastest transform of real data, nn(1) should be even.)
c     the transform values are always complex and are returned in the
c     original array of data, replacing the input data.  the length
c     of each dimension of the data array may be any integer.  the
c     program runs faster on composite integers than on primes, and is
c     particularly fast on numbers rich in factors of two.
c
c     timing is in fact given by the following formula.  let ntot be the
c     total number of points (real or complex) in the data array, that
c     is, ntot=nn(1)*nn(2)*...  decompose ntot into its prime factors,
c     such as 2**k2 * 3**k3 * 5**k5 * ...  let sum2 be the sum of all
c     the factors of two in ntot, that is, sum2 = 2*k2.  let sumf be
c     the sum of all other factors of ntot, that is, sumf = 3*k3*5*k5*..
c     the time taken by a multidimensional transform on these ntot data
c     is t = t0 + ntot*(t1+t2*sum2+t3*sumf).  on the cdc 3300 (floating
c     point add time = six microseconds), t = 3000 + ntot*(600+40*sum2+
c     175*sumf) microseconds on complex data.
c
c     implementation of the definition by summation will run in a time
c     proportional to ntot*(nn(1)+nn(2)+...).  for highly composite ntot
c     the savings offered by this program can be dramatic.  a one-dimen-
c     sional array 4000 in length will be transformed in 4000*(600+
c     40*(2+2+2+2+2)+175*(5+5+5)) = 14.5 seconds versus about 4000*
c     4000*175 = 2800 seconds for the straightforward technique.
c
c     the fast fourier transform places three restrictions upon the
c     data.
c     1.  the number of input data and the number of transform values
c     must be the same.
c     2.  both the input data and the transform values must represent
c     equispaced points in their respective domains of time and
c     frequency.  calling these spacings deltat and deltaf, it must be
c     true that deltaf=2*pi/(nn(i)*deltat).  of course, deltat need not
c     be the same for every dimension.
c     3.  conceptually at least, the input data and the transform output
c     represent single cycles of periodic functions.
c
c     the calling sequence is--
c     call fourt(data,nn,ndim,isign,iform,work)
c
c     data is the array used to hold the real and imaginary parts
c     of the data on input and the transform values on output.  it
c     is a multidimensional floating point array, with the real and
c     imaginary parts of a datum stored immediately adjacent in storage
c     (such as fortran iv places them).  normal fortran ordering is
c     expected, the first subscript changing fastest.  the dimensions
c     are given in the integer array nn, of length ndim.  isign is -1
c     to indicate a forward transform (exponential sign is -) and +1
c     for an inverse transform (sign is +).  iform is +1 if the data are
c     complex, 0 if the data are real.  if it is 0, the imaginary
c     parts of the data must be set to zero.  as explained above, the
c     transform values are always complex and are stored in array data.
c     work is an array used for working storage.  it is floating point
c     real, one dimensional of length equal to twice the largest array
c     dimension nn(i) that is not a power of two.  if all nn(i) are
c     powers of two, it is not needed and may be replaced by zero in the
c     calling sequence.  thus, for a one-dimensional array, nn(1) odd,
c     work occupies as many storage locations as data.  if supplied,
c     work must not be the same array as data.  all subscripts of all
c     arrays begin at one.
c
c     example 1.  three-dimensional forward fourier transform of a
c     complex array dimensioned 32 by 25 by 13 in fortran iv.
c     dimension data(32,25,13),work(50),nn(3)
c     complex data
c     data nn/32,25,13/
c     do 1 i=1,32
c     do 1 j=1,25
c     do 1 k=1,13
c  1  data(i,j,k)=complex value
c     call fourt(data,nn,3,-1,1,work)
c
c     example 2.  one-dimensional forward transform of a real array of
c     length 64 in fortran ii,
c     dimension data(2,64)
c     do 2 i=1,64
c     data(1,i)=real part
c  2  data(2,i)=0.
c     call fourt(data,64,1,-1,0,0)
c
c     there are no error messages or error halts in this program.  the
c     program returns immediately if ndim or any nn(i) is less than one.
c
c     program by norman brenner from the basic program by charles
c     rader,  june 1967.  the idea for the digit reversal was
c     suggested by ralph alter.
c
c     this is the fastest and most versatile version of the fft known
c     to the author.  a program called four2 is available that also
c     performs the fast fourier transform and is written in usasi basic
c     fortran.  it is about one third as long and restricts the
c     dimensions of the input array (which must be complex) to be powers
c     of two.  another program, called four1, is one tenth as long and
c     runs two thirds as fast on a one-dimensional complex array whose
c     length is a power of two.
c
c     reference--
c     ieee audio transactions (june 1967), special issue on the fft.
c
C Parameters:
      INTEGER MXWORK
      PARAMETER (MXWORK=1024)
C Arguments:
      INTEGER IFORM,ISIGN,NDIM
C*** Modification 90/11/29 (BTD):
C      REAL DATA(1)
C      INTEGER NN(1)
      REAL DATA(*)
      INTEGER NN(*)
C
C Local variables:
      REAL DIFI,DIFR,OLDSI,OLDSR,RTHLF,SUMI,SUMR,T2I,T2R,T3I,T3R,T4I,
     +     T4R,TEMPI,TEMPR,THETA,TWOPI,TWOWR,U1I,U1R,U2I,U2R,U3I,U3R,
     +     U4I,U4R,W2I,W2R,W3I,W3R,WI,WR,WSTPI,WSTPR
      INTEGER I,I1,I1MAX,I1RNG,I2,I2MAX,I3,ICALL,ICASE,ICONJ,IDIM,
     +        IDIV,IF,IFMIN,IFP1,IFP2,IMAX,IMIN,INON2,IPAR,IQUOT,IREM,
     +        J,J1,J1MAX,J1MIN,J2,J2MAX,J2MIN,J2RNG,J3,J3MAX,JMAX,JMIN,
     +        K1,K2,K3,K4,KDIF,KMIN,KSTEP,L,LMAX,M,MMAX,
     +        N,NHALF,NMAX,NP0,NP1,NP1HF,NP1TW,NP2,NP2HF,NPREV,NTOT,
     +        NTWO,NWORK
      INTEGER IFACT(32)
      REAL WORK(MXWORK)
C
C Intrinsic functions:
      INTRINSIC COS,MAX0,REAL,SIN
C
C Data statements:
      DATA NP0/0/,NPREV/0/
      DATA TWOPI/6.2831853071796/,RTHLF/0.70710678118655/
Cflatau change: Hardwire that the data is complex.
      DATA IFORM, ICALL/1, 1/
C     ..
Cflatau addition: Error check
      IF(ICALL.EQ.1) THEN
          ICALL=2
          NMAX = MAX( 2*NN(1), 2*NN(2), 2*NN(3) )
          IF(NMAX .GT. MXWORK) THEN          
          CALL ERRMSG('FATAL','FOURX',
     $ ' Increase size of working array MXWORK ')
          END IF
          IF(NDIM.NE.3) THEN
          CALL ERRMSG('FATAL','FOURX',
     $ ' This has to be 3D transform')
          END IF
       END IF
      IF (NDIM-1) 232,101,101
  101 NTOT = 2
      DO 103 IDIM = 1,NDIM
          IF (NN(IDIM)) 232,232,102
  102     NTOT = NTOT*NN(IDIM)
  103 CONTINUE
c
c     main loop for each dimension
c
      NP1 = 2
      DO 231 IDIM = 1,NDIM
          N = NN(IDIM)
          NP2 = NP1*N
          IF (N-1) 232,230,104
c
c     is n a power of two and if not, what are its factors
c
  104     M = N
          NTWO = NP1
          IF = 1
          IDIV = 2
  105     IQUOT = M/IDIV
          IREM = M - IDIV*IQUOT
          IF (IQUOT-IDIV) 113,106,106
  106     IF (IREM) 108,107,108
  107     NTWO = NTWO + NTWO
          IFACT(IF) = IDIV
          IF = IF + 1
          M = IQUOT
          GO TO 105

  108     IDIV = 3
          INON2 = IF
  109     IQUOT = M/IDIV
          IREM = M - IDIV*IQUOT
          IF (IQUOT-IDIV) 115,110,110
  110     IF (IREM) 112,111,112
  111     IFACT(IF) = IDIV
          IF = IF + 1
          M = IQUOT
          GO TO 109

  112     IDIV = IDIV + 2
          GO TO 109

  113     INON2 = IF
          IF (IREM) 115,114,115
  114     NTWO = NTWO + NTWO
          GO TO 116

  115     IFACT(IF) = M
c
c     separate four cases--
c        1. complex transform or real transform for the 4th, 9th,etc.
c           dimensions.
c        2. real transform for the 2nd or 3rd dimension.  method--
c           transform half the data, supplying the other half by con-
c           jugate symmetry.
c        3. real transform for the 1st dimension, n odd.  method--
c           set the imaginary parts to zero.
c        4. real transform for the 1st dimension, n even.  method--
c           transform a complex array of length n/2 whose real parts
c           are the even numbered real values and whose imaginary parts
c           are the odd numbered real values.  separate and supply
c           the second half by conjugate symmetry.
c
  116     ICASE = 1
          IFMIN = 1
          I1RNG = NP1
          IF (IDIM-4) 117,122,122
  117     IF (IFORM) 118,118,122
  118     ICASE = 2
          I1RNG = NP0* (1+NPREV/2)
          IF (IDIM-1) 119,119,122
  119     ICASE = 3
          I1RNG = NP1
          IF (NTWO-NP1) 122,122,120
  120     ICASE = 4
          IFMIN = 2
          NTWO = NTWO/2
          N = N/2
          NP2 = NP2/2
          NTOT = NTOT/2
          I = 1
          DO 121 J = 1,NTOT
              DATA(J) = DATA(I)
              I = I + 2
  121     CONTINUE
c
c     shuffle data by bit reversal, since n=2**k.  as the shuffling
c     can be done by simple interchange, no working array is needed
c
  122     IF (NTWO-NP2) 132,123,123
  123     NP2HF = NP2/2
          J = 1
          DO 131 I2 = 1,NP2,NP1
              IF (J-I2) 124,127,127
  124         I1MAX = I2 + NP1 - 2
              DO 126 I1 = I2,I1MAX,2
                  DO 125 I3 = I1,NTOT,NP2
                      J3 = J + I3 - I2
                      TEMPR = DATA(I3)
                      TEMPI = DATA(I3+1)
                      DATA(I3) = DATA(J3)
                      DATA(I3+1) = DATA(J3+1)
                      DATA(J3) = TEMPR
                      DATA(J3+1) = TEMPI
  125             CONTINUE
  126         CONTINUE
  127         M = NP2HF
  128         IF (J-M) 130,130,129
  129         J = J - M
              M = M/2
              IF (M-NP1) 130,128,128
  130         J = J + M
  131     CONTINUE
          GO TO 142
c
c     shuffle data by digit reversal for general n
c
  132     NWORK = 2*N
          DO 141 I1 = 1,NP1,2
              DO 140 I3 = I1,NTOT,NP2
                  J = I3
                  DO 138 I = 1,NWORK,2
                      IF (ICASE-3) 133,134,133
  133                 WORK(I) = DATA(J)
                      WORK(I+1) = DATA(J+1)
                      GO TO 135

  134                 WORK(I) = DATA(J)
                      WORK(I+1) = 0.
  135                 IFP2 = NP2
                      IF = IFMIN
  136                 IFP1 = IFP2/IFACT(IF)
                      J = J + IFP1
                      IF (J-I3-IFP2) 138,137,137
  137                 J = J - IFP2
                      IFP2 = IFP1
                      IF = IF + 1
                      IF (IFP2-NP1) 138,138,136
  138             CONTINUE
                  I2MAX = I3 + NP2 - NP1
                  I = 1
                  DO 139 I2 = I3,I2MAX,NP1
                      DATA(I2) = WORK(I)
                      DATA(I2+1) = WORK(I+1)
                      I = I + 2
  139             CONTINUE
  140         CONTINUE
  141     CONTINUE
c
c     main loop for factors of two.  perform fourier transforms of
c     length four, with one of length two if needed.  the twiddle factor
c     w=exp(isign*2*pi*sqrt(-1)*m/(4*mmax)).  check for w=isign*sqrt(-1)
c     and repeat for w=w*(1+isign*sqrt(-1))/sqrt(2).
c
  142     IF (NTWO-NP1) 174,174,143
  143     NP1TW = NP1 + NP1
          IPAR = NTWO/NP1
  144     IF (IPAR-2) 149,146,145
  145     IPAR = IPAR/4
          GO TO 144

  146     DO 148 I1 = 1,I1RNG,2
              DO 147 K1 = I1,NTOT,NP1TW
                  K2 = K1 + NP1
                  TEMPR = DATA(K2)
                  TEMPI = DATA(K2+1)
                  DATA(K2) = DATA(K1) - TEMPR
                  DATA(K2+1) = DATA(K1+1) - TEMPI
                  DATA(K1) = DATA(K1) + TEMPR
                  DATA(K1+1) = DATA(K1+1) + TEMPI
  147         CONTINUE
  148     CONTINUE
  149     MMAX = NP1
  150     IF (MMAX-NTWO/2) 151,174,174
  151     LMAX = MAX0(NP1TW,MMAX/2)
          DO 173 L = NP1,LMAX,NP1TW
              M = L
              IF (MMAX-NP1) 156,156,152
  152         THETA = -TWOPI*REAL(L)/REAL(4*MMAX)
              IF (ISIGN) 154,153,153
  153         THETA = -THETA
  154         WR = COS(THETA)
              WI = SIN(THETA)
  155         W2R = WR*WR - WI*WI
              W2I = 2.*WR*WI
              W3R = W2R*WR - W2I*WI
              W3I = W2R*WI + W2I*WR
  156         DO 169 I1 = 1,I1RNG,2
                  KMIN = I1 + IPAR*M
                  IF (MMAX-NP1) 157,157,158
  157             KMIN = I1
  158             KDIF = IPAR*MMAX
  159             KSTEP = 4*KDIF
                  IF (KSTEP-NTWO) 160,160,169
  160             DO 168 K1 = KMIN,NTOT,KSTEP
                      K2 = K1 + KDIF
                      K3 = K2 + KDIF
                      K4 = K3 + KDIF
                      IF (MMAX-NP1) 161,161,164
  161                 U1R = DATA(K1) + DATA(K2)
                      U1I = DATA(K1+1) + DATA(K2+1)
                      U2R = DATA(K3) + DATA(K4)
                      U2I = DATA(K3+1) + DATA(K4+1)
                      U3R = DATA(K1) - DATA(K2)
                      U3I = DATA(K1+1) - DATA(K2+1)
                      IF (ISIGN) 162,163,163
  162                 U4R = DATA(K3+1) - DATA(K4+1)
                      U4I = DATA(K4) - DATA(K3)
                      GO TO 167

  163                 U4R = DATA(K4+1) - DATA(K3+1)
                      U4I = DATA(K3) - DATA(K4)
                      GO TO 167

  164                 T2R = W2R*DATA(K2) - W2I*DATA(K2+1)
                      T2I = W2R*DATA(K2+1) + W2I*DATA(K2)
                      T3R = WR*DATA(K3) - WI*DATA(K3+1)
                      T3I = WR*DATA(K3+1) + WI*DATA(K3)
                      T4R = W3R*DATA(K4) - W3I*DATA(K4+1)
                      T4I = W3R*DATA(K4+1) + W3I*DATA(K4)
                      U1R = DATA(K1) + T2R
                      U1I = DATA(K1+1) + T2I
                      U2R = T3R + T4R
                      U2I = T3I + T4I
                      U3R = DATA(K1) - T2R
                      U3I = DATA(K1+1) - T2I
                      IF (ISIGN) 165,166,166
  165                 U4R = T3I - T4I
                      U4I = T4R - T3R
                      GO TO 167

  166                 U4R = T4I - T3I
                      U4I = T3R - T4R
  167                 DATA(K1) = U1R + U2R
                      DATA(K1+1) = U1I + U2I
                      DATA(K2) = U3R + U4R
                      DATA(K2+1) = U3I + U4I
                      DATA(K3) = U1R - U2R
                      DATA(K3+1) = U1I - U2I
                      DATA(K4) = U3R - U4R
                      DATA(K4+1) = U3I - U4I
  168             CONTINUE
                  KDIF = KSTEP
                  KMIN = 4* (KMIN-I1) + I1
                  GO TO 159

  169         CONTINUE
              M = M + LMAX
              IF (M-MMAX) 170,170,173
  170         IF (ISIGN) 171,172,172
  171         TEMPR = WR
              WR = (WR+WI)*RTHLF
              WI = (WI-TEMPR)*RTHLF
              GO TO 155

  172         TEMPR = WR
              WR = (WR-WI)*RTHLF
              WI = (TEMPR+WI)*RTHLF
              GO TO 155

  173     CONTINUE
          IPAR = 3 - IPAR
          MMAX = MMAX + MMAX
          GO TO 150
c
c     main loop for factors not equal to two.  apply the twiddle factor
c     w=exp(isign*2*pi*sqrt(-1)*(j1-1)*(j2-j1)/(ifp1+ifp2)), then
c     perform a fourier transform of length ifact(if), making use of
c     conjugate symmetries.
c
  174     IF (NTWO-NP2) 175,201,201
  175     IFP1 = NTWO
          IF = INON2
          NP1HF = NP1/2
  176     IFP2 = IFACT(IF)*IFP1
          J1MIN = NP1 + 1
          IF (J1MIN-IFP1) 177,177,184
  177     DO 183 J1 = J1MIN,IFP1,NP1
              THETA = -TWOPI*REAL(J1-1)/REAL(IFP2)
              IF (ISIGN) 179,178,178
  178         THETA = -THETA
  179         WSTPR = COS(THETA)
              WSTPI = SIN(THETA)
              WR = WSTPR
              WI = WSTPI
              J2MIN = J1 + IFP1
              J2MAX = J1 + IFP2 - IFP1
              DO 182 J2 = J2MIN,J2MAX,IFP1
                  I1MAX = J2 + I1RNG - 2
                  DO 181 I1 = J2,I1MAX,2
                      DO 180 J3 = I1,NTOT,IFP2
                          TEMPR = DATA(J3)
                          DATA(J3) = DATA(J3)*WR - DATA(J3+1)*WI
                          DATA(J3+1) = TEMPR*WI + DATA(J3+1)*WR
  180                 CONTINUE
  181             CONTINUE
                  TEMPR = WR
                  WR = WR*WSTPR - WI*WSTPI
                  WI = TEMPR*WSTPI + WI*WSTPR
  182         CONTINUE
  183     CONTINUE
  184     THETA = -TWOPI/REAL(IFACT(IF))
          IF (ISIGN) 186,185,185
  185     THETA = -THETA
  186     WSTPR = COS(THETA)
          WSTPI = SIN(THETA)
          J2RNG = IFP1* (1+IFACT(IF)/2)
          DO 200 I1 = 1,I1RNG,2
              DO 199 I3 = I1,NTOT,NP2
                  J2MAX = I3 + J2RNG - IFP1
                  DO 197 J2 = I3,J2MAX,IFP1
                      J1MAX = J2 + IFP1 - NP1
                      DO 193 J1 = J2,J1MAX,NP1
                          J3MAX = J1 + NP2 - IFP2
                          DO 192 J3 = J1,J3MAX,IFP2
                              JMIN = J3 - J2 + I3
                              JMAX = JMIN + IFP2 - IFP1
                              I = 1 + (J3-I3)/NP1HF
                              IF (J2-I3) 187,187,189
  187                         SUMR = 0.
                              SUMI = 0.
                              DO 188 J = JMIN,JMAX,IFP1
                                  SUMR = SUMR + DATA(J)
                                  SUMI = SUMI + DATA(J+1)
  188                         CONTINUE
                              WORK(I) = SUMR
                              WORK(I+1) = SUMI
                              GO TO 192

  189                         ICONJ = 1 + (IFP2-2*J2+I3+J3)/NP1HF
                              J = JMAX
                              SUMR = DATA(J)
                              SUMI = DATA(J+1)
                              OLDSR = 0.
                              OLDSI = 0.
                              J = J - IFP1
  190                         TEMPR = SUMR
                              TEMPI = SUMI
                              SUMR = TWOWR*SUMR - OLDSR + DATA(J)
                              SUMI = TWOWR*SUMI - OLDSI + DATA(J+1)
                              OLDSR = TEMPR
                              OLDSI = TEMPI
                              J = J - IFP1
                              IF (J-JMIN) 191,191,190
  191                         TEMPR = WR*SUMR - OLDSR + DATA(J)
                              TEMPI = WI*SUMI
                              WORK(I) = TEMPR - TEMPI
                              WORK(ICONJ) = TEMPR + TEMPI
                              TEMPR = WR*SUMI - OLDSI + DATA(J+1)
                              TEMPI = WI*SUMR
                              WORK(I+1) = TEMPR + TEMPI
                              WORK(ICONJ+1) = TEMPR - TEMPI
  192                     CONTINUE
  193                 CONTINUE
                      IF (J2-I3) 194,194,195
  194                 WR = WSTPR
                      WI = WSTPI
                      GO TO 196

  195                 TEMPR = WR
                      WR = WR*WSTPR - WI*WSTPI
                      WI = TEMPR*WSTPI + WI*WSTPR
  196                 TWOWR = WR + WR
  197             CONTINUE
                  I = 1
                  I2MAX = I3 + NP2 - NP1
                  DO 198 I2 = I3,I2MAX,NP1
                      DATA(I2) = WORK(I)
                      DATA(I2+1) = WORK(I+1)
                      I = I + 2
  198             CONTINUE
  199         CONTINUE
  200     CONTINUE
          IF = IF + 1
          IFP1 = IFP2
          IF (IFP1-NP2) 176,201,201
c
c     complete a real transform in the 1st dimension, n even, by con-
c     jugate symmetries.
c
  201     GO TO (230,220,230,202) ICASE

  202     NHALF = N
          N = N + N
          THETA = -TWOPI/REAL(N)
          IF (ISIGN) 204,203,203
  203     THETA = -THETA
  204     WSTPR = COS(THETA)
          WSTPI = SIN(THETA)
          WR = WSTPR
          WI = WSTPI
          IMIN = 3
          JMIN = 2*NHALF - 1
          GO TO 207

  205     J = JMIN
          DO 206 I = IMIN,NTOT,NP2
              SUMR = (DATA(I)+DATA(J))/2.
              SUMI = (DATA(I+1)+DATA(J+1))/2.
              DIFR = (DATA(I)-DATA(J))/2.
              DIFI = (DATA(I+1)-DATA(J+1))/2.
              TEMPR = WR*SUMI + WI*DIFR
              TEMPI = WI*SUMI - WR*DIFR
              DATA(I) = SUMR + TEMPR
              DATA(I+1) = DIFI + TEMPI
              DATA(J) = SUMR - TEMPR
              DATA(J+1) = -DIFI + TEMPI
              J = J + NP2
  206     CONTINUE
          IMIN = IMIN + 2
          JMIN = JMIN - 2
          TEMPR = WR
          WR = WR*WSTPR - WI*WSTPI
          WI = TEMPR*WSTPI + WI*WSTPR
  207     IF (IMIN-JMIN) 205,208,211
  208     IF (ISIGN) 209,211,211
  209     DO 210 I = IMIN,NTOT,NP2
              DATA(I+1) = -DATA(I+1)
  210     CONTINUE
  211     NP2 = NP2 + NP2
          NTOT = NTOT + NTOT
          J = NTOT + 1
          IMAX = NTOT/2 + 1
  212     IMIN = IMAX - 2*NHALF
          I = IMIN
          GO TO 214

  213     DATA(J) = DATA(I)
          DATA(J+1) = -DATA(I+1)
  214     I = I + 2
          J = J - 2
          IF (I-IMAX) 213,215,215
  215     DATA(J) = DATA(IMIN) - DATA(IMIN+1)
          DATA(J+1) = 0.
          IF (I-J) 217,219,219
  216     DATA(J) = DATA(I)
          DATA(J+1) = DATA(I+1)
  217     I = I - 2
          J = J - 2
          IF (I-IMIN) 218,218,216
  218     DATA(J) = DATA(IMIN) + DATA(IMIN+1)
          DATA(J+1) = 0.
          IMAX = IMIN
          GO TO 212

  219     DATA(1) = DATA(1) + DATA(2)
          DATA(2) = 0.
          GO TO 230
c
c     complete a real transform for the 2nd or 3rd dimension by
c     conjugate symmetries.
c
  220     IF (I1RNG-NP1) 221,230,230
  221     DO 229 I3 = 1,NTOT,NP2
              I2MAX = I3 + NP2 - NP1
              DO 228 I2 = I3,I2MAX,NP1
                  IMIN = I2 + I1RNG
                  IMAX = I2 + NP1 - 2
                  JMAX = 2*I3 + NP1 - IMIN
                  IF (I2-I3) 223,223,222
  222             JMAX = JMAX + NP2
  223             IF (IDIM-2) 226,226,224
  224             J = JMAX + NP0
                  DO 225 I = IMIN,IMAX,2
                      DATA(I) = DATA(J)
                      DATA(I+1) = -DATA(J+1)
                      J = J - 2
  225             CONTINUE
  226             J = JMAX
                  DO 227 I = IMIN,IMAX,NP0
                      DATA(I) = DATA(J)
                      DATA(I+1) = -DATA(J+1)
                      J = J - NP0
  227             CONTINUE
  228         CONTINUE
  229     CONTINUE
c
c     end of loop on each dimension
c
  230     NP0 = NP1
          NP1 = NP2
          NPREV = N
  231 CONTINUE
  232 RETURN
c
c revision history---
c
c january 1978     deleted references to the  *cosy  cards and
c                  added revision history
c-----------------------------------------------------------------------
      END

      SUBROUTINE CXFFT3(CXDATA,MX,MY,MZ,ISIGN,CXWORK)
      PARAMETER (MXTRIG=1024)
C*** Arguments:
      INTEGER ISIGN,MX,MY,MZ
      COMPLEX CXDATA(MX,MY,MZ),CXWORK(MX,MY,MZ)
C
C*** Local variables:
      INTEGER INC,JUMP,K,LOT
      CHARACTER CMSGNM*70
      INTEGER IFAX(13),IFAY(13),IFAZ(13)
      REAL TRIG(MXTRIG)
C
C*** External Subroutines:
      EXTERNAL CFFT99,CFTFAX
C
C*** SAVE statements:
      SAVE MXOLD, MYOLD, MZOLD
C
C*** DATA statements:
      DATA MXOLD,MYOLD,MZOLD/0,0,0/
C***********************************************************************
C
C Purpose:
C Calculates direct and inverse 3-dimensional FFT (in place)
C for complex matrix CXDATA.
C
C Input:
C
C CXDATA(NX, NY, NZ)   --- data array (complex). Will be overwritten.
C MX, MY, MZ           --- dimensions of CXDATA; have to be of the form
C                           2**a 3**b 5**c
C ISIGN = (-1,1)       --- (1 for inverse, -1 direct transform).
C                           Read documentation of "cfft99f.f"
C                           code for definition
C TRIGX(2*MX)
C TRIGY(2*MY)
C TRIGZ(2*MZ)          --- storage arrays. CAN NOT BE OVERWRITTEN
C                          between calls
C CXWORK(MX,MY,MZ)     --- complex work array. Can be overwritten.
C
C Output:
C
C CXDATA               --- 3D Fourier transform
C TRIGX, TRIGY, TRIGZ
C
C Local variables:
C
C IFAX(13)
C IFAY(13)
C IFAZ(13)             --- internal integer info array. Dimension 13
C                          is sufficient for very large nx, ny, nz
C MXOLD,MYOLD,MZOLD    --- switch. Keeps track of previous MX,MY,MZ
C INC
C JUMP
C LOT                  --- define how many FFTs
C                          (see "cfft99.f" documentation)
C
C External documentation for "cfft99f"
C
C              THE fft99 PACKAGE WAS WRITTEN BY 
C              CLIVE TEMPERTON AT ECMWF IN
C              NOVEMBER, 1978.  IT WAS MODIFIED, DOCUMENTED, AND TESTED
C              FOR NCAR BY RUSS REW IN SEPTEMBER, 1980.  IT WAS
C              FURTHER MODIFIED FOR THE FULLY COMPLEX CASE BY DAVE
C              FULKER IN NOVEMBER, 1980.
C
C Efficiency:
C
C The code vectorizes on CRAY-YMP and is more efficient than the
C FOURN routine from "Numerical Recipes" by  W. H. Press, B. P. Flannery
C S. A. Teukolsky, W. T. Vettering. For 64x64x32 case this code
C is >6 faster than FOURN.
C
C If speed is important for even values 
C of n=nx=ny=nz  one should insert dummy
C rows and columns to make dimension  cxdata(n+1, n+1, n+1) to
C avoid bank conflicts (on CRAY).

C History:
C Written by P.J.Flatau, 11/24/1990 with the help of C. Temperton
C 94/06/20 (PJF) added mxold, myold, mzold instead of "icall"
C                vecause of 3DFFT test code
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
***********************************************************************
C
C initialize trigs (only once)
      IF(MX.NE.MXOLD .OR. MY.NE.MYOLD .OR. MZ.NE.MZOLD)THEN
         MXOLD=MX
         MYOLD=MY
         MZOLD=MZ
         NTRIG=2*(MX+MY+MZ)
         IF(NTRIG.GT.MXTRIG)THEN
            WRITE(CMSGNM,FMT='(2I5,A)')NTRIG,MXTRIG,
     &         ' 2*NX+2*NY+2*NZ .GT. MXTRIG. Increase MXTRIG! '
            CALL ERRMSG('FATAL','CXFFT3',CMSGNM)
         ENDIF
         LTRIGX=1
         LTRIGY=1+2*MX
         LTRIGZ=1+2*MX+2*MY
         CALL CFTFAX(MX,IFAX,TRIG(LTRIGX))
         CALL CFTFAX(MY,IFAY,TRIG(LTRIGY))
         CALL CFTFAX(MZ,IFAZ,TRIG(LTRIGZ))
      ENDIF
C --- first dimension
      INC=1
      JUMP=MX
      LOT=MY*MZ
      CALL CFFT99(CXDATA,CXWORK,TRIG(LTRIGX),IFAX,INC,JUMP,MX,LOT,ISIGN)
C --- second dimension
      INC=MX
      JUMP=1
      LOT=MX
C --- one plane at a time
      DO 10 K=1,MZ
         CALL CFFT99(CXDATA(1,1,K),CXWORK,TRIG(LTRIGY),IFAY,INC,JUMP,
     &               MY,LOT,ISIGN)
   10 CONTINUE
C --- third dimension
      INC=MX*MY
      JUMP=1
      LOT=MX*MY
      CALL CFFT99(CXDATA,CXWORK,TRIG(LTRIGZ),IFAZ,INC,JUMP,MZ,LOT,ISIGN)
      RETURN
      END

      SUBROUTINE ERRMSG(CSTATS,CSUBRT,CMSGNM)
C Arguments:
      CHARACTER CMSGNM*(*),CSTATS*(*),CSUBRT*(*)
C
C Local variables:
      INTEGER IOERR
C
C***********************************************************************
C Given:
C       CSTATS = 'WARNING' or 'FATAL'
C       CSUBRT = name of subroutine
C       CMESGN = message
C Prints a warning message in a standardized way,
C and STOPs if CSTATS='FATAL'
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C
C History:
C 96.11.14 (PJF) Remove "getset" and hardwire" ioerr"
C***********************************************************************
      data ioerr/6/
      IF(CSTATS.EQ.'FATAL')THEN
         WRITE (IOERR,FMT=9000) CSUBRT
 9000    FORMAT(/,' >>>>> FATAL ERROR IN PROCEDURE: ',A)
         WRITE(IOERR,FMT=9010)CMSGNM
 9010    FORMAT(1X,A)
         WRITE(IOERR,FMT=9020)
 9020    FORMAT(' >>>>> EXECUTION ABORTED ')
         STOP
      ELSEIF(CSTATS.EQ.'WARNING')THEN
         WRITE(IOERR,FMT=9030)CSUBRT
 9030    FORMAT(/,' >>>>> WARNING IN PROCEDURE: ',A)
         WRITE(IOERR,FMT=9010)CMSGNM
 9040    FORMAT(1X,A)
      ENDIF
      RETURN
      END

      SUBROUTINE ESELF(CMETHD,CXZP,NX,NY,NZ,AKD,CXZC,CXZW,CXZE)
C Arguments:
      CHARACTER*6 CMETHD
      REAL AKD
      INTEGER NX,NY,NZ
      COMPLEX CXZC(NX+1,NY+1,NZ+1,6),CXZE(NX,NY,NZ,3),
     &        CXZP(NX,NY,NZ,3),CXZW(2*NX,2*NY,2*NZ,*)
C Local scalars:
      COMPLEX CXEX,CXEY,CXEZ,CXFAC,CXPHAS,CXUNIT,CXXX,CXXY,CXXZ,
     &        CXYY,CXYZ,CXZERO,CXZZ
      REAL FAC,R,R2,R3,WOLD,XX
      INTEGER I,IER,II,IR,ISGN,J,JJ,JR,JSGN,K,KR,KSGN,M,NGRID
C Local arrays:
      REAL X(3)
      INTEGER ISYM(3),NN(3)
C
      EXTERNAL C3DFFT,EXTND,FOURX,PAD,TRIM
      INTRINSIC EXP,MIN,NINT,SIGN,SQRT
      SAVE CXUNIT,CXZERO,NN,NGRID,WOLD
***********************************************************************
C
C       Given the dipole moments, CXZP, at all points on
C       a rectangular grid,oscillating at frequency AKD,
C       compute the electric field amplitude, CXZE,
C       at each point produced by all the other dipoles except the one
C       at that point.
C       The relationship between the dipoles and the field
C       values at the grid points can be expressed as a convolution,
C       and the convolution is efficiently evaluated using 3D FFTs.
C
C       3-dimensional FFT is performed using either
C       a) FOURX code by  N. Brenner + slight PJF mods
C          Works with either MXMEM=0 or 1 in DDSCAT.f
C          Select CMETHD='BRENNR' (in the DDSCAT parameter file)
C       b) CXFFT3 interface to Temperton's CFFT99F code.
C          This option is more suitable for vector machines
C          (CRAY) but takes (8*nx*ny*nz) more memory in comparison
C          with FOURX.  It also requires that NX,NY,NZ each be of form
C          (2**I)*(3**J)*(5**K), for integer I,J,K.  Subroutine EXTEND
C          takes care of choosing suitable NX,NY,NZ.
C          *** Requires that DDSCAT be compiled with MXMEM=1 ***
C          Select CMETHD='TMPRTN' (in the DDSCAT parameter file).
C       c) Native 3d FFT routine in Convex vector library.
C          This option is available only on Convex hardware, and
C          linking must be done with -lveclib option (see the Makefile).
C          This also requires that NX,NY,NZ be of form
C          (2**I)*(3**J)*(5**K); subroutine EXTEND takes care of choosing
C          suitable NX,NY,NZ.
C          Works with either MXMEM=0 or 1 in DDSCAT.f
C          Select CMETHD='CONVEX' (in the DDSCAT parameter file).
C       d) CXFFT3N interface to GPFA code of Temperton. 
C          Good points: 
C             -On CRAY the code is on average 30-40% faster in comparison
C              to TMPRTN (and 10-15 faster in comparison to BRENNR)
C             -On scalar machines the code is 2-8 faster in comparison
C              to BRENNR or TMPRTN
C             -Doesn't require additional storage
C          Problems:
C              -Requires that NX,NY,NZ be of form (2**I)*(3**J)*(5**K); 
C               subroutine EXTEND takes care of choosing suitable NX,NY,NZ.
C              -The code is NOT ON PUBLIC DOMAIN and we do not distribute it.
C              -The choice of "lvr" variable in gpfa2f, gpfa3f, gpfa5f
C               depends on machine. WARNING: on C90 use lvr=128, on
C               all other CRAY's use lvr=64; wrong lvr will produce WRONG
C               RESULTS. On scalar machines lvr depends on cache length
C               but the bad choice degrades performance but still produces
C               correct results.
C        
C       INPUT:
C       CXZP(I,J,K,L)   Lth cartesian component of the dipole
C                       moment at the grid point (I,J,K);
C                       the DIMENSIONed length of CXZP in
C                       the calling routine is CXZP(NX,NY,NZ,3)
C                       [or CXZP(NX*NY*NZ,3) or CXZP(3*NX*NY*NZ)]
C
C       NX,NY,NZ        Size of grid in x,y,z directions (INTEGER).

C       AKD             Frequency of oscillation of dipoles and electric
C                       field; also absolute value of wave vector of
C                       incident wave [c=1]  (REAL*4).

C       CXZC            (NX+1) by (NY+1) by (NZ+1) by 6 array of Green
C                       function coefficients used
C                       internally by ESELF and
C                       *************NOT TO BE OVERWRITTEN***********
C                       between calls, because these coefficients are
C                       recomputed only if W has changed since the last
C                       call to ESELF.

C       CXZW            Complex, scratch-space vector of length:
C                       2*NX*2*NY*2*NY*3   --- for  FOURX FFT
C                       2*NX*2*NY*2*NZ*4   --- for CXFFT3 solver
C                       See comment about FFT usage and CMETHD
C                       flag.
C                       Can be overwritten between calls to ESELF

C       OUTPUT:

C       CXZE(I,J,K,L)   Lth component of dipole-induced electric field
C                       at grid point (I,J,K);
C                       the DECLARED length of ZE in the calling
C                       program is CXZE(NX,NY,NZ,3)
C                       [or CXZE(NX*NY*NZ,3) or CXZE(3*NX*NY*NZ)]
C
C Written by Jeremy J. Goodman, Princeton Univ. Observatory, 90.09.22
C History:
C 90.11.29 (BTD): Modified to set untransformed ZC(1,1,1,1-6)=0.
C 90.11.29 (PJF): Modified to use FOURX and CXFFT99
C 90.12.05 (BTD): Modified for new ordering of elements of polarization
C                 and electric field vectors in calling program.  Modified
C                 ESELF and PAD to remove distinction between NX,NY,NZ
C                 and dimensions CXZE and CXZP, since our new ordering
C                 always assumes this.
C 90.12.13 (BTD): Modified to include CONVEX option.
C 92.04.20 (BTD): removed ISYM from argument list of TRIM (was not used)
C 94.06.20 (PJF): modified to call CXFFT3N when CMETHD='NEWTMP'
C 96.10.18 (BTD): changed NEWTMP to GPFAFT
C 99.04.26 (BTD): changed notation CXY -> CXZE for clarity
C
C Copyright (C) 1993,1994,1996,1999 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      DATA WOLD/-999e-33/,CXUNIT/ (0.,1.)/,CXZERO/(0.,0.)/
C
      IF(AKD.EQ.WOLD)GOTO 70
C
C               AKD.NE.WOLD :
C
C               We have to recompute the
C               Green-function coefficients giving
C               components of field strength at a each grid point R
C               produced by unit-valued component of dipole moment at
C               point R', and then Fourier transform these components.
      WOLD=AKD
      NN(1)=2*NX
      NN(2)=2*NY
      NN(3)=2*NZ
      NGRID=8*NX*NY*NZ
C
C               Compute the actual coefficients:
C
      DO 60 K=1,NZ
         DO 50 J=1,NY
            DO 40 I=1,NX
               IF(I.EQ.1.AND.J.EQ.1.AND.K.EQ.1)GOTO 40
C Note: to use lattice with other than unit spacing in each direction,
C simply multiply RHS of each of next three lines by dx(1),dx(2),dx(3),
C declare real dx(3), and add dx to argument list
C This flexibility has been removed from present code for simplicity.
C 90.11.04 (BTD)
               X(1)=I-1
               X(2)=J-1
               X(3)=K-1
               R2=X(1)**2+X(2)**2+X(3)**2
               R=SQRT(R2)
               R3=R*R2
               CXPHAS=EXP(CXUNIT*AKD*R)
               M=0
               DO 30 II=1,3
                  M=M+1
                  CXFAC=(1.-CXUNIT*AKD*R)/R2
                  CXZC(I,J,K,M)=-CXPHAS/R3*
     &                          (AKD**2*(X(II)**2-R2)+
     &                          CXFAC*(R2-3*X(II)**2))
                  DO 20 JJ=II+1,3
                     M=M+1
                     XX=X(II)*X(JJ)
                     CXZC(I,J,K,M)=-CXPHAS/R3*
     &                             (AKD**2*XX-CXFAC*(3*XX))
   20             CONTINUE
   30          CONTINUE
   40       CONTINUE
   50    CONTINUE
   60 CONTINUE
C
C Set zero-lag elements to zero (they were skipped above)
      DO 65 M=1,6
         CXZC(1,1,1,M)=CXZERO
   65 CONTINUE
C
C          At this point, zc(i,j,k,*) contains the upper triangular
C          part of the symmetric 3 x 3 matrix giving the electric
C          field at grid point (i,j,k) caused by a dipole at (1,1,1)

C          Fill out zc to twice the size in each grid dimension
C          to accomodate negative lags [periodicity in each dimension is
C          assumed, so (e.g.)
C          nx < i <= 2*nx is equivalent to -nx < i <= 0],
C          exploiting symmetries, and Fourier transform.
C          Store only the first octant of the transform,
C          since the others can be obtained by symmetry.
C
      ISYM(1)=1
      ISYM(2)=1
      ISYM(3)=1
      CALL EXTND(CXZC(1,1,1,1),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'BRENNR')THEN
         CALL FOURX(CXZW(1,1,1,1),NN,3,+1)
      ELSEIF(CMETHD.EQ.'TMPRTN')THEN
         CALL CXFFT3(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1,CXZW(1,1,1,4))
      ELSEIF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL C3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF
C 92.04.20 (BTD) removed ISYM from argument list of TRIM:
C      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,ISYM,CXZC(1,1,1,1))
      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,1))
C
      ISYM(1)=-1
      ISYM(2)=-1
      ISYM(3)=1
      CALL EXTND(CXZC(1,1,1,2),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'BRENNR')THEN
         CALL FOURX(CXZW(1,1,1,1),NN,3,+1)
      ELSEIF(CMETHD.EQ.'TMPRTN')THEN
         CALL CXFFT3(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1,CXZW(1,1,1,4))
      ELSEIF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL C3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF
C 92.04.20 (BTD) removed ISYM from argument list of TRIM:
C      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,ISYM,CXZC(1,1,1,2))
      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,2))
C
      ISYM(1)=-1
      ISYM(2)=1
      ISYM(3)=-1
      CALL EXTND(CXZC(1,1,1,3),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'BRENNR')THEN
         CALL FOURX(CXZW(1,1,1,1),NN,3,+1)
      ELSEIF(CMETHD.EQ.'TMPRTN')THEN
         CALL CXFFT3(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1,CXZW(1,1,1,4))
      ELSEIF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL C3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF
C 92.04.20 (BTD) removed ISYM from argument list of TRIM:
C      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,ISYM,CXZC(1,1,1,3))
      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,3))
C
      ISYM(1)=1
      ISYM(2)=1
      ISYM(3)=1
      CALL EXTND(CXZC(1,1,1,4),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'BRENNR')THEN
         CALL FOURX(CXZW(1,1,1,1),NN,3,+1)
      ELSEIF(CMETHD.EQ.'TMPRTN')THEN
         CALL CXFFT3(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1,CXZW(1,1,1,4))
      ELSEIF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL C3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF
C 92.04.20 (BTD) removed ISYM from argument list of TRIM:
C      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,ISYM,CXZC(1,1,1,4))
      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,4))
C
      ISYM(1)=1
      ISYM(2)=-1
      ISYM(3)=-1
      CALL EXTND(CXZC(1,1,1,5),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'BRENNR')THEN
         CALL FOURX(CXZW(1,1,1,1),NN,3,+1)
      ELSEIF(CMETHD.EQ.'TMPRTN')THEN
         CALL CXFFT3(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1,CXZW(1,1,1,4))
      ELSEIF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL C3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF
C 92.04.20 (BTD) removed ISYM from argument list of TRIM:
C      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,ISYM,CXZC(1,1,1,5))
      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,5))
C
      ISYM(1)=1
      ISYM(2)=1
      ISYM(3)=1
      CALL EXTND(CXZC(1,1,1,6),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
      IF(CMETHD.EQ.'BRENNR')THEN
         CALL FOURX(CXZW(1,1,1,1),NN,3,+1)
      ELSEIF(CMETHD.EQ.'TMPRTN')THEN
         CALL CXFFT3(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1,CXZW(1,1,1,4))
      ELSEIF(CMETHD.EQ.'GPFAFT')THEN
         CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
      ELSEIF(CMETHD.EQ.'CONVEX')THEN
         CALL C3DFFT(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
      ENDIF
C 92.04.20 (BTD) removed ISYM from argument list of TRIM:
C      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,ISYM,CXZC(1,1,1,6))
      CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,6))
C
C          End of recomputation of Green-function coefficients
C
   70 CONTINUE
C
C       Fourier transform the polarizations:
C
      DO 80 M=1,3
         CALL PAD(CXZP(1,1,1,M),NX,NY,NZ,CXZW(1,1,1,M))
         IF(CMETHD.EQ.'BRENNR')THEN
            CALL FOURX(CXZW(1,1,1,M),NN,3,+1)
         ELSEIF(CMETHD.EQ.'TMPRTN')THEN
            CALL CXFFT3(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,+1,CXZW(1,1,1,4))
        ELSEIF(CMETHD.EQ.'GPFAFT')THEN
           CALL CXFFT3N(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,+1)
         ELSEIF(CMETHD.EQ.'CONVEX')THEN
            CALL C3DFFT(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,2*NX,2*NY,+1,IER)
         ENDIF
C
C***********************************************************************
   80 CONTINUE
C
C       Multiply by F.T. of Green function:
C
      DO 110 K=1,2*NZ
         KSGN=NINT(SIGN(1.,NZ+1.5-K))
         KR=MIN(K,2*NZ+2-K)
         DO 100 J=1,2*NY
            JSGN=NINT(SIGN(1.,NY+1.5-J))
            JR=MIN(J,2*NY+2-J)
            DO 90 I=1,2*NX
               ISGN=NINT(SIGN(1.,NX+1.5-I))
               IR=MIN(I,2*NX+2-I)
               CXXX=CXZC(IR,JR,KR,1)
               CXXY=CXZC(IR,JR,KR,2)*(ISGN*JSGN)
               CXXZ=CXZC(IR,JR,KR,3)*(ISGN*KSGN)
               CXYY=CXZC(IR,JR,KR,4)
               CXYZ=CXZC(IR,JR,KR,5)*(JSGN*KSGN)
               CXZZ=CXZC(IR,JR,KR,6)
               CXEX=CXXX*CXZW(I,J,K,1)+CXXY*CXZW(I,J,K,2)+
     &              CXXZ*CXZW(I,J,K,3)
               CXEY=CXXY*CXZW(I,J,K,1)+CXYY*CXZW(I,J,K,2)+
     &              CXYZ*CXZW(I,J,K,3)
               CXEZ=CXXZ*CXZW(I,J,K,1)+CXYZ*CXZW(I,J,K,2)+
     &              CXZZ*CXZW(I,J,K,3)
               CXZW(I,J,K,1)=CXEX
               CXZW(I,J,K,2)=CXEY
               CXZW(I,J,K,3)=CXEZ
   90       CONTINUE
  100    CONTINUE
  110 CONTINUE
C
C       Inverse Fourier transform to obtain electric field:
C
      DO 150 M=1,3
         IF(CMETHD.EQ.'BRENNR')THEN
            CALL FOURX(CXZW(1,1,1,M),NN,3,-1)
         ELSEIF(CMETHD.EQ.'TMPRTN')THEN
            CALL CXFFT3(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,-1,CXZW(1,1,1,4))
         ELSEIF(CMETHD.EQ.'GPFAFT')THEN
           CALL CXFFT3N(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,-1)
         ELSEIF(CMETHD.EQ.'CONVEX')THEN
            CALL C3DFFT(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,2*NX,2*NY,-1,IER)
         ENDIF
C
C***********************************************************************
C Note: the Convex FFT routine already normalizes result.
C       For other FFT routines need to divide result by NGRID
C
         IF(CMETHD.EQ.'CONVEX')THEN
            DO 118 K=1,NZ
               DO 116 J=1,NY
                  DO 114 I=1,NX
                     CXZE(I,J,K,M)=CXZW(I,J,K,M)
  114             CONTINUE
  116          CONTINUE
  118       CONTINUE
         ELSE
            FAC=1./NGRID
            DO 140 K=1,NZ
               DO 130 J=1,NY
                  DO 120 I=1,NX
                     CXZE(I,J,K,M)=FAC*CXZW(I,J,K,M)
  120             CONTINUE
  130          CONTINUE
  140       CONTINUE
         ENDIF
  150 CONTINUE
C
      RETURN
      END
C***********************************************************************
C
      SUBROUTINE EXTND(CXA,NX,NY,NZ,ISYM,CXB)
C
C       Using symmetries, extend first octant of coefficient matrix to
C       other octants.
C
C Originally written by J.J. Goodman
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      INTEGER NX,NY,NZ
      COMPLEX CXA(NX+1,NY+1,NZ+1),CXB(2*NX,2*NY,2*NZ)
      INTEGER ISYM(3)
C Local variables:
      INTEGER I,J,K
      COMPLEX CXZERO
C SAVE statement:
      SAVE CXZERO
C DATA statement:
      DATA CXZERO/(0.,0.)/
C***********************************************************************
      DO 30 K=1,NZ
         DO 20 J=1,NY
            DO 10 I=1,NX
               CXB(I,J,K)=CXA(I,J,K)
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
C
      DO 60 K=1,NZ
         DO 50 J=1,NY
            CXB(NX+1,J,K)=CXZERO
            DO 40 I=NX+2,2*NX
               CXB(I,J,K)=CXA(2*NX+2-I,J,K)*ISYM(1)
   40       CONTINUE
   50    CONTINUE
   60 CONTINUE
C
      DO 90 K=1,NZ
         DO 80 I=1,2*NX
            CXB(I,NY+1,K)=CXZERO
            DO 70 J=NY+2,2*NY
               CXB(I,J,K)=CXB(I,2*NY+2-J,K)*ISYM(2)
   70       CONTINUE
   80    CONTINUE
   90 CONTINUE
C
      DO 120 J=1,2*NY
         DO 110 I=1,2*NX
            CXB(I,J,NZ+1)=CXZERO
            DO 100 K=NZ+2,2*NZ
               CXB(I,J,K)=CXB(I,J,2*NZ+2-K)*ISYM(3)
  100       CONTINUE
  110    CONTINUE
  120 CONTINUE
C
      RETURN
      END
C***********************************************************************
C
      SUBROUTINE TRIM(CXB,NX,NY,NZ,CXA)
C
C Copy the first octant of CXB into CXA
C
C Originally written by J.J. Goodman
C History:
C 92.04.20 (BTD) removed ISYM from argument list of TRIM:
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      INTEGER NX,NY,NZ
      COMPLEX CXA(NX+1,NY+1,NZ+1),CXB(2*NX,2*NY,2*NZ)
C Local variables:
      INTEGER I,J,K
C***********************************************************************
      DO 30 K=1,NZ+1
         DO 20 J=1,NY+1
            DO 10 I=1,NX+1
               CXA(I,J,K)=CXB(I,J,K)
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
      RETURN
      END
C***********************************************************************
C
      SUBROUTINE PAD(CXA,NX,NY,NZ,CXB)
C
C Pad the array CXA with zeros out to twice its length in each
C dimension, and put the result in CXB.
C
C Originally written by J.J. Goodman
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      INTEGER NX,NY,NZ
      COMPLEX CXA(NX,NY,NZ),CXB(2*NX,2*NY,2*NZ)
C Local variables:
      COMPLEX CXZERO
      INTEGER I,J,K
      SAVE CXZERO
      DATA CXZERO/(0.,0.)/
C***********************************************************************
      DO 30 K=1,2*NZ
         DO 20 J=1,2*NY
            DO 10 I=1,2*NX
               CXB(I,J,K)=CXZERO
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
C
      DO 60 K=1,NZ
         DO 50 J=1,NY
            DO 40 I=1,NX
               CXB(I,J,K)=CXA(I,J,K)
   40       CONTINUE
   50    CONTINUE
   60 CONTINUE
C
      RETURN
      END

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
C
C     timeit_ibm6000
C 94/06/20 (PJF) add dtime to the formal parameters
C 95.06.19 (PJF) modified to suppress printing if CMSGTM='noprint'
C
C This version of timeit uses the system call "mclock" available under
C RISC6000/320 IBM AIX3.1
C
C Copyright (C) 1993,1995 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C Arguments:
      CHARACTER CMSGTM* (*)
C
C Local variables:
      REAL DTIME, OLDTIM
      CHARACTER CSTA*3, CMSGNM*70
      REAL TARRAY(2)
C
C External Subroutines ..
      EXTERNAL WRIMSG
C
C External Functions ..
      REAL ETIME
      EXTERNAL ETIME
C
      DATA CSTA/'ONE'/
C
      IF(CSTA.EQ.'ONE')THEN
         CSTA='TWO'
         I1=MCLOCK()
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         I2=MCLOCK()
         IALL=I2-I1
         DTIME=FLOAT(IALL)/100.
         IF(CMSGTM(1:7).NE.'NOPRINT'.AND.CMSGTM(1:7).NE.'noprint')THEN
            WRITE(CMSGNM,FMT='(A,A)')' Timing results for: ',CMSGTM
            CALL WRIMSG('TIMEIT',CMSGNM)
            WRITE(CMSGNM,FMT='(G15.6, A)')DTIME,' CPU time (in secs) '
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE EVALA(CXADIA,CXALPH,MXN3,NAT)
C
C*********************************************************************
C Purpose: to evaluate diagonal elements of matrix A for use in
C discrete-dipole scattering calculation.
C
C Given:   CXALPH(1-NAT3)=complex polarizabilities of dipoles
C          NAT=number of dipoles
C          MXN3,MXNAT=dimensioning information
C Returns: CXADIAG(1-3*NAT)=diagonal elements of matrix A
C
C B. T. Draine, Princeton Univ. Obs., 87/1/7
C History:
C 88/ 5/ 5 (BTD): Modifications...
C 90/11/ 6 (BTD): Modified to pass array dimensions
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C*** Arguments:
      INTEGER MXN3,NAT
      COMPLEX CXADIA(MXN3),CXALPH(MXN3)
C
C*** Local variables:
      INTEGER IAX
C
C Compute "diagonal" elements of A: those having I=J
      DO 100 IAX=1,3*NAT
          CXADIA(IAX)=1./CXALPH(IAX)
  100 CONTINUE
      RETURN
C
      END

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
C
C timeit_hp
C
C This version uses the HP-AUX system calls SYSCONF and TIMES
C 94.06.20 (PJF) add dtime to the formal parameters
C 95.06.19 (PJF) modified to suppress printing if CMSGTM='noprint'
C
C Copyright (C) 1993,1995 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C External system calls:
$ALIAS sysconf = 'sysconf' (%val)
      INTEGER SYSCONF,TIMES
      EXTERNAL SYSCONF,TIMES
C
C Arguments:
      CHARACTER CMSGTM*(*)
C
C Local variables:
      INTEGER*2 NAME
      INTEGER CLK_TCK,I
      INTEGER TMS(4)
      REAL DTIME, OLDTIM
      CHARACTER CSTA*3,CMSGNM*70
C
C External subroutines:
      EXTERNAL WRIMSG

C Data statements:
      DATA CSTA/'ONE'/
C     ..
      IF(CSTA.EQ.'ONE')THEN
         NAME=2
         CLK_TCK=SYSCONF(NAME)
         OLDTIM=REAL(TMS(1)+TMS(2))/REAL(CLK_TCK)
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         I=TIMES(TMS)
         DTIME=REAL(TMS(1)+TMS(2))/REAL(CLK_TCK)-OLDTIM
         IF(CMSGTM(1:7).NE.'NOPRINT'.AND.CMSGTM(1:7).NE.'noprint')THEN
            WRITE(CMSGNM,FMT='(A,A)')' Timing results for: ',CMSGTM
            CALL WRIMSG('TIMEIT',CMSGNM)
            WRITE(CMSGNM,FMT='(G15.6, A)')DTIME,' CPU time (in secs) '
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,A1,A2)
C Arguments:
      INTEGER MXNAT,NAT
      INTEGER*2 IXYZ(MXNAT,3),ICOMP(MXNAT,3)
      REAL A1(3),A2(3)
C
C Local variables:
      INTEGER LWORK
      PARAMETER(LWORK=12)
      INTEGER 
     &   I,INFO,
     &   J,J1,J2,J3,JA,JD,
     &   K,LDA,LDVL,LDVR,N
      REAL DENOM,PI,ZNORM,ZNORM2
      REAL 
     &   A(3,3),A3(3),VL(3,3),VR(3,3),WI(3),WORK(LWORK),WR(3),
     &   ZI(3,3),ZR(3,3)
      DOUBLE PRECISION DSUM
      DOUBLE PRECISION CM(3)
      CHARACTER CMSGNM*70
C***********************************************************************
C Subroutine to determine principal axes of moment of inertia tensor
C of target.
C Target is assumed to be homogeneous.
C Given:
C
C MXNAT       =limit on largest allowed value of NAT=number of dipoles
C NAT         =number of dipoles in target
C IXYZ(J,1-3) =x,y,z location of dipole J on lattice
C ICOMP(J,1-3)=composition for dipole J; x,y,z directions
C
C Returns:
C
C A1(1-3)     =principal axis A1 in target frame (normalized)
C A2(1-3)     =principal axis A2 in target frame (normalized)
C
C where A1 = principal axis with largest moment of inertia
C       A2 = principal axis with second-largest moment of inertia
C
C B.T. Draine, Princeton Univ. Observatory, 96.01.26
C History:
C 96.01.26 (BTD) extracted from routine TARBLOCKS
C                IX,IY,IZ replaced by IXYZ
C 96.02.23 (BTD) corrected typo in 2 format statements
C                add code computing axis a3 and printing out
C                eigenvalue.
C 96.11.01 (PJF) modified to use LAPACK code rather than EIGV
C                and associated routines from NSWC package.
C 96.11.21 (BTD) modified to remove WRITE(0 and replace with
C                calls to WRIMSG
C 98.12.15 (BTD) Appears to be a problem with LAPACK routine SGEEV
C                when compiled using g77 under Linux.
C                Add trap to catch this problem if it occurs,
C                print out warning, and terminate execution.
C End history.
C
C Copyright (C) 1993,1994,1995,1996,1998 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
      PI=4.*ATAN(1.)
C
C Compute center of mass (assuming uniform density).
C
      DO JD=1,3
         CM(JD)=0.
      ENDDO
      DO JA=1,NAT
         DO JD=1,3
            CM(JD)=CM(JD)+IXYZ(JA,JD)
         ENDDO
      ENDDO
      DO JD=1,3
         CM(JD)=CM(JD)/NAT
      ENDDO
C
C Compute moment of inertia tensor
C
      DO J=1,3
         DO K=1,3
            A(J,K)=0.
         ENDDO
      ENDDO
      DSUM=0.
      DO K=1,3
         DO JA=1,NAT
            DSUM=DSUM+(IXYZ(JA,K)-CM(K))**2
         ENDDO
      ENDDO
      DO J=1,3
         A(J,J)=DSUM+NAT/6.
      ENDDO
      DO J=1,3
         DO K=1,3
            DSUM=0.
            DO JA=1,NAT
               DSUM=DSUM+(IXYZ(JA,J)-CM(J))*(IXYZ(JA,K)-CM(K))
            ENDDO
            A(J,K)=A(J,K)-DSUM
         ENDDO
      ENDDO
C
C Normalize moment of inertia tensor to units of 0.4*mass*a_eff**2
C
      DENOM=0.4*NAT*(.75*NAT/PI)**(2./3.)
      DO 3500 K=1,3
         DO 3400 J=1,3
            A(J,K)=A(J,K)/DENOM
 3400    CONTINUE
 3500 CONTINUE

c*** diagnostic
c      write(0,*)'in prinaxis:'
c      write(0,*)'center of mass CM=',CM
c      write(0,*)'--- normalized moment of inertia tensor A ---'
c      write(0,*)(a(1,k),k=1,3)
c      write(0,*)(a(2,k),k=1,3)
c      write(0,*)(a(3,k),k=1,3)
c***
C
C Compute eigenvalues and eigenvectors of A(J,K)
C
      N=3
      LDA=3
      LDVR=3
      LDVL=3
C calling sequence of SGEEV from "lapack.f"
C      CALL SGEEV( JOBVL, JOBVR, N, A, LDA, WR, WI, VL, LDVL, VR,
C     $                  LDVR, WORK, LWORK, INFO )
C
C in fact only right eignevectors are needed
C
      CALL SGEEV( 'V', 'V', N, a, LDA, WR, WI, VL, LDVL, VR,
     $                  LDVR, WORK, LWORK, INFO )

C 98.12.06 BTD It appears that SGEEV or subsidiary LAPACK routines
C              are not executing properly under Linux g77.  This 
C              problem has not been noticed previously, and certainly
C              did not appear with the Solaris f77 compiler.  Perhaps
C              one of the LAPACK routines is failing to SAVE some
C              variable between calls.  In any event, we have 
C              introduced this trap to terminate execution in case
C              of failure of SGEEV.
C
      IF(INFO.NE.0)THEN
         WRITE(CMSGNM,FMT='(A,I4)')
     &      'Error in PRINAXIS: returned from SGEEV with INFO=',INFO
         WRITE(CMSGNM,FMT='(A)')
     &      'SGEEV is part of lapack.f'
         WRITE(CMSGNM,FMT='(A)')
     &      'LAPACK routines may not work under Linux g77'
         WRITE(CMSGNM,FMT='(A)')
     &      'workaround by specifying target axis by hand'
         CALL ERRMSG('FATAL','PRINAXIS',' failure in SGEEV')
      ENDIF
C
c  VR      (output) REAL array, dimension (LDVR,N)
c          If JOBVR = 'V', the right eigenvectors v(j) are stored one
c          after another in the columns of VR, in the same order
c          as their eigenvalues.
c          If JOBVR = 'N', VR is not referenced.
c          If the j-th eigenvalue is real, then v(j) = VR(:,j),
c          the j-th column of VR.
c          If the j-th and (j+1)-st eigenvalues form a complex
c          conjugate pair, then v(j) = VR(:,j) + i*VR(:,j+1) and
c          v(j+1) = VR(:,j) = i*VR(:,j+1).

C Copy to zr and zi arrays. This is for historical reasons
C because of previous use of "NSWC Library of mathematical subroutines".
C (code eigv). There is a slight differnce between "eigv"
C and "sgeev" drivers in that eigenvectors in "eigv" are returned 
C as "complex" and "real" part but "sgeev" return just one matrix.
C Now, for real eigenvalues the complex part of eignevector should
C be 0. Thus, there should not be a difference between "eigv"
C and "sgeev" driver. 
C  
      do i=1,3
       do j=1,3
        zr(i,j)=vr(i,j)
        zi(i,j)=0.
       enddo      
      enddo
C
C Normalize the eigenvectors:
C
      DO 4000 J=1,3
         ZNORM2=0.
         DO 3800 K=1,3
            ZNORM2=ZNORM2+ZR(K,J)**2+ZI(K,J)**2
 3800    CONTINUE
C
C Make first component of each eigenvector positive
C
         ZNORM=SQRT(ZNORM2)
         IF(ZR(1,J).LT.0.)THEN
            ZNORM=-ZNORM
         ELSEIF(ZR(1,J).EQ.0.)THEN
            IF(ZR(2,J).LT.0.)ZNORM=-ZNORM
         ENDIF
         DO 3900 K=1,3
            ZR(K,J)=ZR(K,J)/ZNORM
            ZI(K,J)=ZI(K,J)/ZNORM
 3900    CONTINUE
 4000 CONTINUE
C
C Order the eigenvectors by eigenvalue, largest first:
C
      J1=1
      IF(WR(2).GT.WR(1))J1=2
      IF(WR(3).GT.WR(J1))J1=3
      IF(J1.EQ.1)THEN
         J2=2
         IF(WR(3).GT.WR(2))J2=3
      ELSEIF(J1.EQ.2)THEN
         J2=1
         IF(WR(3).GT.WR(1))J2=3
      ELSEIF(J1.EQ.3)THEN
         J2=1
         IF(WR(2).GT.WR(1))J2=2
      ENDIF
      DO 4100 K=1,3
         A1(K)=ZR(K,J1)
         A2(K)=ZR(K,J2)
 4100 CONTINUE
C
C Set J3=3 if J1+J2=1+2=3
C        2         =1+3=4
C        1         =2+3=5
C
      J3=6-J1-J2
C
C Having fixed eigenvectors a_1 and a_2, compute a_3=a_1xa_2
C
      A3(1)=A1(2)*A2(3)-A1(3)*A2(2)
      A3(2)=A1(3)*A2(1)-A1(1)*A2(3)
      A3(3)=A1(1)*A2(2)-A1(2)*A2(1)      
C
C*** enable following lines to print out eigenvalues
      WRITE(CMSGNM,FMT='(A,0PF8.5)')'I_1/.4Ma_eff^2 =',WR(J1)
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE(CMSGNM,FMT='(A,0PF8.5)')'I_2/.4Ma_eff^2 =',WR(J2)
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE(CMSGNM,FMT='(A,0PF8.5)')'I_3/.4Ma_eff^2 =',WR(J3)
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE(CMSGNM,FMT='(A,0P3F9.5,A)')'axis a_1 = (',A1,')'
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE(CMSGNM,FMT='(A,0P3F9.5,A)')'     a_2 = (',A2,')'
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE(CMSGNM,FMT='(A,0P3F9.5,A)')'     a_3 = (',A3,')'
      CALL WRIMSG('PRINAXIS',CMSGNM)
C***
      RETURN
      END

      SUBROUTINE WRITEBIN(CBINFLAG,CBINFILE,IOBIN,CSTAMP,CDESCR,CMDFFT,
     +                    CALPHA,CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,
     +                    MXBETA,MXPHI,MXN3,MXNAT,MXSCA,MXTIMERS,IORTH,
     +                    NX,NY,NZ,NAT0,NAT,NAT3,NSCAT,NCOMP,NORI,NWAV,
     +                    NRAD,NTHETA,NPHI,NBETA,NTIMERS,MXNX,MXNY,MXNZ,
     +                    MXCOMP,BETMID,BETMXD,THTMID,THTMXD,
     +                    PHIMID,PHIMXD,ICTHM,IPHIM,TOL,WAVEA,AEFFA,
     +                    THETA,BETA,PHI,A1,A2,ICOMP,IXYZ0,IWAV,IRAD,
     +                    IORI,AEFF,WAVE,XX,AK1,BETAD,THETAD,PHID,AKR,
     +                    CXE01R,CXE02R,CXRFR,CXEPS,QEXT,QABS,QSCAT,G,
     +                    QBKSCA,QPHA,QAV,QTRQAB,QTRQSC,SM,PHIN,THETAN,
     +                    TIMERS)
C***********************************************************************
C Subroutine  "writebin" writes FORTRAN unformatted binary file
C to file cbinfile ('dd.bin')
C
C Original version created by P.J.Flatau, University of California, SD
C History:
C 96.11.15 (PJF): First version.
C
C end history
C Copyright (C) 1996 B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C***********************************************************************
C
C     .. Scalar Arguments ..
      REAL AEFF,AK1,BETAD,BETMID,BETMXD,PHID,PHIMID,PHIMXD,THETAD,
     +     THTMID,THTMXD,TOL,WAVE,XX
      INTEGER ICTHM,IOBIN,IORI,IORTH,IPHIM,IRAD,IWAV,MXBETA,MXCOMP,MXN3,
     +        MXNAT,MXNX,MXNY,MXNZ,MXPHI,MXRAD,MXSCA,MXTHET,MXTIMERS,
     +        MXWAV,NAT,NAT0,NAT3,NBETA,NCOMP,NORI,NPHI,NRAD,NSCAT,
     +        NTHETA,NTIMERS,NWAV,NX,NY,NZ
      CHARACTER CALPHA*6,CBINFLAG*6,CMDFFT*6,CMDTRQ*6,CSHAPE*6,
     +          CBINFILE*14,CSTAMP*22,CDESCR*67
C     .. Array Arguments ..
      COMPLEX CXE01R(3),CXE02R(3),CXEPS(MXCOMP),CXRFR(MXCOMP)
      REAL A1(3),A2(3),AEFFA(MXRAD),AKR(3),BETA(MXBETA),G(2),PHI(MXPHI),
     +     PHIN(MXSCA),QABS(2),QAV(17),QBKSCA(2),QEXT(2),QPHA(2),
     +     QSCAT(2),QTRQAB(3,2),QTRQSC(3,2),SM(MXSCA,4,4),THETA(MXTHET),
     +     THETAN(MXSCA),TIMERS(MXTIMERS),WAVEA(MXWAV)
      INTEGER*2 ICOMP(MXN3),IXYZ0(MXNAT,3)
C     .. Local Scalars ..
      INTEGER I,IENTRY,IS,J
C     .. External Subroutines ..
      EXTERNAL WRIMSG
C     .. Data statements ..
      DATA IENTRY/0/

      IF (IENTRY.EQ.0) THEN
          CALL WRIMSG('WRITEBIN','First call to binary write')
          IENTRY = 1
C General run information:
          WRITE (IOBIN) CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,CMDTRQ
C mostly dimensions:
          WRITE (IOBIN) IORTH,NX,NY,NZ,NAT0,NAT,NAT3,NSCAT,NCOMP,NORI,
     +      NWAV,NRAD,NTHETA,NPHI,NBETA,NTIMERS
C maximum dimension (not really needed)
          WRITE (IOBIN) MXNX,MXNY,MXNZ,MXCOMP,MXSCA
          WRITE (IOBIN) BETMID,BETMXD,THTMID,THTMXD,PHIMID,PHIMXD
C dump scattering angles
          WRITE (IOBIN) (PHIN(I),I=1,NSCAT), (THETAN(I),I=1,NSCAT)
C misc run information
          WRITE (IOBIN) ICTHM,IPHIM,TOL
          WRITE (IOBIN) (WAVEA(I),I=1,NWAV), (AEFFA(I),I=1,NRAD),
     +      (THETA(I),I=1,NTHETA), (BETA(I),I=1,NBETA),
     +      (PHI(I),I=1,NPHI), (A1(I),I=1,3), (A2(I),I=1,3),
     +      (ICOMP(I),I=1,NAT3), (IXYZ0(I,1),I=1,NAT),
     +      (IXYZ0(I,2),I=1,NAT), (IXYZ0(I,3),I=1,NAT)

c endif  "if(cbinflag.eq.'USEBIN') then"
      END IF

C
C binary write of  for particular "iwav, irad, itheta, ibeta iphi"
C Let us try to keep only  one version of the binary file. Thus, in
C case of IORTH=1 or 'DOTORQ' some values are "missing"
C flatau -->draine  do we need smori for "ppol" do we need cxf_ij ?
C
      IF (IORI.NE.0 .AND. CBINFLAG.EQ.'ALLBIN') THEN
          WRITE (IOBIN) IWAV,IRAD,IORI, (TIMERS(I),I=1,NTIMERS)
          WRITE (IOBIN) AEFF,WAVE,XX,AK1,BETAD,THETAD,PHID,AKR,CXE01R,
     +      CXE02R, (CXRFR(I),I=1,NCOMP), (CXEPS(I),I=1,NCOMP)
          WRITE (IOBIN) QEXT,QABS,QSCAT,G,QBKSCA,QPHA,QAV,QTRQAB,QTRQSC
C write sm as 16 independent matrices (IDL handles 7 subscripts only)
          DO 10 I = 1,4
              DO 10 J = 1,4
                  WRITE (IOBIN) (SM(IS,I,J),IS=1,NSCAT)
   10     CONTINUE
C endif "if(iori. ne. 0 .and. cbinflag.eq.'ALLCDF') then"
      END IF

      IF (IORI.EQ.0) THEN
C iori=0 case
Cflatau ---> note. I need to add code for orientational averages
C but may be I can recalculate it from sm for iwav, irad, itheta,
C ---> dump weigths
      END IF

      RETURN

      END
